(PackageInfo named: 'CV') preamble: '"below, add code to be run before the loading of this package"
(Object class instVarNames includes: ''cvOriginal'')
		ifFalse: [Object class addInstVarName: ''cvOriginal''].'!
SystemOrganization addCategory: #'CV-TestBed'!
SystemOrganization addCategory: #CV!
SystemOrganization addCategory: #'CV-Refs'!
SystemOrganization addCategory: #'CV-UI'!
SystemOrganization addCategory: #'CV-UI-Bar'!
SystemOrganization addCategory: #'CV-UI-Browser'!
SystemOrganization addCategory: #'CV-UI-Commit'!
SystemOrganization addCategory: #'CV-UI-Nodes'!
SystemOrganization addCategory: #'CV-UI-Tests'!

MCPackageLoader subclass: #CvPackageLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvPackageLoader class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.081'!
canBeLateBound
	^ false! !

!CvPackageLoader methodsFor: 'as yet unclassified' stamp: 'bs 5/12/2012 11:59:25.736'!
basicLoad
	"does basically the same thing as the superclass but without displaying progress"
	
	"Load the contents of some package. This is the core loading method
	in Monticello. Be wary about modifying it unless you understand the details
	and dependencies of the various entities being modified."
	errorDefinitions := OrderedCollection new.

	[["Pass 1: Load everything but the methods,  which are collected in methodAdditions."
	additions 
		reject: [:ea | ea isMethodDefinition]
		thenDo: [:ea |
			[ea load] on: Error do: [
				[ea unload] on: Error do: []. 
				errorDefinitions add: ea]].

	"Try again any delayed definitions"
	self shouldWarnAboutErrors ifTrue: [self warnAboutErrors].
	errorDefinitions do: [:ea | ea load].

	"We compile and install new / changed methods"
	additions 
		select: [:ea | ea isMethodDefinition]
		thenDo: [:ea | ea load].

	
	"Remove the obsolete methods and classes"
	removals 
		select: [:ea | ea isMethodDefinition]
		thenDo: [:ea | ea unload].
			
	removals 
		reject: [:ea | ea isMethodDefinition]
		thenDo: [:ea | ea unload].


	additions do: [:ea | ea postloadOver: (self obsoletionFor: ea)].

	] on: InMidstOfFileinNotification do: [:n | n resume: true]
	] ensure: [self flushChangesFile]
! !

!CvPackageLoader methodsFor: 'as yet unclassified' stamp: 'sp 1/22/2013 17:12:50.651'!
containsErrors

	self analyze.
	^unloadableDefinitions notEmpty 
	
	"when loading additions there might be errorDefinitions, check them as well?"! !

!MCPackageLoader methodsFor: '*CV-override' stamp: 'bs 5/12/2012 10:57:23.778'!
basicLoad
	"Load the contents of some package. This is the core loading method
	in Monticello. Be wary about modifying it unless you understand the details
	and dependencies of the various entities being modified."
	| pkgName |
	errorDefinitions := OrderedCollection new.
	"Obviously this isn't the package name but we don't have anything else
	to use here. ChangeSet current name will generally work since a CS is 
	usually installed prior to installation."
	pkgName := ChangeSet current name.

	[["Pass 1: Load everything but the methods,  which are collected in methodAdditions."
	(additions 
		reject: [:ea | ea isMethodDefinition])
		do: [:ea | [ea load] on: Error do: [
						[ea unload] on: Error do: []. 
						errorDefinitions add: ea].
		] displayingProgress: 'Reshaping ', pkgName.

	"Try again any delayed definitions"
	self shouldWarnAboutErrors ifTrue: [self warnAboutErrors].
	errorDefinitions do: [:ea | ea load] 
		displayingProgress: 'Reloading ', pkgName.


	'Compiling and Installing ', pkgName displayProgressAt: Sensor cursorPoint from: 0 to: 2 during:[:bar|

		"We compile and install new / changed methods"
		additions 
			select: [:ea | ea isMethodDefinition]
			thenDo: [:ea | ea load].
		
		"There is no progress *during* installation since a progress bar update
		will redraw the world and potentially call methods that we're just trying to install."
		bar value: 1.

		"Remove the obsolete methods"
		removals 
			select: [:ea | ea isMethodDefinition]
			thenDo: [:ea | ea unload].
			
		removals 
			reject: [:ea | ea isMethodDefinition]
			thenDo: [:ea | ea unload].
	].

	additions do: [:ea | ea postloadOver: (self obsoletionFor: ea)] 
		displayingProgress: 'Initializing ', pkgName.

	] on: InMidstOfFileinNotification do: [:n | n resume: true]
	] ensure: [self flushChangesFile]! !

!HandMorph class methodsFor: '*CV' stamp: 'bs 11/16/2012 13:33:03.008'!
dragThreshold

	^ 10! !

!MCTool methodsFor: '*CV' stamp: 'bs 7/26/2011 17:08:49.637'!
buildPane
	| pane |
	pane := MorphicModel new.
	pane changeProportionalLayout.
	pane model: self.
	self widgetSpecs do: [:spec |
		| send fractions offsets |
		send := spec first.
		fractions := spec at: 2 ifAbsent: [#(0 0 1 1)].
		offsets := spec at: 3 ifAbsent: [#(0 0 0 0)].
		pane
			addMorph: (self perform: send first withArguments: send allButFirst)
			fullFrame:
				(LayoutFrame
					fractions: 
						((fractions first)@(fractions second) corner: 
							(fractions third)@(fractions fourth))
					offsets:
						((offsets first)@(offsets second)  corner:
							(offsets third)@(offsets fourth)))].
	^ pane! !

!RefactoryChangeManager methodsFor: '*CV-override' stamp: 'bs 8/23/2011 08:16:26.235'!
performChange: aRefactoringChange

	self 
		refactoringBegins: aRefactoringChange;
		ignoreChangesWhile: [ self addUndo: aRefactoringChange execute ];
		refactoringEnded: aRefactoringChange.! !

!RefactoryChangeManager methodsFor: '*CV' stamp: 'bs 8/12/2011 15:30:27.789'!
refactoringBegins: aRefactoryChange

	self emit! !

!RefactoryChangeManager methodsFor: '*CV' stamp: 'bs 8/12/2011 15:30:33.584'!
refactoringEnded: aRefactoryChange
	
	self emit! !

!OBClassCategoryNode methodsFor: '*CV' stamp: ''!
backgroundColor
	| activeWC refWC classes |
	activeWC := self activeWorkingCopy.
	refWC := activeWC referenceWC.
	refWC ifNil: [^ nil].
	
	classes := activeWC organization listAtCategoryNamed: self name.
	classes = (refWC organization listAtCategoryNamed: self name)
		ifFalse: [^ nil].
	(classes allSatisfy: [:ea | 
		(activeWC baseVersion classNamed: ea) ==
			(refWC baseVersion classNamed: ea)])
		ifTrue: [^ Color lightGray muchLighter]
		ifFalse: [^ nil]! !

!OBClassCategoryNode methodsFor: '*CV' stamp: 'bs 8/12/2011 15:50:59.047'!
cvItemReference
	
	^ CvCodeReference classCategory: self name! !

!OBClassCategoryNode methodsFor: '*CV' stamp: 'bs 8/10/2011 13:30:15.216'!
valueAt: aCodeBase

	^ (aCodeBase organization categories includes: self name)
		ifTrue: [self]
		ifFalse: [nil]! !

!OBPluggableListMorph methodsFor: '*CV' stamp: ''!
backgroundColorAt: aRowIndex

	^ model backgroundColorAt: aRowIndex! !

UiItemViewColumnSpec subclass: #CvBrowserAbstractTestColumnSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

!CvBrowserAbstractTestColumnSpec methodsFor: 'as yet unclassified' stamp: 'bs 12/11/2012 10:45:59.653'!
includesProperty: aProperty inNode: aVersion

	^ (super includesProperty: aProperty) or: [aProperty = #testResult] ! !

!CvBrowserAbstractTestColumnSpec methodsFor: 'as yet unclassified' stamp: 'bs 12/10/2012 13:43:38.288'!
itemFor: aVersion

	^ (self itemMorphFor: aVersion)
		setProperty: #selectable toValue: (self selectableFor: aVersion);
		fullBounds;
		yourself! !

!CvBrowserAbstractTestColumnSpec methodsFor: 'as yet unclassified' stamp: 'bs 12/10/2012 13:44:16.479'!
itemMorphFor: aVersion

	self subclassResponsibility! !

CvBrowserAbstractTestColumnSpec subclass: #CvBrowserTestChangesColumnSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

!CvBrowserTestChangesColumnSpec methodsFor: 'as yet unclassified' stamp: 'bs 12/10/2012 15:55:27.294'!
itemMorphFor: aVersion

	| outer item |
	aVersion testResult ifNil: [^ '' asMorph].
	
	outer := Morph new.
	outer 
		changeTableLayout;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		listDirection: #leftToRight;
		listCentering: #center;
		color: Color transparent.
		
	item := (AlignmentMorph inARow: (
			CvTestChangeIndicators version: aVersion size: 12) asArray)
		cellInset: 2;
		layoutInset: 0;
		borderWidth: 0;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		yourself.
	
	item cellPositioning: #center.
	outer addMorph: item.
	^ outer

			! !

CvBrowserAbstractTestColumnSpec subclass: #CvBrowserTestResultColumnSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

!CvBrowserTestResultColumnSpec methodsFor: 'as yet unclassified' stamp: 'bs 12/10/2012 13:44:45.749'!
itemMorphFor: aVersion

	| testResult outer itemWidth passedWidth itemHeight item |
	testResult := aVersion testResult.
	(testResult isNil or: [testResult runCount isZero]) 
		ifTrue: [^ '' asMorph ].
	
	itemWidth := 60.
	itemHeight := 12.
	passedWidth := (itemWidth * testResult passedRatio) truncated.
	
	outer := Morph new.
	outer 
		changeTableLayout;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		listDirection: #leftToRight;
		listCentering: #center;
		cellInset: 0;
		color: Color transparent.
		
	item := (AlignmentMorph 
		inARow: {
			Morph new color: Color solarizedGreen lighter; extent: passedWidth@itemHeight.
			Morph new color: Color solarizedOrange; extent: (itemWidth-passedWidth)@itemHeight.
		})
		borderWidth: 0;
		borderColor: Color solarizedBase01Brgreen;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		yourself.
	
	item cellPositioning: #center.
	outer addMorph: item.
	^ outer! !

UiItemViewColumnSpec subclass: #CvBrowserBranchColumnSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

!CvBrowserBranchColumnSpec methodsFor: 'as yet unclassified' stamp: 'bs 11/16/2012 13:51:36.65'!
itemFor: aVersion

	| outer item stuff |
	
	
	outer := Morph new.
	outer 
		changeTableLayout;
		vResizing: #spaceFill;
		hResizing: #shrinkWrap;
		listDirection: #leftToRight;
		listCentering: #center;
		cellInset: 0;
		color: Color transparent.
	
	stuff := (Array new: aVersion numberOfBranches) collect: [:ea | CvHairLineBranchMorph new].
	stuff at: aVersion branch put: CvLineBranchMorph new.
	
	aVersion hasSuccessors ifTrue: [
		aVersion successors allButFirst do: [:branchSuccessor | 
			stuff at: branchSuccessor branch put: CvForkBranchMorph new]].
	
	item := (AlignmentMorph 
		inARow: stuff asArray)
		borderWidth: 0;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		yourself.
	
	item cellPositioning: #center.
	outer addMorph: item.
	
	outer setProperty: #selectable toValue: (self selectableFor: aVersion).
	^ outer

			! !

UiItemViewColumnSpec subclass: #CvCommitTextColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Commit'!

!CvCommitTextColumn methodsFor: 'as yet unclassified' stamp: ''!
initialize

	super initialize.
	self menuSelector: #foobar! !

!CvCommitTextColumn methodsFor: 'as yet unclassified' stamp: 'bs 11/16/2012 13:52:35.873'!
itemFor: aVersion
	| itemMorph |
	itemMorph := super itemFor: aVersion.
	itemMorph width: 480.
	itemMorph height < 40 ifTrue: [itemMorph height: 40].
	itemMorph setProperty: #selectable toValue: (self selectableFor: aVersion).
	^ itemMorph! !

UiItemViewColumnSpec subclass: #CvItemViewColumnSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

!CvItemViewColumnSpec methodsFor: 'as yet unclassified' stamp: 'bs 11/16/2012 14:50:11.64'!
itemFor: aNode

	^ (super itemFor: aNode) ifNotNil: [:superValue |
		superValue 
			height: superValue height + 3;
			width: superValue width + 20;
			yourself]! !

!CvItemViewColumnSpec methodsFor: 'as yet unclassified' stamp: 'bs 11/16/2012 14:28:00.538'!
textConverter

	^ textConverter ifNil: [ 
		[:text | text asText addAttribute: (TextColor color: Color solarizedBase01Brgreen)] ].! !

!Character methodsFor: '*CV' stamp: ''!
isArrow

	^ self = Character arrowUp 
		or: [self = Character arrowRight]
		or: [self = Character arrowLeft]
		or: [self = Character arrowDown]! !

!SystemWindow class methodsFor: '*CV' stamp: 'bs 5/2/2011 22:03:46.962'!
canBeLateBound
	^ false! !

!SystemWindow methodsFor: '*CV' stamp: 'bs 7/21/2011 13:09:37.999'!
duplicateOn: aCodeBase

	^ (self model respondsTo: #duplicateAndOpenOn:)
		ifTrue: [self model duplicateAndOpenOn: aCodeBase]
		ifFalse: [
			self duplicate
				psRebaseTo: aCodeBase;
				yourself]! !

!SystemWindow methodsFor: '*CV' stamp: 'bs 5/15/2011 16:32:43.26'!
formerOwner: anObj
	super formerOwner: anObj.! !

!SystemWindow methodsFor: '*CV' stamp: 'bs 7/24/2011 12:50:53.026'!
previewOn: aCodeBase

	^ self duplicateOn: aCodeBase! !

!SystemWindow methodsFor: '*CV' stamp: 'bs 7/24/2011 12:48:25.098'!
supportsPreview

	^ (self model respondsTo: #supportsPreview)
		 and: [self model supportsPreview]! !

Object subclass: #CvBranch
	instanceVariableNames: 'view items subbranches subbranchesBeginItem laneNumber branchEndItem parent isVisible lastGroup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Bar'!

!CvBranch class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.019'!
canBeLateBound
	^ false! !

!CvBranch methodsFor: 'accessing' stamp: 'bs 4/24/2011 17:16:18.191'!
addItem: aVersionItem
	self items add: aVersionItem! !

!CvBranch methodsFor: 'accessing' stamp: 'TM 5/12/2011 18:17:39.933'!
addItem: aVersionItem after: anOther
	self items add: aVersionItem after: anOther! !

!CvBranch methodsFor: 'accessing' stamp: 'TM 5/12/2011 16:41:47.098'!
addItem: anItem before: anOther

	self items add: anItem before: anOther! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 4/29/2011 11:39:50.305'!
addNewSubbranch
	| newSubbranch |
	newSubbranch := self createSubbranch.
	self subbranches add: newSubbranch.
	^ newSubbranch ! !

!CvBranch methodsFor: 'node selection' stamp: 'bs 4/27/2011 15:01:59.944'!
addSelectedNodesToRanges: ranges withCurrentRange: currentRange

	self nodes do: [:ea |
		ea isSelected
			ifTrue: [currentRange add: ea]
			ifFalse: [
				currentRange ifNotEmpty: [
					ranges add: currentRange copy.
					currentRange removeAll]]].
		
	currentRange ifNotEmpty: [
		ranges add: currentRange copy.
		currentRange removeAll].
	
	self subbranches ifEmpty: [^ self].
	
	self subbranches first 
		addSelectedNodesToRanges: ranges withCurrentRange: currentRange.
		
	self subbranches allButFirst do: [:ea | 
		ea addSelectedNodesToRanges: ranges withCurrentRange: currentRange]! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 5/4/2011 19:42:03.027'!
addSpaceForSubbranch: aBranch
	| baseLaneUpThroughEndItem |
	
	aBranch determineLaneNumber.
	
	(self subbranches noneSatisfy: [:ea | ea isVisible])
		ifTrue: [
			subbranchesBeginItem buildLanes.  
			view addMorph: subbranchesBeginItem after: branchEndItem. ^ self].
		
	self raiseLanesAbove: aBranch.
	
	self laneNumber = aBranch laneNumber
		ifTrue: [baseLaneUpThroughEndItem := aBranch laneNumber]
		ifFalse: [baseLaneUpThroughEndItem := aBranch laneNumber - 1].
	
	(self view submorphs copyUpThrough: self branchEndItem) 
		do: [:ea | ea addLaneSpaceAbove: baseLaneUpThroughEndItem].
		
	(self view submorphs copyAfter: self branchEndItem) 
		do: [:ea | ea addEmptyLaneAbove: aBranch laneNumber - 1].
		
	! !

!CvBranch methodsFor: 'accessing' stamp: 'TM 5/6/2011 15:23:26.252'!
allItems

	^ (self subbranches 
		flatCollect: [:ea | ea allItems])
			addAll: self versionItems;
			yourself! !

!CvBranch methodsFor: 'accessing' stamp: 'bs 5/2/2011 22:27:16.951'!
allNodesDo: aBlock

	self items collect: [:ea | ea versionNode] thenDo: [:node | aBlock value: node].
	self subbranches do: [:subbranch | subbranch allNodesDo: aBlock]! !

!CvBranch methodsFor: 'node selection' stamp: 'bs 4/27/2011 13:16:55.188'!
allSelectedNodes

	^ view allSelectedNodes! !

!CvBranch methodsFor: 'node selection' stamp: 'bs 4/27/2011 13:34:19.322'!
allSelectedNodesInRanges
	^ view allSelectedNodesInRanges! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'TM 5/12/2011 15:31:33.648'!
appendNewGroup: newGroup

	newGroup branch: self.
	self addItem: newGroup.
	
	self isVisible ifTrue: [
		newGroup buildLanes.
		newGroup showItemAt: self laneNumber.
		view addItem: newGroup].
				
	^ newGroup! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'TM 5/12/2011 14:46:40.803'!
appendNewItemForVersion: newVersion
	| newItem |
	newItem := CvChronoVersionItem forVersion: newVersion.
	newItem versionNode branch: self.
	view linkWithLastItem: newItem.
	self addItem: newItem.
	
	self isVisible ifTrue: [
		newItem buildLanes.
		newItem showItemAt: self laneNumber.
		view addItem: newItem].
					
	^ newItem! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 11/9/2012 13:05:59.802'!
appendNewVersion: newVersion
	| predecessorItem prevVersion newItem targetBranch index |
	prevVersion := newVersion predecessor.
	predecessorItem := self versionItems detect: [:ea | ea version = prevVersion].
	index := prevVersion successors indexOf: newVersion.
	
	index = 1
		ifTrue: [targetBranch := self]
		ifFalse: [targetBranch := self forkAfter: predecessorItem].
	
	newItem := targetBranch appendNewItemForVersion: newVersion.
	newItem adaptToPredecessor.
	
	"self halt."
	self rootBranch hideInactiveBranches.
	"in case a new branch was created, the above statement has hid it"
	targetBranch showAllBranchesOfPath. 
	^ newItem! !

!CvBranch methodsFor: 'subbranches' stamp: 'bs 4/29/2011 11:02:23.318'!
branchEndItem
	^ branchEndItem! !

!CvBranch methodsFor: 'subbranches - split' stamp: 'bs 4/29/2011 11:02:23.332'!
branchEndItem: anObject
	branchEndItem := anObject! !

!CvBranch methodsFor: 'hide / show' stamp: 'bs 5/4/2011 19:42:19.275'!
childHid: aSubbranch

	(self subbranches noneSatisfy: [:ea | ea isVisible])
		ifTrue: [
			self subbranchesBeginItem removeLanes.
			view removeMorph: self subbranchesBeginItem].
	
	aSubbranch isLaneAboveParentLane 
		ifTrue: [view submorphs do: [:ea | ea removeLane: aSubbranch laneNumber]]
		ifFalse: [
			((self subbranches copyWithout: aSubbranch) anySatisfy: [:ea | ea isVisible])
				ifTrue: [
			(view submorphs copyUpThrough: self branchEndItem) do: [:ea |
				ea removeLane: aSubbranch laneNumber + 1].
			(view submorphs copyAfter: self branchEndItem) do: [:ea |
				ea removeLane: aSubbranch laneNumber]]].
	
	(self subbranches noneSatisfy: [:ea | ea isVisible])
		ifFalse: [aSubbranch lowerLanesAboveMe].
	aSubbranch laneNumber: 0.! !

!CvBranch methodsFor: 'subbranches - split' stamp: 'bs 5/5/2011 11:20:30.936'!
copyInstVarsNamed: instVarNames to: aBranch
	
	instVarNames do: [:ea |
		aBranch instVarNamed: ea put: (self instVarNamed: ea )]! !

!CvBranch methodsFor: 'subbranches - split' stamp: 'bs 4/30/2011 15:36:23.576'!
createEndAndSubbranchStartItems

	self
		branchEndItem: self createEndPointItem;
		subbranchesBeginItem: self createStartPointsItem.
	
	self assert: [self subbranches size = 1]. "only called in splitAfter:"
	self subbranches first firstItem predecessor: self subbranchesBeginItem.
		
	view 
		addMorph: self branchEndItem after: self lastItem;
		addMorph: self subbranchesBeginItem after: self branchEndItem.! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 4/27/2011 21:11:48.525'!
createEndPoint
	^ CvBranchPoint endPointFor: self! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 10/1/2012 17:04:18.954'!
createEndPointItem 
	| newItem |
	newItem := CvChronoPointsItem new.
	newItem predecessor: self lastItem.
	newItem buildLanes.
	newItem at: self laneNumber putPoint: self createEndPoint.
	^ newItem! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 4/27/2011 21:03:07.952'!
createStartPoint
	^ CvBranchPoint startPointFor: self! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 10/2/2012 10:09:16.533'!
createStartPointsItem 
	| newItem |	
	newItem := CvChronoStartPointsItem new.
	newItem predecessor: self branchEndItem.
	newItem buildLanes.
	self subbranches do: [:ea | 
		newItem at: ea laneNumber putPoint: ea createStartPoint].
	^ newItem! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 5/5/2011 09:50:54.969'!
createSubbranch
	^ CvBranch new initializeWithParent: self andView: view! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 4/29/2011 18:20:56.442'!
determineLaneNumber

	self parent ifNil: [self laneNumber: 1. ^ self].
	
	self laneNumber: (
		self highestVisibleSibling 
			ifNil: [self parent laneNumber]
			ifNotNil: [:siblingBranch | siblingBranch highestLaneNumber + 1])! !

!CvBranch methodsFor: 'accessing' stamp: 'bs 4/29/2011 15:38:13.206'!
firstItem
	^ self items first! !

!CvBranch methodsFor: 'subbranches - split' stamp: 'bs 5/5/2011 11:46:56.609'!
forkAfter: anItem
	| newChild |
	self lastItem ~= anItem 
		ifTrue: [self splitAfter: anItem].
	
	newChild := self addNewSubbranch.
	^ newChild.! !

!CvBranch methodsFor: 'grouping' stamp: 'bs 5/19/2011 10:02:27.966'!
group: items
	| groupItem |
	items first isGroup
		ifTrue: [groupItem := items first]
		ifFalse: [
			groupItem := CvChronoGroupItem new.
			groupItem branch: self.
			groupItem predecessor: items first predecessor.
			self addItem: groupItem before: items first.
	
			groupItem buildLanes.
			groupItem showItemAt: self laneNumber.
			view addMorph: groupItem inFrontOf: items first].
	
	items do: [:ea | groupItem appendVersionItem: ea]! !

!CvBranch methodsFor: 'grouping' stamp: 'bs 5/18/2011 21:26:54.019'!
groupsOfLinkedItems
	| currentGroup groups prevItem |
	groups := OrderedCollection new.
	prevItem := currentGroup := nil.
	
	self items allButFirst do: [:ea | 
		ea predecessor ~= prevItem 
			ifTrue: [
				currentGroup := OrderedCollection new.
				groups add: currentGroup].
		currentGroup add: ea.
		prevItem := ea].

	^ groups! !

!CvBranch methodsFor: 'hide / show' stamp: 'TM 5/12/2011 18:29:56.067'!
hide
	| itemsToBeRemoved |
	self isVisible ifFalse: [^ self].
	
	self subbranches do: [:ea | ea hide].
	
	itemsToBeRemoved := self items reversed.
	itemsToBeRemoved addAll: (
		{self subbranchesBeginItem. self branchEndItem} copyWithout: nil).
		
	itemsToBeRemoved do: [:ea |
		ea removeLanes.
		view hideItem: ea].
	
	isVisible := false.
	self parent ifNotNil: [self parent childHid: self. ] ! !

!CvBranch methodsFor: 'hide / show' stamp: 'bs 5/6/2011 08:42:04.583'!
hideInactiveBranches
	self subbranches do: [:ea | ea hideInactiveBranches].
	
	(self subbranches anySatisfy: [:ea | ea isVisible]) ifTrue: [^ self].
	self includesActiveVersion ifTrue: [^ self].
	self isRoot ifTrue: [^ self].
	self hide.! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 4/27/2011 21:51:38.613'!
highestLaneNumber
	
	^ self laneNumber max: self highestSubbranchLaneNumber! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 5/5/2011 11:48:37.225'!
highestSubbranchLaneNumber
	
	^ self subbranches 
		ifEmpty: [0]
		ifNotEmpty: [
	 		(self subbranches collect: [:ea | ea highestLaneNumber]) max]! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 5/4/2011 19:42:22.033'!
highestVisibleSibling
	
	^ (self parent subbranches copyUpTo: self) 
		reversed detect: [:ea | ea isVisible] ifNone: [nil]! !

!CvBranch methodsFor: 'node selection' stamp: 'TM 5/6/2011 12:10:17.961'!
includes: aVersionItem

	^ (items includes: aVersionItem)
		or: ((items select: [ :item | item isGroup ])
				select: [ :group | group versionItems includes: aVersionItem ]) notEmpty! !

!CvBranch methodsFor: 'accessing' stamp: 'TM 5/6/2011 14:57:45.032'!
includesActiveVersion
	^ self items anySatisfy: [:ea | ea isActive]! !

!CvBranch methodsFor: 'initialize-release' stamp: 'bs 5/4/2011 20:48:06.001'!
initialize

	super initialize.
	isVisible := false.! !

!CvBranch methodsFor: 'initialize-release' stamp: 'bs 5/4/2011 21:05:35.824'!
initializeAsRootWithView: aView

	self initialize.
	view := aView.
	self laneNumber: 1.
	self show.
	! !

!CvBranch methodsFor: 'initialize-release' stamp: 'bs 5/5/2011 09:50:23.647'!
initializeWithParent: parentBranch andView: aViewMorph

	self initialize.
	view := aViewMorph.
	self parent: parentBranch.
	self show.
	! !

!CvBranch methodsFor: 'initialize-release' stamp: 'bs 4/24/2011 16:19:59.668'!
initializeWithView: aView

	self initialize.
	view := aView.
	! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 4/28/2011 20:05:47.68'!
isLaneAboveParentLane
	^ self parent notNil and: [self parent laneNumber < self laneNumber]! !

!CvBranch methodsFor: 'accessing' stamp: 'bs 5/5/2011 10:21:00.66'!
isRoot
	^ self parent isNil! !

!CvBranch methodsFor: 'subbranches' stamp: 'TM 5/12/2011 14:49:24.884'!
isTailBranch

	^ self subbranches isEmpty! !

!CvBranch methodsFor: 'hide / show' stamp: 'bs 5/4/2011 19:41:52.824'!
isVisible
	^ isVisible! !

!CvBranch methodsFor: 'accessing' stamp: 'bs 4/24/2011 17:16:03.446'!
items
	^ items ifNil: [items := OrderedCollection new]! !

!CvBranch methodsFor: 'accessing' stamp: 'bs 4/25/2011 20:25:49.517'!
laneNumber
	^ laneNumber! !

!CvBranch methodsFor: 'accessing' stamp: 'bs 4/25/2011 20:25:49.532'!
laneNumber: anObject
	laneNumber := anObject! !

!CvBranch methodsFor: 'accessing' stamp: 'bs 4/27/2011 21:38:39.099'!
lastItem
	^ self items last! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 5/4/2011 16:02:32.739'!
lowerLane
	laneNumber := laneNumber - 1.
	self subbranches do: [:ea | ea lowerLane]! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 4/28/2011 17:02:17.551'!
lowerLanesAbove: subbranch
	(self subbranches copyAfter: subbranch) do: [:ea | ea lowerLane].
	self lowerLanesAboveMe.! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 4/28/2011 17:02:04.448'!
lowerLanesAboveMe
			
	self parent ifNotNil: [self parent lowerLanesAbove: self].! !

!CvBranch methodsFor: 'node selection' stamp: 'bs 4/27/2011 21:26:26.365'!
nodeBefore: aVersionNode
	| versionItem |
	versionItem := self items detect: [:ea | ea versionNode = aVersionNode].
	^ (self items before: versionItem ifAbsent: [self parent items last]) versionNode! !

!CvBranch methodsFor: 'node selection' stamp: 'bs 4/27/2011 13:37:08.886'!
nodes
	^ self items collect: [:ea | ea versionNode]! !

!CvBranch methodsFor: 'accessing' stamp: 'bs 4/27/2011 21:26:58.66'!
parent
	^ parent! !

!CvBranch methodsFor: 'accessing' stamp: 'bs 4/27/2011 21:26:58.652'!
parent: anObject
	parent := anObject! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 4/28/2011 16:26:50.843'!
raiseLane
	laneNumber := laneNumber + 1! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 4/29/2011 17:32:49.397'!
raiseLanesAbove: subbranch
	(self subbranches copyAfter: subbranch) do: [:ea | ea raiseLane].
	self parent ifNotNil: [:p | p raiseLanesAbove: self].! !

!CvBranch methodsFor: 'accessing' stamp: 'TM 5/6/2011 13:10:03.312'!
releaseItem: aVersionItem

	self removeItem: aVersionItem.
	view hideItem: aVersionItem! !

!CvBranch methodsFor: 'accessing' stamp: 'bs 4/24/2011 18:32:24.635'!
removeItem: aVersionItem
	self items remove: aVersionItem! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'bs 4/29/2011 15:23:24.608'!
removeLaneSpace
	self isLaneAboveParentLane ifTrue: [
		view submorphs do: [:ea | ea removeLane: self laneNumber]].
	self lowerLanesAboveMe.! !

!CvBranch methodsFor: 'accessing' stamp: 'TM 5/12/2011 16:40:59.634'!
replaceItem: anItem byGroup: aGroupItem

	aGroupItem branch: self.
	self addItem: aGroupItem before: anItem.
	
	aGroupItem appendVersionItem: anItem.
	
	self isVisible ifTrue: [
		aGroupItem buildLanes.
		aGroupItem showItemAt: self laneNumber.
		view addMorph: aGroupItem inFrontOf: anItem ].
				
	^ aGroupItem! !

!CvBranch methodsFor: 'accessing' stamp: 'TM 5/12/2011 16:27:58.16'!
replaceItemByGroup: anItem

	^ self replaceItem: anItem byGroup: CvChronoGroupItem new! !

!CvBranch methodsFor: 'accessing' stamp: 'bs 5/6/2011 08:41:03.808'!
rootBranch

	^ self isRoot
		ifTrue: [self]
		ifFalse: [self parent rootBranch]! !

!CvBranch methodsFor: 'node selection' stamp: 'bs 4/27/2011 13:48:57.347'!
selectedNodes
	^ self items 
		collect: [:ea | ea versionNode]
		thenSelect: [:ea | ea isSelected]! !

!CvBranch methodsFor: 'hide / show' stamp: 'bs 10/1/2012 16:42:46.266'!
show
	isVisible ifTrue: [^ self].
	
	self parent ifNotNil: [:p | p addSpaceForSubbranch: self].
	
	self parent ifNotNil: [:p | p subbranchesBeginItem 
		at: self laneNumber putPoint: self createStartPoint].
	
	branchEndItem ifNotNil: [:item | 
		item buildLanes.
		item at: self laneNumber putPoint: self createEndPoint.
		view showItem: item].
			
	self items do: [:ea |
		ea buildLanes.
		ea showItemAt: self laneNumber.
		view showItem: ea].
	
	isVisible := true.! !

!CvBranch methodsFor: 'hide / show' stamp: 'bs 5/5/2011 09:06:15.102'!
showAllBranchesOfPath
	self parent ifNotNil: [:p | p showAllBranchesOfPath].
	self show.! !

!CvBranch methodsFor: 'hide / show' stamp: 'bs 5/4/2011 19:42:25.504'!
showSubbranches
		
	self subbranches reject: [:ea | ea isVisible] thenDo: [:ea | ea show]! !

!CvBranch methodsFor: 'accessing' stamp: 'bs 5/4/2011 19:40:08.023'!
siblings
	^ self parent subbranches copyWithout: self! !

!CvBranch methodsFor: 'subbranches - split' stamp: 'bs 5/5/2011 11:48:21.266'!
splitAfter: anItem
	| newTail subbranchesToCopy |
	subbranchesToCopy := self subbranches copy.
	self subbranches removeAll.
	
	newTail := CvBranch new.
	newTail parent: self.
	self subbranches add: newTail.
	subbranchesToCopy do: [:ea | 
		ea parent: newTail.
		newTail subbranches add: ea].
		    
	 (self items copyAfter: anItem) do: [:ea | 
		self removeItem: ea.
		newTail addItem: ea.
		ea versionNode branch: newTail].

	self copyInstVarsNamed: {#subbranchesBeginItem. #branchEndItem} to: newTail.
	self copyInstVarsNamed: {#laneNumber. #isVisible. #view} to: newTail.
	
	self createEndAndSubbranchStartItems.
	^ self! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'TM 5/6/2011 15:06:56.036'!
subbranchOf: aVersion
	self withAllSubbranchesDo: [:branch | 
		(branch versionItems anySatisfy: [:item | item version = aVersion]) 
			ifTrue: [^ branch]].! !

!CvBranch methodsFor: 'accessing' stamp: 'bs 4/24/2011 17:22:54.88'!
subbranches
	^ subbranches ifNil: [subbranches := OrderedCollection new]! !

!CvBranch methodsFor: 'subbranches' stamp: 'bs 4/29/2011 11:03:01.523'!
subbranchesBeginItem
	^ subbranchesBeginItem! !

!CvBranch methodsFor: 'subbranches - split' stamp: 'bs 4/29/2011 11:03:01.541'!
subbranchesBeginItem: anObject
	subbranchesBeginItem := anObject! !

!CvBranch methodsFor: 'grouping' stamp: 'bs 5/18/2011 20:32:45.58'!
tryGrouping
	| itemGroups |
	itemGroups := self groupsOfLinkedItems.
	itemGroups allButLast do: [:ea | self group: ea].
	
	itemGroups last size > 10 
		ifTrue: [self group: (itemGroups last allButLast: 5)]! !

!CvBranch methodsFor: 'as yet unclassified' stamp: 'TM 5/12/2011 17:38:49.036'!
versionItems
|versionItems|

	versionItems := self items select: [ :item | item isVersion ].
	"(self items select: [ :item | item isGroup]) do: [ :group | versionItems addAll: group versionItems]."
	
	^ versionItems! !

!CvBranch methodsFor: 'accessing' stamp: 'bs 4/29/2011 11:48:42.849'!
view
	^ view! !

!CvBranch methodsFor: 'accessing' stamp: 'bs 5/5/2011 09:01:39.492'!
visibleSiblings
	^ self parent 
		ifNil: [Array new]
		ifNotNil: [:p | (p subbranches copyWithout: self) select: [:ea | ea isVisible]].! !

!CvBranch methodsFor: 'grouping' stamp: 'bs 5/9/2011 23:37:05.407'!
visibleUngroupedItems

	^ self items 
		select: [:ea | ea isVisible and: [ea isKindOf: CvChronoVersionItem]]! !

!CvBranch methodsFor: 'subbranches' stamp: 'pt 1/10/2013 17:24:46.796'!
withAllParents
	| all |
	all := OrderedCollection new.
	self withAllParentsDo: [:ea | all add: ea].
	^ all! !

!CvBranch methodsFor: 'subbranches' stamp: 'pt 1/10/2013 17:26:59.468'!
withAllParentsDo: aBlock
	aBlock value: self.
	parent ifNotNil: [ parent withAllParentsDo: aBlock ].! !

!CvBranch methodsFor: 'subbranches' stamp: 'bs 5/4/2011 20:31:09.492'!
withAllSubbranches
	| all |
	all := OrderedCollection new.
	self withAllSubbranchesDo: [:ea | all add: ea].
	^ all! !

!CvBranch methodsFor: 'subbranches' stamp: 'bs 4/27/2011 13:52:45.475'!
withAllSubbranchesDo: aBlock
	aBlock value: self.
	self subbranches do: [:ea | ea withAllSubbranchesDo: aBlock].! !

!CvBranch methodsFor: 'derived accessing' stamp: 'bs 8/1/2012 13:31:47.319'!
workingCopies

	^ self view workingCopies! !

Object subclass: #CvBrowserRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

Object subclass: #CvBrowserTreeModel
	instanceVariableNames: 'controller versionsWithoutTestResult root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

!CvBrowserTreeModel class methodsFor: 'as yet unclassified' stamp: 'bs 8/12/2011 17:59:15.664'!
controller: aCvController

	^ self basicNew initializeWithController: aCvController! !

!CvBrowserTreeModel methodsFor: 'accessing' stamp: 'bs 8/12/2011 17:59:15.107'!
controller
	^ controller! !

!CvBrowserTreeModel methodsFor: 'accessing' stamp: 'bs 8/12/2011 17:59:15.15'!
controller: anObject
	controller := anObject! !

!CvBrowserTreeModel methodsFor: 'tree' stamp: 'bs 8/12/2011 17:59:15.192'!
detectIndex: aBlock parent: aModelIndex
	| index |
	
	((self rowCountFor: aModelIndex) to: 1 by: -1) do: [:row | 
		index := self indexRow: row column: 1 parent: aModelIndex.
		(aBlock value: index) ifTrue: [^ index].
		(self hasChildrenFor: index) ifTrue: [
			(self detectIndex: aBlock parent: index) ifNotNil: [:target | ^ target]]].
	^ nil.! !

!CvBrowserTreeModel methodsFor: 'tree' stamp: 'bs 8/12/2011 17:59:15.299'!
indexOfGroup: aVersionGroup

	self root = aVersionGroup ifTrue: [^ nil].
	
	^ self 
		detectIndex: [:anIndex | (anIndex valueOfProperty: #versionOrGroup) = aVersionGroup]
		parent: nil.! !

!CvBrowserTreeModel methodsFor: 'tree' stamp: 'bs 8/12/2011 17:59:15.341'!
indexOfParentOf: aVersionOrGroup
	
	^ self 
		detectIndex: [:anIndex |
			| current |
			current := anIndex valueOfProperty: #versionOrGroup.
			current isVersionGroup and: [current hasChild: aVersionOrGroup]] 
		parent: nil.! !

!CvBrowserTreeModel methodsFor: 'tree' stamp: 'bs 8/12/2011 17:59:15.384'!
indexOfVersion: aVersion
	
	^ self 
		detectIndex: [:anIndex | (anIndex valueOfProperty: #versionOrGroup) = aVersion]
		parent: nil.! !

!CvBrowserTreeModel methodsFor: 'initialize-release' stamp: 'bs 7/18/2012 17:34:52.07'!
initializeWithController: aCvController
	self initialize.
	root := CvRootGroup new.
	
	self controller: aCvController.
	self controller versionsChronologically do: [:ea | self insert: ea].
	self 
		connect: self controller 
		signal: #versionSaved:
		toSelector: #insert:.
	! !

!CvBrowserTreeModel methodsFor: 'tree' stamp: 'bs 2/3/2012 17:11:42.709'!
insert: aVersion
	
	self root insert: aVersion.! !

!CvBrowserTreeModel methodsFor: 'as yet unclassified' stamp: 'bs 1/12/2012 11:56:54.493'!
menuFor: aModelIndex
	| aVersionOrGroup aVersion |
	aModelIndex row = 0 
		ifTrue: [^ super menuFor: aModelIndex].
	
	aVersionOrGroup := aModelIndex valueOfProperty: #versionOrGroup.
	aVersionOrGroup isVersionGroup 
		ifTrue: [^ super menuFor: aModelIndex].
	aVersion := aVersionOrGroup.
	
	^ CvVersionMenu version: aVersion! !

!CvBrowserTreeModel methodsFor: 'initialize-release' stamp: 'bs 8/17/2011 17:20:09.62'!
release

	super release.
	controller disconnectSignal: #versionSaved: from: self.
	controller := nil! !

!CvBrowserTreeModel methodsFor: 'tree' stamp: 'bs 8/16/2011 17:31:45.725'!
root

	^ root! !

!CvBrowserTreeModel methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2012 13:31:47.312'!
workingCopy

	^ self controller workingCopies first! !

Object subclass: #CvCheckedVersionRangesCollector
	instanceVariableNames: 'ranges currentRange currentVersion versions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI'!

!CvCheckedVersionRangesCollector methodsFor: 'as yet unclassified' stamp: 'bs 2/4/2012 17:20:18.877'!
collect

	versions do: [:ea | 
		ea predecessor ~= currentVersion
			ifTrue: [self emptyCurrentRange].
		currentVersion := ea.
		self processCurrent].
	
	self emptyCurrentRange.
	^ ranges.! !

!CvCheckedVersionRangesCollector methodsFor: 'as yet unclassified' stamp: 'bs 2/4/2012 16:59:09.088'!
emptyCurrentRange

	currentRange ifNotEmpty: [
		ranges add: currentRange copy. 
		currentRange removeAll]! !

!CvCheckedVersionRangesCollector methodsFor: 'as yet unclassified' stamp: 'bs 2/4/2012 16:50:25.603'!
initialize

	ranges := OrderedCollection new.
	currentRange := OrderedCollection new.! !

!CvCheckedVersionRangesCollector methodsFor: 'as yet unclassified' stamp: 'bs 2/4/2012 16:59:26.151'!
processCurrent

	currentVersion isChecked 
		ifTrue: [currentRange add: currentVersion]
		ifFalse: [self emptyCurrentRange]! !

!CvCheckedVersionRangesCollector methodsFor: 'as yet unclassified' stamp: 'bs 2/4/2012 17:14:13.832'!
setVersions: versionCollection

	versions := versionCollection.! !

Object subclass: #CvCodeReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-Refs'!

CvCodeReference subclass: #CvClassCategoryReference
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-Refs'!

!CvClassCategoryReference class methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 17:05:04.024'!
name: aName

	^ self new
		name: aName;
		yourself! !

!CvClassCategoryReference methodsFor: 'converting' stamp: 'bs 8/24/2012 13:52:58.556'!
asOBNode

	^ OBClassCategoryNode on: self name! !

!CvClassCategoryReference methodsFor: 'accessing' stamp: 'bs 8/16/2011 18:00:14.267'!
classCategory

	^ self category! !

!CvClassCategoryReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 16:32:35.926'!
depth 
	
	^ 1! !

!CvClassCategoryReference methodsFor: 'as yet unclassified' stamp: 'bs 8/2/2011 13:44:31.492'!
entityName

	^ self name asText addAttribute: TextEmphasis italic  ! !

!CvClassCategoryReference methodsFor: 'comparing' stamp: 'bs 1/19/2012 10:42:40.981'!
hash
	
	^ super hash bitXor: self name hash! !

!CvClassCategoryReference methodsFor: 'testing' stamp: 'bs 8/15/2011 15:25:22.972'!
isCvClassCategoryReference

	^ true! !

!CvClassCategoryReference methodsFor: 'testing' stamp: 'bs 8/23/2012 17:46:47.608'!
isValidInActiveCodeBase

	^ self activeCodeBase organization categories includes: self name! !

!CvClassCategoryReference methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 17:48:29.131'!
matches: aCodeReference

	^ aCodeReference representsClassCategory: self! !

!CvClassCategoryReference methodsFor: 'accessing' stamp: 'bs 6/16/2011 17:04:37.415'!
name
	^ name! !

!CvClassCategoryReference methodsFor: 'accessing' stamp: 'bs 6/16/2011 17:04:33.428'!
name: anObject
	name := anObject! !

!CvClassCategoryReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 16:41:59.613'!
parent

	^ self class root! !

!CvClassCategoryReference methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 17:47:10.998'!
representsClass: aClassReference

	^ self name = aClassReference category! !

!CvClassCategoryReference methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 17:49:15.929'!
representsClassCategory: aClassCategoryReference

	^ self name = aClassCategoryReference name! !

!CvClassCategoryReference methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 17:59:44.525'!
representsMethod: aMethodReference

	^ self name = aMethodReference classCategory! !

!CvClassCategoryReference methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 15:27:10.848'!
representsMethodCategory: aMethodCategoryReference

	^ self name = aMethodCategoryReference classCategory! !

CvCodeReference subclass: #CvClassReference
	instanceVariableNames: 'name category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-Refs'!

!CvClassReference class methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2011 14:42:31.603'!
class: aClass

	^ self class: aClass category: aClass category! !

!CvClassReference class methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2011 14:41:00.015'!
class: aClass category: aClassCategoryName

	^ self new 
		name: aClass name;
		category: aClassCategoryName;
		yourself! !

!CvClassReference methodsFor: 'converting' stamp: 'bs 8/24/2012 13:54:10.344'!
asOBNode

	^ OBClassNode on: (self bind: self activeCodeBase)! !

!CvClassReference methodsFor: 'as yet unclassified' stamp: 'bs 8/2/2011 17:53:21.027'!
bind: aCodeBase

	^ (aCodeBase hasClassNamed: self name)
		ifTrue: [aCodeBase classNamed: self name]
		ifFalse: [nil]! !

!CvClassReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:08:10.912'!
category
	^ category! !

!CvClassReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:08:10.92'!
category: anObject
	category := anObject! !

!CvClassReference methodsFor: 'accessing' stamp: 'bs 8/16/2011 16:34:12.51'!
classCategory

	^ self category! !

!CvClassReference methodsFor: 'accessing' stamp: 'bs 8/16/2011 19:11:31.042'!
classReference

	^ self! !

!CvClassReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 16:32:30.894'!
depth 
	
	^ 2! !

!CvClassReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 18:57:52.339'!
entity

	^ self name! !

!CvClassReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 18:58:57.571'!
entityName

	^ self name! !

!CvClassReference methodsFor: 'comparing' stamp: 'bs 1/19/2012 10:50:32.398'!
hash
	
	^ (super hash bitXor: self name hash) bitXor: self category hash! !

!CvClassReference methodsFor: 'testing' stamp: 'bs 1/18/2012 15:59:25.323'!
isCvClassReference

	^ true! !

!CvClassReference methodsFor: 'as yet unclassified' stamp: 'bs 8/2/2011 15:00:19.649'!
isSameBetween: codeBase1 and: codeBase2

	^ (self bind: codeBase1) = (self bind: codeBase2)! !

!CvClassReference methodsFor: 'testing' stamp: 'bs 8/23/2012 17:40:45.066'!
isValidInActiveCodeBase

	^ self activeCodeBase hasClassNamed: self name! !

!CvClassReference methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 16:02:52.962'!
matches: aCodeReference

	^ aCodeReference representsClass: self! !

!CvClassReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:06:43.535'!
name

	^ name! !

!CvClassReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:05:55.788'!
name: aString

	name := aString! !

!CvClassReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 16:42:34.796'!
parent

	^ self class classCategory: self category! !

!CvClassReference methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 17:47:10.986'!
representsClass: aClassReference

	^ self name = aClassReference name! !

!CvClassReference methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 17:57:10.309'!
representsMethod: aMethodReference

	^ self name = aMethodReference className! !

!CvClassReference methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 15:26:30.796'!
representsMethodCategory: aMethodCategoryReference

	^ self name = aMethodCategoryReference className! !

!CvCodeReference class methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 16:12:09.948'!
class: aClass
 
	^ aClass isMeta
		ifTrue: [CvMetaClassReference metaClass: aClass]
		ifFalse: [CvClassReference class: aClass]! !

!CvCodeReference class methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2011 14:41:31.868'!
class: aClass category: aClassCategoryName
	
	^ CvClassReference class: aClass category: aClassCategoryName! !

!CvCodeReference class methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 17:05:16.136'!
classCategory: aName

	^ CvClassCategoryReference name: aName! !

!CvCodeReference class methodsFor: 'as yet unclassified' stamp: 'bs 8/30/2012 11:42:04.533'!
detectMethodCategory: aCompiledMethod

	^ self 
		detectSelectorCategory: aCompiledMethod selector
		inClass: aCompiledMethod methodClass.! !

!CvCodeReference class methodsFor: 'as yet unclassified' stamp: 'bs 8/30/2012 11:41:25.486'!
detectSelectorCategory: aSelector inClass: methodClass
	 
	^ (methodClass organization categoryOfElement: aSelector)
		ifNil: ['CV: category informaiton not available']! !

!CvCodeReference class methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 19:52:25.305'!
fuzzySearch: aString

	^ CvFuzzyReference searchText: aString! !

!CvCodeReference class methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 16:01:30.14'!
metaClass: aClass
	^ CvMetaClassReference metaClass: aClass! !

!CvCodeReference class methodsFor: 'as yet unclassified' stamp: 'bs 8/2/2011 13:51:31.943'!
method: aCompiledMethod

	^ self 
		method: aCompiledMethod 
		category: (self detectMethodCategory: aCompiledMethod)! !

!CvCodeReference class methodsFor: 'as yet unclassified' stamp: 'bs 8/2/2011 13:52:42.525'!
method: aCompiledMethod category: aCategorySymbolOrNil
	| aCategorySymbol | 
	aCategorySymbol := aCategorySymbolOrNil 
		ifNil: [self detectMethodCategory: aCompiledMethod].
	^ CvMethodReference method: aCompiledMethod category: aCategorySymbol! !

!CvCodeReference class methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2011 14:39:03.336'!
methodCategory: aName class: aClass 
	^ self methodCategory: aName classReference: (self class: aClass)! !

!CvCodeReference class methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2011 14:38:07.158'!
methodCategory: aName classReference: aClassReference
	^ CvMethodCategoryReference methodCategory: aName classReference: aClassReference! !

!CvCodeReference class methodsFor: 'as yet unclassified' stamp: 'FB 12/21/2012 15:10:11.202'!
nullReference
	
	^ CvNullReference new! !

!CvCodeReference class methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 15:26:20.244'!
root
	
	^ CvRootReference new! !

!CvCodeReference class methodsFor: 'as yet unclassified' stamp: 'bs 8/30/2012 11:42:33.849'!
selector: aSelectorSymbol category: aCategorySymbolOrNil class: methodClass
	| aCategorySymbol | 
	aCategorySymbol := aCategorySymbolOrNil 
		ifNil: [self detectSelectorCategory: aSelectorSymbol inClass: methodClass].
	
	^ CvMethodReference 
		selector: aSelectorSymbol 
		category: aCategorySymbol
		class: methodClass! !

!CvCodeReference methodsFor: 'comparing' stamp: 'bs 8/1/2011 17:46:45.529'!
= anObject

	self == anObject ifTrue: [^ true].
	
	^ (self class name = anObject class name)
	  	and: [self matches: anObject]! !

!CvCodeReference methodsFor: 'converting' stamp: 'bs 8/24/2012 13:52:27.563'!
asOBNode

	^ OBSystemBrowser defaultRootNode! !

!CvCodeReference methodsFor: 'accessing' stamp: 'bs 8/16/2011 16:34:39.012'!
classCategory

	^ nil! !

!CvCodeReference methodsFor: 'accessing' stamp: 'bs 8/16/2011 19:10:28.518'!
classCategoryReference
	
	^ self classCategory ifNotNil: [:aName | self class classCategory: aName]! !

!CvCodeReference methodsFor: 'accessing' stamp: 'bs 8/16/2011 19:11:01.033'!
classReference
	
	^ nil! !

!CvCodeReference methodsFor: 'as yet unclassified' stamp: 'bs 8/2/2011 13:21:43.782'!
commonParentWith: aCodeReference

	^ self depth <= aCodeReference depth
		ifTrue: [self findParentThatMatches: aCodeReference]
		ifFalse: [aCodeReference findParentThatMatches: self]! !

!CvCodeReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 16:28:15.488'!
depth

	^ self subclassResponsibility! !

!CvCodeReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 18:57:12.034'!
entityName

	^ self subclassResponsibility! !

!CvCodeReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 16:43:01.359'!
findParentThatMatches: aCodeReference

	^ (aCodeReference matches: self)
		ifTrue: [self]
		ifFalse: [self parent findParentThatMatches: aCodeReference]! !

!CvCodeReference methodsFor: 'comparing' stamp: 'bs 1/19/2012 10:41:27.659'!
hash
	"Hash is reimplemented because = is implemented."
	
	^ self species hash! !

!CvCodeReference methodsFor: 'testing' stamp: 'bs 8/15/2011 15:25:14.974'!
isCvClassCategoryReference

	^ false! !

!CvCodeReference methodsFor: 'testing' stamp: 'bs 1/18/2012 15:59:00.468'!
isCvClassReference

	^ false! !

!CvCodeReference methodsFor: 'testing' stamp: 'bs 8/17/2011 10:48:09.104'!
isCvMethodReference

	^ false! !

!CvCodeReference methodsFor: 'as yet unclassified' stamp: 'bs 8/2/2011 15:00:41.94'!
isSameBetween: codeBase1 and: codeBase2

	^ false! !

!CvCodeReference methodsFor: 'testing' stamp: 'bs 8/23/2012 17:37:54.175'!
isValidInActiveCodeBase

	self subclassResponsibility! !

!CvCodeReference methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 16:56:35.992'!
matches: aCodeReference

	^ false! !

!CvCodeReference methodsFor: 'as yet unclassified' stamp: 'bs 7/29/2011 16:25:39.124'!
matchesAny: codeReferences

	^ codeReferences anySatisfy: [:ea | self matches: ea]! !

!CvCodeReference methodsFor: 'accessing' stamp: 'bs 8/16/2011 19:15:37.679'!
methodReference

	^ nil! !

!CvCodeReference methodsFor: 'printing' stamp: 'bs 5/12/2012 12:31:29.15'!
printOn: aStream

	aStream nextPutAll: self entityName asString! !

!CvCodeReference methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 17:47:10.994'!
representsClass: aClassReference

	^ false! !

!CvCodeReference methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 17:48:49.057'!
representsClassCategory: aClassCategoryReference
	
	^ false! !

!CvCodeReference methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 16:05:44.733'!
representsMetaClass: aMetaClassReference

	^ self representsClass: aMetaClassReference theNonMetaClassReference! !

!CvCodeReference methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 17:52:54.402'!
representsMethod: aMethodReference

	^ false! !

!CvCodeReference methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 18:13:12.129'!
representsMethodCategory: aMethodCategoryReference

	^ false! !

CvCodeReference subclass: #CvFuzzyReference
	instanceVariableNames: 'searchText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-Refs'!

!CvFuzzyReference class methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 19:52:48.498'!
searchText: aString

	^ self new
		searchText: aString;
		yourself! !

!CvFuzzyReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 18:58:36.557'!
entityName

	^ 'fuzzy search: ', self searchText! !

!CvFuzzyReference methodsFor: 'comparing' stamp: 'bs 1/19/2012 10:44:32.128'!
hash
	
	^ super hash bitXor: self searchText hash! !

!CvFuzzyReference methodsFor: 'testing' stamp: 'bs 8/24/2012 13:50:05.821'!
isValidInActiveCodeBase

	^ true! !

!CvFuzzyReference methodsFor: 'as yet unclassified' stamp: 'bs 6/17/2011 11:02:03.418'!
matchesText: aString

	^ aString includesSubstring: aString caseSensitive: false! !

!CvFuzzyReference methodsFor: 'as yet unclassified' stamp: 'bs 6/17/2011 10:57:53.632'!
representsClass: aClassReference

	^ {	aClassReference name.
		aClassReference category }
			anySatisfy: [:ea | self matchesText: ea]! !

!CvFuzzyReference methodsFor: 'as yet unclassified' stamp: 'bs 6/17/2011 10:58:27.882'!
representsClassCategory: aClassCategoryReference

	^ {	aClassCategoryReference name }
			anySatisfy: [:ea | self matchesText: ea]! !

!CvFuzzyReference methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 15:24:05.546'!
representsMethod: aMethodReference

	^ {	aMethodReference selector.
		aMethodReference className.
		aMethodReference category.
		aMethodReference classCategory }
			anySatisfy: [:ea | self matchesText: ea]! !

!CvFuzzyReference methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 15:19:31.832'!
representsMethodCategory: aMethodCategoryReference

	^ {	aMethodCategoryReference categoryName.
		aMethodCategoryReference className. 
		aMethodCategoryReference classCategory }
			anySatisfy: [:ea | self matchesText: ea]! !

!CvFuzzyReference methodsFor: 'accessing' stamp: 'bs 6/16/2011 19:51:53.994'!
searchText
	^ searchText! !

!CvFuzzyReference methodsFor: 'accessing' stamp: 'bs 6/16/2011 19:51:54.002'!
searchText: anObject
	searchText := anObject! !

CvCodeReference subclass: #CvMetaClassReference
	instanceVariableNames: 'theNonMetaClassReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-Refs'!

!CvMetaClassReference class methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 15:57:23.789'!
metaClass: aMetaClass
	
	^ self new
		theNonMetaClassReference: (self class: aMetaClass theNonMetaClass)! !

!CvMetaClassReference methodsFor: 'converting' stamp: 'bs 8/24/2012 13:56:51.977'!
asOBNode

	^ OBMetaclassNode on: (self theNonMetaClassReference bind: self activeCodeBase)! !

!CvMetaClassReference methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2011 14:17:34.11'!
bind: aCodeBase

	^ (self theNonMetaClassReference bind: aCodeBase) theMetaClass! !

!CvMetaClassReference methodsFor: 'accessing' stamp: 'bs 7/25/2011 16:55:06.547'!
category

	^ self theNonMetaClassReference category! !

!CvMetaClassReference methodsFor: 'accessing' stamp: 'bs 8/16/2011 17:58:47.795'!
classCategory

	^ self theNonMetaClassReference classCategory! !

!CvMetaClassReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 17:08:06.025'!
depth

	^ self parent depth + 1! !

!CvMetaClassReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 18:59:35.424'!
entityName

	^ self theNonMetaClassReference entityName, ' class'! !

!CvMetaClassReference methodsFor: 'comparing' stamp: 'bs 1/19/2012 10:45:09.102'!
hash
	
	^ super hash bitXor: self theNonMetaClassReference hash! !

!CvMetaClassReference methodsFor: 'testing' stamp: 'bs 8/23/2012 17:41:17.87'!
isValidInActiveCodeBase

	^ self theNonMetaClassReference isValidInActiveCodeBase! !

!CvMetaClassReference methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 16:03:03.68'!
matches: aCodeReference

	^ aCodeReference representsMetaClass: self.! !

!CvMetaClassReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 17:08:27.133'!
parent

	^ self theNonMetaClassReference! !

!CvMetaClassReference methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 16:06:13.926'!
representsMetaClass: aMetaClassReference

	^ self theNonMetaClassReference representsClass: 
			aMetaClassReference theNonMetaClassReference! !

!CvMetaClassReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:50:47.703'!
theNonMetaClassReference
	^ theNonMetaClassReference! !

!CvMetaClassReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:50:47.711'!
theNonMetaClassReference: anObject
	theNonMetaClassReference := anObject! !

CvCodeReference subclass: #CvMethodCategoryReference
	instanceVariableNames: 'classReference category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-Refs'!

!CvMethodCategoryReference class methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2011 14:38:06.515'!
methodCategory: aName classReference: aClassReference
	aName ifNil: [self halt].
	^ self new
		classReference: aClassReference;
		category: aName;
		yourself! !

!CvMethodCategoryReference methodsFor: 'converting' stamp: 'bs 8/24/2012 13:58:33.757'!
asOBNode

	^ OBMethodCategoryNode
		on: self category 
		inClass: (self classReference bind: self activeCodeBase)! !

!CvMethodCategoryReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:18:19.674'!
category
	^ category! !

!CvMethodCategoryReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:18:29.318'!
category: anObject
	category := anObject! !

!CvMethodCategoryReference methodsFor: 'accessing' stamp: 'bs 8/16/2011 17:58:12.917'!
classCategory

	^ self classReference classCategory! !

!CvMethodCategoryReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:26:41.039'!
className

	^ self classReference name! !

!CvMethodCategoryReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:09:55.84'!
classReference
	^ classReference! !

!CvMethodCategoryReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:09:55.848'!
classReference: anObject
	classReference := anObject! !

!CvMethodCategoryReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 17:00:47.989'!
depth

	^ self parent depth + 1! !

!CvMethodCategoryReference methodsFor: 'as yet unclassified' stamp: 'bs 8/2/2011 14:26:43.962'!
entityName

	^ (self classReference entityName, ' / ', self category) 
		asText addAttribute: TextEmphasis italic! !

!CvMethodCategoryReference methodsFor: 'comparing' stamp: 'bs 1/19/2012 10:50:46.049'!
hash
	
	^ (super hash bitXor: self classReference hash) bitXor: self category hash! !

!CvMethodCategoryReference methodsFor: 'testing' stamp: 'bs 8/23/2012 17:44:24.944'!
isValidInActiveCodeBase

	^ self classReference isValidInActiveCodeBase
		and: [
			(self classReference bind: self activeCodeBase) 
				organization categories includes: self category]! !

!CvMethodCategoryReference methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 18:13:00.096'!
matches: aCodeReference

	^ aCodeReference representsMethodCategory: self.! !

!CvMethodCategoryReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 17:00:30.554'!
parent

	^ self classReference! !

!CvMethodCategoryReference methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 15:23:42.746'!
representsMethod: aMethodReference

	^ (self classReference representsClass: aMethodReference classReference)
		and: [self category = aMethodReference category]! !

!CvMethodCategoryReference methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 15:23:15.894'!
representsMethodCategory: aMethodCategoryReference

	^ (self classReference representsClass: aMethodCategoryReference classReference)
		and: [self category = aMethodCategoryReference category]! !

CvCodeReference subclass: #CvMethodReference
	instanceVariableNames: 'classReference selector category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-Refs'!

!CvMethodReference class methodsFor: 'as yet unclassified' stamp: 'bs 8/30/2012 11:35:55.06'!
method: aCompiledMethod category: categoryName

	^ self 
		selector: aCompiledMethod selector 
		category: categoryName 
		class: aCompiledMethod methodClass! !

!CvMethodReference class methodsFor: 'as yet unclassified' stamp: 'bs 8/30/2012 11:39:29.79'!
selector: aSelectorSymbol category: categoryName class: methodClass

	self assert: categoryName notNil.
	
	^ self new 
		classReference: (self class: methodClass);
		selector: aSelectorSymbol;
		category: categoryName;
		yourself! !

!CvMethodReference methodsFor: 'converting' stamp: 'bs 8/24/2012 13:58:54.09'!
asOBNode

	^ OBMethodNode
		on: self selector 
		inClass: (self classReference bind: self activeCodeBase)! !

!CvMethodReference methodsFor: 'as yet unclassified' stamp: 'bs 8/2/2011 17:54:19.492'!
bind: aCodeBase

	^ (self classReference bind: aCodeBase) 
		ifNotNil: [:aClass |
			aClass compiledMethodAt: self selector ifAbsent: [nil]]! !

!CvMethodReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:14:06.921'!
category
	^ category! !

!CvMethodReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:14:06.927'!
category: anObject
	category := anObject! !

!CvMethodReference methodsFor: 'accessing' stamp: 'bs 8/16/2011 17:58:21.665'!
classCategory

	^ self classReference classCategory! !

!CvMethodReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:22:24.185'!
className

	^ self classReference name! !

!CvMethodReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:13:43.841'!
classReference

	^ classReference! !

!CvMethodReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:13:33.135'!
classReference: anObject
	classReference := anObject! !

!CvMethodReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 16:50:47.839'!
depth

	^ self parent depth + 1! !

!CvMethodReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 19:04:14.431'!
entityName

	^ self classReference entityName, ' >> #', self selector! !

!CvMethodReference methodsFor: 'comparing' stamp: 'bs 1/19/2012 10:50:54.916'!
hash
	
	^ ((super hash 
		bitXor: self classReference hash) 
		bitXor: self category hash) 
		bitXor: self selector hash! !

!CvMethodReference methodsFor: 'testing' stamp: 'bs 8/17/2011 10:48:18.061'!
isCvMethodReference

	^ true! !

!CvMethodReference methodsFor: 'as yet unclassified' stamp: 'bs 8/2/2011 18:41:48.943'!
isSameBetween: codeBase1 and: codeBase2

	^ (self bind: codeBase1) == (self bind: codeBase2)! !

!CvMethodReference methodsFor: 'testing' stamp: 'bs 8/23/2012 17:43:19.972'!
isValidInActiveCodeBase

	^ self classReference isValidInActiveCodeBase
		and: [
			(self classReference bind: self activeCodeBase) 
				includesSelector: self selector]! !

!CvMethodReference methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 17:52:41.546'!
matches: aCodeReference

	^ aCodeReference representsMethod: self.! !

!CvMethodReference methodsFor: 'accessing' stamp: 'bs 6/16/2011 18:28:43.589'!
methodCategoryName

	^ self method methodClass organization categoryOfElement: self method selector
	! !

!CvMethodReference methodsFor: 'accessing' stamp: 'bs 8/16/2011 19:15:47.408'!
methodReference

	^ self! !

!CvMethodReference methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2011 14:38:07.198'!
parent
	^ self class methodCategory: self category classReference: self classReference! !

!CvMethodReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:22:49.468'!
qualifiedName

	^ self classReference name, ' >> #', self selector ! !

!CvMethodReference methodsFor: 'as yet unclassified' stamp: 'bs 7/29/2011 16:40:59.691'!
representsMethod: aMethodReference

	^ (self selector = aMethodReference selector) 
		and: [self className = aMethodReference className]! !

!CvMethodReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:13:59.762'!
selector

	^ selector! !

!CvMethodReference methodsFor: 'accessing' stamp: 'bs 7/13/2011 15:13:50.654'!
selector: anObject
	selector := anObject! !

CvCodeReference subclass: #CvNullReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-Refs'!

!CvNullReference methodsFor: 'as yet unclassified' stamp: 'lk 1/2/2013 15:29:20.364'!
bind: aCodeBase
	^ nil! !

!CvNullReference methodsFor: 'as yet unclassified' stamp: 'FB 12/21/2012 15:09:56.062'!
entityName
	^'(NULL)'! !

CvCodeReference subclass: #CvRootReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-Refs'!

!CvRootReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 16:02:43.839'!
commonParentWith: aCodeReference

	^ self! !

!CvRootReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 16:32:39.764'!
depth 
	
	^ 0! !

!CvRootReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 19:01:42.733'!
entityName

	^ 'root'! !

!CvRootReference methodsFor: 'testing' stamp: 'bs 8/24/2012 13:49:59.721'!
isValidInActiveCodeBase

	^ true! !

!CvRootReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 16:47:47.245'!
matches: aCodeReference

	^ self class name = aCodeReference class name! !

!CvRootReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 15:27:49.518'!
representsClass: aClassReference

	^ true! !

!CvRootReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 15:28:00.998'!
representsClassCategory: aClassCategoryReference

	^ true! !

!CvRootReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 15:28:07.072'!
representsMethod: aMethodReference

	^ true! !

!CvRootReference methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 15:28:13.771'!
representsMethodCategory: aMethodCategoryReference

	^ true! !

Object subclass: #CvCommit
	instanceVariableNames: 'versionNodes size dependencies versionsCE versionsMC workingCopyMC workingCopyCE hasBranchCreated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvCommit class methodsFor: 'instance creation' stamp: 'pt 1/21/2013 11:56:52.886'!
allVersionsExistInSameBranch: cvVersionNodes
	| branchChains longestChain |

	branchChains := cvVersionNodes collect: [:v |
		v branch withAllParents ].
	longestChain := branchChains detectMax: [:branch| branch size ].
	^ branchChains allSatisfy: [:chain | longestChain includesAllOf: chain ]
	! !

!CvCommit class methodsFor: 'instance creation' stamp: 'pt 1/24/2013 14:40:35.476'!
allVersionsOriginFromSamePackage: cvVersionNodes

	^ (cvVersionNodes collect: [ :v | v version mcPackageName ]) asSet size = 1
	! !

!CvCommit class methodsFor: 'instance creation' stamp: 'pt 1/24/2013 14:37:21.686'!
isApplicableFor: cvVersionNodes
	"Whether it is OK to create a Commit out of the given versions"

	^ cvVersionNodes notEmpty and:
		[ self allVersionsExistInSameBranch: cvVersionNodes. ] and:
		[ self allVersionsOriginFromSamePackage: cvVersionNodes. ] and:
		[ self noVersionIsAlreadyCommitted: cvVersionNodes. ].
! !

!CvCommit class methodsFor: 'instance creation' stamp: 'pt 1/24/2013 14:38:08.254'!
noVersionIsAlreadyCommitted: cvVersionNodes
	
	^ cvVersionNodes noneSatisfy: [:v | v version isCommittedToMC ]! !

!CvCommit class methodsFor: 'instance creation' stamp: 'sp 1/17/2013 13:09:17.353'!
tryCommit: cvVersionNodes
	self assert: (self isApplicableFor: cvVersionNodes).
	
	^ self new 
		versionNodes: cvVersionNodes;
		size: cvVersionNodes size;
		tryCommit.! !

!CvCommit methodsFor: 'committing' stamp: 'pt 1/11/2013 08:10:23.39'!
branchIsWithoutGap: versions startingAt: lastCommittedVersion
	"Returns true only if there is no gap between the given version. Starting from lastCommittedVersion."
	lastCommittedVersion ifNil: [ ^ false ].
	^ versions allSatisfy: [ :version |
		(versions includes: version predecessor) or: [
			version predecessor = lastCommittedVersion ]]
	! !

!CvCommit methodsFor: 'committing' stamp: 'sp 1/14/2013 08:42:43.731'!
cacheFileNames

	| version |
	version := self versionsInMC last. "TODO: or do this for all versions??"
	
		MCCacheRepository default cacheAllFileNamesDuring: [
			self repository cacheAllFileNamesDuring: [
				version allAvailableDependenciesDo: [ :dependency |
					(self repository includesVersionNamed: dependency info name)
						ifFalse: [self repository storeVersion: dependency]
				] ] ]! !

!CvCommit methodsFor: 'committing' stamp: 'sp 1/13/2013 21:57:25.202'!
checkForNewerVersionsIn: aMCWorkingCopy
	| newer |
	newer := aMCWorkingCopy possiblyNewerVersionsIn: self repository. "where to get repo?!!"
	^ newer isEmpty or: [
		self confirm: 'CAUTION!! These versions in the repository may be newer:', 
			String cr, (newer asString truncateWithElipsisTo: 150), String cr,
			'Do you really want to save this version?'].! !

!CvCommit methodsFor: 'testing' stamp: 'sp 1/24/2013 11:12:37.088'!
checkOriginalVersionsConsistency
	"TODO: do not check with accumulated changes, instead do prependApplyPatch with some cvFakeVersions and delete those afterwards"
		
	| currentVersion aggregatedPatch lastCommittedVersion hasErrors|
	currentVersion := self workingCopyInCE baseVersion.
	lastCommittedVersion := currentVersion lastCommittedVersion.
	aggregatedPatch := (self originalVersionsInCE last patchRelativeToBase: self originalVersionsInCE first predecessor).
	
	hasErrors := (self workingCopyInCE rebaseTo: lastCommittedVersion) pretendApplyPatch: aggregatedPatch.	
	self workingCopyInCE rebaseTo: currentVersion.
	
	^hasErrors


! !

!CvCommit methodsFor: 'committing' stamp: 'sp 1/14/2013 08:33:25.314'!
commitMCVersions

	Cursor wait showWhile: [
		self versionsInMC do: [ :mcVersion |
			self repository storeVersion: mcVersion.
		].
	].! !

!CvCommit methodsFor: 'accessing' stamp: 'pt 1/14/2013 18:51:59.009'!
commitNameFor: originalName index: aNumber
	| commitNumber baseName |
	commitNumber := originalName numericSuffix.
	baseName := originalName withoutTrailingDigits.
	^ baseName, (commitNumber + aNumber- 1)! !

!CvCommit methodsFor: 'committing' stamp: 'sp 1/23/2013 12:01:40.015'!
copyVersionsToNewBranchIfNeccessary
	
	| lastCommittedVersion  |	
	lastCommittedVersion := self workingCopyInCE baseVersion lastCommittedVersion.
	
	( self branchIsWithoutGap: self originalVersionsInCE startingAt: lastCommittedVersion ) 
		ifTrue: [ self versionsInCE addAll: self originalVersionsInCE. ]
		ifFalse: [ self versionsInCE addAll: (self copyVersionsToNewBranchSplittingAt: lastCommittedVersion). ].
		! !

!CvCommit methodsFor: 'committing' stamp: 'sp 1/23/2013 11:31:20.502'!
copyVersionsToNewBranchSplittingAt: lastCommittedVersion
	
	self hasBranchCreated: true.
	self workingCopyInCE rebaseTo: lastCommittedVersion.
	
	self originalVersionsInCE do: [ :version |
		self workingCopyInCE 
			silentlyApplyPatch: (version patchRelativeToBase: version predecessor).
	].
	^ (self workingCopyInCE baseVersion withAllPredecessorsUpTo: lastCommittedVersion) reverse
! !

!CvCommit methodsFor: 'committing' stamp: 'sp 1/27/2013 16:36:06.654'!
createMCVersionFor: cvVersion withName: versionName message: message to: aMCWorkingCopy
	"creates a MCVersion and loads it in Monticello. further links the cvVersion to the MCVersion"
	
	| info mcVersion |
	info := MCVersionInfo
		name: versionName
		id: UUID new
		message: message
		date: cvVersion versionInfo date
		time: cvVersion versionInfo time
		author: cvVersion versionInfo author
		ancestors: aMCWorkingCopy ancestors asArray
		stepChildren: aMCWorkingCopy ancestry stepChildren asArray. "what is this?"
	mcVersion := MCVersion
		package: aMCWorkingCopy package
		info: info
		snapshot: cvVersion snapshot
		dependencies: (self dependenciesFrom: aMCWorkingCopy).
			
	cvVersion versionInfo mcVersionInfo: info.
	cvVersion isCommittedToMC: true.
	aMCWorkingCopy loaded: mcVersion.
	self versionsInMC add: mcVersion.! !

!CvCommit methodsFor: 'committing' stamp: 'sp 1/14/2013 12:41:41.479'!
dependenciesFrom: aMCWorkingCopy

	dependencies ifNotNil: [^dependencies].
	
	^dependencies := aMCWorkingCopy requiredPackages collect:
		[:package | 
		MCVersionDependency
			package: package
			info: package workingCopy currentVersionInfo].! !

!CvCommit methodsFor: 'testing' stamp: 'sp 1/22/2013 15:13:44.98'!
hasBranchCreated
	^hasBranchCreated! !

!CvCommit methodsFor: 'testing' stamp: 'sp 1/22/2013 15:13:27.721'!
hasBranchCreated: aBoolean
	hasBranchCreated:= aBoolean.! !

!CvCommit methodsFor: 'committing' stamp: 'sp 1/23/2013 11:34:32.707'!
ifTestsPassOrUserConfirmsDo: commitBlock

	(self versionsInCE last testResult hasPassed or:
		[ self confirm: 'The tests of the last version to be committed failed.', Character cr, 'Do you want to commit anyways?' ])
		ifTrue: [ commitBlock value ].! !

!CvCommit methodsFor: 'initialization' stamp: 'sp 1/23/2013 08:14:32.742'!
initialize

	versionsCE := OrderedCollection new.
	versionsMC := OrderedCollection new.
	
	workingCopyCE := self activeCodeBase.! !

!CvCommit methodsFor: 'accessing' stamp: 'sp 1/13/2013 20:48:57.013'!
msgAppendixFor: aNumber

	^ Character cr asString, Character cr, 'CoExist ', aNumber, '/', self size.! !

!CvCommit methodsFor: 'accessing' stamp: 'sp 1/16/2013 11:45:57.172'!
originalVersionsInCE
	^ versionNodes collect: [:node | node version ]! !

!CvCommit methodsFor: 'accessing' stamp: 'pt 1/28/2013 17:41:39.97'!
package

	^MCPackage named: (self versionNodes last version mcPackageName subStrings: '-') first! !

!CvCommit methodsFor: 'committing' stamp: 'sp 1/23/2013 08:28:12.201'!
prepareAndCommitVersionsOn: aMCWorkingCopy
	"commit each single CE version to MC (with specified commit msg + appendix)"
	
	(self promtForCommitMessageFor: aMCWorkingCopy) ifNotNil: [:pair |
		self versionsInCE withIndexDo: [:cvVersion :index |
			self createMCVersionFor: cvVersion
				withName: (self commitNameFor: pair first index: index)
				message: ((pair last), (self msgAppendixFor: index))
				to: aMCWorkingCopy.
		].
		self originalVersionsInCE do: [:cvVersion |
			cvVersion isCommittedToMC: true.
		].
		self commitMCVersions.
		self cacheFileNames.
	].! !

!CvCommit methodsFor: 'committing' stamp: 'sp 1/16/2013 10:16:23.29'!
promtForCommitMessageFor: aMCWorkingCopy
	"returns a pair that contains first a version name and second a commit message"

	| pair |
	pair := aMCWorkingCopy 
		requestVersionNameAndMessageWithSuggestion: aMCWorkingCopy 
		uniqueVersionName initialMessage: aMCWorkingCopy patchMessageSuggestion.
	pair ifNil: [^pair].
	
	pair atLast: 1 put: (aMCWorkingCopy patchMessageStripped: pair last).
	^pair! !

!CvCommit methodsFor: 'accessing' stamp: 'sp 1/23/2013 08:11:28.216'!
repository
	"we assume that there is only one repository used during all the lifecycle of CE"

	^self versionNodes last version package repository! !

!CvCommit methodsFor: 'committing' stamp: 'sp 1/24/2013 11:06:51.503'!
rollback

	self originalVersionsInCE do: [:version |
		version isCommittedToMC: false ].
	
	self hasBranchCreated ifFalse: [^self].
	
	self versionsInCE do: [:version |
		version isCommittedToMC: false ].

! !

!CvCommit methodsFor: 'accessing' stamp: 'sp 1/3/2013 16:31:56.122'!
size
	^size! !

!CvCommit methodsFor: 'accessing' stamp: 'sp 1/14/2013 08:35:30.029'!
size: aNumber
	size := aNumber! !

!CvCommit methodsFor: 'committing' stamp: 'sp 1/24/2013 16:09:08.996'!
tryCommit
	| aMCWorkingCopy commitProcess |
	(aMCWorkingCopy := self workingCopyInMC) ifNil: [ ^self ].
	"self checkOriginalVersionsConsistency ifFalse: [ ^self ]."
	self copyVersionsToNewBranchIfNeccessary.
	self versionsInCE ifEmpty: [ self inform: 'No changes to commit'. ^self ].
	
	commitProcess := [
		self waitForPendingTests.
		self ifTestsPassOrUserConfirmsDo: [ self prepareAndCommitVersionsOn: aMCWorkingCopy ]].
	commitProcess forkAt: Processor userBackgroundPriority.! !

!CvCommit methodsFor: 'accessing' stamp: 'pt 1/14/2013 12:00:37.712'!
versionNodes
	^ versionNodes! !

!CvCommit methodsFor: 'accessing' stamp: 'sp 1/22/2013 17:27:21.712'!
versionNodes: cvVersionNodes
	versionNodes := cvVersionNodes sortBy: [:a :b | 
		(a version timeStamp) < (b version timeStamp) ]. "TODO: use date and time, cause nanoseconds will not be set for timestamps"! !

!CvCommit methodsFor: 'accessing' stamp: 'sp 1/23/2013 08:13:28.266'!
versionsInCE
	^versionsCE! !

!CvCommit methodsFor: 'accessing' stamp: 'sp 1/23/2013 08:13:24.707'!
versionsInMC	
	^versionsMC! !

!CvCommit methodsFor: 'committing' stamp: 'sp 1/24/2013 11:34:25.086'!
waitForPendingTests

	"TODO: Give UI Feedback to let the user know we are waiting for the test"
	[ self versionsInCE last isTestResultAvailable ] whileFalse: [
		(Delay forMilliseconds: 500) wait. ]
	"TODO: Remove UI Feedback given above"! !

!CvCommit methodsFor: 'accessing' stamp: 'sp 1/23/2013 08:14:39.795'!
workingCopyInCE
	^workingCopyCE! !

!CvCommit methodsFor: 'accessing' stamp: 'sp 1/23/2013 08:20:23.914'!
workingCopyInMC

	| newer |
	workingCopyMC ifNotNil: [ ^workingCopyMC ].
	workingCopyMC := self package workingCopy.
	
	workingCopyMC ifNil:[ self inform: 'No Working copy available!!'. ^ nil ].
	newer := workingCopyMC possiblyNewerVersionsIn: self repository.
	(newer isEmpty or: [
		self confirm: 'CAUTION!! These versions in the repository may be newer:', 
			String cr, (newer asString truncateWithElipsisTo: 150), String cr,
			'Do you really want to save this version?'
		]) ifFalse: [^nil].
	
	^workingCopyMC! !

Object subclass: #CvController
	instanceVariableNames: 'isInstalled changeNotifier polySource chronologicalOrderedVersions package rootClassName deferredEvent deferredEventWC testJobQueue testRunProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvController class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.057'!
canBeLateBound
	^ false! !

!CvController class methodsFor: 'instance creation' stamp: 'bs 3/7/2011 09:44:46.278'!
new
	self error: 'a special factory method must be used'! !

!CvController class methodsFor: 'instance creation' stamp: 'bs 3/7/2011 09:45:51.651'!
notifier: aChangeNotifier polySource: polySource
	^ super new 
		initializeWithNotifier: aChangeNotifier 
		polySource: polySource! !

!CvController methodsFor: 'working copies' stamp: 'bs 8/23/2011 09:26:11.965'!
activateWorkingCopy: aWc

	self polySource addCodeBase: aWc.
	self workingCopyActivated: aWc.! !

!CvController methodsFor: 'accessing' stamp: 'bs 3/6/2011 21:39:37.854'!
changeNotifier
	^ changeNotifier! !

!CvController methodsFor: 'versioning' stamp: 'bs 4/12/2011 13:36:23.609'!
checkout: aCvVersion
	
	^ CvWorkingCopy checkout: aCvVersion.! !

!CvController methodsFor: 'working copies' stamp: 'bs 5/13/2011 21:24:19.953'!
controlledWorkingCopies
	
	^ self polySource codeBases 
		select: [:ea | ea isCvWorkingCopy and: [ea controller = self]]
! !

!CvController methodsFor: 'fault detection' stamp: 'bs 1/13/2012 18:05:11.48'!
detectFault: aTestMethod begin: firstVersion end: lastVersion
	| lastPass versionsReversed |
	self assert: [lastVersion hasAncestor: firstVersion].
	
	versionsReversed := lastVersion withAllPredecessorsUpThrough: firstVersion.
	lastPass := versionsReversed detect: [:ea |
		[(aTestMethod valueAt: ea) newTestCase run hasPassed] valueBasedOn: ea].
	^ versionsReversed before: lastPass! !

!CvController methodsFor: 'monticello-integration' stamp: 'lk 1/23/2013 14:58:17.846'!
fetchRemoteChanges
	"<^self>"
	"Fetch changes for the current package from the currently selected repository"
	
	UIManager default displayProgress: 'Fetching Remote Changes' at: Sensor cursorPoint from: 0 to: 1 during: [ :update |
		| packageName repo versions |
		packageName := self package name.
		repo := self versionsChronologically last package repository.
		versions := repo freshVersionsForPackageNamed: packageName.
		update value: 1 / (versions size + 1).
		
		versions doWithIndex: [ :version :versionIndex |
			self mergeMcVersion: version.
			update value: ((versionIndex + 1) / (versions size + 1)).
		].
		update value: 1.
	].! !

!CvController methodsFor: 'as yet unclassified' stamp: 'TM 4/5/2011 15:19:26.523'!
firstVersion
	
	^ self pvtChronologicalOrderedVersions first! !

!CvController methodsFor: 'system event handling' stamp: ''!
handleEvent: aSystemEvent

	aSystemEvent isDoIt ifTrue: [^ self].
	(self controlledWorkingCopies includes: self activeCodeBase) ifFalse: [^ self].
	aSystemEvent canBeVersioned ifFalse: [^ self].
	
	deferredEventWC := deferredEvent := nil.
	self shouldDefer 
		ifTrue: [
			deferredEvent := aSystemEvent.
			deferredEventWC := self activeCodeBase]
		ifFalse: [self snapshot: self activeCodeBase for: aSystemEvent]! !

!CvController methodsFor: 'morphic event processing' stamp: 'bs 5/11/2011 14:12:08.814'!
handleKeyboardShortcuts: evt
	| focusedMorph focusedWorkingCopy shortcuts command |
	
	evt wasHandled ifTrue: [^ self].
	evt isKeystroke ifFalse: [^self].
	
	focusedMorph := ActiveHand keyboardFocus ifNil: [World].
	
	focusedWorkingCopy := focusedMorph psCodeBase ifNil: [^ self].
	focusedWorkingCopy isCvWorkingCopy ifFalse: [^ self].
	
	evt shiftPressed ifFalse: [^ self].
	(evt anyModifierKeyPressed) ifFalse: [^ self].
	
	shortcuts := Dictionary newFrom: {
		$a -> #moveOneStepBack. 
		$d -> #moveOneStepForward}.
		
	command := shortcuts at: evt keyCharacter asLowercase ifAbsent: [^ self].
	
	focusedWorkingCopy perform: command.
	evt wasHandled: true.! !

!CvController methodsFor: 'morphic event processing' stamp: 'bs 5/11/2011 14:11:43.046'!
handleListenEvent: aKeyboardEvent
	self handleKeyboardShortcuts: aKeyboardEvent.! !

!CvController methodsFor: 'accessing' stamp: 'bs 3/29/2011 12:04:16.363'!
initialVersion
	
	^ self pvtChronologicalOrderedVersions at: 1 ifAbsent: [nil]! !

!CvController methodsFor: 'initialize-release' stamp: 'bs 5/12/2011 15:47:38.059'!
initializeWithNotifier: aChangeNotifier polySource: aPolySource
	super initialize.
	changeNotifier := aChangeNotifier.
	polySource := aPolySource.
	self packageUnchecked: (PackageInfo named: '').! !

!CvController methodsFor: 'install-uninstall' stamp: 'bs 5/11/2012 14:58:04.523'!
install
	(Object class instVarNames includes: 'cvOriginal')
		ifFalse: [Object class addInstVarName: 'cvOriginal'].
		
	isInstalled := true.
	self registerForSystemEvents.
	self registerAsWorldKeyboardListener.
	self startTestRunProcess.! !

!CvController methodsFor: 'install-uninstall' stamp: 'bs 3/2/2011 14:17:31.097'!
isInstalled
	^ isInstalled ifNil: [isInstalled := false]! !

!CvController methodsFor: 'accessing by path' stamp: 'TM 4/14/2011 13:10:11.763'!
logicalTimeOf: aVersion

	^ self pvtChronologicalOrderedVersions indexOf: aVersion
	! !

!CvController methodsFor: 'monticello-integration' stamp: 'sp 1/28/2013 14:45:29.39'!
mergeMcVersion: aMcVersion
	"<aMcVersion iOf: MCVersion, ^(true | false)>"
	"Load the @aMcVersion, maintaining branches in the MC repository"
	
	|predecessor wc patch|
		aMcVersion existsInCvGraph ifFalse: [
			"Transcript show: ('Loading ', aMcVersion info name, ' (successor of ', aMcVersion info ancestors first name, ')'); cr."
			predecessor := aMcVersion findPrecedingCvVersion.
			patch := aMcVersion snapshot patchRelativeToBase: predecessor snapshot.
			wc := self checkout: predecessor.
			wc silentlyApplyPatch: patch.
			"In case there were no changes, the predecessor won't have any successors"
			(predecessor successors size > 0) 
				ifTrue: [ |latestVersion|
					latestVersion := predecessor lastVersionInSuccessorChain.
					self assert: [latestVersion = wc baseVersion].
					latestVersion versionInfo mcVersionInfo: aMcVersion info.
					(latestVersion withAllPredecessorsUpTo: predecessor) do: [:version|
						version isCommittedToMC: true.
						version versionInfo author: aMcVersion info author]]]! !

!CvController methodsFor: 'monticello-integration' stamp: 'lk 1/23/2013 14:42:49.243'!
mergeMcVersions: anOrderedCollection
	"<anOrderedCollection iOf: (OrderedCollection of: MCVersion, ^(true | false)>"
	"Load all MCVersions in @anOrderedCollection, maintaining branches in the MC repository"
	
	anOrderedCollection do: [ :version | self mergeMcVersion: version ].! !

!CvController methodsFor: 'versioning' stamp: 'bs 5/22/2011 12:41:30.386'!
nameOfRootClass
	
	^ rootClassName! !

!CvController methodsFor: 'packages' stamp: 'bs 4/6/2011 21:07:02.938'!
package
	^ package! !

!CvController methodsFor: 'packages' stamp: 'bs 5/12/2011 15:59:43.062'!
package: aPackageInfo
	| compiledMethod |
	package := aPackageInfo.
	
	"ensure late class binding for 'managed' packages. this check is very important, 
	 as monticello loads packages using binary snapshots"
	package methods do: [:ea |  
		compiledMethod := ea compiledMethod.
		(compiledMethod allLiterals anySatisfy: [:lit | lit isKindOf: Association])
			ifTrue: [ea actualClass recompile: ea selector]]! !

!CvController methodsFor: 'packages' stamp: 'bs 5/12/2011 15:47:21.931'!
packageUnchecked: aPackageInfo
	package := aPackageInfo.! !

!CvController methodsFor: 'system event handling' stamp: ''!
performDeferredSnapshot
	deferredEvent ifNil: [^ self].
	self snapshot: deferredEventWC for: deferredEvent.
	deferredEvent := nil.
	deferredEventWC := nil.! !

!CvController methodsFor: 'accessing' stamp: 'bs 3/6/2011 21:53:01.766'!
polySource
	^ polySource! !

!CvController methodsFor: 'as yet unclassified' stamp: 'bs 3/29/2011 11:57:10.339'!
pvtChronologicalOrderedVersions
		
	^ chronologicalOrderedVersions 
		ifNil: [chronologicalOrderedVersions := OrderedCollection new]! !

!CvController methodsFor: 'versioning' stamp: 'bs 8/23/2011 09:42:38.187'!
pvtStartVersioning: aCodeBase rootClass: aClassName

	self assert: self pvtChronologicalOrderedVersions isEmpty
		 description: 'there is already a codebase under version control'.
		
	rootClassName := aClassName.
	
	^ CvWorkingCopy new
		setController: self andStartVersioning: aCodeBase;
		yourself! !

!CvController methodsFor: 'morphic event processing' stamp: 'bs 5/9/2011 11:18:48.272'!
registerAsWorldKeyboardListener

	ActiveHand addKeyboardListener: self! !

!CvController methodsFor: 'system event handling' stamp: 'bs 5/9/2011 18:47:06.352'!
registerForSystemEvents
	| relevantItemKinds |
	relevantItemKinds :=  #(#category #class #method #protocol).
	relevantItemKinds do: [:itemKind |
		self changeNotifier notify: self ofSystemChangesOfItem: itemKind using: #handleEvent: ].! !

!CvController methodsFor: 'sunit' stamp: 'bs 5/11/2012 15:02:05.662'!
runTestJobs

	[true] whileTrue: [self testJobQueue next value] ! !

!CvController methodsFor: 'system event handling' stamp: ''!
shouldDefer

	^ CvShouldDeferSnapshot value! !

!CvController methodsFor: 'system event handling' stamp: ''!
snapshot: aWorkingCopy for: aSystemEvent
	| newVersion |
	newVersion := self activeCodeBase saveVersionForChange: aSystemEvent.
	self versionSaved: newVersion! !

!CvController methodsFor: 'sunit' stamp: 'bs 5/11/2012 14:55:22.67'!
startTestRunProcess

	testRunProcess := [self runTestJobs] forkAt: Processor userBackgroundPriority! !

!CvController methodsFor: 'versioning' stamp: 'bs 7/18/2011 17:57:15.734'!
startVersioning: aCodeBase
	
	^ self pvtStartVersioning: aCodeBase rootClass: #ProtoObject ! !

!CvController methodsFor: 'versioning' stamp: 'bs 8/29/2011 16:43:04.119'!
startVersioning: aCodeBase duplicateClassesStartAt: aClassName
	| copyOfCodeBase result |
	
	rootClassName := aClassName.
	copyOfCodeBase := aCodeBase copyWithClassesStartAt: rootClassName.
	self assert: [(aCodeBase classNamed: #CvTbPerson) ~= (copyOfCodeBase classNamed: #CvTbPerson)].
	
	result := self pvtStartVersioning: copyOfCodeBase rootClass: rootClassName.
	self assert: [(aCodeBase classNamed: #CvTbPerson) ~= (copyOfCodeBase classNamed: #CvTbPerson)].
	self assert: [(aCodeBase classNamed: #CvTbPerson) ~= (result classNamed: #CvTbPerson)].
	self assert: [(result classNamed: #CvTbPerson) ~= (self activeCodeBase classNamed: #CvTbPerson)].
	
	^ result! !

!CvController methodsFor: 'sunit' stamp: 'bs 5/11/2012 14:55:55.843'!
stopTestRunProcess

	testRunProcess terminate.
	testRunProcess := nil! !

!CvController methodsFor: 'sunit' stamp: 'bs 5/11/2012 14:52:57.046'!
testJobQueue

	^ testJobQueue ifNil: [testJobQueue := SharedQueue new]! !

!CvController methodsFor: 'versioning' stamp: 'FB 1/17/2013 12:03:09.338'!
tryToSetInitialMCVersionInfo
	"<^(iOf: MCVersionInfo | nil)>"
	"If the initial CvVersion's MCVersionInfo is nil, then try to set it to the
	 MCVersionInfo of the ancestor of the current working copy of my package.
	 Return the version info if this was set successful, otherwise nil."
	
	|package ancestors|
	"Must be MCPackage, not CvPackage"
	package := MCPackage named: self package packageName.
	ancestors := package workingCopy ancestry ancestors.
	ancestors ifNotEmpty: [
		self firstVersion versionInfo mcVersionInfo: ancestors first.
		^ancestors first].
	^nil! !

!CvController methodsFor: 'install-uninstall' stamp: 'bs 5/11/2012 14:58:13.034'!
uninstall
	isInstalled ifFalse: [^ self ].
	
	self stopTestRunProcess.
	self pvtChronologicalOrderedVersions removeAll.
	self unregisterAsWorldKeyboardListener.
	self unregisterForSystemEvents. 
	
	self controlledWorkingCopies do: [:ea | 
		self polySource removeCodeBase: ea].
	
	isInstalled := false! !

!CvController methodsFor: 'morphic event processing' stamp: 'bs 5/9/2011 11:19:02.157'!
unregisterAsWorldKeyboardListener

	ActiveHand removeKeyboardListener: self! !

!CvController methodsFor: 'system event handling' stamp: 'bs 3/6/2011 21:39:49.033'!
unregisterForSystemEvents
	self changeNotifier noMoreNotificationsFor: self! !

!CvController methodsFor: 'accessing by path' stamp: 'TM 6/24/2011 10:47:27.184'!
versionAt: aNumber

	^ self pvtChronologicalOrderedVersions at: aNumber! !

!CvController methodsFor: 'accessing by path' stamp: 'bs 7/27/2011 19:06:45.359'!
versionByPath: aPathString
	"look at #test20NamedBranches for some documentation on how this works.
	 the first branch in time is the default/implicit one. While explicitness is to be preferred,
	 it allows to keep pathes short and keep them working when new branches are added "
	| pathMarkers markerParts versionNo branchNo aVersion |
	aVersion := self initialVersion.
	
	pathMarkers := aPathString findTokens: '->'.
	pathMarkers allButLast do: [:aMarker | 
		markerParts := aMarker findTokens: '/'.
		versionNo := markerParts first asInteger.
		aVersion := aVersion findOnFirstBranchesPath: versionNo.
		
		branchNo := [1] unless: [markerParts size = 2] 
						 proceed: [markerParts second asInteger].
		aVersion := aVersion nextOnBranchNo: branchNo].

	versionNo := pathMarkers last asInteger.
	^ aVersion findOnFirstBranchesPath: versionNo! !

!CvController methodsFor: 'as yet unclassified' stamp: 'bs 8/22/2011 10:34:06.229'!
versionSaved: aVersion
	
	self pvtChronologicalOrderedVersions add: aVersion.
	aVersion runTestsInBackground.
	self emitAlways.! !

!CvController methodsFor: 'as yet unclassified' stamp: 'bs 3/29/2011 11:57:40.554'!
versionsChronologically
	
	^ self pvtChronologicalOrderedVersions copy! !

!CvController methodsFor: 'working copies' stamp: 'bs 8/1/2012 13:31:47.215'!
workingCopies

	^ self polySource codeBases select: [:ea | ea isCvWorkingCopy]! !

!CvController methodsFor: 'working copies' stamp: 'bs 4/5/2011 19:05:00.893'!
workingCopyActivated: aWc

	self emit! !

Object subclass: #CvInitialVersionNullEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvInitialVersionNullEvent methodsFor: 'as yet unclassified' stamp: 'bs 8/25/2011 17:24:06.702'!
checkoutChangesTo: aWorkingCopy! !

!CvInitialVersionNullEvent methodsFor: 'as yet unclassified' stamp: 'bs 1/19/2012 15:45:54.935'!
cvEventKindString

	^ 'initial version'! !

!CvInitialVersionNullEvent methodsFor: 'as yet unclassified' stamp: 'bs 9/6/2012 09:37:39.843'!
cvItemReference

	^ CvCodeReference root! !

!CvInitialVersionNullEvent methodsFor: 'as yet unclassified' stamp: 'bs 1/5/2012 15:03:17.19'!
cvSummary

	^ 'initial version'! !

!CvInitialVersionNullEvent methodsFor: 'as yet unclassified' stamp: 'bs 5/9/2012 14:23:30.166'!
environmentAt: anItemKind

	^ nil! !

!CvInitialVersionNullEvent methodsFor: 'as yet unclassified' stamp: 'bs 8/30/2011 11:51:27.577'!
includedInCheckoutOf: aClass

	^ true! !

!CvInitialVersionNullEvent methodsFor: 'as yet unclassified' stamp: 'bs 5/9/2012 11:53:26.985'!
itemRequestor: requestor

	! !

!CvInitialVersionNullEvent methodsFor: 'as yet unclassified' stamp: 'bs 8/25/2011 17:26:09.953'!
saveCodeReference
	! !

Object subclass: #CvInvalidMethod
	instanceVariableNames: 'methodClass selector source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvInvalidMethod class methodsFor: 'as yet unclassified' stamp: ''!
class: aClass selector: aSymbol

	^ self new
		methodClass: aClass;
		selector: aSymbol! !

!CvInvalidMethod methodsFor: 'as yet unclassified' stamp: ''!
flushCache

	! !

!CvInvalidMethod methodsFor: 'as yet unclassified' stamp: ''!
getSourceFor: selector in: class

	| unstyledSource styledSource |
	unstyledSource := self getUnstyledSourceFor: selector in: class.
	styledSource := SwaSourceTextStyler instance styleSource: unstyledSource of: self.
	^ styledSource.! !

!CvInvalidMethod methodsFor: 'as yet unclassified' stamp: ''!
getUnstyledSourceFor: selector in: class
	
	^ source! !

!CvInvalidMethod methodsFor: 'as yet unclassified' stamp: ''!
literalsDo: aBlock

	! !

!CvInvalidMethod methodsFor: 'accessing' stamp: ''!
methodClass
	^ methodClass! !

!CvInvalidMethod methodsFor: 'accessing' stamp: ''!
methodClass: anObject
	methodClass := anObject! !

!CvInvalidMethod methodsFor: 'accessing' stamp: ''!
methodHome

	^ self methodClass! !

!CvInvalidMethod methodsFor: 'as yet unclassified' stamp: ''!
parent

	^ self methodClass! !

!CvInvalidMethod methodsFor: 'as yet unclassified' stamp: ''!
pragmas
	
	^ {}! !

!CvInvalidMethod methodsFor: 'as yet unclassified' stamp: ''!
qualifiedName
	^ self methodClass name, ' >> #', self selector ! !

!CvInvalidMethod methodsFor: 'as yet unclassified' stamp: ''!
run: t1 with: t2 in: t3 
	self
		error: ('invalid source code: the message with selector {1} in class {2} is not yet executable' format: {t1. t3 class})! !

!CvInvalidMethod methodsFor: 'accessing' stamp: ''!
selector
	^ selector! !

!CvInvalidMethod methodsFor: 'accessing' stamp: ''!
selector: anObject
	selector := anObject! !

!CvInvalidMethod methodsFor: 'as yet unclassified' stamp: ''!
storeSource: sourceStr 

	source := sourceStr

	! !

Object subclass: #CvMockController
	instanceVariableNames: 'chronologicalOrderedVersions activeWorkingCopies activeWorkinCopy activeWorkingCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Tests'!

!CvMockController class methodsFor: 'as yet unclassified' stamp: 'TM 5/19/2011 12:02:08.72'!
forVersions: aCollection

	^ self new
		addVersions: aCollection! !

!CvMockController methodsFor: 'as yet unclassified' stamp: 'TM 6/24/2011 13:41:17.609'!
activeWorkingCopies: aCollection

	activeWorkingCopies := aCollection! !

!CvMockController methodsFor: 'as yet unclassified' stamp: 'TM 6/24/2011 13:44:26.95'!
activeWorkingCopy

	^activeWorkingCopy! !

!CvMockController methodsFor: 'as yet unclassified' stamp: 'TM 6/24/2011 13:44:20.637'!
activeWorkingCopy: aWorkingCopy

	activeWorkingCopy := aWorkingCopy! !

!CvMockController methodsFor: 'as yet unclassified' stamp: 'TM 5/19/2011 12:05:49.229'!
addVersions: aCollection

	aCollection do: [:aVersion | self versionSaved: aVersion]! !

!CvMockController methodsFor: 'as yet unclassified' stamp: 'TM 5/20/2011 10:36:32.37'!
addWorkingCopy: aMockWorkingCopy

	self workingCopyActivated: aMockWorkingCopy! !

!CvMockController methodsFor: 'as yet unclassified' stamp: 'TM 5/19/2011 11:24:40.713'!
chronologicalOrderedVersions

	^ chronologicalOrderedVersions! !

!CvMockController methodsFor: 'as yet unclassified' stamp: 'TM 5/19/2011 11:24:32.262'!
chronologicalOrderedVersions: aCollection

	chronologicalOrderedVersions := aCollection! !

!CvMockController methodsFor: 'as yet unclassified' stamp: 'TM 6/24/2011 13:52:39.069'!
handleEvent: anEvent

	self versionSaved:  (self activeWorkingCopy saveVersionForChange: anEvent)! !

!CvMockController methodsFor: 'as yet unclassified' stamp: 'TM 5/20/2011 09:27:29.786'!
initialize

	super initialize.
	
	self
		chronologicalOrderedVersions: OrderedCollection new;
		activeWorkingCopies: OrderedCollection new.
		
	self workingCopyActivated: CvMockWorkingCopy new.! !

!CvMockController methodsFor: 'as yet unclassified' stamp: 'TM 5/19/2011 11:16:48.519'!
install! !

!CvMockController methodsFor: 'as yet unclassified' stamp: 'TM 5/20/2011 10:00:45.542'!
saveNewVersion: aVersion

	self versionSaved: aVersion! !

!CvMockController methodsFor: 'as yet unclassified' stamp: 'TM 5/20/2011 10:29:18.012'!
versionAt: aNumber

	^ self versionsChronologically at: aNumber

	! !

!CvMockController methodsFor: 'as yet unclassified' stamp: 'TM 5/20/2011 09:59:25.388'!
versionSaved: aVersion

	self chronologicalOrderedVersions add: aVersion.
	
	self emit.! !

!CvMockController methodsFor: 'as yet unclassified' stamp: 'TM 5/19/2011 11:26:48.917'!
versionsChronologically

	^ self chronologicalOrderedVersions! !

!CvMockController methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2012 13:31:47.226'!
workingCopies

	^ activeWorkingCopies! !

!CvMockController methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2012 13:31:47.323'!
workingCopyActivated: aMockWorkingCopy

	self workingCopies add: aMockWorkingCopy.
	aMockWorkingCopy controller: self.
	self emit.! !

Object subclass: #CvMockWorkingCopy
	instanceVariableNames: 'controller baseVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Tests'!

!CvMockWorkingCopy methodsFor: 'as yet unclassified' stamp: 'TM 5/20/2011 09:36:34.145'!
baseVersion

	^ baseVersion! !

!CvMockWorkingCopy methodsFor: 'as yet unclassified' stamp: 'TM 5/20/2011 09:36:23.461'!
baseVersion: aVersion

	baseVersion := aVersion! !

!CvMockWorkingCopy methodsFor: 'as yet unclassified' stamp: 'TM 5/20/2011 09:32:43.667'!
color

	^ Color red! !

!CvMockWorkingCopy methodsFor: 'as yet unclassified' stamp: 'TM 5/20/2011 09:57:14.736'!
controller

	^ controller! !

!CvMockWorkingCopy methodsFor: 'as yet unclassified' stamp: 'TM 5/20/2011 09:51:26.718'!
controller: aMockController

	controller := aMockController! !

!CvMockWorkingCopy methodsFor: 'as yet unclassified' stamp: 'TM 5/20/2011 09:35:11.109'!
rebasedFrom: aVersion to: otherVersion

	self emit.! !

!CvMockWorkingCopy methodsFor: 'as yet unclassified' stamp: 'bs 7/24/2011 19:04:31.17'!
saveVersionForChange: anEvent
|version|

	version := CvVersion new.
	version versionInfo: version createVersionInfo.
	version systemEvent: anEvent.

	self baseVersion
		ifNotNil: [ :bv | bv addSuccessor: version.
				version number: bv number + 1.		
				version predecessor: bv.	].
	
	self baseVersion: version.
	self versionSaved.
	^ version! !

!CvMockWorkingCopy methodsFor: 'as yet unclassified' stamp: 'TM 5/20/2011 09:33:45.214'!
versionSaved

	self emit.! !

Object subclass: #CvPatchView
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Nodes'!

!CvPatchView class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.089'!
canBeLateBound
	^ false! !

!CvPatchView class methodsFor: 'as yet unclassified' stamp: 'bs 3/10/2011 14:01:15.232'!
forPatch: aPatch
	^ self new patch: aPatch! !

!CvPatchView methodsFor: 'as yet unclassified' stamp: 'bs 3/13/2011 18:22:55.629'!
build
	| list |

	list := PluggableListMorph on: self
		list: #list
		selected: nil
		changeSelected: nil.
	list color: Color gray muchLighter.
	list width: self calcListWidth + 10.
	list height: self calcListHeight.
	list borderWidth: 0.
	list hideScrollBars.
	^ list.! !

!CvPatchView methodsFor: 'as yet unclassified' stamp: 'bs 3/10/2011 13:56:03.791'!
calcListHeight
	^ (self list size max: 1) * self defaultFont height! !

!CvPatchView methodsFor: 'as yet unclassified' stamp: 'bs 3/13/2011 18:17:18.1'!
calcListWidth
	^ (self list collect: [:ea | self defaultFont widthOfStringOrText: ea]) 
		ifEmpty: [^ 10]
		ifNotEmpty: [:sizes | sizes max].! !

!CvPatchView methodsFor: 'as yet unclassified' stamp: 'bs 3/10/2011 13:51:55.179'!
defaultFont
	^ TextStyle default defaultFont! !

!CvPatchView methodsFor: 'as yet unclassified' stamp: 'bs 3/10/2011 14:09:11.94'!
items
	^ items! !

!CvPatchView methodsFor: 'as yet unclassified' stamp: 'bs 3/10/2011 14:04:14.07'!
list
	^ self items collect: [:ea | ea summary]! !

!CvPatchView methodsFor: 'as yet unclassified' stamp: 'bs 3/10/2011 14:01:35.567'!
patch: aPatch
	items := aPatch operations asSortedCollection! !

Object subclass: #CvTbGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-TestBed'!

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 8/12/2011 14:49:48.929'!
createLastnameSlot
	
	CvTbPerson 
		addInstVarName: 'lastname';
		compile: 'lastname
			^ lastname ifNil: [''foo'']';
		compile: 'lastname: anObject
			lastname := anObject'.! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 1/17/2012 18:20:34.343'!
createTestForLastnameSlot
	| aSymbol |
	aSymbol := CvTbPersonTest compile: 'testLastname
		| sut |
		sut := CvTbPerson new.
		sut lastname: ''Foo''.
		self assert: ''Foo'' equals: sut lastname'.
	^ CvTbPersonTest >> aSymbol! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 1/13/2012 10:02:12.988'!
generateChanges
		
	self 
		createTestForLastnameSlot;
		createLastnameSlot;
		removeLastnameSlot;
		removeTestForLastnameSlot! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: ''!
generateChangesOn: aWorkingCopy
	| firstVersion fourthVersion secondVersion thirdVersion |
	firstVersion := aWorkingCopy baseVersion.
	
	self basedOn: aWorkingCopy do: [	
		CvTbPersonTest compile: 'testLastname
			| sut |
			sut := CvTbPerson new.
			sut lastname: ''Foo''.
			self assert: ''Foo'' equals: sut lastname'.
			
		CvTbPerson addInstVarName: 'lastname'.
	
		CvTbPerson compile: 'lastname
			^ lastname ifNil: [''foo'']'.
	
		CvTbPerson compile: 'lastname: anObject
			lastname := anObject'].
	
	secondVersion := firstVersion successors first.
	thirdVersion := secondVersion successors first.
	fourthVersion := thirdVersion successors first.
	
	firstVersion versionInfo instVarNamed: 'time' put: (Time now subtractTime: (Time seconds: 400)).
	secondVersion versionInfo instVarNamed: 'time' put: (Time now subtractTime: (Time seconds: 390)).
	thirdVersion versionInfo instVarNamed: 'time' put: (Time now subtractTime: (Time seconds: 330)).
	fourthVersion versionInfo instVarNamed: 'time' put: (Time now subtractTime: (Time seconds: 300)).! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 8/23/2011 09:59:20.16'!
generateManyChanges
	
	| testLastnameSource aNewClass |
	testLastnameSource := 'testLastname
		| sut |
		sut := CvTbPerson new.
		sut lastname: ''Foo''.
		self assert: ''Foo'' equals: sut lastname'.
		
	CvTbPersonTest 
		compile: testLastnameSource;
		compile: testLastnameSource;
		compile: testLastnameSource.
	
	self 
		createLastnameSlot;
		renameInstVarLastnameToFoo;
		renameInstVarFooToLastname;
		removeLastnameSlot.
	
	CvTbPersonTest removeSelector: #testLastname.
	aNewClass := CvTbPerson newSubclass.
	aNewClass removeFromSystem.! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 4/11/2011 11:09:27.465'!
generateMoreChanges
	
	CvTbPersonTest compile: 'testLastname
		| sut |
		sut := CvTbPerson new.
		sut lastname: ''Foo''.
		self assert: ''Foo'' equals: sut lastname'.
	
	CvTbPerson compile: 'lastname
		^ lastname ifNil: [''foo'']'.
	
	CvTbPerson compile: 'lastname: anObject
		lastname := anObject'.! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 8/12/2011 14:50:12.623'!
removeLastnameSlot
	
	CvTbPerson 
		removeSelector: #lastname:;
		removeSelector: #lastname;
		removeInstVarName: 'lastname'.! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 1/13/2012 10:01:03.699'!
removeTestForLastnameSlot

	CvTbPersonTest removeSelector: #testLastname.! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 8/12/2011 14:53:55.303'!
renameInstVarFooToLastname
	
	(RenameInstanceVariableRefactoring 
		rename: 'foo' to: 'lastname' in: CvTbPerson)
			execute! !

!CvTbGenerator methodsFor: 'as yet unclassified' stamp: 'bs 8/12/2011 14:53:58.029'!
renameInstVarLastnameToFoo
	
	(RenameInstanceVariableRefactoring 
		rename: 'lastname' to: 'foo' in: CvTbPerson)
			execute! !

Object subclass: #CvTbObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-TestBed'!

!CvTbObject class methodsFor: 'as yet unclassified' stamp: 'bs 5/20/2011 14:45:33.179'!
wantsRecompilationProgressReported
	"Answer whether the receiver would like progress of its recompilation reported interactively to the user."

	^ false! !

CvTbObject subclass: #CvTbPerson
	instanceVariableNames: 'firstname'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'CV-TestBed'!

CvTbPerson subclass: #CvTbEmployee
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-TestBed'!

!CvTbPerson class methodsFor: 'as yet unclassified' stamp: ''!
createNewDefault
	"self setValue."
	Default := nil.
	Default := CvTbPerson new! !

!CvTbPerson class methodsFor: 'as yet unclassified' stamp: ''!
default
	
	^ Default! !

!CvTbPerson class methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 15:45:56.897'!
new
	^ super new! !

!CvTbPerson methodsFor: 'as yet unclassified' stamp: 'bs 6/4/2011 09:35:48.051'!
anotherMethod
	
	! !

!CvTbPerson methodsFor: 'accessing' stamp: 'bs 12/28/2012 10:47:22.855'!
firstname

	^ firstname ifNil: ['foo'] ! !

!CvTbPerson methodsFor: 'accessing' stamp: 'bs 11/16/2012 13:15:23.99'!
firstname: anObject
	"foo    "
	firstname := anObject " "  ! !

CvTbObject subclass: #CvTbTestCase
	instanceVariableNames: 'testSelector timeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-TestBed'!

CvTbTestCase class
	instanceVariableNames: 'history'!

CvTbTestCase class
	instanceVariableNames: 'history'!

CvTbTestCase subclass: #CvTbPersonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-TestBed'!

!CvTbPersonTest methodsFor: 'as yet unclassified' stamp: 'bs 11/16/2012 14:35:40.799'!
testFirstname
	| sut |
	sut := CvTbPerson new.
	sut firstname: 'Foo'.
	self assert: 'Foo' equals: sut firstname.! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.439'!
addTestsFor: classNameString toSuite: suite

	| cls  |
	cls := Smalltalk at: classNameString ifAbsent: [ ^suite ].
	^cls isAbstract 
		ifTrue:  [
			cls allSubclasses do: [ :each |
				each isAbstract ifFalse: [
					each addToSuiteFromSelectors: suite ] ].
			suite]
		ifFalse: [ cls addToSuiteFromSelectors: suite ]
! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.449'!
addToSuite: suite fromMethods: testMethods 
	testMethods do:  [ :selector | 
			suite addTest: (self selector: selector) ].
	^suite! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.445'!
addToSuiteFromSelectors: suite
	^self addToSuite: suite fromMethods: (self shouldInheritSelectors
		ifTrue: [ self allTestSelectors ]
		ifFalse: [self testSelectors ])! !

!CvTbTestCase class methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.419'!
allTestSelectors

	^(self allSelectors asArray select: [ :each | 
		(each beginsWith: 'test') and: [ each numArgs isZero ] ]) sort
			! !

!CvTbTestCase class methodsFor: 'ob-sunitintegration' stamp: 'bs 5/22/2011 12:53:14.826'!
browserIcon
	| classHistory |
	self isAbstract
		ifTrue: [ ^ super browserIcon ].
	classHistory := TestResult historyFor: self.
	(classHistory at: #errors) isEmpty
		ifFalse: [ ^ #testRed ].
	(classHistory at: #failures) isEmpty
		ifFalse: [ ^ #testOrange ].
	(classHistory at: #passed) isEmpty
		ifFalse: [ ^ #testGreen ].
	^ #testGray! !

!CvTbTestCase class methodsFor: 'ob-sunitintegration' stamp: 'bs 5/22/2011 12:53:14.832'!
browserIcon: aClassDescription selector: aSelector
	(aClassDescription isMeta or: [ aClassDescription isAbstract or: [ (aSelector beginsWith: 'test') not ] ])
		ifTrue: [ ^ super browserIcon: aClassDescription selector: aSelector ].
	(aClassDescription methodRaisedError: aSelector)
		ifTrue: [ ^ #testRed ].
	(aClassDescription methodFailed: aSelector)
		ifTrue: [ ^ #testOrange ].
	(aClassDescription methodPassed: aSelector)
		ifTrue: [ ^ #testGreen ].
	^ #testGray! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.456'!
buildSuite
	| suite |
	suite := TestSuite new.
	^ self isAbstract
		ifTrue: [
			suite name: self name asString.
			self allSubclasses
				do: [:each | each isAbstract
						ifFalse: [each addToSuiteFromSelectors: suite]].
			suite]
		ifFalse: [self addToSuiteFromSelectors: suite]! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.462'!
buildSuiteFromAllSelectors

	^self buildSuiteFromMethods: self allTestSelectors
			! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.47'!
buildSuiteFromLocalSelectors

	^self buildSuiteFromMethods: self testSelectors
			! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.48'!
buildSuiteFromMethods: testMethods 
	| suite |
	suite := (TestSuite new)
				name: self name asString;
				yourself.
	^self addToSuite: suite fromMethods: testMethods! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.484'!
buildSuiteFromSelectors

	^self shouldInheritSelectors
		ifTrue: [self buildSuiteFromAllSelectors]
		ifFalse: [self buildSuiteFromLocalSelectors]
			! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.673'!
coverage
	"returns the coverage determined by a simple static analysis of test coverage 
	made by the receiver on a class that is identified by the name of the receiver.
	We assume that SetTest test Set."
	
	| cls className |
	(self name endsWith: 'Test') ifFalse: [self error: 'Please, use #coverageForClass: instead'].

	className := self name copyFrom: 1 to: (self name size - 'Test' size).
	cls := Smalltalk at: className asSymbol ifAbsent: [self error: 'Please, use #coverageForClass: instead'].
	
	"May happen with Transcript"
	cls isBehavior ifFalse: [cls := cls class].
	
	^ self coverageForClass: cls! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.681'!
coverageAsString
	| cov className |
	cov := self coverage first asInteger. 
	"coverage already checks that the name is ends with 'Test' and if the class tested exists"
	
	className := self name copyFrom: 1 to: (self name size - 'Test' size).
	^ self name asString, ' covers ', cov asString, '% of ', className.! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.687'!
coverageForClass: cls
	"returns the test coverage of all the methods included inherited ones"
	^ self coverageForClass: cls until: ProtoObject! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.699'!
coverageForClass: cls until: aRootClass
	"returns the test coverage of all the methods included inherited ones but stopping at aRootClass included"
	
	| definedMethods testedMethods untestedMethods |
	definedMethods := cls allSelectorsAboveUntil: aRootClass.
	definedMethods size = 0
		ifTrue: [^ {0. Set new}].
	testedMethods := 
		self methodDictionary inject: Set new into: 
							[:sums :cm | sums union: cm messages].
	testedMethods := testedMethods reject: [:sel | (definedMethods includes: sel) not].
	untestedMethods := definedMethods select: [:selector | (testedMethods includes: selector) not].
	^ { (testedMethods size * 100 / definedMethods size) asFloat . untestedMethods}
! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.705'!
coveragePercentage
	^ self coverage first! !

!CvTbTestCase class methodsFor: 'instance creation' stamp: 'bs 5/22/2011 12:53:14.496'!
debug: aSymbol

	^(self selector: aSymbol) debug
			! !

!CvTbTestCase class methodsFor: 'history' stamp: 'bs 5/22/2011 12:53:14.741'!
generateLastStoredRunMethod

	self shouldGenerateLastStoredRunMethod ifTrue: [
		self class
			compile: (self lastRunMethodNamed: #lastStoredRun)
			classified: 'history' ]! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.525'!
hasMethodBeenRun: aSelector
	^ ((self lastRun at: #errors),
		(self lastRun at: #failures),
		(self lastRun at: #passed))
			includes: aSelector! !

!CvTbTestCase class methodsFor: 'history' stamp: 'bs 5/22/2011 12:53:14.747'!
history
	^ history ifNil: [ history := self newTestDictionary ]! !

!CvTbTestCase class methodsFor: 'history' stamp: 'bs 5/22/2011 12:53:14.753'!
history: aDictionary
	history := aDictionary! !

!CvTbTestCase class methodsFor: 'initialize - event' stamp: 'bs 5/22/2011 12:53:14.796'!
initialize
     super initialize.
	SystemChangeNotifier uniqueInstance notify: self ofSystemChangesOfItem: #method using: #methodChanged:.! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.529'!
isAbstract
	"Override to true if a TestCase subclass is Abstract and should not have
	TestCase instances built from it"

	^self name = #TestCase
			! !

!CvTbTestCase class methodsFor: 'SwaUtil' stamp: 'bs 5/22/2011 12:53:14.839'!
isTestCaseClass
	^ true! !

!CvTbTestCase class methodsFor: 'history' stamp: 'bs 5/22/2011 12:53:14.757'!
lastRun
	^ TestResult historyFor: self! !

!CvTbTestCase class methodsFor: 'history' stamp: ''!
lastRunMethodNamed: aSelector
	
	^ String streamContents: [:str |
		str nextPutAll: aSelector asString ;cr.
		str tab; nextPutAll: '^ ', (self lastRun) storeString]
! !

!CvTbTestCase class methodsFor: 'history' stamp: 'bs 5/22/2011 12:53:14.769'!
lastStoredRun
	^ ((Dictionary new) add: (#failures->#()); add: (#passed->#()); add: (#errors->#()); yourself)! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.715'!
localCoverage
	"returns the coverage determined by a simple static analysis of test coverage 
	made by the receiver on a class that is identified by the name of the receiver.
	We assume that SetTest test Set. The computation of the coverage takes only into
	account the methods defined locally in the tested class. See coverage for a more global 
	coverage"
	
	| cls className |
	(self name endsWith: 'Test') ifFalse: [self error: 'Please, use #localCoverageForClass: instead'].
	className := self name copyFrom: 1 to: (self name size - 'Test' size).
	cls := Smalltalk at: className asSymbol ifAbsent: [self error: 'Please, use #localCoverageForClass: instead'].
	cls isBehavior ifFalse: [cls := cls class].
	^ self localCoverageForClass: cls! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.721'!
localCoverageAsString
	| cov className |
	cov := self localCoverage first asInteger. 
	"coverage already checks that the name is ends with 'Test' and if the class tested exists"
	
	className := self name copyFrom: 1 to: (self name size - 'Test' size).
	^ self name asString, ' covers ', cov asString, '% of ', className.! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.729'!
localCoverageForClass: cls
	
	| definedMethods testedMethods untestedMethods |
	definedMethods := cls selectors asSet.
	"It happens for IdentityBag / IdentityBagTest"
	definedMethods size = 0
		ifTrue: [^ {0. Set new}].

	testedMethods := 
		self methodDictionary inject: Set new into: 
							[:sums :cm | sums union: cm messages].
					
	"testedMethods contains all the methods send in test methods, which probably contains methods that have nothign to do with collection"
	testedMethods := testedMethods reject: [:sel | (definedMethods includes: sel) not].

	untestedMethods := definedMethods select: [:selector | (testedMethods includes: selector) not].

	^ { (testedMethods size * 100 / definedMethods size) asFloat . untestedMethods}
! !

!CvTbTestCase class methodsFor: 'coverage' stamp: 'bs 5/22/2011 12:53:14.735'!
localCoveragePercentage
	^ self localCoverage first! !

!CvTbTestCase class methodsFor: 'initialize - event' stamp: 'bs 5/22/2011 12:53:14.802'!
methodChanged: anEvent
	"Remove the changed method from the known test results."
	
	| cls sel |
	anEvent item isCompiledMethod ifFalse: [ ^ self ].
	cls := anEvent item methodClass.
	(cls inheritsFrom: TestCase)
		ifFalse: [^ self].
	sel := anEvent item selector.
	(sel beginsWith: 'test')
		ifFalse: [^ self].
	TestResult removeFromTestHistory: sel in: cls.
! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.533'!
methodFailed: aSelector
	^ (self lastRun at: #failures) includes: aSelector! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.539'!
methodPassed: aSelector
	^ (self lastRun at: #passed) includes: aSelector! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.545'!
methodProgressed: aSelector
	^ ((self storedMethodRaisedError: aSelector) or: [self storedMethodFailed: aSelector])
		and: [self methodPassed: aSelector]
		! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.549'!
methodRaisedError: aSelector
	^ (self lastRun at: #errors) includes: aSelector! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.555'!
methodRegressed: aSelector
	^ (self storedMethodPassed: aSelector) and: [(self methodFailed: aSelector) or: [self methodRaisedError: aSelector]]! !

!CvTbTestCase class methodsFor: 'history' stamp: ''!
newTestDictionary

	^ Dictionary new at: #timeStamp put: TimeStamp now;
		at: #passed put: Set new;
		at: #failures put: Set new;
		at: #errors put: Set new;
		yourself
		! !

!CvTbTestCase class methodsFor: 'sunitgui' stamp: 'bs 5/22/2011 12:53:14.81'!
packageNamesUnderTest
	"Answer a collection of package names under test. This is used by the test runner to automatically instrument the code in these packages when checking for test coverage."
	
	^ #()! !

!CvTbTestCase class methodsFor: 'history' stamp: 'bs 5/22/2011 12:53:14.786'!
resetHistory
	history := nil! !

!CvTbTestCase class methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.425'!
resources

	^#()
			! !

!CvTbTestCase class methodsFor: 'instance creation' stamp: 'bs 5/22/2011 12:53:14.502'!
run: aSymbol

	^(self selector: aSymbol) run
			! !

!CvTbTestCase class methodsFor: 'instance creation' stamp: 'bs 5/22/2011 12:53:14.508'!
selector: aSymbol

	^self new setTestSelector: aSymbol
			! !

!CvTbTestCase class methodsFor: 'history' stamp: 'bs 5/22/2011 12:53:14.79'!
shouldGenerateLastStoredRunMethod
	| sameRun |
	
	(self class methodDictionary includesKey: #lastStoredRun)
		ifFalse: [^ true].
	sameRun := #(#passed #failures #errors) inject: true into: 
		[ :ok :set | ok and: [(self lastRun at: set) = (self lastStoredRun at: set) ]].
	^ sameRun not
! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.566'!
shouldInheritSelectors
	"I should inherit from an Abstract superclass but not from a concrete one by default, unless I have no testSelectors in which case I must be expecting to inherit them from my superclass.  If a test case with selectors wants to inherit selectors from a concrete superclass, override this to true in that subclass."

	^self superclass isAbstract
		or: [self testSelectors isEmpty]

"$QA Ignore:Sends system method(superclass)$"
			! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.572'!
storedMethodFailed: aSelector
	^ (self lastStoredRun at: #failures) includes: aSelector! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.661'!
storedMethodPassed: aSelector
	^ (self lastStoredRun at: #passed) includes: aSelector! !

!CvTbTestCase class methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.667'!
storedMethodRaisedError: aSelector
	^ (self lastStoredRun at: #errors) includes: aSelector! !

!CvTbTestCase class methodsFor: 'instance creation' stamp: 'bs 5/22/2011 12:53:14.514'!
suite

	^self buildSuite
			! !

!CvTbTestCase class methodsFor: 'building suites' stamp: 'bs 5/22/2011 12:53:14.49'!
suiteClass
	^TestSuite
			! !

!CvTbTestCase class methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.431'!
sunitVersion
	^'3.1'
			! !

!CvTbTestCase class methodsFor: 'SwaUtil' stamp: 'bs 5/22/2011 12:53:14.843'!
testMethods
	^ self methodDict values asIdentitySet select: [ :m | m isTestMethod ]! !

!CvTbTestCase class methodsFor: 'Accessing' stamp: 'bs 5/22/2011 12:53:14.814'!
testSelectors

	^(self selectors asArray select: [ :each | 
		(each beginsWith: 'test') and: [ each numArgs isZero ] ]) sort! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 13:41:05.612'!
activeDict
	^ self activeCodeBase dictionary! !

!CvTbTestCase methodsFor: 'dependencies' stamp: 'bs 5/22/2011 12:53:14.242'!
addDependentToHierachy: anObject 
	"an empty method. for Composite compability with TestSuite"


			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:13.997'!
assert: aBooleanOrBlock

	aBooleanOrBlock value ifFalse: [self signalFailure: 'Assertion failed']
			! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/20/2011 20:13:46.38'!
assert: aBlock basedOn: aCodeBase
	self assert: (aBlock valueBasedOn: aCodeBase)! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.005'!
assert: aBooleanOrBlock description: aString
	aBooleanOrBlock value ifFalse: [
		self logFailure: aString.
		TestResult failure signal: aString]
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.013'!
assert: aBooleanOrBlock description: aString resumable: resumableBoolean 
	| exception |
	aBooleanOrBlock value
		ifFalse: 
			[self logFailure: aString.
			exception := resumableBoolean
						ifTrue: [TestResult resumableFailure]
						ifFalse: [TestResult failure].
			exception signal: aString]
			! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/20/2011 20:09:35.662'!
assert: anObject differsFrom: anotherObject
	^ self
		assert: (anObject ~= anotherObject)
		description: 'unexpected equality of values'
! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.019'!
assert: expected equals: actual
	^ self
		assert: (expected = actual)
		description: (self comparingStringBetween: expected and: actual)
! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 10:45:38.875'!
assert: aBlock equalsFor: aBlockArg and: anotherBlockArg.
	self assert: (aBlock value: aBlockArg) == (aBlock value: anotherBlockArg)! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 21:35:41.87'!
assert: aBlock equalsForCodeBases: aCodeBase and: anotherCodeBase.
	self assert: 
		([aBlock cull: aCodeBase] valueBasedOn: aCodeBase) =
		([aBlock cull: anotherCodeBase] valueBasedOn: anotherCodeBase)! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 21:35:37.856'!
assert: aBlock isSameForCodeBases: aCodeBase and: anotherCodeBase.
	self assert: 
		([aBlock cull: aCodeBase] valueBasedOn: aCodeBase) ==
		([aBlock cull: anotherCodeBase] valueBasedOn: anotherCodeBase)! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 18:10:27.067'!
assert: aBlock isUnlikeFor: aBlockArg and: anotherBlockArg.
	self assert: (aBlock value: aBlockArg) ~~ (aBlock value: anotherBlockArg)! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 21:27:03.174'!
assert: aBlock isUnlikeForCodeBases: aCodeBase and: anotherCodeBase.
	self assert: 
		([aBlock cull: aCodeBase] valueBasedOn: aCodeBase) ~~
		([aBlock cull: anotherCodeBase] valueBasedOn: anotherCodeBase)! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 09:27:13.245'!
basedOn: aCodeBase assert: aBlock
	self assert: (aBlock valueBasedOn: aCodeBase)! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 09:27:20.418'!
basedOn: aCodeBase deny: aBlock
	self deny: (aBlock valueBasedOn: aCodeBase)! !

!CvTbTestCase methodsFor: 'private' stamp: ''!
comparingStringBetween: expected and: actual
	^ String streamContents: [:stream |
		stream
			nextPutAll: 'Expected ';
			nextPutAll: (expected printStringLimitedTo: 10);
			nextPutAll: ' but was ';
			nextPutAll: (actual printStringLimitedTo: 10);
			nextPutAll: '.'
		]! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.258'!
debug
	self resources do: [:res | 
		res isAvailable ifFalse: [^res signalInitializationError]].
	[(self class selector: testSelector) runCase] 
		ensure: [self resources do: [:each | each reset]]
			! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.264'!
debugAsFailure
	| semaphore |
	semaphore := Semaphore new.
	self resources do: [:res | 
		res isAvailable ifFalse: [^res signalInitializationError]].
	[semaphore wait. self resources do: [:each | each reset]] fork.
	(self class selector: testSelector) runCaseAsFailure: semaphore.! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.026'!
defaultTimeout
	"Answer the default timeout to use for tests in this test case.
	The timeout is a value in seconds."

	^5 "seconds"! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.032'!
deny: aBooleanOrBlock

	self assert: aBooleanOrBlock value not
			! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 18:25:34.943'!
deny: aBlock basedOn: aCodeBase
	self deny: (aBlock valueBasedOn: aCodeBase)! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.04'!
deny: aBooleanOrBlock description: aString
	self assert: aBooleanOrBlock value not description: aString
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.044'!
deny: aBooleanOrBlock description: aString resumable: resumableBoolean 
	self
		assert: aBooleanOrBlock value not
		description: aString
		resumable: resumableBoolean
			! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 15:28:42.919'!
deny: expected equals: actual
	^ self
		assert: (expected ~= actual)
		description: 'unexpected equality of values'
! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 18:25:46.087'!
deny: aBlock forAll: blockArgs
	blockArgs do: [:ea | self deny: [aBlock value: ea]]! !

!CvTbTestCase methodsFor: 'private' stamp: 'bs 5/22/2011 12:53:14.35'!
executeShould: aBlock inScopeOf: anExceptionalEvent 
	^[aBlock value.
 	false] on: anExceptionalEvent
		do: [:ex | ex return: true]
			! !

!CvTbTestCase methodsFor: 'private' stamp: 'bs 5/22/2011 12:53:14.354'!
executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionContaining: aString
	^[aBlock value.
 	false] on: anExceptionalEvent
		do: [:ex | ex return: (ex description includesSubString: aString) ]
			! !

!CvTbTestCase methodsFor: 'private' stamp: 'bs 5/22/2011 12:53:14.362'!
executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionNotContaining: aString
	^[aBlock value.
 	false] on: anExceptionalEvent
		do: [:ex | ex return: (ex description includesSubString: aString) not ]
			! !

!CvTbTestCase methodsFor: 'extensions' stamp: 'bs 5/22/2011 12:53:14.379'!
executeShould: aBlock inScopeOf: anException withExceptionDo: anotherBlock

	^[aBlock value.
 	false] 
		on: anException
		do: [:exception | 
			anotherBlock value: exception.
			exception return: true]! !

!CvTbTestCase methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.333'!
expectedFailures
	^ Array new! !

!CvTbTestCase methodsFor: 'extensions' stamp: 'bs 5/22/2011 12:53:14.385'!
fail

	^self assert: false! !

!CvTbTestCase methodsFor: 'running' stamp: ''!
failureLog	
	^Transcript

			! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.276'!
isLogging
	"By default, we're not logging failures. If you override this in 
	a subclass, make sure that you override #failureLog"
	^false
			! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.286'!
logFailure: aString
	self isLogging ifTrue: [
		self failureLog 
			cr; 
			nextPutAll: aString; 
			flush]
			! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.29'!
openDebuggerOnFailingTestMethod
	"SUnit has halted one step in front of the failing test method. Step over the 'self halt' and 
	 send into 'self perform: testSelector' to see the failure from the beginning"

	self
		halt;
		performTest! !

!CvTbTestCase methodsFor: 'private' stamp: 'bs 5/22/2011 12:53:14.366'!
performTest

	self perform: testSelector asSymbol
			! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 14:26:47.951'!
polySource
	^ World polySource! !

!CvTbTestCase methodsFor: 'printing' stamp: 'bs 5/22/2011 12:53:14.252'!
printOn: aStream

	aStream
		nextPutAll: self class printString;
		nextPutAll: '>>#';
		nextPutAll: testSelector
			! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 09:57:33.989'!
psCodeBases
	^ self polySource codeBases! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 18:16:30.817'!
removeClassNamed: aSymbol on: aCodeBase
	self basedOn: aCodeBase do: [
		(self activeDict at: aSymbol) removeFromSystem ]! !

!CvTbTestCase methodsFor: 'dependencies' stamp: 'bs 5/22/2011 12:53:14.246'!
removeDependentFromHierachy: anObject 
	"an empty method. for Composite compability with TestSuite"


			! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/16/2011 16:00:21.4'!
removeMethod: aMethod on: aCodeBase
	^ self basedOn: aCodeBase do: [
		aMethod methodClass removeSelector: aMethod selector ]! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.048'!
resources
	| allResources resourceQueue |
	allResources := Set new.
	resourceQueue := OrderedCollection new.
	resourceQueue addAll: self class resources.
	[resourceQueue isEmpty] whileFalse: [
		| next |
		next := resourceQueue removeFirst.
		allResources add: next.
		resourceQueue addAll: next resources].
	^allResources
			! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.299'!
run
	| result |
	result := TestResult new.
	self run: result.
	^result
			! !

!CvTbTestCase methodsFor: 'CV-override' stamp: 'bs 5/22/2011 12:53:14.415'!
run: aResult 
	| originalRunCode | 
	originalRunCode := [aResult runCase: self].
	self activeCodeBase 
		ifNil: [originalRunCode value]
		ifNotNil: [:codeBase | 
			originalRunCode valueBasedOn: codeBase testCodeBase]
! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.303'!
runCase
	"Run this TestCase. Time out if the test takes too long."

	[self timeout: [self setUp]
		after: self timeoutForSetUp.
	self timeout: [self performTest]
		after: self timeoutForTest]
		ensure: [self tearDown]! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.309'!
runCaseAsFailure: aSemaphore
	[self setUp.
	self openDebuggerOnFailingTestMethod] ensure: [
		self tearDown.
		aSemaphore signal]! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.054'!
selector
	^testSelector
			! !

!CvTbTestCase methodsFor: 'private' stamp: 'bs 5/22/2011 12:53:14.373'!
setTestSelector: aSymbol
	testSelector := aSymbol
			! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.315'!
setUp! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.06'!
should: aBlock
	self assert: aBlock value
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.065'!
should: aBlock description: aString
	self assert: aBlock value description: aString
			! !

!CvTbTestCase methodsFor: 'extensions' stamp: ''!
should: aBlock notTakeMoreThan: aDuration
    "Evaluate aBlock in a forked process and if it takes more than anInteger milliseconds
    to run we terminate the process and report a test failure.  It'' important to
    use the active process for the test failure so that the failure reporting works correctly
    in the context of the exception handlers."

    | evaluated evaluationProcess result delay testProcess |

    evaluated := false.
    delay := Delay forDuration: aDuration.
    testProcess := Processor activeProcess.
    "Create a new process to evaluate aBlock"
    evaluationProcess := [
        result := aBlock value.
        evaluated := true.
        delay unschedule.
        testProcess resume ] forkNamed: 'Process to evaluate should: notTakeMoreThanMilliseconds:'.

    "Wait the milliseconds they asked me to"
    delay wait.
    "After this point either aBlock was evaluated or not..."
    evaluated ifFalse: [
        evaluationProcess terminate.
        self assert: false description: ('Block evaluation took more than the expected <1p>' expandMacrosWith: aDuration)].
   
    ^result! !

!CvTbTestCase methodsFor: 'extensions' stamp: ''!
should: aBlock notTakeMoreThanMilliseconds: anInteger
    "For compatibility with other Smalltalks"

   self should: aBlock notTakeMoreThan: (Duration milliSeconds: anInteger).! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.071'!
should: aBlock raise: anExceptionalEvent 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent)
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.079'!
should: aBlock raise: anExceptionalEvent description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent)
		description: aString
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.083'!
should: aBlock raise: anExceptionalEvent whoseDescriptionDoesNotInclude: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionNotContaining: subString)
		description: aString
! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.087'!
should: aBlock raise: anExceptionalEvent whoseDescriptionIncludes: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionContaining: subString)
		description: aString
! !

!CvTbTestCase methodsFor: 'extensions' stamp: 'bs 5/22/2011 12:53:14.411'!
should: aBlock raise: anException withExceptionDo: anotherBlock 

	^self assert: (self executeShould: aBlock inScopeOf: anException withExceptionDo: anotherBlock)! !

!CvTbTestCase methodsFor: 'extensions' stamp: 'bs 5/22/2011 12:53:14.401'!
shouldFix: aBlock 

	^self should: aBlock raise: Exception! !

!CvTbTestCase methodsFor: 'testing' stamp: 'bs 5/22/2011 12:53:14.337'!
shouldPass
	"Unless the selector is in the list we get from #expectedFailures, we expect it to pass"
	^ (self expectedFailures includes: testSelector) not! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.091'!
shouldnt: aBlock
	self deny: aBlock value
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.097'!
shouldnt: aBlock description: aString
	self deny: aBlock value description: aString
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.101'!
shouldnt: aBlock raise: anExceptionalEvent 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent) not
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.108'!
shouldnt: aBlock raise: anExceptionalEvent description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent) not 		description: aString
			! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.114'!
shouldnt: aBlock raise: anExceptionalEvent whoseDescriptionDoesNotInclude: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionNotContaining: subString) not
		description: aString
! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.118'!
shouldnt: aBlock raise: anExceptionalEvent whoseDescriptionIncludes: subString description: aString 
	^self assert: (self executeShould: aBlock inScopeOf: anExceptionalEvent withDescriptionContaining: subString) not
		description: aString
! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.122'!
signalFailure: aString
	TestResult failure signal: aString! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 14:03:09.193'!
tbClass
	^ self activeDict at: self tbClassName! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 14:03:12.443'!
tbClassMethod
	^ self tbClass class >> self tbClassMethodName! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 14:03:16.869'!
tbClassMethodName
	^ #new! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 14:03:20.285'!
tbClassName
	^ #CvTbPerson ! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 15:38:51.897'!
tbMethod
	^ self tbClass >> self tbMethodName! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 15:38:44.335'!
tbMethodName
	^ #firstname! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2011 10:54:36.959'!
tbPackageInfo
	^ PackageOrganizer default packageOfClass: self tbClass! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2011 10:56:48.844'!
tbPackageName
	^ self tbPackageInfo name! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 16:15:38.804'!
tbSubclass
	^ self activeDict at: self tbSubclassName! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 16:15:25.728'!
tbSubclassName
	^ #CvTbEmployee! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 09:38:42.364'!
tbTestClass
	^ self activeDict at: self tbTestClassName! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 09:38:31.429'!
tbTestClassName
	^ #CvTbPersonTest! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 10:42:21.497'!
tbTestMethod
	^ self tbClass >> self tbTestMethodName! !

!CvTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 10:42:08.207'!
tbTestMethodName
	^ #testFirstname! !

!CvTbTestCase methodsFor: 'running' stamp: 'bs 5/22/2011 12:53:14.319'!
tearDown! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.128'!
timeout: seconds
	"The timeout for a test should normally be set with a method annotation.
	However, for tests that are expected to run in images that do not support
	method annotations, the value may be set by setting the value from the
	#setUp method (i.e. prior to running the test method)."

	timeout := seconds! !

!CvTbTestCase methodsFor: 'running' stamp: ''!
timeout: aBlock after: seconds
	"Evaluate the argument block. Time out if the evaluation is not
	complete after the given number of seconds. Handle the situation
	that a timeout may occur after a failure (during debug)"

	| theProcess delay watchdog |

	"the block will be executed in the current process"
	theProcess := Processor activeProcess.
	delay := Delay forSeconds: seconds.

	"make a watchdog process"
	watchdog := [
		delay wait. 	"wait for timeout or completion"
		theProcess ifNotNil:[ theProcess signalException: 
			(TestFailure new messageText: 'Test timed out') ] 
	] newProcess.

	"Watchdog needs to run at high priority to do its job (but not at timing priority)"
	watchdog priority: Processor timingPriority-1.

	"catch the timeout signal"
	watchdog resume.				"start up the watchdog"
	^[aBlock on: TestFailure, Error, Halt do:[:ex|
		theProcess := nil.
		ex pass.
	]] ensure:[							"evaluate the receiver"
		theProcess := nil.				"it has completed, so ..."
		delay delaySemaphore signal.	"arrange for the watchdog to exit"
	]! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.132'!
timeoutForSetUp
	"Answer the timeout to use for setUp"

	| method |
	method := self class lookupSelector: testSelector asSymbol.
	(method pragmaAt: #timeout:) ifNotNil:[:tag| ^tag arguments first].
	^self defaultTimeout! !

!CvTbTestCase methodsFor: 'accessing' stamp: 'bs 5/22/2011 12:53:14.231'!
timeoutForTest
	"Answer the timeout to use for this test"

	| method |
	method := self class lookupSelector: testSelector asSymbol.
	(method pragmaAt: #timeout:) ifNotNil:[:tag| ^tag arguments first].
	^timeout ifNil: [self defaultTimeout]! !

Object subclass: #CvTestChangeIndicators
	instanceVariableNames: 'version morphSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvTestChangeIndicators class methodsFor: 'as yet unclassified' stamp: 'bs 12/10/2012 15:53:09.843'!
version: aVersion size: aPositiveNumber

	^ CvTestChangeIndicators new
		version: aVersion;
		morphSize: aPositiveNumber;
		yourself! !

!CvTestChangeIndicators methodsFor: 'as yet unclassified' stamp: 'bs 12/10/2012 15:49:14.742'!
asArray

	^ Array with: self newPassedIndicator with: self newDefectsIndicator! !

!CvTestChangeIndicators methodsFor: 'as yet unclassified' stamp: 'bs 12/10/2012 15:52:57.449'!
indicatorExtent

	^ self morphSize @ self morphSize! !

!CvTestChangeIndicators methodsFor: 'accessing' stamp: 'bs 12/10/2012 15:52:41.727'!
morphSize
	^ morphSize! !

!CvTestChangeIndicators methodsFor: 'accessing' stamp: 'bs 12/10/2012 15:52:41.734'!
morphSize: anObject
	morphSize := anObject! !

!CvTestChangeIndicators methodsFor: 'as yet unclassified' stamp: 'bs 12/10/2012 15:50:12.05'!
newDefectsIndicator

	| indicator |
	indicator := Morph new extent: self indicatorExtent.
	indicator color: (self version newDefectTests 
		ifNotEmpty: [Color solarizedOrange] 
		ifEmpty: [Color transparent]).
	^ indicator! !

!CvTestChangeIndicators methodsFor: 'as yet unclassified' stamp: 'bs 12/10/2012 15:50:07.336'!
newPassedIndicator
	| indicator |
	indicator := Morph new extent: self indicatorExtent.
	indicator color: (self version newlyPassedTests 
		ifNotEmpty: [Color solarizedGreen] 
		ifEmpty: [Color transparent]).
	^ indicator! !

!CvTestChangeIndicators methodsFor: 'accessing' stamp: 'bs 12/10/2012 15:45:54.113'!
version
	^ version! !

!CvTestChangeIndicators methodsFor: 'accessing' stamp: 'bs 12/10/2012 15:45:54.12'!
version: anObject
	version := anObject! !

Object subclass: #CvVersionGroup
	uses: TUiItemModel
	instanceVariableNames: 'codeReference children innerGroupFactory checked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

CvVersionGroup class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

CvVersionGroup subclass: #CvRefactoringGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvRefactoringGroup class methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2011 12:00:03.963'!
canGroup: newVersion forParent: parentGroup 

	^ newVersion isBeginOfRefactoring! !

!CvRefactoringGroup methodsFor: 'views' stamp: 'bs 8/16/2011 22:06:22.784'!
description

	^ self firstChild refactoringName! !

!CvRefactoringGroup methodsFor: 'grouping' stamp: 'bs 8/16/2011 22:04:28.843'!
wantsNewChild: aVersion

	^ self lastChild isEndOfRefactoring not! !

CvVersionGroup subclass: #CvRootGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvRootGroup methodsFor: 'as yet unclassified' stamp: 'bs 2/3/2012 19:25:59.753'!
initialize
	super initialize.
	self codeReference: CvCodeReference root! !

!CvRootGroup methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2012 17:30:57.352'!
innerGroupFactories
	
	^ {CvRefactoringGroup. CvSameMethodGroup}! !

!CvRootGroup methodsFor: 'as yet unclassified' stamp: 'bs 7/19/2012 19:34:51.799'!
insert: aNewVersion

	(aNewVersion predecessor ~= aNewVersion chronologicalPredecessor)
		ifTrue: [self modelReset].
		
	super insert: aNewVersion.
	self propertyChanged: #currentBaseIcon! !

CvVersionGroup subclass: #CvSameMethodGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvSameMethodGroup class methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2011 12:25:14.666'!
canGroup: newVersion forParent: parentGroup 
	| prevChange prevVersion |
	
	^ parentGroup hasChildren 
		and: [
			prevVersion := parentGroup lastChild.
			prevVersion isVersionGroup not] 
		and: [
			prevChange := prevVersion changedCodeReference.
			prevChange isCvMethodReference]
		and: [prevChange = newVersion changedCodeReference].! !

!CvSameMethodGroup class methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2011 12:36:19.066'!
newFor: newVersion parent: parentGroup
	| prevVersion |
	prevVersion := parentGroup lastChild.
	parentGroup removeChild: prevVersion.
	^ self basicNew
		initializeWithFirstChild: prevVersion;
		insert: newVersion;
		yourself! !

!CvSameMethodGroup methodsFor: 'views' stamp: 'bs 7/18/2012 17:28:32.336'!
affectedClassCategory

	^ self methodReference classCategoryReference name! !

!CvSameMethodGroup methodsFor: 'views' stamp: 'bs 8/17/2011 10:42:24.531'!
affectedClassName

	^ self methodReference className! !

!CvSameMethodGroup methodsFor: 'views' stamp: 'bs 8/17/2011 10:43:34.495'!
affectedMethodName

	^ self methodReference selector! !

!CvSameMethodGroup methodsFor: 'as yet unclassified' stamp: 'bs 2/26/2012 10:35:47.069'!
changeAsText

	^ self predecessorDiff 
		ifNil: [self systemEvent asString asText]
		ifNotNil: [self predecessorDiff cvSummaryBody]. ! !

!CvSameMethodGroup methodsFor: 'as yet unclassified' stamp: 'bs 11/17/2011 11:08:42.06'!
changedCodeReference

	^ self methodReference! !

!CvSameMethodGroup methodsFor: 'views' stamp: 'bs 2/26/2012 10:24:31.636'!
description

	^ 'Modified method (', self children size asString, ')'! !

!CvSameMethodGroup methodsFor: 'accessing' stamp: 'bs 8/17/2011 12:26:40.946'!
methodReference

	^ self firstVersion changedCodeReference! !

!CvSameMethodGroup methodsFor: 'as yet unclassified' stamp: 'bs 2/26/2012 10:35:02.195'!
predecessorDiff

	^ self predecessorPatch operations 
		ifEmpty: [nil]
		ifNotEmpty: [self predecessorPatch operations first].! !

!CvSameMethodGroup methodsFor: 'as yet unclassified' stamp: 'bs 2/26/2012 10:34:51.423'!
predecessorPatch

	^ self lastVersion patchRelativeToBase: self firstVersion predecessor! !

!CvSameMethodGroup methodsFor: 'grouping' stamp: 'bs 8/17/2011 10:38:14.569'!
wantsNewChild: aVersion

	^ self methodReference = aVersion changedCodeReference! !

!CvVersionGroup class methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2011 11:59:17.851'!
canGroup: newVersion forParent: parentGroup 

	^ false! !

!CvVersionGroup class methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2011 12:36:26.434'!
newFor: newVersion parent: parentGroup

	^ self basicNew
		initializeWithFirstChild: newVersion;
		yourself! !

!CvVersionGroup methodsFor: 'views' stamp: 'bs 7/18/2012 17:27:38.409'!
affectedClassCategory

	^ String space! !

!CvVersionGroup methodsFor: 'views' stamp: 'bs 8/16/2011 18:46:36.893'!
affectedClassName

	^ String space! !

!CvVersionGroup methodsFor: 'views' stamp: 'bs 8/16/2011 18:46:43.833'!
affectedMethodName

	^ String space! !

!CvVersionGroup methodsFor: 'grouping' stamp: 'bs 8/2/2011 15:40:33.094'!
append: newVersion orGroupWith: aVersion

	| commonParent |
	commonParent := aVersion changedCodeReference commonParentWith: newVersion changedCodeReference.
	self codeReference = commonParent
		ifTrue: [self appendChild: newVersion]
		ifFalse: [ | aGroup |
			aGroup := CvVersionGroup new codeReference: commonParent.
			aGroup 
				insert: aVersion;
				insert: newVersion.
			self removeChild: aVersion.
			self appendChild: aGroup].
	^ self! !

!CvVersionGroup methodsFor: 'grouping' stamp: 'bs 8/2/2011 18:52:43.667'!
append: newVersion orMergeWith: aGroup

	(newVersion changedCodeReference matches: aGroup changedCodeReference)
		ifTrue: [^ self lastChild insert: newVersion]
		ifFalse: [^ self append: newVersion orGroupWith: aGroup]

	! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 12/11/2012 10:55:19.282'!
appendChild: aVersionOrGroup

	self pvtChildren add: aVersionOrGroup.
	self childInserted: self pvtChildren size.
	self connect: aVersionOrGroup signal: #hasRunTests: toSelector: #processTestResult:! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 18:21:07.559'!
at: anIndex

	^ self pvtChildren at: anIndex! !

!CvVersionGroup methodsFor: 'branching' stamp: 'bs 7/19/2012 18:50:35.928'!
branch

	^ self lastChild branch! !

!CvVersionGroup methodsFor: 'views' stamp: ''!
branchDescription
	
	^ [self firstChild branchDescription]
		unless: [:desc | desc = String space]
		proceed: [self lastChild branchDescription]! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/2/2011 14:07:14.065'!
changeAsText

	^ Text new! !

!CvVersionGroup methodsFor: 'views' stamp: 'bs 8/17/2011 14:56:07.882'!
changeTimeAsText
	"
	| duration |
	duration := self lastVersion changeTimeStamp - self firstVersion changeTimeStamp.
	^ self lastVersion changeTimeAsText, 
		' (',  
		duration minutes ,
		' min)'
	"
	^ String space! !

!CvVersionGroup methodsFor: 'views' stamp: 'bs 8/2/2011 18:41:24.935'!
changeTimeStamp

	^ self lastVersion changeTimeStamp! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 17:29:03.833'!
changedCodeReference

	^ self codeReference! !

!CvVersionGroup methodsFor: 'views' stamp: 'bs 8/2/2011 14:11:38.965'!
changedEntityKind

	^ '' asText ! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2011 10:26:21.969'!
childBeforeLast

	^ self pvtChildren before: self lastChild! !

!CvVersionGroup methodsFor: 'item model' stamp: ''!
childCount

	^ self visibleChildren size! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 15:38:27.451'!
children
	
	^ self pvtChildren asArray! !

!CvVersionGroup methodsFor: 'accessing' stamp: 'bs 8/1/2011 15:29:09.399'!
codeReference
	^ codeReference! !

!CvVersionGroup methodsFor: 'accessing' stamp: 'bs 8/1/2011 15:29:09.453'!
codeReference: anObject
	codeReference := anObject! !

!CvVersionGroup methodsFor: 'views' stamp: 'bs 2/4/2012 11:13:47.703'!
currentBaseIcon

	^ self isActive
		ifTrue: [UiFugueIcons eyeHalfIcon]
		ifFalse: [nil]! !

!CvVersionGroup methodsFor: 'views' stamp: 'bs 8/16/2011 19:23:26.093'!
description

	^ String space! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 19:05:40.162'!
firstChild

	^ self children first! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 19:09:38.206'!
firstVersion

	^ [self firstChild] 
		unless: [:aChild | aChild isVersionGroup]
		proceed: [:aGroup | aGroup firstChild]! !

!CvVersionGroup methodsFor: 'item model - hierarchy' stamp: 'bs 11/16/2012 13:36:54.025'!
groups
	"Return a list of all child groups. Each group can be implemented as #groupName returning a list of all child nodes OR handled in #childAt:inGroup:."
	
	^ #(visibleChildren)! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/2/2011 18:18:05.876'!
hasChild: aVersionOrGroup

	^ self pvtChildren includes: aVersionOrGroup! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 17:52:13.351'!
hasChildren

	^ self pvtChildren isEmpty not! !

!CvVersionGroup methodsFor: 'test result' stamp: 'bs 12/11/2012 10:56:44.206'!
hasRunTests: aTestResult
	
	self emit! !

!CvVersionGroup methodsFor: 'branching' stamp: 'bs 7/19/2012 19:28:02.831'!
hasSuccessors

	^ false! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/2/2011 15:23:31.116'!
indexOf: aChild

	^ self pvtChildren indexOf: aChild! !

!CvVersionGroup methodsFor: 'initialize-release' stamp: 'bs 8/16/2011 19:26:08.438'!
initializeWithFirstChild: aVersion

	self	
		initialize;
		appendChild: aVersion! !

!CvVersionGroup methodsFor: 'grouping' stamp: 'bs 8/17/2011 12:22:49.91'!
innerGroupFactories

	^ self innerGroupFactory
		ifNil: [Array new]
		ifNotNil: [:factory | Array with: factory]! !

!CvVersionGroup methodsFor: 'accessing' stamp: 'bs 8/16/2011 17:20:22.173'!
innerGroupFactory
	^ innerGroupFactory! !

!CvVersionGroup methodsFor: 'accessing' stamp: 'bs 8/16/2011 17:20:22.182'!
innerGroupFactory: anObject
	innerGroupFactory := anObject! !

!CvVersionGroup methodsFor: 'grouping' stamp: ''!
insert: newVersion
	"self halt."
	"return the topmost group that has been changed to"
	newVersion hasPredecessor ifFalse: [self appendChild: newVersion. ^ self].
	self supportsInnerGroups ifFalse: [self appendChild: newVersion. ^ self].
		
	(self hasChildren 
		and: [self lastChild isVersionGroup]
		and: [self lastChild wantsNewChild: newVersion])
			ifTrue: [^ self lastChild insert: newVersion].
	
	self innerGroupFactories 
		detect: [:ea | ea canGroup: newVersion forParent: self]
		thenDo: [:factory | self appendChild: (factory newFor: newVersion parent: self)]
		ifNone: [self appendChild: newVersion]! !

!CvVersionGroup methodsFor: 'views' stamp: 'bs 2/3/2012 19:30:07.747'!
isActive

	^ self children contains: [:ea | ea isActive]! !

!CvVersionGroup methodsFor: 'views' stamp: 'bs 12/26/2012 18:37:54.765'!
isCheckable

	^ false! !

!CvVersionGroup methodsFor: 'views' stamp: 'bs 2/4/2012 16:40:18.035'!
isChecked

	^ checked ifNil: [checked := false]! !

!CvVersionGroup methodsFor: 'views' stamp: 'bs 2/4/2012 16:40:25.105'!
isChecked: aBoolean

	checked := aBoolean! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 17:33:26.917'!
isVersionGroup

	^ true! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: ''!
isVisible

	^ self visibleChildren size > 0! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 15:56:02.025'!
lastChild

	^ self children last! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 19:09:52.065'!
lastVersion

	^ [self lastChild] 
		unless: [:aChild | aChild isVersionGroup]
		proceed: [:aGroup | aGroup lastChild]! !

!CvVersionGroup methodsFor: 'views' stamp: 'bs 1/23/2012 16:52:57.634'!
menu
	^ nil! !

!CvVersionGroup methodsFor: 'test result' stamp: 'bs 12/10/2012 16:02:38.093'!
newDefectTests
	
	self lastChild predecessor ifNil: [^ Set new].
	^ self lastChild defectTests difference: self firstChild predecessor defectTests! !

!CvVersionGroup methodsFor: 'test result' stamp: 'bs 12/10/2012 16:02:43.15'!
newlyPassedTests
	
	self lastChild predecessor ifNil: [^ Set new].
	^ self lastChild passedTests difference: self firstChild predecessor passedTests! !

!CvVersionGroup methodsFor: 'branching' stamp: 'bs 7/19/2012 18:54:16.514'!
numberOfBranches

	^ self lastChild numberOfBranches! !

!CvVersionGroup methodsFor: 'branching' stamp: 'bs 7/19/2012 18:52:51.148'!
numberOfSuccessiveBranches

	^ self lastChild numberOfSuccessiveBranches! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 18:34:23.486'!
patchRelativeToBase: aCodeBase

	^ self lastChild patchRelativeToBase: aCodeBase ! !

!CvVersionGroup methodsFor: 'test result' stamp: 'bs 12/11/2012 11:01:43.958'!
processTestResult: aTestResult

	self propertiesChanged: #(testResult).
	self hasRunTests: aTestResult! !

!CvVersionGroup methodsFor: 'item model - properties' stamp: 'bs 12/11/2012 10:39:32.493'!
properties
	"Return an ordered list of all known properties. This list can then be used to configure column specifications of item views more conveniently."
	
	^ #(testResult)! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 15:38:10.854'!
pvtChildren

	^ children ifNil: [children := OrderedCollection new]! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: ''!
removeChild: aVersionOrGroup
	| oldObject |
	oldObject := self pvtChildren remove: aVersionOrGroup.
	self childRemoved: self pvtChildren size + 1 "the previous position".
	^ oldObject! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 18:33:43.848'!
screenshot

	^ self lastChild screenshot! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 18:18:06.864'!
size

	^ self pvtChildren size! !

!CvVersionGroup methodsFor: 'grouping' stamp: 'bs 8/17/2011 12:21:10.3'!
supportsInnerGroups

	^ self innerGroupFactories notEmpty! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 18:24:32.223'!
systemEvent

	^ self lastChild systemEvent! !

!CvVersionGroup methodsFor: 'test result' stamp: 'bs 2/26/2012 10:47:01.159'!
testResult

	^ self lastVersion testResult! !

!CvVersionGroup methodsFor: 'views' stamp: 'bs 11/16/2012 13:41:35.473'!
timeCreated

	^ String space! !

!CvVersionGroup methodsFor: 'views' stamp: 'bs 2/4/2012 16:42:09.286'!
uncheck

	self isChecked: false.
	self propertyChanged: #isChecked! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 18:24:16.781'!
versionInfo

	^ self lastChild versionInfo! !

!CvVersionGroup methodsFor: 'as yet unclassified' stamp: ''!
visibleChildren

	^ self pvtChildren select: [:ea | ea isVisible]! !

!CvVersionGroup methodsFor: 'grouping' stamp: 'bs 8/16/2011 22:03:33.568'!
wantsNewChild: aVersion

	^ false! !

!Object class methodsFor: '*CV' stamp: 'bs 4/30/2012 16:46:30.778'!
addCopyTo: aCodeBase do: aBlock
	| copyOfSelf |
	self assert: [self activeCodeBase ~= aCodeBase].
	self removeInvalidSubclassesFrom: aCodeBase.
	
	copyOfSelf := aCodeBase adoptCopyOfClass: self.
	copyOfSelf superclass ~= self superclass
		ifTrue: [
			copyOfSelf superclass 
				addSubclassOrReplaceEquallyNamedWith: copyOfSelf].
		
	self subclasses
		select: [ :subclass | subclass mustNotBeLateBound ]
		thenDo: [ :subclass | 
			copyOfSelf addSubclass: subclass.
			subclass withAllSubclassesDo: [:aClass | 
				self assert: [aClass == (aCodeBase classNamed: aClass name)]
				"aCodeBase dictionary at: aClass name put: aClass"]].
		
	self subclasses
		select: [ :ea | ea canBeLateBound ]
		thenDo: [ :ea | ea addCopyTo: aCodeBase do: aBlock].
		
	aBlock cull: self cull: copyOfSelf.
	^ copyOfSelf! !

!Object class methodsFor: '*CV' stamp: 'bs 8/10/2011 13:30:15.162'!
addTo: aCodeBase
	
	(self superclass valueAt: aCodeBase) addSubclass: self.
	aCodeBase dictionary at: self name put: self.
	aCodeBase organization classify: self name under: self category! !

!Object class methodsFor: '*CV' stamp: 'bs 5/22/2011 15:26:35.423'!
copyClassVars

	self classPool keysAndValuesDo: [:key :value |
		self classPool at: key put: value copy].! !

!Object class methodsFor: '*CV' stamp: 'bs 2/3/2012 15:08:54.361'!
cvOriginal

	"^ cvOriginal ifNotNil: [:weakArray | weakArray first]"
	^ nil! !

!Object class methodsFor: '*CV' stamp: 'bs 1/27/2012 08:31:26.412'!
cvOriginal: aClass

	"aClass 
		ifNil: [ cvOriginal := nil ]
		ifNotNil: [ cvOriginal := WeakArray with: aClass ]"! !

!Object class methodsFor: '*CV' stamp: 'bs 1/27/2012 08:31:33.769'!
cvOriginalOrSelf

	"^ cvOriginal ifNil: [self]"! !

!Object class methodsFor: '*CV' stamp: 'bs 3/21/2011 10:15:15.82'!
parent
	^ self superclass! !

!Object class methodsFor: '*CV' stamp: 'bs 8/22/2011 19:52:30.948'!
removeFrom: aCodeBase
	
	(self valueAt: aCodeBase) ifNotNil: [:aClass |
		
		self basedOn: aCodeBase do: [
			
			aClass withAllSubclassesDo: [:ea | 
				aCodeBase dictionary removeKey: ea name ifAbsent: []].
			
			(aClass superclass valueAt: aCodeBase) removeSubclass: aClass]]! !

!Object class methodsFor: '*CV' stamp: 'bs 8/29/2011 15:23:04.63'!
removeInvalidSubclassesFrom: aCodeBase

	self basedOn: aCodeBase do: [
		(self valueAt: aCodeBase) ifNotNil: [:classToBeReplaced |
			classToBeReplaced subclasses 
				reject: [:ea | self subclasses includes: ea]
				thenDo: [:ea | ea removeFrom: aCodeBase]]].! !

!Object methodsFor: '*CV' stamp: 'bs 8/26/2011 13:42:14.233'!
activeWorkingCopy

	self assert: [self activeCodeBase isCvWorkingCopy].
	^ self activeCodeBase! !

!RecategorizedEvent methodsFor: '*CV' stamp: 'bs 8/25/2011 16:00:43.97'!
changedMetaObject

	^ self itemKind == self class classKind
		ifTrue: [self item]
		ifFalse: [
			self assert: [self itemKind == self class methodKind].
			self item parent].! !

!RecategorizedEvent methodsFor: '*CV' stamp: 'bs 4/30/2012 12:08:12.347'!
checkoutChangesTo: aWorkingCopy

	self isClassItem
		ifTrue: [self copyOrganizationTo: aWorkingCopy]
		ifFalse: [
			self assert: [self isMethodItem].
			(self cvItemReference bind: aWorkingCopy)
				organization: (self reboundItem organization deepCopy)].! !

!RecategorizedEvent methodsFor: '*CV' stamp: 'bs 4/30/2012 12:01:31.957'!
cleanUpChangesTo: aVersion

	self isClassItem
		ifTrue: [self copyOrganizationTo: aVersion]
		ifFalse: [
			self assert: [self isMethodItem].
			self item parent saveFlatCopyTo: aVersion].! !

!RecategorizedEvent methodsFor: '*CV' stamp: 'bs 8/30/2011 11:51:27.548'!
includedInCheckoutOf: aClass

	^ self reboundItem = aClass! !

!RecategorizedEvent methodsFor: '*CV' stamp: 'bs 8/23/2012 13:15:14.252'!
itemToBeCheckedOut

	^ self isMethodItem 
		ifTrue: [self cvParentItemReference] 
		ifFalse: [nil]! !

!RecategorizedEvent methodsFor: '*CV' stamp: 'bs 8/23/2012 14:37:50.265'!
requiresCheckoutTo: aWorkingCopy

	self isMethodItem ifFalse: [^ false].
	
	^ (self cvParentItemReference bind: self activeCodeBase)
		ifNil: [false] 
		ifNotNil: [:boundItem |
			boundItem requiresReCheckoutTo: aWorkingCopy]! !

!String methodsFor: '*CV' stamp: ''!
lineNumberForIndex: anIndex
	| lineCount |
	lineCount := 0.
	self lineIndicesDo: [:start :endWithoutDelimiters :end |
		lineCount := lineCount + 1.
		anIndex <= end ifTrue: [^ lineCount]].
	^ lineCount! !

!MCAddition methodsFor: '*CV' stamp: 'bs 11/9/2012 16:10:02.503'!
cvSummaryPrefix
	^ 'A'! !

!OBMethodDefinition methodsFor: '*CV' stamp: 'bs 2/27/2012 21:47:39.279'!
isMethodDefinition

	^ true! !

MenuMorph subclass: #CvVersionMenu
	instanceVariableNames: 'version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI'!

!CvVersionMenu class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.156'!
canBeLateBound
	^ false! !

!CvVersionMenu class methodsFor: 'as yet unclassified' stamp: 'bs 1/11/2012 16:33:03.084'!
version: aCvVersion

	^ self basicNew initializeWith: aCvVersion! !

!CvVersionMenu methodsFor: 'as yet unclassified' stamp: 'bs 2/4/2012 16:39:14.351'!
allCheckedVersions

	^ self allVersions select: [:ea | ea isChecked]! !

!CvVersionMenu methodsFor: 'as yet unclassified' stamp: 'bs 2/3/2012 23:01:41.077'!
allVersions

	^ self version controller versionsChronologically! !

!CvVersionMenu methodsFor: 'as yet unclassified' stamp: 'bs 2/4/2012 18:11:47.839'!
appendSelectionMenuItems
		
	self 
		addMenuItem: (MenuItemMorph new
			contents: 'clear selection';
			target: self;
			selector: #clearSelection;
			arguments: Array new;
			isEnabled: self allCheckedVersions notEmpty);
		addMenuItem: (MenuItemMorph new
			contents: 'apply changes here';
			target: self;
			selector: #applyChanges;
			isEnabled: (self allCheckedVersions notEmpty and: self version isActive));
		"addMenuItem: (MenuItemMorph new
			contents: 'revert changes on ...';
			subMenu: self buildRevertChangesSubmenu;
			icon: nil;
			isEnabled: self allCheckedVersions notEmpty);"
		addMenuItem: (MenuItemMorph new
			contents: 'merge with selected version';
			target: self;
			selector: #mergeSelectedVersion;
			arguments: Array new;
			isEnabled: (self version isActive and: [self allCheckedVersions size = 1])).! !

!CvVersionMenu methodsFor: 'as yet unclassified' stamp: 'bs 2/4/2012 18:10:48.217'!
applyChanges
	 | ranges patchBase lastVersion patch |
	self assert: [self activeWorkingCopy baseVersion = self version].
	
	ranges := self collectCheckedVersionInRanges.
	ranges do: [:eachRange |
		patchBase := eachRange first predecessor.
		lastVersion := eachRange last.
		patch := lastVersion patchRelativeToBase: patchBase.
		self activeWorkingCopy applyPatch: patch ]! !

!CvVersionMenu methodsFor: 'rebasing' stamp: 'bs 1/11/2012 16:35:55.151'!
buildRebaseItemFor: aWorkingCopy
	
	^ MenuItemMorph new
			contents: aWorkingCopy asString;
			target: self;
			selector: #rebaseWorkingCopy: ;
			arguments: {aWorkingCopy};
			icon: (aWorkingCopy color iconOrThumbnailOfSize: 10)! !

!CvVersionMenu methodsFor: 'rebasing' stamp: 'bs 12/10/2012 14:00:28.544'!
buildRebaseItems

	self addMenuItem: (
		(self buildRebaseItemFor: self activeCodeBase)
			contents: 'rebase here';
			isEnabled: self isBaseVersionOfActiveWorkingCopy not)! !

!CvVersionMenu methodsFor: 'test results' stamp: 'bs 5/13/2011 21:37:50.432'!
buildTestRunnerItem

	self isBaseVersionOfActiveWorkingCopy
		ifTrue: [self add: 'open TestRunner' action: #openTestRunner]
		ifFalse: [self add: 'open TestRunner' action: #openTestRunnerInNewEnvironment]! !

!CvVersionMenu methodsFor: 'as yet unclassified' stamp: ''!
checkoutAndOpenInNewEnvironment
	| newWorkingCopy |
	newWorkingCopy := self version checkout.
	newWorkingCopy openInNewEnvironment! !

!CvVersionMenu methodsFor: 'as yet unclassified' stamp: 'bs 2/3/2012 23:07:50.2'!
clearSelection

	self allCheckedVersions do: [:ea | ea uncheck]! !

!CvVersionMenu methodsFor: 'as yet unclassified' stamp: 'bs 2/4/2012 17:22:13.024'!
collectCheckedVersionInRanges
	
	^  CvCheckedVersionRangesCollector new
		setVersions: self version controller versionsChronologically;
		collect! !

!CvVersionMenu methodsFor: 'test results' stamp: 'bs 8/1/2012 15:54:49.158'!
createTestRunner
	| runner runnerWindow |
	runner := TestRunner new.
	runner selectCategoriesOfPackageUnderDevelopment.
	runnerWindow := ToolBuilder build: runner.
	runnerWindow model 
		result: self version testResult;
		updateResults.
	runnerWindow refreshWindowColor.
	^ runnerWindow! !

!CvVersionMenu methodsFor: 'as yet unclassified' stamp: 'bs 2/3/2012 22:58:18.1'!
initializeWith: aCvVersion
	self initialize.
	self defaultTarget: self.
	version := aCvVersion.
	
	self buildRebaseItems.
	self buildTestRunnerItem.
	.
	self add: 'edit in new env' action: #checkoutAndOpenInNewEnvironment.
	
	self addLine.	
	self appendSelectionMenuItems.! !

!CvVersionMenu methodsFor: 'accessing' stamp: 'bs 1/12/2012 09:27:17.333'!
isBaseVersionOfActiveWorkingCopy
	
	^ true! !

!CvVersionMenu methodsFor: 'as yet unclassified' stamp: 'bs 5/13/2011 14:13:42.096'!
isWorkingCopyActive
	^ self psCodeBase isCvWorkingCopy! !

!CvVersionMenu methodsFor: 'test results' stamp: 'bs 5/13/2011 20:52:39.034'!
openTestRunner
	
	self createTestRunner openInHand! !

!CvVersionMenu methodsFor: 'test results' stamp: 'bs 5/13/2011 21:43:18.447'!
openTestRunnerInNewEnvironment
	| testWc testWcEnv |	
	testWc := self version checkout.
	self basedOn: testWc do: [ 
		testWcEnv := testWc openInNewEnvironment.
		testWcEnv addMorph: (
			self createTestRunner center: testWcEnv center)]! !

!CvVersionMenu methodsFor: 'rebasing' stamp: 'bs 1/11/2012 16:35:29.386'!
rebaseWorkingCopy: aWc
	
	aWc rebaseTo: self version! !

!CvVersionMenu methodsFor: 'accessing' stamp: 'bs 1/11/2012 16:31:10.281'!
version
	^ version! !

CvVersionMenu subclass: #CvVersionNodeMenu
	instanceVariableNames: 'versionNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Nodes'!

!CvVersionNodeMenu class methodsFor: 'as yet unclassified' stamp: 'bs 1/11/2012 16:32:20.426'!
versionNode: aCvVersionNode
	
	^ self basicNew initializeWith: aCvVersionNode! !

!CvVersionNodeMenu methodsFor: 'as yet unclassified' stamp: 'bs 2/3/2012 22:57:53.676'!
appendSelectionMenuItems
		
	self versionNode appendSelectionMenuItems: self.! !

!CvVersionNodeMenu methodsFor: 'accessing' stamp: 'bs 1/11/2012 16:34:57.853'!
assignedWorkingCopies

	^ self versionNode assignedWorkingCopies! !

!CvVersionNodeMenu methodsFor: 'as yet unclassified' stamp: 'bs 2/3/2012 22:55:54.799'!
initializeWith: aCvVersionNode
	versionNode := aCvVersionNode.
	super initializeWith: aCvVersionNode version.! !

!CvVersionNodeMenu methodsFor: 'accessing' stamp: 'bs 1/12/2012 09:27:09.722'!
isBaseVersionOfActiveWorkingCopy
	
	^ self assignedWorkingCopies includes: self activeWorkingCopy! !

!CvVersionNodeMenu methodsFor: 'accessing' stamp: 'bs 1/11/2012 16:31:17.757'!
versionNode
	^ versionNode! !

!CvVersionNodeMenu methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2012 13:31:47.285'!
workingCopies
	^ self versionNode workingCopies! !

!WorldState methodsFor: '*CV' stamp: 'bs 3/8/2011 09:30:19.59'!
cvController
	^ self slotNamed: self cvInstVarName.! !

!WorldState methodsFor: '*CV' stamp: 'bs 3/8/2011 09:31:52.445'!
cvController: aCvController
	^ self slotNamed: self cvInstVarName put: aCvController.! !

!WorldState methodsFor: '*CV' stamp: 'bs 3/2/2011 13:26:36.654'!
cvInstVarName
	^ 'continuousVersioning'! !

!WorldState methodsFor: '*CV' stamp: 'bs 5/13/2011 19:46:51.274'!
cvVersionBar
	^ self slotNamed: self cvVersionBarInstVarName! !

!WorldState methodsFor: '*CV' stamp: 'bs 5/13/2011 19:46:29.337'!
cvVersionBar: aVersionBar
	^ self slotNamed: self cvVersionBarInstVarName put: aVersionBar.! !

!WorldState methodsFor: '*CV' stamp: 'bs 5/13/2011 19:46:23.434'!
cvVersionBarInstVarName
	^ 'cvVersionBar'! !

!FormMenuView class methodsFor: '*CV' stamp: 'bs 4/29/2011 21:13:42.669'!
canBeLateBound
	^ false! !

!MCModification methodsFor: '*CV' stamp: 'bs 11/9/2012 16:10:07.021'!
cvSummaryPrefix
	^ 'M'! !

!Metaclass class methodsFor: '*CV' stamp: 'bs 4/30/2012 16:47:10.905'!
addCopyTo: aCodeBase do: aBlock
	| copyOfSelf superclassForCopyOfSelf |
	"already prepared in ProtoObject class addCopyTo:do:"
	copyOfSelf := aCodeBase metaclassClass.
	superclassForCopyOfSelf := copyOfSelf superclass valueAt: aCodeBase.
	
	self assert: [copyOfSelf notNil & (copyOfSelf ~= Metaclass)].
	aCodeBase adoptClass: copyOfSelf.
			
	copyOfSelf superclassWithoutFlushingCache: superclassForCopyOfSelf.
	copyOfSelf class superclassWithoutFlushingCache: superclassForCopyOfSelf class.
	superclassForCopyOfSelf 
		addSubclassOrReplaceEquallyNamedWith: copyOfSelf.
	
	^ copyOfSelf! !

!Metaclass class methodsFor: '*CV' stamp: 'bs 8/23/2011 10:59:39.687'!
canBeLateBound

	^ true! !

!Metaclass class methodsFor: '*CV' stamp: 'bs 8/22/2011 22:26:03.777'!
checkoutChangesTo: aWorkingCopy withSuperclass: superclassForCopyOfSelf
	
	
	
	! !

!Metaclass methodsFor: '*CV' stamp: 'bs 8/8/2011 15:31:40.126'!
checkoutCopyTo: aWorkingCopy

	^ (self theNonMetaClass checkoutCopyTo: aWorkingCopy) theMetaClass! !

!Metaclass methodsFor: '*CV' stamp: 'bs 8/30/2011 12:02:24.806'!
cleanUpSubclasses

	self theNonMetaClass cleanUpSubclasses! !

!Metaclass methodsFor: '*CV' stamp: 'bs 8/10/2011 13:38:45.417'!
copy
	| copyOfSelf |
	copyOfSelf := super copy.
	copyOfSelf organization: self organization deepCopy.
	^ copyOfSelf! !

!Metaclass methodsFor: '*CV' stamp: 'TM 3/11/2011 13:32:32.227'!
cvCategory

	^ self parent cvCategory! !

!Metaclass methodsFor: '*CV' stamp: 'bs 2/28/2011 11:48:53.984'!
parent
	^ self theNonMetaClass! !

!Metaclass methodsFor: '*CV' stamp: 'bs 7/29/2011 15:18:33.388'!
rebindSubclassesToActiveCodeBase
! !

!Metaclass methodsFor: '*CV' stamp: 'bs 4/30/2012 14:47:13.729'!
requiresReCheckoutTo: aWorkingCopy

	^ self theNonMetaClass requiresReCheckoutTo: aWorkingCopy! !

!Metaclass methodsFor: '*CV' stamp: 'bs 8/8/2011 15:31:44.796'!
saveCopyTo: aVersion

	^ (self theNonMetaClass saveCopyTo: aVersion) theMetaClass! !

!Metaclass methodsFor: '*CV' stamp: 'bs 8/27/2011 14:56:35.768'!
saveFlatCopyTo:	 aVersion
	
	^ (self theNonMetaClass saveFlatCopyTo: aVersion) theMetaClass! !

!Metaclass methodsFor: '*CV' stamp: 'bs 5/16/2012 13:26:12.279'!
saveHierarchyCopyTo: aVersion
	
	^ (self theNonMetaClass saveHierarchyCopyTo: aVersion) theMetaClass! !

!Metaclass methodsFor: '*CV' stamp: 'bs 3/26/2011 20:36:17.977'!
valueAt: aCodeBase
	
	^ (self theNonMetaClass valueAt: aCodeBase) ifNotNil: [:c | c theMetaClass]! !

!OBBrowser methodsFor: '*CV' stamp: 'bs 8/24/2012 13:44:20.173'!
psRebaseTo: aCodeBase
	| currentNode |
	self currentOrRootNode ifNil: [^ self].
	self currentOrRootNode isEnvironmentNode ifTrue: [^ self].
	
	currentNode := self currentNode.
	self navigationPanel columns do: [:ea | ea changed: #list].
	self psEnsureConsistentSelection.
	
	currentNode cvItemReference isValidInActiveCodeBase ifFalse: [^ self].
	self basedOn: aCodeBase do: [
		self jumpTo: currentNode.
		self signalRefresh]! !

!OBBrowser methodsFor: '*CV' stamp: 'bs 7/24/2011 12:49:02.676'!
supportsPreview

	^ true! !

!OBClassAwareNode methodsFor: '*CV' stamp: ''!
backgroundColor
	| activeWC |
	activeWC := self activeWorkingCopy.
	^ activeWC referenceWC ifNotNil: [:refWC |
		(self cvItem valueAt: activeWC baseVersion) == 
			(self cvItem valueAt: refWC baseVersion)
			ifTrue: [Color lightGray muchLighter]
			ifFalse: [nil]]
	! !

!OBClassAwareNode methodsFor: '*CV' stamp: ''!
cvItem

	^ self theClass ! !

!OBClassAwareNode methodsFor: '*CV' stamp: 'bs 8/12/2011 15:50:59.061'!
cvItemReference
	
	^ CvCodeReference class: self theClass! !

!OBClassAwareNode methodsFor: '*CV' stamp: 'bs 6/24/2012 17:17:04.218'!
valueAt: aCodeBase

	^ (self theClass valueAt: aCodeBase) 
		ifNotNil: [:aClass | 
			(self class valueAt: aCodeBase) new
				theClass: aClass;
				yourself]! !

UserInterface subclass: #CvBrowserUi
	instanceVariableNames: 'treeView unnamedMorph1 screenshotContainer changeDetails patchViewContainer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

!CvBrowserUi methodsFor: 'accessing' stamp: 'bs 7/28/2011 16:54:00.179'!
changeDetails
	"nil"
	
	^ changeDetails! !

!CvBrowserUi methodsFor: 'ui - private' stamp: 'bs 7/28/2011 16:54:00.298'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (1200@600).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (4).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#leftToRight).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	panel color: (Color darkGray).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	treeView := CvBrowserTreeView new.
	treeView extent: (882@592).
	treeView position: (4@4).
	treeView hResizing: (#spaceFill).
	treeView vResizing: (#spaceFill).
	treeView cellInset: (0).
	treeView cellPositioning: (#center).
	treeView cellSpacing: (#none).
	treeView layoutInset: (0).
	treeView listCentering: (#topLeft).
	treeView listDirection: (#topToBottom).
	treeView listSpacing: (#none).
	treeView maxCellSize: (1073741823).
	treeView minCellSize: (0).
	treeView wrapCentering: (#topLeft).
	treeView wrapDirection: (#none).
	treeView frameFractions: (0@0 corner: 1@1).
	treeView frameOffsets: (0@0 corner: 0@0).
	treeView balloonText: (nil).
	treeView balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	treeView widgetResizable: (false).
	treeView horizontalScrollBarPolicy: (#asNeeded).
	treeView verticalScrollBarPolicy: (#asNeeded).
	treeView outerBorderWidth: (0).
	treeView scrollBarThickness: (9).
	treeView modelClass: (nil).
	treeView horizontalHeaderVisible: (true).
	treeView verticalHeaderVisible: (false).
	treeView selectionBehavior: (#selectRows).
	treeView selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	treeView selectionMode: (UiViewSingleSelection).
	treeView setProperty: #objectName toValue: 'treeView'.
	panel addMorphBack: treeView.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (300@592).
	unnamedMorph1 position: (893@4).
	unnamedMorph1 hResizing: (#rigid).
	unnamedMorph1 vResizing: (#spaceFill).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (4).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#topToBottom).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color lightGray).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	screenshotContainer := UiContainer new.
	screenshotContainer changeProportionalLayout.
	screenshotContainer extent: (292@172).
	screenshotContainer position: (897@11).
	screenshotContainer hResizing: (#spaceFill).
	screenshotContainer vResizing: (#rigid).
	screenshotContainer cellInset: (4).
	screenshotContainer cellPositioning: (#center).
	screenshotContainer cellSpacing: (#none).
	screenshotContainer layoutInset: (0).
	screenshotContainer listCentering: (#topLeft).
	screenshotContainer listDirection: (#topToBottom).
	screenshotContainer listSpacing: (#none).
	screenshotContainer maxCellSize: (1073741823).
	screenshotContainer minCellSize: (0).
	screenshotContainer wrapCentering: (#topLeft).
	screenshotContainer wrapDirection: (#none).
	screenshotContainer frameFractions: (0@0 corner: 1@1).
	screenshotContainer frameOffsets: (0@0 corner: 0@0).
	screenshotContainer balloonText: (nil).
	screenshotContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	screenshotContainer color: (Color white).
	screenshotContainer borderWidth: (0).
	screenshotContainer borderStyle2: (#simple).
	screenshotContainer borderColor: (Color black).
	screenshotContainer setProperty: #objectName toValue: 'screenshotContainer'.
	unnamedMorph1 addMorphBack: screenshotContainer.
	changeDetails := UiTextEdit new.
	changeDetails extent: (292@130).
	changeDetails position: (897@191).
	changeDetails hResizing: (#spaceFill).
	changeDetails vResizing: (#rigid).
	changeDetails cellInset: (0).
	changeDetails cellPositioning: (#center).
	changeDetails cellSpacing: (#none).
	changeDetails layoutInset: (0).
	changeDetails listCentering: (#topLeft).
	changeDetails listDirection: (#topToBottom).
	changeDetails listSpacing: (#none).
	changeDetails maxCellSize: (1073741823).
	changeDetails minCellSize: (0).
	changeDetails wrapCentering: (#topLeft).
	changeDetails wrapDirection: (#none).
	changeDetails frameFractions: (0@0 corner: 1@1).
	changeDetails frameOffsets: (0@0 corner: 0@0).
	changeDetails balloonText: (nil).
	changeDetails balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	changeDetails widgetResizable: (true).
	changeDetails horizontalScrollBarPolicy: (#alwaysOff).
	changeDetails verticalScrollBarPolicy: (#alwaysOn).
	changeDetails outerBorderWidth: (1).
	changeDetails scrollBarThickness: (9).
	changeDetails theText: ('').
	changeDetails readOnly: (false).
	changeDetails autoConvert: (false).
	changeDetails autoAccept: (false).
	changeDetails acceptOnFocusLost: (false).
	changeDetails scrollingMode: (#none).
	changeDetails scrollingLimit: (10).
	changeDetails setProperty: #objectName toValue: 'changeDetails'.
	unnamedMorph1 addMorphBack: changeDetails.
	patchViewContainer := UiContainer new.
	patchViewContainer changeTableLayout.
	patchViewContainer extent: (292@266).
	patchViewContainer position: (897@326).
	patchViewContainer hResizing: (#spaceFill).
	patchViewContainer vResizing: (#spaceFill).
	patchViewContainer cellInset: (0).
	patchViewContainer cellPositioning: (#center).
	patchViewContainer cellSpacing: (#none).
	patchViewContainer layoutInset: (0).
	patchViewContainer listCentering: (#topLeft).
	patchViewContainer listDirection: (#topToBottom).
	patchViewContainer listSpacing: (#none).
	patchViewContainer maxCellSize: (1073741823).
	patchViewContainer minCellSize: (0).
	patchViewContainer wrapCentering: (#topLeft).
	patchViewContainer wrapDirection: (#none).
	patchViewContainer frameFractions: (0@0 corner: 1@1).
	patchViewContainer frameOffsets: (0@0 corner: 0@0).
	patchViewContainer balloonText: (nil).
	patchViewContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	patchViewContainer color: (Color white).
	patchViewContainer borderWidth: (0).
	patchViewContainer borderStyle2: (#simple).
	patchViewContainer borderColor: (Color black).
	patchViewContainer setProperty: #objectName toValue: 'patchViewContainer'.
	unnamedMorph1 addMorphBack: patchViewContainer.
	panel addMorphBack: unnamedMorph1.
	panel setProperty: #uiClassName toValue: 'CvBrowser'.! !

!CvBrowserUi methodsFor: 'accessing' stamp: 'bs 7/28/2011 16:54:00.238'!
patchViewContainer
	"nil"
	
	^ patchViewContainer! !

!CvBrowserUi methodsFor: 'accessing' stamp: 'bs 7/28/2011 16:53:59.981'!
screenshotContainer
	"nil"
	
	^ screenshotContainer! !

!CvBrowserUi methodsFor: 'accessing' stamp: 'bs 7/28/2011 16:53:59.927'!
treeView
	"nil"
	
	^ treeView! !

UserInterface subclass: #CvBrowserUi2
	instanceVariableNames: 'treeView menu main screenshotContainer changeDetails patchViewContainer selectionFilterSwitch rightColumnContainer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

!CvBrowserUi2 methodsFor: 'accessing' stamp: ''!
changeDetails
	"nil"
	
	^ changeDetails! !

!CvBrowserUi2 methodsFor: 'ui - private' stamp: 'bs 11/16/2012 14:49:02.335'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (1200@650).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (0).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (0).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.933)).
	panel color: (Color darkGray).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	menu := UiContainer new.
	menu changeTableLayout.
	menu extent: (1192@25).
	menu position: (4@7).
	menu hResizing: (#spaceFill).
	menu vResizing: (#rigid).
	menu cellInset: (4).
	menu cellPositioning: (#center).
	menu cellSpacing: (#none).
	menu layoutInset: (0).
	menu listCentering: (#topLeft).
	menu listDirection: (#topToBottom).
	menu listSpacing: (#none).
	menu maxCellSize: (1073741823).
	menu minCellSize: (0).
	menu wrapCentering: (#topLeft).
	menu wrapDirection: (#none).
	menu frameFractions: (0@0 corner: 1@1).
	menu frameOffsets: (0@0 corner: 0@0).
	menu balloonText: (nil).
	menu balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	menu color: (Color gray).
	menu borderWidth: (0).
	menu borderStyle2: (#simple).
	menu borderColor: (Color black).
	menu setProperty: #objectName toValue: 'menu'.
	selectionFilterSwitch := UiCheckBox new.
	selectionFilterSwitch changeTableLayout.
	selectionFilterSwitch extent: (83@20).
	selectionFilterSwitch position: (6@9).
	selectionFilterSwitch hResizing: (#shrinkWrap).
	selectionFilterSwitch vResizing: (#shrinkWrap).
	selectionFilterSwitch cellInset: (4).
	selectionFilterSwitch cellPositioning: (#center).
	selectionFilterSwitch cellSpacing: (#none).
	selectionFilterSwitch layoutInset: (2@0 corner: 2@0).
	selectionFilterSwitch listCentering: (#topLeft).
	selectionFilterSwitch listDirection: (#leftToRight).
	selectionFilterSwitch listSpacing: (#none).
	selectionFilterSwitch maxCellSize: (1073741823).
	selectionFilterSwitch minCellSize: (0).
	selectionFilterSwitch wrapCentering: (#topLeft).
	selectionFilterSwitch wrapDirection: (#none).
	selectionFilterSwitch frameFractions: (0@0 corner: 1@1).
	selectionFilterSwitch frameOffsets: (0@0 corner: 0@0).
	selectionFilterSwitch balloonText: (nil).
	selectionFilterSwitch balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	selectionFilterSwitch enabled: (true).
	selectionFilterSwitch setProperty: #iconByDesigner toValue: 'nil'.
	selectionFilterSwitch icon: (nil).
	selectionFilterSwitch text: ('CheckBox').
	selectionFilterSwitch color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	selectionFilterSwitch checkable: (true).
	selectionFilterSwitch checked: (false).
	selectionFilterSwitch autoExclusive: (false).
	selectionFilterSwitch setProperty: #objectName toValue: 'selectionFilterSwitch'.
	menu addMorphBack: selectionFilterSwitch.
	panel addMorphBack: menu.
	main := UiContainer new.
	main changeTableLayout.
	main extent: (1192@617).
	main position: (4@39).
	main hResizing: (#spaceFill).
	main vResizing: (#spaceFill).
	main cellInset: (4).
	main cellPositioning: (#center).
	main cellSpacing: (#none).
	main layoutInset: (0).
	main listCentering: (#topLeft).
	main listDirection: (#leftToRight).
	main listSpacing: (#none).
	main maxCellSize: (1073741823).
	main minCellSize: (0).
	main wrapCentering: (#topLeft).
	main wrapDirection: (#none).
	main frameFractions: (0@0 corner: 1@1).
	main frameOffsets: (0@0 corner: 0@0).
	main balloonText: (nil).
	main balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.949)).
	main color: (Color gray).
	main borderWidth: (0).
	main borderStyle2: (#simple).
	main borderColor: (Color black).
	main setProperty: #objectName toValue: 'main'.	
	treeView := CvBrowserTreeView new.
	treeView extent: (882@592).
	treeView position: (4@4).
	treeView hResizing: (#spaceFill).
	treeView vResizing: (#spaceFill).
	treeView cellInset: (0).
	treeView cellPositioning: (#center).
	treeView cellSpacing: (#none).
	treeView layoutInset: (0).
	treeView listCentering: (#topLeft).
	treeView listDirection: (#topToBottom).
	treeView listSpacing: (#none).
	treeView maxCellSize: (1073741823).
	treeView minCellSize: (0).
	treeView wrapCentering: (#topLeft).
	treeView wrapDirection: (#none).
	treeView frameFractions: (0@0 corner: 1@1).
	treeView frameOffsets: (0@0 corner: 0@0).
	treeView balloonText: (nil).
	treeView balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	treeView widgetResizable: (false).
	treeView horizontalScrollBarPolicy: (#asNeeded).
	treeView verticalScrollBarPolicy: (#asNeeded).
	treeView outerBorderWidth: (0).
	treeView scrollBarThickness: (9).
	treeView modelClass: (nil).
	treeView horizontalHeaderVisible: (true).
	treeView verticalHeaderVisible: (false).
	treeView selectionBehavior: (#selectRows).
	treeView selectionColor: ((Color r: 0.772 g: 0.858 b: 1.0)).
	treeView selectionMode: (UiViewSingleSelection).
	treeView setProperty: #objectName toValue: 'treeView'.
	
	rightColumnContainer := UiContainer new.
	rightColumnContainer changeTableLayout.
	rightColumnContainer extent: (300@592).
	rightColumnContainer position: (893@4).
	rightColumnContainer hResizing: (#rigid).
	rightColumnContainer vResizing: (#spaceFill).
	rightColumnContainer cellInset: (4).
	rightColumnContainer cellPositioning: (#center).
	rightColumnContainer cellSpacing: (#none).
	rightColumnContainer layoutInset: (0).
	rightColumnContainer listCentering: (#topLeft).
	rightColumnContainer listDirection: (#topToBottom).
	rightColumnContainer listSpacing: (#none).
	rightColumnContainer maxCellSize: (1073741823).
	rightColumnContainer minCellSize: (0).
	rightColumnContainer wrapCentering: (#topLeft).
	rightColumnContainer wrapDirection: (#none).
	rightColumnContainer frameFractions: (0@0 corner: 1@1).
	rightColumnContainer frameOffsets: (0@0 corner: 0@0).
	rightColumnContainer balloonText: (nil).
	rightColumnContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	rightColumnContainer color: (Color lightGray).
	rightColumnContainer borderWidth: (0).
	rightColumnContainer borderStyle2: (#simple).
	rightColumnContainer borderColor: (Color black).
	screenshotContainer := UiContainer new.
	screenshotContainer changeProportionalLayout.
	screenshotContainer extent: (292@172).
	screenshotContainer position: (897@11).
	screenshotContainer hResizing: (#spaceFill).
	screenshotContainer vResizing: (#rigid).
	screenshotContainer cellInset: (0).
	screenshotContainer cellPositioning: (#center).
	screenshotContainer cellSpacing: (#none).
	screenshotContainer layoutInset: (0).
	screenshotContainer listCentering: (#topLeft).
	screenshotContainer listDirection: (#topToBottom).
	screenshotContainer listSpacing: (#none).
	screenshotContainer maxCellSize: (1073741823).
	screenshotContainer minCellSize: (0).
	screenshotContainer wrapCentering: (#topLeft).
	screenshotContainer wrapDirection: (#none).
	screenshotContainer frameFractions: (0@0 corner: 1@1).
	screenshotContainer frameOffsets: (0@0 corner: 0@0).
	screenshotContainer balloonText: (nil).
	screenshotContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	screenshotContainer color: (Color solarizedBase3Brwhite).
	screenshotContainer borderWidth: (0).
	screenshotContainer borderStyle2: (#simple).
	screenshotContainer borderColor: (Color black).
	screenshotContainer setProperty: #objectName toValue: 'screenshotContainer'.
	rightColumnContainer addMorphBack: screenshotContainer.
	changeDetails := UiTextEdit new.
	changeDetails extent: (292@130).
	changeDetails position: (897@191).
	changeDetails hResizing: (#spaceFill).
	changeDetails vResizing: (#rigid).
	changeDetails cellInset: (0).
	changeDetails cellPositioning: (#center).
	changeDetails cellSpacing: (#none).
	changeDetails layoutInset: (0).
	changeDetails listCentering: (#topLeft).
	changeDetails listDirection: (#topToBottom).
	changeDetails listSpacing: (#none).
	changeDetails maxCellSize: (1073741823).
	changeDetails minCellSize: (0).
	changeDetails wrapCentering: (#topLeft).
	changeDetails wrapDirection: (#none).
	changeDetails frameFractions: (0@0 corner: 1@1).
	changeDetails frameOffsets: (0@0 corner: 0@0).
	changeDetails balloonText: (nil).
	changeDetails balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.941)).
	changeDetails widgetResizable: (true).
	changeDetails horizontalScrollBarPolicy: (#alwaysOff).
	changeDetails verticalScrollBarPolicy: (#alwaysOn).
	changeDetails outerBorderWidth: (1).
	changeDetails scrollBarThickness: (9).
	changeDetails theText: ('').
	changeDetails readOnly: (false).
	changeDetails autoConvert: (false).
	changeDetails autoAccept: (false).
	changeDetails acceptOnFocusLost: (false).
	changeDetails scrollingMode: (#none).
	changeDetails scrollingLimit: (10).
	changeDetails setProperty: #objectName toValue: 'changeDetails'.
	changeDetails color: Color solarizedBase3Brwhite.
	rightColumnContainer addMorphBack: changeDetails.
	patchViewContainer := UiContainer new.
	patchViewContainer changeTableLayout.
	patchViewContainer extent: (292@266).
	patchViewContainer position: (897@326).
	patchViewContainer hResizing: (#spaceFill).
	patchViewContainer vResizing: (#spaceFill).
	patchViewContainer cellInset: (0).
	patchViewContainer cellPositioning: (#center).
	patchViewContainer cellSpacing: (#none).
	patchViewContainer layoutInset: (0).
	patchViewContainer listCentering: (#topLeft).
	patchViewContainer listDirection: (#topToBottom).
	patchViewContainer listSpacing: (#none).
	patchViewContainer maxCellSize: (1073741823).
	patchViewContainer minCellSize: (0).
	patchViewContainer wrapCentering: (#topLeft).
	patchViewContainer wrapDirection: (#none).
	patchViewContainer frameFractions: (0@0 corner: 1@1).
	patchViewContainer frameOffsets: (0@0 corner: 0@0).
	patchViewContainer balloonText: (nil).
	patchViewContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	patchViewContainer color: (Color solarizedBase3Brwhite).
	patchViewContainer borderWidth: (0).
	patchViewContainer borderStyle2: (#simple).
	patchViewContainer borderColor: (Color black).
	patchViewContainer setProperty: #objectName toValue: 'patchViewContainer'.
	rightColumnContainer addMorphBack: patchViewContainer.
	
	main addMorphBack: treeView.
	main addMorphBack: rightColumnContainer.
	panel addMorphBack: main.
	panel setProperty: #uiClassName toValue: 'CvBrowser'.! !

!CvBrowserUi2 methodsFor: 'accessing' stamp: ''!
menu

	^ menu! !

!CvBrowserUi2 methodsFor: 'accessing' stamp: ''!
panel

	^ panel! !

!CvBrowserUi2 methodsFor: 'accessing' stamp: ''!
patchViewContainer
	"nil"
	
	^ patchViewContainer! !

!CvBrowserUi2 methodsFor: 'accessing' stamp: ''!
rightColumnContainer

	^ rightColumnContainer! !

!CvBrowserUi2 methodsFor: 'accessing' stamp: ''!
screenshotContainer
	"nil"
	
	^ screenshotContainer! !

!CvBrowserUi2 methodsFor: 'accessing' stamp: ''!
treeView
	"nil"
	
	^ treeView! !

UserInterface subclass: #CvBrowserUiMod
	instanceVariableNames: 'topBar selectionFilterSwitch fetchChangesButton main screenshotContainer changeDetails patchViewContainer treeView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

!CvBrowserUiMod methodsFor: 'accessing' stamp: 'pt 1/16/2013 14:36:01.092'!
changeDetails
	"No description given."
	
	^ changeDetails! !

!CvBrowserUiMod methodsFor: 'accessing' stamp: 'pt 1/16/2013 14:36:01.07'!
fetchChangesButton
	"No description given."
	
	^ fetchChangesButton! !

!CvBrowserUiMod methodsFor: 'ui - private' stamp: 'pt 1/16/2013 14:36:01.128'!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	| unnamedMorph1 |
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (1200@650).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel minWidth: (2).
	panel minHeight: (2).
	panel cellInset: (0).
	panel cellPositioning: (#center).
	panel cellSpacing: (#none).
	panel layoutInset: (0).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.929)).
	panel color: (Color darkGray).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	topBar := UiContainer new.
	topBar changeTableLayout.
	topBar extent: (1200@21).
	topBar position: (0@0).
	topBar hResizing: (#spaceFill).
	topBar vResizing: (#shrinkWrap).
	topBar minWidth: (2).
	topBar minHeight: (2).
	topBar cellInset: (4).
	topBar cellPositioning: (#center).
	topBar cellSpacing: (#none).
	topBar layoutInset: (0).
	topBar listCentering: (#topLeft).
	topBar listDirection: (#leftToRight).
	topBar listSpacing: (#none).
	topBar maxCellSize: (1073741823).
	topBar minCellSize: (0).
	topBar wrapCentering: (#topLeft).
	topBar wrapDirection: (#none).
	topBar frameFractions: (0@0 corner: 1@1).
	topBar frameOffsets: (0@0 corner: 0@0).
	topBar balloonText: (nil).
	topBar balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	topBar color: (Color gray).
	topBar borderWidth: (0).
	topBar borderStyle2: (#simple).
	topBar borderColor: (Color black).
	topBar setProperty: #objectName toValue: 'topBar'.
	selectionFilterSwitch := UiCheckBox new.
	selectionFilterSwitch changeTableLayout.
	selectionFilterSwitch extent: (85@20).
	selectionFilterSwitch position: (0@1).
	selectionFilterSwitch hResizing: (#shrinkWrap).
	selectionFilterSwitch vResizing: (#shrinkWrap).
	selectionFilterSwitch minWidth: (2).
	selectionFilterSwitch minHeight: (2).
	selectionFilterSwitch cellInset: (4).
	selectionFilterSwitch cellPositioning: (#center).
	selectionFilterSwitch cellSpacing: (#none).
	selectionFilterSwitch layoutInset: (2@0 corner: 2@0).
	selectionFilterSwitch listCentering: (#topLeft).
	selectionFilterSwitch listDirection: (#leftToRight).
	selectionFilterSwitch listSpacing: (#none).
	selectionFilterSwitch maxCellSize: (1073741823).
	selectionFilterSwitch minCellSize: (0).
	selectionFilterSwitch wrapCentering: (#topLeft).
	selectionFilterSwitch wrapDirection: (#none).
	selectionFilterSwitch frameFractions: (0@0 corner: 1@1).
	selectionFilterSwitch frameOffsets: (0@0 corner: 0@0).
	selectionFilterSwitch balloonText: (nil).
	selectionFilterSwitch balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	selectionFilterSwitch enabled: (true).
	selectionFilterSwitch setProperty: #iconByDesigner toValue: 'nil'.
	selectionFilterSwitch icon: (nil).
	selectionFilterSwitch text: ('CheckBox').
	selectionFilterSwitch color: ((Color r: 0.85 g: 0.85 b: 0.85)).
	selectionFilterSwitch checkable: (true).
	selectionFilterSwitch checked: (false).
	selectionFilterSwitch autoExclusive: (false).
	selectionFilterSwitch setProperty: #objectName toValue: 'selectionFilterSwitch'.
	topBar addMorphBack: selectionFilterSwitch.
	fetchChangesButton := UiPushButton new.
	fetchChangesButton changeTableLayout.
	fetchChangesButton extent: (163@20).
	fetchChangesButton position: (89@0).
	fetchChangesButton hResizing: (#shrinkWrap).
	fetchChangesButton vResizing: (#shrinkWrap).
	fetchChangesButton minWidth: (2).
	fetchChangesButton minHeight: (2).
	fetchChangesButton cellInset: (4).
	fetchChangesButton cellPositioning: (#center).
	fetchChangesButton cellSpacing: (#none).
	fetchChangesButton layoutInset: (2@0 corner: 2@0).
	fetchChangesButton listCentering: (#topLeft).
	fetchChangesButton listDirection: (#leftToRight).
	fetchChangesButton listSpacing: (#none).
	fetchChangesButton maxCellSize: (1073741823).
	fetchChangesButton minCellSize: (0).
	fetchChangesButton wrapCentering: (#topLeft).
	fetchChangesButton wrapDirection: (#none).
	fetchChangesButton frameFractions: (0@0 corner: 1@1).
	fetchChangesButton frameOffsets: (0@0 corner: 0@0).
	fetchChangesButton balloonText: (nil).
	fetchChangesButton balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	fetchChangesButton enabled: (true).
	fetchChangesButton setProperty: #iconByDesigner toValue: 'UiDiagonaIcons icon0443Normal'.
	fetchChangesButton icon: (UiDiagonaIcons icon0443Normal).
	fetchChangesButton text: ('Fetch remote changes').
	fetchChangesButton color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	fetchChangesButton checkable: (false).
	fetchChangesButton checked: (false).
	fetchChangesButton autoExclusive: (false).
	fetchChangesButton setProperty: #objectName toValue: 'fetchChangesButton'.
	topBar addMorphBack: fetchChangesButton.
	panel addMorphBack: topBar.
	main := UiContainer new.
	main changeTableLayout.
	main extent: (1200@628).
	main position: (0@22).
	main hResizing: (#spaceFill).
	main vResizing: (#spaceFill).
	main minWidth: (2).
	main minHeight: (2).
	main cellInset: (4).
	main cellPositioning: (#center).
	main cellSpacing: (#none).
	main layoutInset: (0).
	main listCentering: (#topLeft).
	main listDirection: (#leftToRight).
	main listSpacing: (#none).
	main maxCellSize: (1073741823).
	main minCellSize: (0).
	main wrapCentering: (#topLeft).
	main wrapDirection: (#none).
	main frameFractions: (0@0 corner: 1@1).
	main frameOffsets: (0@0 corner: 0@0).
	main balloonText: (nil).
	main balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	main color: (Color gray).
	main borderWidth: (0).
	main borderStyle2: (#simple).
	main borderColor: (Color black).
	main setProperty: #objectName toValue: 'main'.
	unnamedMorph1 := UiContainer new.
	unnamedMorph1 changeTableLayout.
	unnamedMorph1 extent: (300@628).
	unnamedMorph1 position: (1@22).
	unnamedMorph1 hResizing: (#rigid).
	unnamedMorph1 vResizing: (#spaceFill).
	unnamedMorph1 minWidth: (2).
	unnamedMorph1 minHeight: (2).
	unnamedMorph1 cellInset: (4).
	unnamedMorph1 cellPositioning: (#center).
	unnamedMorph1 cellSpacing: (#none).
	unnamedMorph1 layoutInset: (0).
	unnamedMorph1 listCentering: (#topLeft).
	unnamedMorph1 listDirection: (#topToBottom).
	unnamedMorph1 listSpacing: (#none).
	unnamedMorph1 maxCellSize: (1073741823).
	unnamedMorph1 minCellSize: (0).
	unnamedMorph1 wrapCentering: (#topLeft).
	unnamedMorph1 wrapDirection: (#none).
	unnamedMorph1 frameFractions: (0@0 corner: 1@1).
	unnamedMorph1 frameOffsets: (0@0 corner: 0@0).
	unnamedMorph1 balloonText: (nil).
	unnamedMorph1 balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	unnamedMorph1 color: (Color lightGray).
	unnamedMorph1 borderWidth: (0).
	unnamedMorph1 borderStyle2: (#simple).
	unnamedMorph1 borderColor: (Color black).
	screenshotContainer := UiContainer new.
	screenshotContainer changeProportionalLayout.
	screenshotContainer extent: (300@172).
	screenshotContainer position: (1@22).
	screenshotContainer hResizing: (#spaceFill).
	screenshotContainer vResizing: (#rigid).
	screenshotContainer minWidth: (2).
	screenshotContainer minHeight: (2).
	screenshotContainer cellInset: (0).
	screenshotContainer cellPositioning: (#center).
	screenshotContainer cellSpacing: (#none).
	screenshotContainer layoutInset: (0).
	screenshotContainer listCentering: (#topLeft).
	screenshotContainer listDirection: (#topToBottom).
	screenshotContainer listSpacing: (#none).
	screenshotContainer maxCellSize: (1073741823).
	screenshotContainer minCellSize: (0).
	screenshotContainer wrapCentering: (#topLeft).
	screenshotContainer wrapDirection: (#none).
	screenshotContainer frameFractions: (0@0 corner: 1@1).
	screenshotContainer frameOffsets: (0@0 corner: 0@0).
	screenshotContainer balloonText: (nil).
	screenshotContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	screenshotContainer color: ((Color r: 0.992 g: 0.965 b: 0.891)).
	screenshotContainer borderWidth: (0).
	screenshotContainer borderStyle2: (#simple).
	screenshotContainer borderColor: (Color black).
	screenshotContainer setProperty: #objectName toValue: 'screenshotContainer'.
	unnamedMorph1 addMorphBack: screenshotContainer.
	changeDetails := UiTextEdit new.
	changeDetails extent: (300@130).
	changeDetails position: (1@199).
	changeDetails hResizing: (#spaceFill).
	changeDetails vResizing: (#rigid).
	changeDetails minWidth: (2).
	changeDetails minHeight: (2).
	changeDetails cellInset: (0).
	changeDetails cellPositioning: (#center).
	changeDetails cellSpacing: (#none).
	changeDetails layoutInset: (0).
	changeDetails listCentering: (#topLeft).
	changeDetails listDirection: (#topToBottom).
	changeDetails listSpacing: (#none).
	changeDetails maxCellSize: (1073741823).
	changeDetails minCellSize: (0).
	changeDetails wrapCentering: (#topLeft).
	changeDetails wrapDirection: (#none).
	changeDetails frameFractions: (0@0 corner: 1@1).
	changeDetails frameOffsets: (0@0 corner: 0@0).
	changeDetails balloonText: (nil).
	changeDetails balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.937)).
	changeDetails widgetResizable: (true).
	changeDetails horizontalScrollBarPolicy: (#alwaysOff).
	changeDetails verticalScrollBarPolicy: (#alwaysOn).
	changeDetails outerBorderWidth: (1).
	changeDetails scrollBarThickness: (9).
	changeDetails theText: ('').
	changeDetails readOnly: (false).
	changeDetails autoConvert: (false).
	changeDetails autoAccept: (false).
	changeDetails acceptOnFocusLost: (false).
	changeDetails scrollingMode: (#none).
	changeDetails scrollingLimit: (10).
	changeDetails setProperty: #objectName toValue: 'changeDetails'.
	unnamedMorph1 addMorphBack: changeDetails.
	patchViewContainer := UiContainer new.
	patchViewContainer changeTableLayout.
	patchViewContainer extent: (300@316).
	patchViewContainer position: (1@334).
	patchViewContainer hResizing: (#spaceFill).
	patchViewContainer vResizing: (#spaceFill).
	patchViewContainer minWidth: (2).
	patchViewContainer minHeight: (2).
	patchViewContainer cellInset: (0).
	patchViewContainer cellPositioning: (#center).
	patchViewContainer cellSpacing: (#none).
	patchViewContainer layoutInset: (0).
	patchViewContainer listCentering: (#topLeft).
	patchViewContainer listDirection: (#topToBottom).
	patchViewContainer listSpacing: (#none).
	patchViewContainer maxCellSize: (1073741823).
	patchViewContainer minCellSize: (0).
	patchViewContainer wrapCentering: (#topLeft).
	patchViewContainer wrapDirection: (#none).
	patchViewContainer frameFractions: (0@0 corner: 1@1).
	patchViewContainer frameOffsets: (0@0 corner: 0@0).
	patchViewContainer balloonText: (nil).
	patchViewContainer balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	patchViewContainer color: ((Color r: 0.992 g: 0.965 b: 0.891)).
	patchViewContainer borderWidth: (0).
	patchViewContainer borderStyle2: (#simple).
	patchViewContainer borderColor: (Color black).
	patchViewContainer setProperty: #objectName toValue: 'patchViewContainer'.
	unnamedMorph1 addMorphBack: patchViewContainer.
	main addMorphBack: unnamedMorph1.
	treeView := CvBrowserTreeView new.
	treeView extent: (894@628).
	treeView position: (306@22).
	treeView hResizing: (#spaceFill).
	treeView vResizing: (#spaceFill).
	treeView minWidth: (2).
	treeView minHeight: (2).
	treeView cellInset: (0).
	treeView cellPositioning: (#center).
	treeView cellSpacing: (#none).
	treeView layoutInset: (0).
	treeView listCentering: (#topLeft).
	treeView listDirection: (#topToBottom).
	treeView listSpacing: (#none).
	treeView maxCellSize: (1073741823).
	treeView minCellSize: (0).
	treeView wrapCentering: (#topLeft).
	treeView wrapDirection: (#none).
	treeView frameFractions: (0@0 corner: 1@1).
	treeView frameOffsets: (0@0 corner: 0@0).
	treeView balloonText: (nil).
	treeView balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.922)).
	treeView widgetResizable: (false).
	treeView horizontalScrollBarPolicy: (#asNeeded).
	treeView verticalScrollBarPolicy: (#asNeeded).
	treeView outerBorderWidth: (0).
	treeView scrollBarThickness: (9).
	treeView modelClass: (nil).
	treeView horizontalHeaderVisible: (true).
	treeView verticalHeaderVisible: (false).
	treeView selectionBehavior: (#selectRows).
	treeView selectionColor: ((TranslucentColor r: 0.772 g: 0.858 b: 1.0 alpha: 0.298)).
	treeView selectionMode: (UiViewSingleSelection).
	treeView setProperty: #objectName toValue: 'treeView'.
	main addMorphBack: treeView.
	panel addMorphBack: main.
	panel setProperty: #uiClassName toValue: 'CvBrowser'.! !

!CvBrowserUiMod methodsFor: 'accessing' stamp: 'pt 1/16/2013 14:36:01.078'!
main
	"No description given."
	
	^ main! !

!CvBrowserUiMod methodsFor: 'accessing' stamp: 'pt 1/16/2013 14:36:01.098'!
patchViewContainer
	"No description given."
	
	^ patchViewContainer! !

!CvBrowserUiMod methodsFor: 'accessing' stamp: 'pt 1/16/2013 14:36:01.084'!
screenshotContainer
	"No description given."
	
	^ screenshotContainer! !

!CvBrowserUiMod methodsFor: 'accessing' stamp: 'pt 1/16/2013 14:36:01.062'!
selectionFilterSwitch
	"No description given."
	
	^ selectionFilterSwitch! !

!CvBrowserUiMod methodsFor: 'accessing' stamp: 'pt 1/16/2013 14:36:01.052'!
topBar
	"No description given."
	
	^ topBar! !

!CvBrowserUiMod methodsFor: 'accessing' stamp: 'pt 1/16/2013 14:36:01.106'!
treeView
	"No description given."
	
	^ treeView! !

UserInterface subclass: #CvCommitDialogUi
	instanceVariableNames: 'message button'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Commit'!

!CvCommitDialogUi methodsFor: 'accessing' stamp: ''!
button
	"nil"
	
	^ button! !

!CvCommitDialogUi methodsFor: 'ui - private' stamp: ''!
initializePanel
	"This code is auto-generated. DO NOT modify it because another generation step will overwrite all changes."
	
	panel := UiContainer new.
	panel changeTableLayout.
	panel extent: (426@93).
	panel position: (0@0).
	panel hResizing: (#rigid).
	panel vResizing: (#rigid).
	panel cellInset: (4).
	panel cellPositioning: (#rightCenter).
	panel cellSpacing: (#none).
	panel layoutInset: (4).
	panel listCentering: (#topLeft).
	panel listDirection: (#topToBottom).
	panel listSpacing: (#none).
	panel maxCellSize: (1073741823).
	panel minCellSize: (0).
	panel wrapCentering: (#topLeft).
	panel wrapDirection: (#none).
	panel frameFractions: (0@0 corner: 1@1).
	panel frameOffsets: (0@0 corner: 0@0).
	panel balloonText: (nil).
	panel balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	panel color: (Color gray).
	panel borderWidth: (0).
	panel borderStyle2: (#simple).
	panel borderColor: (Color black).
	panel setProperty: #objectName toValue: 'panel'.
	message := UiTextEdit new.
	message extent: (418@58).
	message position: (4@5).
	message hResizing: (#spaceFill).
	message vResizing: (#rigid).
	message cellInset: (0).
	message cellPositioning: (#center).
	message cellSpacing: (#none).
	message layoutInset: (0).
	message listCentering: (#topLeft).
	message listDirection: (#topToBottom).
	message listSpacing: (#none).
	message maxCellSize: (1073741823).
	message minCellSize: (0).
	message wrapCentering: (#topLeft).
	message wrapDirection: (#none).
	message frameFractions: (0@0 corner: 1@1).
	message frameOffsets: (0@0 corner: 0@0).
	message balloonText: (nil).
	message balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	message widgetResizable: (true).
	message horizontalScrollBarPolicy: (#alwaysOff).
	message verticalScrollBarPolicy: (#alwaysOn).
	message outerBorderWidth: (1).
	message scrollBarThickness: (9).
	message theText: ('').
	message readOnly: (false).
	message autoConvert: (false).
	message autoAccept: (false).
	message acceptOnFocusLost: (false).
	message scrollingMode: (#none).
	message scrollingLimit: (10).
	message setProperty: #objectName toValue: 'message'.
	panel addMorphBack: message.
	button := UiPushButton new.
	button changeTableLayout.
	button extent: (53@20).
	button position: (369@69).
	button hResizing: (#shrinkWrap).
	button vResizing: (#shrinkWrap).
	button cellInset: (4).
	button cellPositioning: (#center).
	button cellSpacing: (#none).
	button layoutInset: (2@0 corner: 2@0).
	button listCentering: (#topLeft).
	button listDirection: (#leftToRight).
	button listSpacing: (#none).
	button maxCellSize: (1073741823).
	button minCellSize: (0).
	button wrapCentering: (#topLeft).
	button wrapDirection: (#none).
	button frameFractions: (0@0 corner: 1@1).
	button frameOffsets: (0@0 corner: 0@0).
	button balloonText: (nil).
	button balloonColor: ((TranslucentColor r: 0.91 g: 0.94 b: 1.0 alpha: 0.945)).
	button enabled: (true).
	button setProperty: #iconByDesigner toValue: 'nil'.
	button icon: (nil).
	button text: ('Commit').
	button color: ((Color r: 0.8 g: 0.8 b: 0.8)).
	button checkable: (false).
	button checked: (false).
	button autoExclusive: (false).
	button setProperty: #objectName toValue: 'button'.
	panel addMorphBack: button.
	panel setProperty: #uiClassName toValue: 'CvCommitDialog'.! !

!CvCommitDialogUi methodsFor: 'accessing' stamp: ''!
message
	"nil"
	
	^ message! !

!RemovedEvent methodsFor: '*CV' stamp: 'bs 7/14/2011 17:13:37.172'!
backup
	^ self slotNamed: 'backup'! !

!RemovedEvent methodsFor: '*CV' stamp: 'bs 7/14/2011 16:26:50.583'!
backup: aClassOrMethod
	self slotNamed: 'backup' put: aClassOrMethod! !

!RemovedEvent methodsFor: '*CV' stamp: 'bs 1/15/2013 17:34:34.256'!
checkoutChangesTo: aWorkingCopy

	self isCategoryItem ifTrue: [^ self].
	
	self reboundItem 
		ifNil: [ 
			self basedOn: aWorkingCopy do: [
				(self cvItemReference bind: aWorkingCopy) 
					ifNotNil: [:aMethodOrClass | 
						aMethodOrClass removeFrom: aWorkingCopy]]]
		ifNotNil: [:aMethodOrClass | "we are going back / ensure to make it undone"
			aMethodOrClass checkoutCopyTo: aWorkingCopy]! !

!RemovedEvent methodsFor: '*CV' stamp: 'bs 8/30/2011 11:54:15.937'!
cleanUpChangesTo: aVersion

	self copyOrganizationTo: aVersion.
	self isCategoryItem ifTrue: [^ self].
	
	self reboundParentItem saveFlatCopyTo: aVersion.
	self isClassItem ifTrue: [
		(self cvItemReference bind: aVersion) removeFrom: aVersion].
	self basedOn: aVersion do: [
		self reboundParentItem cleanUpSubclasses].! !

!RemovedEvent methodsFor: '*CV' stamp: 'bs 8/17/2011 14:43:25.155'!
createItemReference
	
	self itemKind = self class classKind
		ifTrue: [^ CvCodeReference class: self backup category: self itemCategory].
	
	^ super createItemReference! !

!RemovedEvent methodsFor: '*CV' stamp: 'bs 8/30/2011 11:51:27.558'!
includedInCheckoutOf: aClass

	^ self isCategoryItem 
		or: self reboundParentItem = aClass! !

!RemovedEvent methodsFor: '*CV' stamp: 'bs 8/23/2012 13:15:18.457'!
itemToBeCheckedOut

	^ self cvItemReference! !

!RemovedEvent methodsFor: '*CV' stamp: 'bs 4/14/2011 19:04:06.083'!
nonObsoleteClassName
	
	^ (self item name copyReplaceAll: 'AnObsolete' with: '') asSymbol! !

!RemovedEvent methodsFor: '*CV' stamp: 'bs 8/23/2012 13:42:04.859'!
requiresCheckoutTo: aWorkingCopy

	^ (self cvItemReference bind: self activeCodeBase) 
		ifNil: [(self cvItemReference bind: aWorkingCopy) notNil]
		ifNotNil: [:boundItem | boundItem requiresReCheckoutTo: aWorkingCopy].! !

!MCRemoval methodsFor: '*CV' stamp: 'bs 11/9/2012 16:10:10.818'!
cvSummaryPrefix
	^ 'R'! !

!Refactoring methodsFor: '*CV-override' stamp: 'bs 8/12/2011 15:09:47.548'!
primitiveExecute
	self checkPreconditions.
	self transform.! !

!OBAllMethodCategoryNode methodsFor: '*CV' stamp: ''!
backgroundColor
	| activeWC |
	activeWC := self activeWorkingCopy.
	^ activeWC referenceWC ifNotNil: [:refWC |
		(self theClass valueAt: activeWC baseVersion) selectors =
			(self cvItem valueAt: refWC baseVersion) selectors
			ifTrue: [Color lightGray muchLighter]
			ifFalse: [nil]]
	! !

!OBAllMethodCategoryNode methodsFor: '*CV' stamp: 'bs 8/12/2011 15:50:59.071'!
cvItemReference
	
	^ CvCodeReference class: self theClass! !

PackageInfo subclass: #CvPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvPackageInfo class methodsFor: 'packages access' stamp: 'bs 4/13/2011 22:25:43.202'!
allPackages
	^PackageOrganizer default packages! !

!CvPackageInfo class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.077'!
canBeLateBound
	^ false! !

!CvPackageInfo class methodsFor: 'private' stamp: 'bs 4/13/2011 22:25:43.23'!
classFor: packageNameString 
	self
		allSubclassesDo: [:each | (each packageName isString
					and: [each packageName sameAs: packageNameString])
				ifTrue: [^ each]]! !

!CvPackageInfo class methodsFor: 'compatibility' stamp: 'bs 4/13/2011 22:25:43.196'!
default
	^ self allPackages detect: [:ea | ea class = self] ifNone: [self new register]! !

!CvPackageInfo class methodsFor: 'class initialization' stamp: 'bs 4/13/2011 22:25:43.188'!
initialize
	self allSubclassesDo: [:ea | ea new register]! !

!CvPackageInfo class methodsFor: 'packages access' stamp: 'bs 4/13/2011 22:25:43.21'!
named: aString 
	"Answer the PackageInfo with name aString."
	| original replacement |
	original := PackageOrganizer default
				packageNamed: aString
				ifAbsent: [].
	^ (original isNil
			or: [original class
					~= (self classFor: aString)])
		ifTrue: [replacement := self newNamed: aString.
			original
				ifNotNil: [replacement copySameFrom: original].
			replacement register; yourself]
		ifFalse: [original]! !

!CvPackageInfo class methodsFor: 'private' stamp: 'bs 4/13/2011 22:25:43.239'!
newNamed: aString 
	^ (self classFor: aString) new packageName: aString;
		 yourself! !

!CvPackageInfo class methodsFor: 'packages access' stamp: 'bs 4/13/2011 22:25:43.218'!
packageName
	"Subclasses announce their presence for a particular package by
	overriding this method, answering the packageName of the package
	they wish to represent. This is useful for the #classFor: factory
	method. "
	^ nil! !

!CvPackageInfo class methodsFor: 'registration / unregistration' stamp: 'bs 4/13/2011 22:25:43.245'!
registerPackage: aString
	"for compatibility with old fileOuts"
	^ Smalltalk at: #FilePackageManager ifPresent: [:p | p registerPackage: aString]! !

!CvPackageInfo class methodsFor: 'registration / unregistration' stamp: 'bs 4/13/2011 22:25:43.251'!
registerPackageName: aString
	^ PackageOrganizer default registerPackageNamed: aString! !

!CvPackageInfo methodsFor: 'enumerating' stamp: 'bs 4/13/2011 23:18:40.201'!
allOverriddenMethodsDo: aBlock
	"Evaluates aBlock with all the overridden methods in the system"
	^ Smalltalk allClassesDo: [:class | 
		self overriddenMethodsInClass: class do: aBlock]
! !

!CvPackageInfo methodsFor: 'listing' stamp: 'bs 4/14/2011 12:47:01.429'!
coreMethods
	^ self classesAndMetaClasses flatCollect: [:class | self coreMethodsForClass: class]! !

!CvPackageInfo methodsFor: 'listing' stamp: 'bs 4/14/2011 12:48:11.371'!
extensionMethods
	^ self externalBehaviors flatCollect: [:classOrTrait | self extensionMethodsForClass: classOrTrait]! !

!CvPackageInfo methodsFor: 'testing' stamp: 'bs 5/4/2011 18:12:17.053'!
extensionMethodsForClass: aClass
	^ (self extensionCategoriesForClass: aClass)
		flatCollect: [:cat | self methodsInCategory: cat ofClass: aClass ]! !

!CvPackageInfo methodsFor: 'testing' stamp: 'bs 4/14/2011 12:48:20.378'!
extensionMethodsFromClasses: classes
	^classes
		flatCollect: [:class | self extensionMethodsForClass: class]! !

!CvPackageInfo methodsFor: 'dependencies' stamp: 'bs 4/14/2011 12:48:45.031'!
externalCallers
	^ self 
		externalRefsSelect: [:literal | literal isSymbol] 
		thenCollect: [:l | l].! !

!CvPackageInfo methodsFor: 'dependencies' stamp: 'bs 4/13/2011 23:09:55.372'!
externalClasses
	| myClasses |
	myClasses := self classesAndMetaClasses asIdentitySet.
	^ Array streamContents:
		[:s |
		Smalltalk allClassesDo:
			[:class |
			(myClasses includes: class) ifFalse: [s nextPut: class]]]! !

!CvPackageInfo methodsFor: 'testing' stamp: 'bs 4/14/2011 12:49:42'!
foreignExtensionMethodsForClass: aClass
	^ (self foreignExtensionCategoriesForClass: aClass)
		flatCollect: [:cat | (aClass organization listAtCategoryNamed: cat)
						  collect: [:sel | self referenceForMethod: sel ofClass: aClass]]! !

!PackageInfo class methodsFor: '*CV' stamp: 'bs 4/15/2011 23:07:11.303'!
canBeLateBound
	^ false! !

!OBClassNode methodsFor: '*CV' stamp: 'bs 9/5/2012 11:22:29.763'!
valueAt: aCodeBase

	^ (super valueAt: aCodeBase)
		ifNil: [self classCategoryNode 
				ifNotNil: [:node | node valueAt: aCodeBase]]! !

!ChangeSet class methodsFor: '*CV' stamp: 'bs 4/15/2011 23:08:03.434'!
canBeLateBound
	^ false! !

!PackageOrganizer class methodsFor: '*CV' stamp: 'bs 4/15/2011 23:07:35.003'!
canBeLateBound
	^ false! !

!Debugger methodsFor: '*CV' stamp: 'bs 7/24/2011 13:01:37.752'!
duplicateAndOpenOn: aCodeBase
	| theMethod aWrapper |
	self performsTest ifFalse: [^ self].
	
	theMethod := self selectedMethod valueAt: aCodeBase.
	self basedOn: aCodeBase do: [
		aWrapper := SwaDebuggingWrapper onMethod: theMethod.
		aWrapper install.
		theMethod newTestCase run]! !

!Debugger methodsFor: '*CV' stamp: 'bs 7/24/2011 11:04:43.561'!
performsTest

	^ self contextStackList anySatisfy: [:ea | 
		ea endsWith: '(TestCase)>>performTest' ]! !

!Debugger methodsFor: '*CV' stamp: 'bs 7/24/2011 11:54:02.84'!
selectedMethod

	^ self selectedContext methodClass >> self selectedContext selector! !

!Debugger methodsFor: '*CV' stamp: 'bs 7/24/2011 12:49:27.088'!
supportsPreview

	^ false! !

!Debugger methodsFor: '*CV' stamp: 'bs 7/24/2011 11:38:58.184'!
testMethod
	| name nameParts |
	name := self contextStackList before: (
		self contextStackList detect: [:ea | 
			ea endsWith: '(TestCase)>>performTest']).
	
	nameParts := name subStrings: '>>'.
	^ (Smalltalk classNamed: nameParts first) >> (nameParts second asSymbol) ! !

UiTreeViewport subclass: #CvBrowserTreeViewport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

!CvBrowserTreeViewport methodsFor: 'drawing' stamp: ''!
drawSelectionOn: aCanvas
	| aCell aVersion aCodeRef codeRefsOfSelection |
	super drawSelectionOn: aCanvas.
	
	"codeRefsOfSelection := {self activeWorkingCopy selectedItem}
		copyWithout: nil.
	
	(self visibleButUnselectedRowsIndices: aCanvas) do: [:rowIndex | 
		aCell := 1@rowIndex.
		aVersion := (self modelIndexFor: aCell) node.
		aCodeRef := aVersion changedCodeReference.
		(aCodeRef notNil and: [aCodeRef matchesAny: codeRefsOfSelection]) 
			ifTrue: [
				self 
					drawHighlightOn: aCanvas
					bounds: (self boundsFor: aCell)
					color: self selectionColor muchLighter]]"! !

!CvBrowserTreeViewport methodsFor: 'drawing' stamp: 'bs 7/29/2011 16:33:44.613'!
onSelectionChangedFrom: oldCells to: newCells

	self invalidRect: self innerBounds! !

!CvBrowserTreeViewport methodsFor: 'drawing' stamp: 'bs 7/29/2011 16:08:36.985'!
selectedRowsIndices
	
	^ self selection cells collect: [:ea | ea y].! !

!CvBrowserTreeViewport methodsFor: 'drawing' stamp: 'bs 2/2/2012 22:28:24.697'!
selectedVersions

	^ (self selection selectedIndices collect: [:index |
		index node]) copyWithoutDuplicates! !

!CvBrowserTreeViewport methodsFor: 'drawing' stamp: 'bs 7/29/2011 16:09:26.055'!
visibleButUnselectedRowsIndices: aCanvas

	^ (self visibleRowsIndices: aCanvas) difference: self selectedRowsIndices.! !

!ChangeRecord class methodsFor: '*CV' stamp: 'bs 4/15/2011 23:07:56.919'!
canBeLateBound
	^ false! !

DynamicVariable subclass: #CvShouldDeferSnapshot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI'!

!CvShouldDeferSnapshot class methodsFor: 'as yet unclassified' stamp: ''!
default

	^ false! !

!ReorganizedEvent methodsFor: '*CV' stamp: 'bs 8/27/2011 14:52:48.593'!
cleanUpChangesTo: aVersion

	self copyOrganizationTo: aVersion.
	self isCategoryItem ifTrue: [^ self].
	self item saveFlatCopyTo: aVersion.! !

!ReorganizedEvent methodsFor: '*CV' stamp: 'bs 8/30/2011 11:51:27.542'!
includedInCheckoutOf: aClass

	^ true! !

!ReorganizedEvent methodsFor: '*CV' stamp: 'bs 4/30/2012 12:55:31.62'!
itemToBeCheckedOut

	^ nil! !

!ReorganizedEvent methodsFor: '*CV' stamp: 'bs 8/23/2012 16:24:38.631'!
requiresCheckoutTo: aWorkingCopy

	^ false! !

!Categorizer class methodsFor: '*CV' stamp: 'bs 4/15/2011 23:08:31.393'!
canBeLateBound
	^ false! !

DockingBarMorph subclass: #CvVersionBar
	instanceVariableNames: 'tree hoverNode subscribedOBs summaries controller scrollArea doAfterNextStepBlock timeline chronoView notifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Bar'!

!CvVersionBar class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.144'!
canBeLateBound
	^ false! !

!CvVersionBar class methodsFor: 'as yet unclassified' stamp: 'bs 4/6/2011 14:44:05.819'!
controller: aCvController

	^ self new initializeWithController: aCvController! !

!CvVersionBar methodsFor: 'creation' stamp: 'bs 11/29/2012 16:28:03.742'!
backgroundColor

	^ Color solarizedBase02Black! !

!CvVersionBar methodsFor: 'accessing' stamp: 'bs 4/5/2011 19:14:30.722'!
controller
	^ controller! !

!CvVersionBar methodsFor: 'accessing' stamp: 'bs 4/5/2011 19:14:30.728'!
controller: anObject
	controller := anObject! !

!CvVersionBar methodsFor: 'creation' stamp: 'pt 1/17/2013 16:28:44.22'!
createFetchChangesButton

	^ UiPushButton new
			text: nil;
			icon: (UiDiagonaIcons icon0443Normal);
			yourself! !

!CvVersionBar methodsFor: 'creation' stamp: 'bs 12/4/2012 12:46:08.146'!
createScrollAreaForHistory: scrolledMorph
	| result |
	result := UiScrollArea new
		verticalScrollBarPolicy: #alwaysOff;
		horizontalScrollBarPolicy: #asNeeded;
		changeTableLayout;
		areaResizable: true;
		listDirection: #bottomToTop;
		hResizing: #spaceFill;
		scrollBarThickness: 12.
	result horizontalScrollBar color: self backgroundColor.
	result transformMorph color: Color transparent.
	
	scrolledMorph
		changeTableLayout;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	
	result widget: scrolledMorph.
	^ result! !

!CvVersionBar methodsFor: 'creation' stamp: 'bs 6/4/2011 10:19:31.206'!
createSearchEdit

	^ UiLineEdit new 
		width: 150;
		hResizing: #shrinkWrap;
		helpText: 'search ...'! !

!CvVersionBar methodsFor: 'creation' stamp: 'bs 4/8/2011 11:34:02.726'!
createSpacerForCorner
	
	^ Morph new 
		extent: 15@1;
		color: Color transparent;
		vResizing: #spaceFill! !

!CvVersionBar methodsFor: 'OB support' stamp: 'bs 5/2/2011 22:14:44.895'!
currentOBWindows
	
	^ self owner submorphs select: [:ea | 
		ea isSystemWindow 
			and: [ea model notNil 
				and: [ea model isOBBrowser]]]
	! !

!CvVersionBar methodsFor: 'OB support' stamp: 'bs 8/1/2012 13:31:47.303'!
delete
	self subscribedOBs do: [:ea | self unsubscribeToOB: ea].
	self unsubscribeToOwnersAddedRemovedMorph.
	self workingCopies do: [:wc | 
		self disconnectSignal: #rebasedFrom:to: from: self.
		self disconnectSignal: #versionSaved from: self].
	notifier delete.
	notifier := nil.
	super delete! !

!CvVersionBar methodsFor: 'as yet unclassified' stamp: 'FB 1/22/2013 15:15:52.475'!
fetchRemoteChanges
	
	"CvPackage named: World cvController package fetchRemoteChanges packageName."
	"TODO testing"
	
	World cvController fetchRemoteChanges! !

!CvVersionBar methodsFor: 'as yet unclassified' stamp: 'bs 11/8/2012 17:11:40.709'!
handlesMouseDown: anEvent

	^ true! !

!CvVersionBar methodsFor: 'highlighting' stamp: 'bs 6/16/2011 19:07:33.008'!
highlight: aCodeReference

	self view highlight: aCodeReference! !

!CvVersionBar methodsFor: 'highlighting' stamp: 'bs 6/17/2011 10:36:49.449'!
highlightForSearchText: aString

	self highlight: (CvCodeReference fuzzySearch: aString)! !

!CvVersionBar methodsFor: 'creation' stamp: 'bs 12/4/2012 12:46:54.65'!
initializeLayout
	
	self
		changeTableLayout;
		setToAdhereToEdge: #bottom;
		hResizing: #spaceFill;
		listDirection: #leftToRight;
		borderWidth: 0;
		extent: 30@100;
		autoGradient: false;
		layoutInset: 1;
		cellInset: 1;
		color: self backgroundColor.! !

!CvVersionBar methodsFor: 'creation' stamp: 'pt 1/17/2013 16:21:40.5'!
initializeWithController: aCvController
	| searchEdit fetchChangesButton |
	self 
		initialize;
		controller: aCvController;
		initializeLayout.	
	
	chronoView := CvChronoView versionBar: self.
	scrollArea := self createScrollAreaForHistory: chronoView.
	
	searchEdit := self createSearchEdit.
	searchEdit deferEditSignalTime: 300.
	self connect: searchEdit signal: #textEdited: toSelector: #highlightForSearchText:.
	
	fetchChangesButton := self createFetchChangesButton.
	self connect: fetchChangesButton signal: #pressed toSelector: #fetchRemoteChanges.
	
	self
		addMorph: self createSpacerForCorner;
		addMorph: fetchChangesButton;  
		addMorph: searchEdit;
		addMorph: scrollArea.
	
	"this call requires the scroll area to be created"
	chronoView displayVersions: aCvController versionsChronologically.
	
	aCvController workingCopies do: [:aWc | self workingCopyActivated: aWc].
	self subscribeForWorkingCopies..
	
	chronoView rootBranch withAllSubbranches 
		select: [:ea | ea includesActiveVersion]
		thenDo: [:ea | ea showAllBranchesOfPath].
		
	notifier := CvEventNotifier new! !

!CvVersionBar methodsFor: 'OB support' stamp: 'bs 3/14/2011 11:16:55.999'!
isOBInstalled
	^ Smalltalk hasClassNamed: #OBSystemBrowser! !

!CvVersionBar methodsFor: 'as yet unclassified' stamp: 'bs 11/8/2012 17:24:03.169'!
mouseDown: evt
	
	(self submorphs first visible)
		ifTrue: [
			self submorphs do: [:ea | ea hide].
			self height: 10]
		ifFalse: [
			self submorphs do: [:ea | ea show].
			self height: scrollArea height].
	self changed.
	evt wasHandled: true.
	evt hand releaseMouseFocus: self ! !

!CvVersionBar methodsFor: 'as yet unclassified' stamp: 'bs 11/29/2012 16:23:43.993'!
mouseDownPriority

	^ 0! !

!CvVersionBar methodsFor: 'as yet unclassified' stamp: 'bs 5/16/2011 09:38:29.47'!
noteNewOwner: aMorph

	self owner addMorph: notifier.
	notifier bottomLeft: self topLeft.
	
	self 
		subscribeToOpenOBs;
		subscribeToOwnersAddedRemovedMorph! !

!CvVersionBar methodsFor: 'accessing' stamp: 'bs 5/3/2011 09:40:47.48'!
notifier
	^ notifier! !

!CvVersionBar methodsFor: 'OB support' stamp: 'bs 8/10/2011 14:10:00.108'!
obSelectionChanged: aSelectionChangedEvent
	
	aSelectionChangedEvent node
		ifNotNil: [:selectedNode |
			self highlight: selectedNode cvItemReference]
	
	
	

	
! !

!CvVersionBar methodsFor: 'OB support' stamp: 'bs 5/10/2011 21:53:07.023'!
ownerAddedMorph: aMorph
	
	aMorph isSystemWindow ifFalse: [^ self].
	
	self isOBInstalled ifFalse: [^ self].
	aMorph model ifNil: [^ self].
	(aMorph model isOBBrowser) ifFalse: [^ self].
	
	self subscribeToOB: aMorph model! !

!CvVersionBar methodsFor: 'OB support' stamp: 'bs 5/10/2011 21:53:12.776'!
ownerRemovedMorph: aMorph
	
	aMorph isSystemWindow ifFalse: [^ self].
	
	self isOBInstalled ifFalse: [^ self].
	aMorph model ifNil: [^ self].
	(aMorph model isOBBrowser) ifFalse: [^ self].
	
	self unsubscribeToOB: aMorph model! !

!CvVersionBar methodsFor: 'working copies' stamp: 'bs 8/24/2012 13:17:58.752'!
rebaseToolsWorkingOn: aWorkingCopy
	
	doAfterNextStepBlock := [self signalRebasedToToolsWorkingOn: aWorkingCopy].
	self startStepping.! !

!CvVersionBar methodsFor: 'working copies' stamp: 'bs 8/24/2012 13:18:11.363'!
rebased: aWorkingCopy from: oldVersion to: newVersion
	
	self rebaseToolsWorkingOn: aWorkingCopy.
	
	self psCodeBase ~= aWorkingCopy ifTrue: [^ self].
	notifier ifNil: [^ self].
	notifier bottomLeft: self topLeft.
	notifier rebasedFrom: oldVersion to: newVersion.
	
	! !

!CvVersionBar methodsFor: 'working copies' stamp: 'bs 5/3/2011 13:50:51.841'!
rebasedFrom: oldVersion to: newVersion
	notifier ifNil: [^ self].
	notifier bottomLeft: self topLeft.
	notifier rebasedFrom: oldVersion to: newVersion! !

!CvVersionBar methodsFor: 'working copies' stamp: 'bs 8/24/2012 13:22:18.976'!
refreshToolsWorkingOn: aWorkingCopy
	
	doAfterNextStepBlock := [self signalRefreshToToolsWorkingOn: aWorkingCopy].
	self startStepping.! !

!CvVersionBar methodsFor: 'accessing' stamp: 'bs 4/11/2011 11:14:49.593'!
scrollArea
	^ scrollArea! !

!CvVersionBar methodsFor: 'as yet unclassified' stamp: 'bs 5/10/2011 22:43:35.755'!
scrollToShow: aMorph
	chronoView fullBounds.
	self scrollArea scrollToShow: aMorph! !

!CvVersionBar methodsFor: 'as yet unclassified' stamp: 'bs 5/9/2011 20:47:15.384'!
signalRebasedToToolsWorkingOn: aWorkingCopy
	
	self windowsOfOwnerMorph 
		select: [:ea | ea psCodeBase = aWorkingCopy]
		thenDo: [:ea | ea psRebased]! !

!CvVersionBar methodsFor: 'as yet unclassified' stamp: 'bs 8/24/2012 13:21:53.534'!
signalRefreshToToolsWorkingOn: aWorkingCopy
	
	self windowsOfOwnerMorph 
		select: [:ea | ea psCodeBase = aWorkingCopy]
		thenDo: [:ea | ea psRefresh]! !

!CvVersionBar methodsFor: 'as yet unclassified' stamp: 'bs 5/12/2011 22:12:24.501'!
step
	self stopStepping.
	doAfterNextStepBlock value.
	doAfterNextStepBlock := nil! !

!CvVersionBar methodsFor: 'working copies' stamp: 'bs 4/13/2011 11:18:02.471'!
subscribeForWorkingCopies
	
	self connect: self controller signal: #workingCopyActivated: toSelector: #workingCopyActivated:.! !

!CvVersionBar methodsFor: 'OB support' stamp: 'TM 4/1/2011 14:33:49.857'!
subscribeToOB: aClassBrowser

	self subscribedOBs add: aClassBrowser.
	aClassBrowser announcer 
		observe: OBSelectionChanged
		send: #obSelectionChanged:
		to: self! !

!CvVersionBar methodsFor: 'OB support' stamp: 'bs 3/14/2011 11:35:09.624'!
subscribeToOpenOBs
	self isOBInstalled ifFalse: [^ self].
	self currentOBWindows do: [:window | self subscribeToOB: window model]
	! !

!CvVersionBar methodsFor: 'OB support' stamp: 'bs 5/10/2011 21:53:34.93'!
subscribeToOwnersAddedRemovedMorph
	self 
		connect: self owner signal: #addedMorph: toSelector: #ownerAddedMorph: ;
		connect: self owner signal: #removedMorph: toSelector: #ownerRemovedMorph:! !

!CvVersionBar methodsFor: 'OB support' stamp: 'bs 3/14/2011 11:45:15.631'!
subscribedOBs
	^ subscribedOBs ifNil: [subscribedOBs := IdentitySet new]! !

!CvVersionBar methodsFor: 'accessing' stamp: 'bs 4/19/2011 21:16:02.166'!
timeline
	^ timeline! !

!CvVersionBar methodsFor: 'highlighting' stamp: 'TM 4/1/2011 12:15:46.643'!
tree

	^ tree! !

!CvVersionBar methodsFor: 'OB support' stamp: 'bs 5/2/2011 22:41:46.675'!
unsubscribeToOB: aClassBrowser
	aClassBrowser announcer unsubscribe: self.
	self subscribedOBs remove: aClassBrowser ifAbsent: [].! !

!CvVersionBar methodsFor: 'OB support' stamp: 'bs 5/2/2011 22:18:46.686'!
unsubscribeToOwnersAddedRemovedMorph
	self owner 
		disconnectSignal: #addedMorph: from: self;
		disconnectSignal: #removedMorph: from: self! !

!CvVersionBar methodsFor: 'working copies' stamp: 'bs 8/24/2012 13:22:48.124'!
versionSavedOn: aWorkingCopy
	
	"this seems a bad idea, because the computation takes too long, in particular for senders and implementors browsers. I am not sure if this is really needed, or why I did implement it"
	self refreshToolsWorkingOn: aWorkingCopy! !

!CvVersionBar methodsFor: 'working copies' stamp: 'bs 4/27/2011 11:35:03.737'!
view

	^ chronoView! !

!CvVersionBar methodsFor: 'accessing' stamp: 'bs 5/9/2011 20:47:10.587'!
windowsOfOwnerMorph
	
	^ self owner submorphs select: [:ea | ea isSystemWindow]
			! !

!CvVersionBar methodsFor: 'working copies' stamp: 'bs 8/1/2012 13:31:47.294'!
workingCopies

	^ self controller workingCopies! !

!CvVersionBar methodsFor: 'working copies' stamp: 'bs 7/31/2012 10:54:04.142'!
workingCopyActivated: aWc
	
	CvWorkingCopyPointer workingCopy: aWc versionBar: self.
	self 
		connect: aWc 
		signal: #rebasedFrom:to: 
		toSelector: #rebased:from:to: 
		pattern: #(0 1 2).
	self 
		connect: aWc 
		signal: #versionSaved 
		toSelector: #versionSavedOn: 
		pattern: #(0).! !

!TestRunner methodsFor: '*CV-override' stamp: 'bs 5/15/2011 15:20:21.939'!
runSuite: aTestSuite
	| originalCode |
	originalCode := [ 
		self basicRunSuite: aTestSuite do: [ :each | self runTest: each ].
		self updateResults].
	
	self activeCodeBase 
		ifNil: [originalCode value]
		ifNotNil: [:codeBase | 
			originalCode valueBasedOn: codeBase testCodeBase].! !

!TestRunner methodsFor: '*CV-override' stamp: 'bs 8/1/2012 15:54:36.318'!
selectCategoriesOfPackageUnderDevelopment
	categoriesSelected := World cvController package systemCategories asSet.
	self changed: #allSelections; changed: #categorySelected; updateClasses! !

!TestSuite methodsFor: '*CV-override' stamp: 'bs 5/11/2011 14:58:15.499'!
run
	| result originalCode |
	result := TestResult new.
	originalCode := [ 
		self resources do: [ :res |
			res isAvailable ifFalse: [^res signalInitializationError]].
		[self run: result] ensure: [self resources do: [:each | each reset]]].
	
	self activeCodeBase 
		ifNil: [originalCode value]
		ifNotNil: [:codeBase | 
			originalCode valueBasedOn: codeBase testCodeBase].
		
	^result.

			! !

MCPatch subclass: #CvPatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvPatch class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.085'!
canBeLateBound
	^ false! !

!CvPatch methodsFor: 'as yet unclassified' stamp: 'bs 4/14/2011 13:18:56.6'!
initializeWithBase: baseSnapshot target: targetSnapshot
	| base target |	
	operations := OrderedCollection new.
	base := MCDefinitionIndex definitions: baseSnapshot definitions.
	target := MCDefinitionIndex definitions: targetSnapshot definitions.
	
	target definitions do:
		[:t |
		base
			definitionLike: t
			ifPresent: [:b | (b isSameRevisionAs: t) ifFalse: [operations add: (MCModification of: b to: t)]]
			ifAbsent: [operations add: (MCAddition of: t)]].
		
	base definitions do:
		[:b |
		target
			definitionLike: b
			ifPresent: [:t]
			ifAbsent: [operations add: (MCRemoval of: b)]]		! !

!DisplayObject class methodsFor: '*CV' stamp: 'bs 4/29/2011 21:08:09.411'!
canBeLateBound
	
	^ false! !

!AddedEvent methodsFor: '*CV' stamp: ''!
changedMetaObject

	^ self itemKind = AbstractEvent categoryKind
		ifTrue: [nil]
		ifFalse: [	
			"item is either a class or a method"
			self reboundItem].! !

!AddedEvent methodsFor: '*CV' stamp: 'bs 1/15/2013 17:34:21.175'!
checkoutChangesTo: aWorkingCopy

	self isCategoryItem ifTrue: [^ self].

	self reboundItem 
		ifNil: [ "we are going back / ensure to make it undone"
			self basedOn: aWorkingCopy do: [
				(self cvItemReference bind: aWorkingCopy) 
					ifNotNil: [:aMethodOrClass | aMethodOrClass removeFrom: aWorkingCopy]]]
		ifNotNil: [:aMethodOrClass | 
			aMethodOrClass checkoutCopyTo: aWorkingCopy]! !

!AddedEvent methodsFor: '*CV' stamp: 'bs 2/3/2012 22:44:31.874'!
cleanUpChangesTo: aVersion

	self copyOrganizationTo: aVersion.
	self isCategoryItem ifTrue: [^ self].
	
	self reboundParentItem saveFlatCopyTo: aVersion.
	self isClassItem ifTrue: [
		self reboundItem saveFlatCopyTo: aVersion].
	self basedOn: aVersion do: [ 
		self reboundParentItem cleanUpSubclasses].
	! !

!AddedEvent methodsFor: '*CV' stamp: 'bs 8/30/2011 11:51:27.554'!
includedInCheckoutOf: aClass

	^ self isCategoryItem 
		or: self reboundParentItem = aClass
		or: self reboundItem = aClass! !

!AddedEvent methodsFor: '*CV' stamp: 'bs 8/23/2012 13:14:25.951'!
itemToBeCheckedOut

	^ self itemKind = AbstractEvent categoryKind
		ifTrue: [nil]
		ifFalse: [	
			"item is either a class or a method"
			self cvItemReference].! !

!AddedEvent methodsFor: '*CV' stamp: 'bs 8/23/2012 13:44:39.286'!
requiresCheckoutTo: aWorkingCopy

	^ (self cvItemReference bind: self activeCodeBase) 
		ifNil: [(self cvItemReference bind: aWorkingCopy) notNil]
		ifNotNil: [:boundItem | boundItem requiresReCheckoutTo: aWorkingCopy].! !

!Editor methodsFor: '*CV' stamp: 'bs 2/27/2012 21:46:19.698'!
supportsEagerSaving

	^ false! !

!MCPatchOperation methodsFor: '*CV' stamp: 'bs 3/14/2011 19:19:05.664'!
cvSummary
	^ Array
		with: self cvSummaryHeader
		with: self cvSummaryBody! !

!MCPatchOperation methodsFor: '*CV' stamp: 'bs 3/14/2011 20:16:29.258'!
cvSummaryBody
	| result |
	result := self source.
	result runs mapValues: [:attributes | attributes collect: [:eachAttr |
		(eachAttr isKindOf: TextColor) 
			ifFalse: [eachAttr]
			ifTrue: [ | newTextColor |
				newTextColor := eachAttr color.
				eachAttr color = Color red ifTrue: [newTextColor := TextColor color: Color red darker darker].
				eachAttr color = Color blue ifTrue: [newTextColor := TextColor color: Color blue darker darker].
				newTextColor]]].
	^ result! !

!MCPatchOperation methodsFor: '*CV' stamp: 'bs 11/9/2012 17:04:51.005'!
cvSummaryHeader
	^ self cvSummaryPrefix, ' ',
	   (self isClassPatch ifTrue: [''] ifFalse: ['in ']),
	  ( [self definition summary] 
		unless: [self definition isMethodDefinition]
		proceed: [:summary | summary copyUpTo: '>' asCharacter ]	)! !

!MCPatchOperation methodsFor: '*CV' stamp: 'bs 3/14/2011 19:00:48.932'!
cvSummaryPrefix
	^ ''! !

!OBMethodNode methodsFor: '*CV' stamp: ''!
cvItem

	^ self theClass >> self selector
	! !

!OBMethodNode methodsFor: '*CV' stamp: 'bs 8/30/2012 11:43:20.783'!
cvItemReference
	
	^ CvCodeReference 
		selector: self selector 
		category: self category 
		class: self theClass! !

!OBMethodNode methodsFor: '*CV' stamp: 'bs 6/24/2012 17:27:03.06'!
valueAt: aCodeBase

	^ (self theClass valueAt: aCodeBase) 
		ifNotNil: [:aClass |
			(aClass includesSelector: self selector)
				ifFalse: [OBClassNode on: aClass]
				ifTrue: [OBMethodNode on: self selector inClass: aClass]]! !

TestCase subclass: #CvUsingTbTestCase
	instanceVariableNames: 'codeBasesBeforeTestRun'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-TestBed'!

CvUsingTbTestCase subclass: #CvBasicsTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvBasicsTestCase class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.015'!
canBeLateBound
	^ false! !

!CvBasicsTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 16:12:35.11'!
assert: aBlock basedOn: aCodeBase
	self assert: (aBlock valueBasedOn: aCodeBase)! !

!CvBasicsTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2011 16:10:35.451'!
copyDictAndDuplicatePathTo: aMetaObject
	| copy |
	copy := self activeCodeBase copy.
	(aMetaObject valueAt: copy) addCopyTo: copy do: [  ].
	^ copy dictionary! !

!CvBasicsTestCase methodsFor: 'system event handling' stamp: 'bs 3/29/2011 10:54:57.345'!
handleEvent: aSystemEvent
	self activeWorkingCopy saveVersionForChange: aSystemEvent! !

!CvBasicsTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 14:45:42.682'!
test01DuplicatingClasses
	| dictCopy |
	dictCopy := self copyDictAndDuplicatePathTo: self tbClass.
	self assert: [dictCopy isKindOf: SystemDictionary].
	self deny: [dictCopy ==  self activeDict].
	self assert: [dictCopy size =  self activeDict size].
	self deny: (self tbClass) == (dictCopy at: self tbClassName)! !

!CvBasicsTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 21:17:05.564'!
test02SubclassesAfterDuplicate
	| copiedDict orgClass copiedClass orgSuperclass |
	orgClass := self tbClass.
	orgSuperclass := self tbClass superclass.
	copiedDict := self copyDictAndDuplicatePathTo: self tbClass.
	copiedClass := copiedDict at: self tbClassName.
	
	PsActiveCodeBase 
		value: (PsCodeBase new dictionary: copiedDict)
		during: [
			self assert: (orgSuperclass subclasses includes: copiedClass).
			self deny: (orgSuperclass subclasses includes: orgClass).
			self assert: orgClass subclasses = copiedClass subclasses ]! !

!CvBasicsTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/21/2011 11:18:42.309'!
test03SuperAndMetaSuperClassesAfterDuplicate
	| copiedDict subjects |
	"ToDo: Behavior darf nicht dabei sein, in den Subclasses"
	copiedDict := self copyDictAndDuplicatePathTo: Object.
	self assert: [Object subclasses includes: Behavior] 
		 basedOn: (PsCodeBase new dictionary: copiedDict).
	
	subjects := {Morph. BorderedMorph. TestCase. LeafNode} collect: [:ea | ea name].
	subjects do: [:ea | | org copy |
		org := copiedDict classNamed: ea.
		copy := self activeDict classNamed: ea.
		self deny: org = copy.
		self deny: org superclass = copy superclass.
		self deny: org class = copy class.
		self deny: org class superclass = copy class superclass ]! !

!CvBasicsTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 15:48:09.809'!
test04DuplicateMethod
	| copiedDict |
	copiedDict := self copyDictAndDuplicatePathTo: self tbMethod.
	self assert: [:dict | dict at: self tbClassName ] isUnlikeFor: self activeDict and: copiedDict.
	self assert: [:dict | (dict at: self tbClassName) >> self tbMethodName ] 
		isUnlikeFor: self activeDict 
		and: copiedDict.! !

!CvBasicsTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 15:48:06.333'!
test05DuplicateClassMethod
	| copiedDict |
	copiedDict := self copyDictAndDuplicatePathTo: self tbClassMethod.
	self assert: [:dict | dict at: self tbClassName ] isUnlikeFor: self activeDict and: copiedDict.
	self assert: [:dict | (dict at: self tbClassName) class >> self tbClassMethodName ] 
		isUnlikeFor: self activeDict 
		and: copiedDict.! !

CvUsingTbTestCase subclass: #CvCodeReferenceTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-Refs'!

!CvCodeReferenceTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 15:24:50.503'!
assert: aCodeReference matches: targetReference

	self assert: (aCodeReference matches: targetReference)! !

!CvCodeReferenceTestCase methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 16:55:14.552'!
test01ClassMatching

	self assert: ((CvCodeReference class: CvTbPerson) matches: (CvCodeReference class: CvTbPerson))! !

!CvCodeReferenceTestCase methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 17:33:20.766'!
test02ClassMatchingCategory

	self assert: ((CvCodeReference class: CvTbPerson) matches: (CvCodeReference classCategory: 'CV-TestBed'))! !

!CvCodeReferenceTestCase methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 17:49:47.595'!
test03CatgoryMatchingCategory

	self assert: ((CvCodeReference classCategory: 'CV-TestBed') matches: (CvCodeReference classCategory: 'CV-TestBed'))! !

!CvCodeReferenceTestCase methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 17:54:31.222'!
test04MethodMatchingMethod

	self assert: ((CvCodeReference method: CvTbPerson >> #firstname) matches: (CvCodeReference class: CvTbPerson))! !

!CvCodeReferenceTestCase methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 17:54:51.84'!
test05MethodMatchingClass

	self assert: ((CvCodeReference method: CvTbPerson >> #firstname) matches: (CvCodeReference method: CvTbPerson >> #firstname))! !

!CvCodeReferenceTestCase methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 17:58:45.846'!
test06MethodMatchingCategory

	self assert: ((CvCodeReference method: CvTbPerson >> #firstname) matches: (CvCodeReference classCategory: 'CV-TestBed'))! !

!CvCodeReferenceTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2011 14:39:32.613'!
test07MethodCategoryMatchingMethodCategory

	self assert: ((CvCodeReference methodCategory: 'accessing' class: CvTbPerson ) matches: (CvCodeReference methodCategory: 'accessing' class: CvTbPerson ))! !

!CvCodeReferenceTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2011 14:39:46.913'!
test08MethodMatchingMethodCategory

	self assert: ((CvCodeReference method: CvTbPerson >> #firstname) matches: (CvCodeReference methodCategory: 'accessing' class: CvTbPerson ))! !

!CvCodeReferenceTestCase methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 19:51:31.936'!
test09MethodMatchingFuzzySearch

	self assert: ((CvCodeReference method: CvTbPerson >> #firstname) matches: (CvCodeReference fuzzySearch: 'name')).
	
	self assert: ((CvCodeReference method: CvTbPerson >> #firstname) matches: (CvCodeReference fuzzySearch: 'Tb'))! !

!CvCodeReferenceTestCase methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 19:58:22.817'!
test10ClassMatchingFuzzySearch

	self assert: ((CvCodeReference class: CvTbPerson) matches: (CvCodeReference fuzzySearch: 'Tb'))! !

!CvCodeReferenceTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 09:36:22.203'!
test11Equals

	self assert: (CvCodeReference class: self tbClass)
		 equals: (CvCodeReference class: self tbClass).
		
	self deny: (CvCodeReference class: self tbClass)
		 equals: (CvCodeReference class: self tbSubclass).
	
	self deny: (CvCodeReference class: self tbClass)
		 equals: (CvCodeReference method: self tbMethod).
	
	self assert: (CvCodeReference method: self tbMethod)
		 equals: (CvCodeReference method: self tbMethod).! !

!CvCodeReferenceTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 15:25:08.074'!
test12Root

	self assert: (CvCodeReference class: CvTbPerson) 
		 matches: CvCodeReference root! !

!CvCodeReferenceTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 19:24:50.714'!
test13CommonParentWith

	self assert: ((CvCodeReference class: self tbClass) commonParentWith: (CvCodeReference method: self tbMethod)) 
		 equals: (CvCodeReference class: self tbClass).
	
	self assert: ((CvCodeReference class: self tbSubclass) commonParentWith: (CvCodeReference method: self tbMethod)) 
		 equals: (CvCodeReference classCategory: self tbClassCategory).! !

CvUsingTbTestCase subclass: #CvTestCase
	instanceVariableNames: 'sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

CvTestCase subclass: #CvCheckoutChangesTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvCheckoutChangesTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/3/2012 16:13:19.39'!
test01KeepClassesWhenRevertMethodModification
	| wc tbClassV1 tbSubclassV1 |
	wc := self startTbVersioning.
	
	self basedOn: wc do: [
		tbClassV1 := self tbClass.
		tbSubclassV1 := self tbSubclass.
		self tbClass compile: self tbMethod getSource.
		wc rebaseTo: wc baseVersion predecessor.
	
		self assert: tbClassV1 equals: self tbClass.
		self assert: tbSubclassV1 equals: self tbSubclass ].! !

!CvCheckoutChangesTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/3/2012 15:18:39.599'!
test02RevertMethodAddition
	| wc tbClassV1 tbSubclassV1 |
	wc := self startTbVersioning.
	
	self basedOn: wc do: [
		tbClassV1 := self tbClass.
		tbSubclassV1 := self tbSubclass.
		self tbClass compile: 'fooBar'.
		wc rebaseTo: wc baseVersion predecessor.
	
		self assert: tbClassV1 equals: self tbClass.
		self assert: tbSubclassV1 equals: self tbSubclass ].! !

!CvCheckoutChangesTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/3/2012 15:28:15.217'!
test03MethodCategoryWhenRedoingMethodAddition
	| category symbol wc vAfterAddition |
	category := #accessing.
	symbol := #fooBar.
	wc := self startTbVersioning.
	
	self basedOn: wc do: [
		self tbClass compile: symbol asString classified: category.
		vAfterAddition := wc baseVersion.
		wc rebaseTo: wc baseVersion predecessor.
		wc rebaseTo: vAfterAddition.
		
		self assert: (self tbClass organization listAtCategoryNamed: category) 
			 includes: symbol].! !

!CvCheckoutChangesTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/3/2012 16:32:01.978'!
test04RevertMethodModification
	| symbol wc vBeforeMod theMethod |
	symbol := #fooBar.
	wc := self startTbVersioning.
	
	self basedOn: wc do: [
		self tbClass compile: symbol asString.
		vBeforeMod := wc baseVersion.
		self tbClass compile: symbol asString, ' ''foobar'' '.
		
		theMethod := self tbClass >> symbol.
		self assert: (theMethod valueAt: vBeforeMod) getSource
		       differsFrom: theMethod getSource.
		
		wc rebaseTo: wc baseVersion predecessor.
		
		self assert: symbol asString asText
			 equals: (self tbClass >> symbol) getSource].! !

CvTestCase subclass: #CvClassCopyTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvClassCopyTestCase class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.053'!
canBeLateBound
	^ false! !

!CvClassCopyTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2011 16:03:24.987'!
test01AdoptionOfClassOrgSubject
	| aClass copyOfCodeBase copyOfClass |
	aClass := self tbClass.
	copyOfCodeBase := self activeCodeBase copy.
	copyOfClass := aClass addCopyTo: copyOfCodeBase do: [  ].	
	
	"it is necessary to use #instVarNamed: rather than sending #organization,
	 as the #organization method will refresh the subject and thus won't reveal
	 the issues"
	self deny: (aClass class instVarNamed: 'organization') equals: (copyOfClass class instVarNamed: 'organization').
	self assert: aClass equals: (aClass instVarNamed: 'organization') subject.
	self assert: aClass class equals: (aClass class instVarNamed: 'organization') subject! !

!CvClassCopyTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:46:28.244'!
test02CleanCopyOfStDict
	| numberOfClasses aWc |
	numberOfClasses := Metaclass allInstances size.
	aWc := self startTbVersioning.
	self basedOn: aWc do: [self tbSubclass removeFromSystem].
	(SignalSpy 
		onSender: aWc baseVersion 
		signal: #hasRunTests:)
			waitForNextSignal.
	
	aWc := nil.
	sut uninstall.
	Smalltalk garbageCollect.
	self assert: numberOfClasses equals: Metaclass allInstances size.! !

!CvClassCopyTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/3/2012 15:07:01.029'!
test03DuplicatingClassVars
	| aWc |
	CvTbPerson createNewDefault.
	aWc := self startTbVersioning.
	self basedOn: aWc
		 assert: [CvTbPerson default notNil].
	self assert: [:codeBase | (codeBase classNamed: #CvTbPerson) default]
		 isUnlikeForCodeBases: aWc and: self activeCodeBase! !

CvTestCase subclass: #CvCleanUpChangesTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvCleanUpChangesTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/25/2011 16:11:58.799'!
test01CleanUpMethodModification
	| wc v1 v2 |
	wc := self startTbVersioning.
	v1 := wc baseVersion.
	self basedOn: wc do: [
		self tbClass compile: self tbMethod getSource ].
	v2 := wc baseVersion.
	
	self assert: [self tbClass]
		 isUnlikeForCodeBases: v1 and: v2.
		
	self assert: [self tbSubclass]
		 equalsForCodeBases: v1 and: v2.! !

!CvCleanUpChangesTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/26/2011 11:25:07.148'!
test02CleanUpMethodAdditionAndRemoval
	| wc v1 v2 v3 |
	wc := self startTbVersioning.
	v1 := wc baseVersion.
	
	[self tbClass compile: 'foo'] valueBasedOn: wc.
	v2 := wc baseVersion.
	
	self assert: [self tbClass] isUnlikeForCodeBases: v1 and: v2.		
	self assert: [self tbSubclass] equalsForCodeBases: v1 and: v2.
	
	[self tbClass removeSelector: #foo] valueBasedOn: wc.
	v3 := wc baseVersion.
	
	self assert: [self tbClass] isUnlikeForCodeBases: v2 and: v3.		
	self assert: [self tbSubclass] equalsForCodeBases: v2 and: v3.! !

!CvCleanUpChangesTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/26/2011 11:43:04.992'!
test03CleanUpClassModification
	| newInstVarName wc v1 v2 | 
	newInstVarName := 'foobar'.
	wc := self startTbVersioning.
	v1 := wc baseVersion.
	
	[self tbClass addInstVarName: newInstVarName] valueBasedOn: wc.
	v2 := wc baseVersion.
	
	self assert: [self tbObjectClass] equalsForCodeBases: v1 and: v2.
	self assert: [self tbClass] isUnlikeForCodeBases: v1 and: v2.
	self assert: [self tbSubclass] isUnlikeForCodeBases: v1 and: v2.! !

!CvCleanUpChangesTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/30/2011 11:55:29.218'!
test04CleanUpClassAdditionAndRemoval
	| subclassName wc v1 v2 v3 | 
	subclassName := #CvSpecialPerson.
	wc := self startTbVersioning.
	v1 := wc baseVersion.
	
	[self createSubclassOfTbClassNamed: subclassName] valueBasedOn: wc.
	v2 := wc baseVersion.
	
	self assert: [v2 hasClassNamed: subclassName].
	self assert: [self tbObjectClass] equalsForCodeBases: v1 and: v2.
	self assert: [self tbClass] isUnlikeForCodeBases: v1 and: v2.
	self assert: [self tbSubclass] equalsForCodeBases: v1 and: v2.
	self assert: (v2 classNamed: subclassName) cvOriginal isNil. 
	self assert: (v2 classNamed: subclassName)
		 equals: (((self tbClass valueAt: v2) instVarNamed: 'subclasses') detect: [:ea | ea name = subclassName]).
	
	[self removeClassNamed: subclassName] valueBasedOn: wc.
	v3 := wc baseVersion.
	
	self assert: [self tbObjectClass] equalsForCodeBases: v2 and: v3.
	self assert: [self tbClass] isUnlikeForCodeBases: v2 and: v3.
	self assert: [self tbSubclass] equalsForCodeBases: v2 and: v3.! !

!CvCleanUpChangesTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/30/2011 12:05:39.378'!
test05CleanUpClassModifications
	| wc |
	wc := self startTbVersioning.
	
	self basedOn: wc do: [
		CvTbPerson
			addInstVarName: 'lastname';
			compile: 'lastname
				^ lastname ifNil: [''foo'']';
			removeSelector: #lastname;
			removeInstVarName: 'lastname'].
	
	self basedOn: wc baseVersion
		 deny: [self tbClass instVarNames includes: 'lastname'].! !

CvTestCase subclass: #CvCvTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvCvTestCase class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.061'!
canBeLateBound
	^ false! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:46:44.007'!
test01Versioning
	| aWorkingCopy |
		
	aWorkingCopy := self startTbVersioning.
	self assert: (self polySource codeBases includes: aWorkingCopy).
	self assert: [:aCodeBase | aCodeBase classNamed: self tbClassName]
		 isUnlikeFor: self activeCodeBase and: aWorkingCopy.
	
	self basedOn: aWorkingCopy do: [
		self tbClass removeSelector: self tbMethodName.
		self deny: (self tbClass includesSelector: self tbMethodName) ].
		
	aWorkingCopy := nil.
	Smalltalk garbageCollect.
	self deny: (self polySource codeBases includes: aWorkingCopy).! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 13:26:46.456'!
test03RunningTestsInBackground
	| aWc aVersion |
	sut packageUnchecked: self tbPackageInfo.
	aWc := self startTbVersioning.
	aVersion := aWc baseVersion.
	self assert: aVersion testResult isNil.
	
	(SignalSpy onSender: aVersion signal: #hasRunTests:)
		waitForNextSignal.
	World doOneCycle.
	World doOneCycle.
	
	self assert: aVersion testResult notNil! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:47:33.179'!
test04Checkout
	| baseVersion aWorkingCopy |
	aWorkingCopy := self startTbVersioning.
	baseVersion := aWorkingCopy baseVersion.
	
	self assert: [:aVersion | aVersion classNamed: self tbClassName ]
		isUnlikeFor: aWorkingCopy and: baseVersion.! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:48:15.831'!
test05DuplicateForRemovedMethod
	| baseVersion aWorkingCopy newBase |
	aWorkingCopy := self startTbVersioning.
	baseVersion := aWorkingCopy baseVersion.
	
	self basedOn: aWorkingCopy do: [
		self tbClass removeSelector: self tbMethodName].
	
	newBase := aWorkingCopy baseVersion.
	self deny: newBase = baseVersion.
	self deny: ((newBase classNamed: self tbClassName) selectors includes: self tbMethodName)! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:48:32.732'!
test06DuplicateForRemovedSubclass
	| baseVersion aWorkingCopy newBase |
	aWorkingCopy := self startTbVersioning.
	baseVersion := aWorkingCopy baseVersion.
	
	self assert: (baseVersion dictionary hasClassNamed: self tbSubclassName).
	
	self removeClassNamed: self tbSubclassName on: aWorkingCopy.

	newBase := aWorkingCopy baseVersion.
	self deny: (newBase dictionary allClasses includes: self tbSubclass).

	self assert: (baseVersion dictionary hasClassNamed: self tbSubclassName)! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/22/2011 11:52:20.95'!
test07OrganizationOfDictionary
	| wc base |
		
	wc := self startTbVersioning.
	base := wc baseVersion.
	
	self deny: base organization = wc organization.
	SystemOrganizer instVarNames do: [:ea |
		self deny: (base organization instVarNamed: ea) == (wc organization instVarNamed: ea)
			 description: 'system organization needs to be copied deep' ].! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:49:15.931'!
test08ImplicitBranching
	| base wc1 wc2 |
	wc1 := self startTbVersioning.
	base := wc1 baseVersion.
	self basedOn: wc1 do: [ 
		self tbSubclass removeFromSystem ].
	
	wc2 := sut checkout: base.
	self basedOn: wc2 do: [
		self tbClass removeSelector: self tbMethodName].
	
	self assert: (base successors includes: wc1 baseVersion).
	self assert: (base successors includes: wc2 baseVersion).! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:49:49.394'!
test09HandlingEventsOnlyIfCodeBaseIsActive
	| base nonActiveWc |
	nonActiveWc := self startTbVersioning.
	base := nonActiveWc baseVersion.
	nonActiveWc saveVersionForChange: (RemovedEvent class: self tbSubclass).
	self assert: base equals: nonActiveWc baseVersion.
	self deny: (base classNamed: self tbSubclassName) isNil.! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:50:38.405'!
test10VersionNumbers
	| base wc |
	wc := self startTbVersioning.
	base := wc baseVersion.
	self assert: 1 equals: base number.
	self assert: 'version 1' equals: base asString.
	
	self assert: 'working copy of version 1' equals: wc asString.
	
	self removeClassNamed: self tbSubclassName on: wc.
	self assert: 2 equals: wc baseVersion number. ! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:51:26.724'!
test12McPackage
	| wc1 aMcPackage |
	wc1 := self startTbVersioning.
	self removeClassNamed: self tbSubclassName on: wc1.
	
	PsActiveCodeBase value: wc1 during: [
		aMcPackage := CvPackage named: self tbPackageName.
		self deny: [aMcPackage snapshot definitions anySatisfy: [:ea |
			ea className = self tbSubclassName ] ] ].! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:51:49.205'!
test13Merge
	<timeout: 20>
	| base wc1 wc2 aMcPkg |
	sut packageUnchecked: self tbPackageInfo.
	wc1 := self startTbVersioning.
	base := wc1 baseVersion.
	self removeClassNamed: self tbSubclassName on: wc1.
	
	wc2 := sut checkout: base.
	self removeMethod: self tbMethod on: wc2.
	
	self assert: wc2 version ~= wc1 version.
	self assert: wc2 version ~= PsActiveCodeBase value version.
	self assert: wc1 version ~= PsActiveCodeBase value version.
	
	wc1 merge: wc2 baseVersion.

	aMcPkg := MCPackage named: self tbPackageName.
	self assert: 1 equals: (MCWorkingCopy forPackage: aMcPkg) ancestry ancestors size.
	self deny: [self tbClass includesSelector: self tbMethodName] 
		 basedOn: wc1.
	self assert: (wc1 baseVersion versionInfo ancestors includes: wc2 baseVersion versionInfo).
	
	self deny: base = wc1 baseVersion predecessor.
	self assert: base = wc1 baseVersion predecessor predecessor.! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:52:01.09'!
test14ViewChanges
	<timeout: 20>
	| base wc1 patch |
	sut packageUnchecked: self tbPackageInfo.
	wc1 := self startTbVersioning.
	base := wc1 baseVersion.
	self removeClassNamed: self tbSubclassName on: wc1.
	self removeMethod: self tbMethod on: wc1.

	patch := wc1 baseVersion patchRelativeToBase: base.
	(CvPatchView forPatch: patch) build.
	"(CvPatchView forPatch: patch) build openInWorld."
	"(MCPatchBrowser forPatch: patch) show."! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:52:17.282'!
test15RealVersioning
	| aWc |
	aWc := self startTbVersioning.
	
	self basedOn: aWc do: [
		self tbClass removeSelector: self tbMethodName.
		self tbTestClass removeSelector: #testFirstname. ].
		
	self basedOn: aWc baseVersion predecessor
		 deny: [self tbClass selectors includes: self tbMethodName].
		
	self basedOn: aWc baseVersion predecessor 
		 assert: [self tbTestClass selectors includes: #testFirstname].	
	
	self basedOn: aWc baseVersion 
		 deny: [self tbTestClass selectors includes: #testFirstname].! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/22/2011 19:31:42.023'!
test16DuplicateOfSuperclasses
	| aWc |
	aWc := sut startVersioning: self activeCodeBase.
	
	self assert: [:aCodeBase | aCodeBase classNamed: #TestCase]
		 isUnlikeFor: aWc baseVersion and: self activeCodeBase.
	
	self assert: [:aCodeBase | aCodeBase classNamed: #Object]
		 isUnlikeFor: aWc baseVersion and: self activeCodeBase.
	
	self assert: [:aCodeBase | aCodeBase classNamed: #ProtoObject]
		 isUnlikeFor: aWc baseVersion and: self activeCodeBase.! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/27/2011 16:52:30.403'!
test17EqualTestResultsWhenReferencingMethodIsChanged
	<timeout: 20>
	| aWc |
	sut packageUnchecked: self tbPackageInfo.
	aWc := self startTbVersioning.
	
	"creating a new test method that, after compilation, has a direct reference 
	 to the CvTbPerson class"
	self basedOn: aWc 
		 do: [self tbTestClass compile: 'testLastname
				| sut |
				sut := CvTbPerson new.
				sut lastname: ''Foo''.
				self assert: ''Foo'' equals: sut lastname'].
	
	"we change the referencing class"
	self basedOn: aWc 
		 do: [self tbTestClass addInstVarName: 'lastname' ].
	
	"check whether the compiler updates referencing methods 
	 such as the above create one. this behavior is not necessary, 
	 but currently expected. so we just assure whether this test is still required"
	self assert: [:aVersion | (aVersion classNamed: self tbTestClassName) >> #testLastname ]
		 isUnlikeForCodeBases: aWc baseVersion and: aWc baseVersion predecessor.

	"wait until background process finished executing corresponding tests for the applied change"
	(SignalSpy onSender: aWc baseVersion signal: #hasRunTests:)
		waitForNextSignal.
	World doOneCycle.
	World doOneCycle.
	
	"Even if referencing methods are updated, this should not affect the test results,
	 which are, e.g., compared in our history/version bar"
	self assert: [:aVersion | aVersion defectTests ]
		 equalsForCodeBases: aWc baseVersion and: aWc baseVersion predecessor.! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/26/2011 15:26:41.392'!
test18ConsistencyOfMetaclasses
	| aWc activeObjectClass |
	aWc := sut startVersioning: self activeCodeBase.
	
	self assert: [:aCodeBase | aCodeBase classNamed: #ProtoObject ]
		 isUnlikeFor: self activeCodeBase and: aWc baseVersion.
	
	self assert: Class equals: ProtoObject class superclass.
	
	activeObjectClass := Object.
	self basedOn: aWc baseVersion do: [
		self assert: Object class class equals: Metaclass.
		self assert: Class equals: ProtoObject class superclass.
		self assert: (Class subclasses includes: ProtoObject class).
		self assert: 1 equals: ProtoObject subclasses size.
		self assert: #Object equals: ProtoObject subclasses anyOne name.
		self assert: activeObjectClass differsFrom: ProtoObject subclasses anyOne].! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/27/2011 17:15:43.847'!
test18aAddingMethodToObject
	| aWc |
	aWc := sut startVersioning: self activeCodeBase duplicateClassesStartAt: #ProtoObject.
	
	self basedOn: aWc do: [
		self deny: (CvTbPerson respondsTo: #fooBar).
		Object compile: 'fooBar ^ ''hello'' '.
		self assert: (CvTbPerson respondsTo: #fooBar).
		self assert: 'hello' equals: CvTbPerson fooBar].

	self activeCodeBase rebindAllClassReferences.! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/27/2011 16:16:43.988'!
test19AdoptionOfCopiedClassAndMetaClass
	| wc wc2 |
	wc := sut startVersioning: self activeCodeBase.
	wc2 := wc baseVersion checkout.

	self basedOn: wc2 do: [
		self assert: (Metaclass class class == Metaclass).
		self assert: (Metaclass superclass == ClassDescription).
		self assert: (Metaclass class superclass == ClassDescription class).
		self assert: (Class isKindOf: Class).
		self assert: (CvTbPerson isKindOf: Behavior).
		self assert: (CvTbPerson class isKindOf: Metaclass) ]! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 13:27:37.835'!
test20NamedBranches
	<timeout: 20>
	| wc1 wc2 |
	wc1 := self startTbVersioning.
	wc2 := sut checkout: wc1 baseVersion.
	
	self assert: '1' equals: wc1 baseVersion path.
	self assert: wc1 baseVersion equals: (sut versionByPath: '1').
	
	self basedOn: wc1 do: [	
		self tbClass removeSelector: self tbMethodName.
		self tbTestClass removeSelector: #testFirstname].
	
	self assert: '3' equals: wc1 baseVersion path.
	self assert: wc1 baseVersion equals: (sut versionByPath: '3').
	self assert: wc1 baseVersion equals: (sut versionByPath: '1/1->3').
	self assert: wc1 baseVersion equals: (sut versionByPath: '1/1->2/1->3').
	
	self basedOn: wc2 do: [
		self tbClass removeSelector: self tbMethodName.
		self tbTestClass removeSelector: #testFirstname.].
	
	self assert: '1/2->3' equals: wc2 baseVersion path.
	self assert: wc2 baseVersion equals: (sut versionByPath: '1/2->3').
	self assert: wc2 baseVersion equals: (sut versionByPath: '1/2->2/1->3').
	
	"this should still work, once a path expression become valid it should never become invalid."
	self assert: wc1 baseVersion equals: (sut versionByPath: '3').! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/22/2011 17:22:56.281'!
test21RebaseWorkingCopy
	| wc |
	wc := self startTbVersioning.
	self basedOn: wc do: [
		self tbClass compile: 'foo ^ ''Foo'''.
		self tbClass compile: 'bar ^ ''Foo'''.].
	
	self assert: [
		(wc classNamed: self tbClassName) cvOriginal ~~ 
			(wc baseVersion predecessor classNamed: self tbClassName)].
	self basedOn: wc do: [
		wc rebaseTo: wc baseVersion predecessor].
	
	self basedOn: wc assert: [self tbClass includesSelector: #foo].
	self basedOn: wc deny: [self tbClass includesSelector: #bar]! !

!CvCvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/22/2011 18:47:52.711'!
test23RebaseWithClassModification
	| wc |
	wc := self startTbVersioning.
	
	self basedOn: wc do: [
		CvTbPerson addInstVarName: 'lastname'.
		CvTbPerson compile: 'lastname ^ lastname ifNil: [''foo'']'.
		CvTbPerson compile: 'lastname: anObject lastname := anObject' ].
	
	self basedOn: wc do: [
		wc rebaseTo: wc baseVersion predecessor predecessor].
	
	self basedOn: wc 
		 deny: [self tbClass includesSelector: #lastname]! !

CvTestCase subclass: #CvFaultAnalysisTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvFaultAnalysisTestCase methodsFor: 'as yet unclassified' stamp: 'bs 1/17/2012 18:25:13.024'!
test01
	| wc begin aGen aTestMethod versionBeforeFault faultVersion detectedVersion |
	wc := self startTbVersioning.
	aGen := CvTbGenerator new.
	
	self basedOn: wc do: [
		aTestMethod := aGen createTestForLastnameSlot.
		begin := wc baseVersion.
		aGen createLastnameSlot.
		versionBeforeFault := wc baseVersion.
		aGen removeLastnameSlot.
		faultVersion := versionBeforeFault successors first].
	
	detectedVersion := sut detectFault: aTestMethod begin: begin end: wc baseVersion.
	self assert: faultVersion equals: detectedVersion.! !

!CvTestCase class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.118'!
canBeLateBound
	^ false! !

!CvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/24/2011 16:50:54.598'!
polySource
	^ World polySource! !

!CvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 4/6/2011 13:58:46.507'!
setUp
	super setUp.
	
	sut := CvController 
			notifier: SystemChangeNotifier uniqueInstance 
			polySource: self polySource.
	
	sut install.! !

!CvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2011 11:57:27.769'!
startTbVersioning
	
	^ sut startVersioning: self activeCodeBase duplicateClassesStartAt: self tbRootClassName! !

!CvTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/30/2011 12:10:24.461'!
tearDown
	sut uninstall.
	"this is quite important to enforce some garbage collection.
	 note that test results including testcases might be hold for some time"
	sut := nil.
	super tearDown! !

CvTestCase subclass: #CvVersioningTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvVersioningTestCase class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.164'!
canBeLateBound
	^ false! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/27/2011 15:39:01.921'!
test01MethodModification
	| wc firstVersion |
	wc := self startTbVersioning.
	firstVersion := sut initialVersion.
	self assert: sut initialVersion = wc baseVersion.
	
	self basedOn: wc do: [
		self tbClass compile: self tbMethod getSource ].
	
	self assert: [ self tbClass ]
		 isUnlikeForCodeBases: firstVersion and: wc.
		
	self assert: [ self tbClass >> self tbMethodName ]
		 isUnlikeForCodeBases: firstVersion and: wc.! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2011 13:17:25.596'!
test02SubclassRemoval
	| wc firstVersion classCategory |
	wc := self startTbVersioning.
	firstVersion := wc baseVersion.
	
	self basedOn: wc do: [
		self tbSubclass removeFromSystem].
	
	classCategory := self tbSubclass category.
	self basedOn: wc baseVersion
		 deny: [
			(SystemOrganization listAtCategoryNamed: classCategory)
				includes: self tbSubclassName].
			
	self assert: self tbSubclassName equals: (firstVersion classNamed: self tbSubclassName) name.
	self deny: [wc baseVersion dictionary hasClassNamed: self tbSubclassName].
	self assert: [firstVersion dictionary hasClassNamed: self tbSubclassName].
	self assert: [self tbClass]
		 isUnlikeForCodeBases: firstVersion and: wc.
	
	self basedOn: wc do: [self tbClass subclasses]. "ensure initialization of subclasses"
	self basedOn: wc 
		 assert: [(self tbClass instVarNamed: 'subclasses') size = 0]! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/22/2012 13:34:18.391'!
test02bClassRemoval
	| wc firstVersion category |
	wc := self startTbVersioning.
	firstVersion := wc baseVersion.
	
	self basedOn: wc do: [
		self tbTestClass compile: self tbMethod getSource.
		self tbSubclass removeFromSystem].
					
	self assert: [(firstVersion classNamed: self tbClassName) 
					subclasses anySatisfy: [:ea | ea name = self tbSubclassName]].
	
	category := self tbSubclassCategory.
	self basedOn: wc baseVersion deny: [
		(SystemOrganization listAtCategoryNamed: category) includes: self tbSubclassName].! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/31/2012 17:00:16.619'!
test02cRemovalOfSubclassAfterClass
	| wc |
	wc := self startTbVersioning.
	
	self basedOn: wc do: [
		self tbClass removeWithSubclassesFromSystem].
	
	"to class removed events should be generated, first the subclass, then the regular one"
	self assert: 3 equals: sut versionsChronologically size.! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/22/2012 13:40:05.092'!
test02dClassRemoval
	| wc category |
	wc := self startTbVersioning.
	
	self basedOn: wc do: [
		self tbSubclass removeFromSystem].
					
	category := self tbSubclassCategory.
	self basedOn: wc baseVersion deny: [
		(SystemOrganization listAtCategoryNamed: category) includes: self tbSubclassName].! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:53:18.991'!
test03AdoptionOfSubclasses
	| wc |
	wc := self startTbVersioning.
	
	self basedOn: wc
		 assert: [self tbClass subclasses size =  1].
	
	self basedOn: wc
		 assert: [self tbClass subclasses includes: self tbSubclass]
	! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/27/2011 16:06:31.272'!
test04MethodAddition
	| wc firstVersion |
	wc := self startTbVersioning.
	firstVersion := wc baseVersion.
	
	self basedOn: wc do: [
		self tbClass compile: 'foo ^ ''foo''' ].
	
	self basedOn: firstVersion
		 deny: [self tbClass includesSelector: #foo].
	
	self basedOn: wc
		 assert: [self tbClass includesSelector: #foo].
		
	self basedOn: wc baseVersion
		 assert: [self tbClass includesSelector: #foo].! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/3/2012 19:43:35.216'!
test04bMethodAdditionFoo
	| wc |
	wc := self startTbVersioning.
	
	self basedOn: wc do: [
		self tbClass compile: 'foo ^ ''foo'''.
		self assert: self tbClass equals: self tbSubclass superclass].
	! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/30/2011 10:04:05.929'!
test05ClassAddition
	| newClassName wc firstVersion classCategory |
	newClassName := #CvSpecialPerson.
	wc := self startTbVersioning.
	firstVersion := wc baseVersion.
	self basedOn: firstVersion
		 assert: [(self tbClass instVarNamed: 'subclasses') size = 1].
		
	self basedOn: wc do: [
		self createSubclassOfTbClassNamed: newClassName ].
	
	self assert: [:codeBase | codeBase classNamed: #CvSpecialPerson]
		 isUnlikeForCodeBases: wc and: wc baseVersion.
	
	classCategory := self tbClass category.
	self basedOn: wc baseVersion
		 assert: [
			(SystemOrganization listAtCategoryNamed: classCategory)
				includes: newClassName].
	
	self assert: [wc hasClassNamed: newClassName].
	self basedOn: wc
		 assert: [(self tbClass instVarNamed: 'subclasses') size = 2].
	
	self assert: [wc baseVersion hasClassNamed: newClassName].
	self basedOn: wc baseVersion
		 assert: [(self tbClass instVarNamed: 'subclasses') size = 2].
	
	self deny: [firstVersion hasClassNamed: newClassName].
	self basedOn: firstVersion
		 assert: [(self tbClass instVarNamed: 'subclasses') size = 1]! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:53:44.772'!
test06VersionChronology
	| wc1 wc2 |
	wc1 := self startTbVersioning.
	wc2 := sut checkout: wc1 baseVersion.
	
	self assert: 1 equals: sut versionsChronologically size.
	self assert: wc1 baseVersion equals: sut versionsChronologically first.
	
	self basedOn: wc1 do: [
		self tbClass removeSelector: self tbMethodName].
	
	self basedOn: wc2 do: [
		self tbTestClass removeSelector: #testFirstname].

	self assert: 3 equals: sut versionsChronologically size.	
	self assert: wc1 baseVersion equals: sut versionsChronologically second.
	self assert: wc2 baseVersion equals: sut versionsChronologically third.! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:53:54.746'!
test07DeepCopyOfWorkingData
	| wc wc2 |
	wc := self startTbVersioning.
	self basedOn: wc do: [
		self tbTestClass removeFromSystem ].
	
	wc2 := sut checkout: wc baseVersion.
	self basedOn: wc2 do: [
		self tbSubclass removeFromSystem ].
	
	self assert: (wc dictionary hasClassNamed: self tbSubclassName).
	self basedOn: wc baseVersion
		 assert: [self tbClass subclasses size = 1]! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:54:05.997'!
test08ShallowDictCopy
	| wc |
	sut packageUnchecked: self tbPackageInfo.
	wc := self startTbVersioning.
	
	self basedOn: wc do: [
		self tbClass removeSelector: self tbMethodName ].
	
	self assert: [self tbTestClass]
		 isSameForCodeBases: wc baseVersion and: wc baseVersion predecessor! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:54:23.716'!
test10SameClassAfterUndoAndRedo
	| wc aPerson |
	wc := self startTbVersioning.
	
	aPerson := self basedOn: wc do: [CvTbPerson new].
	self basedOn: wc do: [CvTbPerson removeSelector: #firstname].
	
	self basedOn: wc
		 assert: [CvTbPerson = aPerson class]! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/29/2011 16:44:22.037'!
test11SameClassAfterUndoAndRedo
	"this test expresses an idea which is still wishful thinking, unfortunately"
	| wc firstVersion aPerson |
	wc := self startTbVersioning.
	firstVersion := wc baseVersion.
	
	self assert: [CvTbPerson]
		 isUnlikeForCodeBases: wc and: self activeCodeBase.
	
	aPerson := self basedOn: wc do: [CvTbPerson new].
	self basedOn: wc do: [
		CvTbPerson removeSelector: #firstname.
		self deny: [CvTbPerson includesSelector: #firstname]].
	
	self basedOn: firstVersion do: [
		self assert: [CvTbPerson includesSelector: #firstname]].
	
	self basedOn: wc do: [
		wc moveOneStepBack.
		self assert: [CvTbPerson includesSelector: #firstname].
		self assert: [CvTbPerson = aPerson class].
		
		wc moveOneStepForward.
		self deny: [CvTbPerson includesSelector: #firstname].
		self assert: [CvTbPerson = aPerson class]]! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/30/2011 11:52:26.359'!
test12RebasingOfWorkingCopies
	| wc v1 v2 v3 v4 v5 newSubclass v6 |
	wc := self startTbVersioning.
	
	self basedOn: wc do: [
		v1 := wc baseVersion.
		CvTbPerson removeSelector: self tbMethodName.
		v2 := wc baseVersion.
		newSubclass := CvTbPerson subclass: #CvSpecialPerson
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: CvTbPerson category.
		v3 := wc baseVersion.
		CvTbEmployee removeFromSystem.
		v4 := wc baseVersion.
		newSubclass removeFromSystem.
		v5 := wc baseVersion.
		CvTbPerson removeFromSystem.
		v6 := wc baseVersion ].
	
	self deny: [wc hasClassNamed: #CvTbPerson].
	self deny: [wc hasClassNamed: #CvTbEmployee].
	self basedOn: v3
		 assert: [CvTbPerson subclasses size = 2].
	
	wc rebaseTo: v5.
	self assert: [wc dictionary hasClassNamed: #CvTbPerson].
	self deny: [wc dictionary hasClassNamed: #CvTbEmployee].
	
	self assert: [wc hasClassNamed: #CvTbTestCase].
	self basedOn: wc 
		 assert: [CvTbObject subclasses includes: CvTbTestCase].

	wc rebaseTo: v4.
	self basedOn: wc do:[
		self assert: 1 equals: CvTbPerson subclasses size.
		self assert: #CvSpecialPerson equals: CvTbPerson subclasses first name].
	
	wc rebaseTo: v3.
	self assert: [wc hasClassNamed: #CvTbEmployee].
	
	self basedOn: wc do:[
		self assert: 2 equals: CvTbPerson subclasses size].
	
	wc rebaseTo: v2.
	self deny: [wc dictionary hasClassNamed: #CvSpecialPerson].
	
	wc rebaseTo: v1.
	self basedOn: wc
	 	 assert: [CvTbPerson includesSelector: self tbMethodName].
	
	wc rebaseTo: v2.
	self basedOn: wc
	 	 deny: [CvTbPerson includesSelector: self tbMethodName].
	
	wc rebaseTo: v3.
	self assert: [wc dictionary hasClassNamed: #CvSpecialPerson].
	
	wc rebaseTo: v4.
	self deny: [wc dictionary hasClassNamed: #CvTbEmployee].
	
	wc rebaseTo: v6.
	self deny: [wc dictionary hasClassNamed: #CvTbPerson].! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/30/2011 11:56:26.172'!
test12aRebasingOfWorkingCopies
	| wc |
	wc := self startTbVersioning.
	
	self basedOn: wc do: [
		CvTbEmployee removeFromSystem.
		CvTbPerson removeFromSystem].
	
	wc rebaseTo: wc baseVersion predecessor.
	self assert: [wc hasClassNamed: #CvTbPerson].
	self deny: [wc hasClassNamed: #CvTbEmployee].! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/30/2011 12:00:26.708'!
test14GoingBackAndForward
	| wc1 firstVersion wc2 wc1ThirdVersion wc2SecondVersion |
	wc1 := self startTbVersioning.
	firstVersion := wc1 baseVersion.
	wc2 := sut checkout: firstVersion.
	
	self basedOn: wc1 do: [
		CvTbPerson removeSelector: #firstname.
		CvTbEmployee removeFromSystem].
	
	self basedOn: wc2 do: [
		CvTbPerson removeSelector: #firstname.
		CvTbEmployee removeFromSystem].
	
	wc1ThirdVersion := wc1 baseVersion.
	wc2SecondVersion := wc2 baseVersion predecessor.
	
	wc1 moveOneStepBack.
	wc1 moveOneStepBack.
	self assert: firstVersion equals: wc1 baseVersion.
	wc1 moveOneStepBack.
	self assert: firstVersion equals: wc1 baseVersion.
	
	wc1 moveOneStepForward.
	wc1 moveOneStepForward.
	self assert: wc1ThirdVersion equals: wc1 baseVersion.
	
	wc1 moveOneStepForward.
	self assert: wc1ThirdVersion equals: wc1 baseVersion.
	
	wc1 moveOneStepBack.
	wc1 moveOneStepBack.
	wc1 rebaseTo: wc2SecondVersion.
	self assert: wc2SecondVersion equals: wc1 baseVersion.
	wc1 moveOneStepForward.
	self assert: wc2SecondVersion equals: wc1 baseVersion.! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/30/2011 12:00:33.951'!
test15ClassModification
	| newInstVarName wc firstVersion |
	newInstVarName := 'foobar'.
	wc := self startTbVersioning.
	firstVersion := wc baseVersion.
		
	self basedOn: wc do: [
		self tbSubclass addInstVarName: newInstVarName].
	
	self basedOn: wc
		assert: [(self tbSubclass instVarNames includes: newInstVarName)].
	
	self basedOn: wc baseVersion
		 assert: [(self tbSubclass instVarNames includes: newInstVarName)].
		
	self basedOn: firstVersion
		 deny: [(self tbSubclass instVarNames includes: newInstVarName)].
		
	self basedOn: wc baseVersion
		 assert: [self tbClass == self tbSubclass superclass]! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/30/2011 12:00:39.421'!
test16SubclassingNotLateBoundClass
	| newClassName wc |
	newClassName := #CvSpeciaEvent.
	wc := self startTbVersioning.
	[
	self basedOn: wc do: [
		AbstractEvent subclass: newClassName
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: self tbClass category ].
	
	self assert: [wc hasClassNamed: newClassName].
	self assert: [wc baseVersion hasClassNamed: newClassName].
	] ensure: [
		(wc hasClassNamed: newClassName) 
			ifTrue: [(wc classNamed: newClassName) removeFromSystem]
	]
	! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/30/2011 12:00:45.396'!
test17AddingMethodToMetaClass
	| wc firstVersion |
	wc := self startTbVersioning.
	firstVersion := wc baseVersion.
	
	self basedOn: wc do: [
		self tbClass class compile: 'foo ^ ''foo''' ].
	
	self basedOn: firstVersion
		 deny: [self tbClass class includesSelector: #foo].
	
	self basedOn: wc
		 assert: [self tbClass class includesSelector: #foo].
		
	self basedOn: wc baseVersion
		 assert: [self tbClass class includesSelector: #foo]! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/12/2011 15:36:58.454'!
test18Refactoring
	| wc firstRenamingChange |
	wc := self startTbVersioning.
	
	self basedOn: wc do: [
		CvTbGenerator new 
			createLastnameSlot;
			renameInstVarLastnameToFoo].
	
	firstRenamingChange := wc baseVersion predecessor predecessor predecessor.
	self assert: wc baseVersion isEndOfRefactoring.
	self assert: firstRenamingChange isBeginOfRefactoring.
	self assert: firstRenamingChange refactoringName
		 equals: 'a RenameInstanceVariableRefactoring'! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/3/2012 17:58:09.739'!
test19aRenameClass
	| wc firstVersion |
	wc := self startTbVersioning.
	firstVersion := wc baseVersion.
	
	self basedOn: wc do: [
		self tbClass rename: 'CvTbFooClass'].
	
	self assert: [firstVersion hasClassNamed: self tbClassName].
	self assert: [wc baseVersion hasClassNamed: 'CvTbFooClass'].
	self deny: [firstVersion hasClassNamed: 'CvTbFooClass'].
	self deny: [wc baseVersion hasClassNamed: self tbClassName].! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/3/2012 17:58:16.061'!
test19bRenameSubclass
	| wc firstVersion |
	wc := self startTbVersioning.
	firstVersion := wc baseVersion.
	
	self basedOn: wc do: [
		self tbSubclass rename: 'CvTbFooSubclass'].
	
	self assert: [firstVersion hasClassNamed: self tbSubclassName].
	self assert: [wc baseVersion hasClassNamed: 'CvTbFooSubclass'].
	self deny: [firstVersion hasClassNamed: 'CvTbFooSubclass'].
	self deny: [wc baseVersion hasClassNamed: self tbSubclassName].! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/3/2012 18:10:05.871'!
test19cRenameClassCheckMethods
	| wc firstVersion |
	wc := self startTbVersioning.
	firstVersion := wc baseVersion.
	
	self basedOn: wc do: [
		self tbClass rename: 'CvTbFooClass'].
	
	self basedOn: firstVersion do: [
		self 
			assert: self tbClassName 
			equals: self tbClass methodDict values first methodClass name.]! !

!CvVersioningTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/23/2012 11:44:32.245'!
test20SameSuperclassWhenRevertingClassRemoval
	| wc tbClass |
	wc := self startTbVersioning.
	
	self basedOn: wc do: [
		tbClass := self tbClass].
	
	self basedOn: wc do: [
		self tbSubclass removeFromSystem].
	
	wc moveOneStepBack.
	
	self basedOn: wc assert: [
		tbClass == self tbClass]! !

CvUsingTbTestCase subclass: #CvTreeStructureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

!CvTreeStructureTest methodsFor: 'as yet unclassified' stamp: 'bs 7/31/2011 18:17:51.371'!
addMethodToTbClass

	^ CvVersion new
		systemEvent: self tbMethodAddedEvent;
		yourself! !

!CvTreeStructureTest methodsFor: 'as yet unclassified' stamp: 'bs 7/31/2011 18:17:47.543'!
createInitialVersion

	^ CvVersion new
		systemEvent: (ModifiedClassDefinitionEvent class: Object);
		yourself! !

!CvTreeStructureTest methodsFor: 'as yet unclassified' stamp: 'bs 8/16/2011 19:22:52.159'!
createModel

	^ CvBrowserTreeModel new! !

!CvTreeStructureTest methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 18:12:08.437'!
modifyProtoObject

	^ CvVersion new
		systemEvent: (self classModifiedEvent: ProtoObject)
		yourself ! !

!CvTreeStructureTest methodsFor: 'as yet unclassified' stamp: 'bs 7/31/2011 18:17:41.913'!
modifyTbClass

	^ CvVersion new
		systemEvent: self tbClassModifiedEvent
		yourself ! !

!CvTreeStructureTest methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 19:13:09.206'!
test01
	| aGroup initialVersion version2 version3 |
	aGroup := CvVersionGroup root.
	initialVersion := self modifyProtoObject.
	aGroup insert: initialVersion.
	self assert: aGroup children includes: initialVersion.
	
	version2 := self modifyTbClass.
	aGroup insert: version2.
	self assert: aGroup children includes: initialVersion.
	self assert: aGroup children includes: version2.
	
	version3 := self addMethodToTbClass.
	aGroup insert: version3.
	self assert: aGroup children includes: initialVersion.
	self deny: aGroup children includes: version2.
	self deny: aGroup children includes: version3.
	
	self assert: (aGroup lastChild isKindOf: CvVersionGroup).
	self assert: aGroup lastChild children includes: version2.
	self assert: aGroup lastChild children includes: version3.! !

!CvTreeStructureTest methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 19:16:51.336'!
test02
	| aGroup initialVersion version2 version3 version4 |
	aGroup := CvVersionGroup root.
	initialVersion := self modifyProtoObject.
	aGroup insert: initialVersion.
	
	version2 := self modifyTbClass.
	aGroup insert: version2.
	version3 := self modifyTbClass.
	aGroup insert: version3.
	self assert: aGroup lastChild children includes: version2.
	self assert: aGroup lastChild children includes: version3.
	
	version4 := self addMethodToTbClass.
	aGroup insert: version4.

	self deny: aGroup children includes: version4.
	self deny: aGroup lastChild children includes: version4.
	! !

!CvTreeStructureTest methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2011 19:18:57.208'!
test03
	| aGroup initialVersion version2 version3 version4 |
	aGroup := CvVersionGroup root.
	initialVersion := self modifyProtoObject.
	aGroup insert: initialVersion.
	
	version2 := self addMethodToTbClass.
	self halt.
	aGroup insert: version2.
	self deny: aGroup lastChild isVersionGroup.
	version3 := self addMethodToTbClass.
	aGroup insert: version3.
	self assert: aGroup lastChild isVersionGroup.
	self assert: aGroup lastChild children includes: version2.
	self assert: aGroup lastChild children includes: version3.
	
	version4 := self modifyTbClass.
	aGroup insert: version4.

	self deny: aGroup children includes: version4.
	self deny: aGroup lastChild children includes: version4.
	! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 13:41:05.612'!
activeDict
	^ self activeCodeBase dictionary! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/20/2011 20:13:46.38'!
assert: aBlock basedOn: aCodeBase
	self assert: (aBlock valueBasedOn: aCodeBase)! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/20/2011 20:09:35.662'!
assert: anObject differsFrom: anotherObject
	^ self
		assert: (anObject ~= anotherObject)
		description: 'unexpected equality of values'
! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 10:45:38.875'!
assert: aBlock equalsFor: aBlockArg and: anotherBlockArg.
	self assert: (aBlock value: aBlockArg) == (aBlock value: anotherBlockArg)! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 21:35:41.87'!
assert: aBlock equalsForCodeBases: aCodeBase and: anotherCodeBase.
	self assert: 
		([aBlock cull: aCodeBase] valueBasedOn: aCodeBase) =
		([aBlock cull: anotherCodeBase] valueBasedOn: anotherCodeBase)! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 21:35:37.856'!
assert: aBlock isSameForCodeBases: aCodeBase and: anotherCodeBase.
	self assert: 
		([aBlock cull: aCodeBase] valueBasedOn: aCodeBase) ==
		([aBlock cull: anotherCodeBase] valueBasedOn: anotherCodeBase)! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 18:10:27.067'!
assert: aBlock isUnlikeFor: aBlockArg and: anotherBlockArg.
	self assert: (aBlock value: aBlockArg) ~~ (aBlock value: anotherBlockArg)! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 21:27:03.174'!
assert: aBlock isUnlikeForCodeBases: aCodeBase and: anotherCodeBase.
	self assert: 
		([aBlock cull: aCodeBase] valueBasedOn: aCodeBase) ~~
		([aBlock cull: anotherCodeBase] valueBasedOn: anotherCodeBase)! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 09:27:13.245'!
basedOn: aCodeBase assert: aBlock
	self assert: (aBlock valueBasedOn: aCodeBase)! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 09:27:20.418'!
basedOn: aCodeBase deny: aBlock
	self deny: (aBlock valueBasedOn: aCodeBase)! !

!CvUsingTbTestCase methodsFor: 'simulating system events' stamp: 'bs 8/1/2011 15:32:53.376'!
classModifiedEvent: aClass
	
	^ (ModifiedClassDefinitionEvent class: aClass)
		saveCodeReference;
		yourself
		! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/26/2011 11:58:48.128'!
createSubclassOfTbClass

	^ self createSubclassOfTbClassNamed: #CvTbSpecialPerson.! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/26/2011 11:58:10.672'!
createSubclassOfTbClassNamed: aName

	^ self tbClass subclass: aName asSymbol
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: self tbClass category! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 18:25:34.943'!
deny: aBlock basedOn: aCodeBase
	self deny: (aBlock valueBasedOn: aCodeBase)! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 15:28:42.919'!
deny: expected equals: actual
	^ self
		assert: (expected ~= actual)
		description: 'unexpected equality of values'
! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 18:25:46.087'!
deny: aBlock forAll: blockArgs
	blockArgs do: [:ea | self deny: [aBlock value: ea]]! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 14:26:47.951'!
polySource
	^ World polySource! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 09:57:33.989'!
psCodeBases
	^ self polySource codeBases! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/26/2011 12:02:45.509'!
removeClassNamed: aSymbol
	
	(self activeDict at: aSymbol) removeFromSystem! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/7/2011 18:16:30.817'!
removeClassNamed: aSymbol on: aCodeBase
	self basedOn: aCodeBase do: [
		(self activeDict at: aSymbol) removeFromSystem ]! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/16/2011 16:00:21.4'!
removeMethod: aMethod on: aCodeBase
	^ self basedOn: aCodeBase do: [
		aMethod methodClass removeSelector: aMethod selector ]! !

!CvUsingTbTestCase methodsFor: 'running' stamp: ''!
setUp
	super setUp.
	self assert: [World psIsInstalled].
	"self deny: [World cvIsInstalled]."
	codeBasesBeforeTestRun := self psCodeBases.! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 14:03:09.193'!
tbClass
	^ self activeDict at: self tbClassName! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 16:53:09.847'!
tbClassCategory
	^ self tbClass category! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 14:03:12.443'!
tbClassMethod
	^ self tbClass class >> self tbClassMethodName! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 14:03:16.869'!
tbClassMethodName
	^ #new! !

!CvUsingTbTestCase methodsFor: 'simulating system events' stamp: 'bs 8/1/2011 15:33:15.6'!
tbClassModifiedEvent
	
	^ self classModifiedEvent: self tbClass
		! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 14:03:20.285'!
tbClassName
	^ #CvTbPerson ! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 15:38:51.897'!
tbMethod
	^ self tbClass >> self tbMethodName! !

!CvUsingTbTestCase methodsFor: 'simulating system events' stamp: 'bs 7/31/2011 18:17:11.554'!
tbMethodAddedEvent
	^ (AddedEvent
		method: self tbMethod
		selector: self tbMethodName
		protocol: self tbMethodProtocol
		class: self tbClass
		requestor: nil)
			saveCodeReference;
			yourself
		! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/27/2011 18:42:15.741'!
tbMethodCategory
	^ self tbClass organization categoryOfElement: self tbMethodName! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/25/2011 15:38:44.335'!
tbMethodName
	^ #firstname! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 10:50:58.355'!
tbMethodProtocol
	^ self tbClass organization categoryOfElement: self tbMethodName! !

!CvUsingTbTestCase methodsFor: 'simulating system events' stamp: 'bs 7/31/2011 18:17:17.492'!
tbMethodRemovedEvent
	^ (RemovedEvent
		method: self tbMethod
		selector: self tbMethodName
		protocol: self tbMethodProtocol
		class: self tbClass)
			saveCodeReference;
			yourself
		! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 16:54:57.639'!
tbObjectClass
	^ self activeDict at: self tbObjectClassName! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/13/2011 16:54:44.602'!
tbObjectClassName
	^ #CvTbObject! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2011 10:54:36.959'!
tbPackageInfo
	^ PackageOrganizer default packageOfClass: self tbClass! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2011 10:56:48.844'!
tbPackageName
	^ self tbPackageInfo name! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 5/22/2011 11:26:15.69'!
tbRootClassName
	
	^ CvTbObject name! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 16:15:38.804'!
tbSubclass
	^ self activeDict at: self tbSubclassName! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/27/2011 18:53:20.592'!
tbSubclassCategory
	^ self tbSubclass category! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 2/28/2011 16:15:25.728'!
tbSubclassName
	^ #CvTbEmployee! !

!CvUsingTbTestCase methodsFor: 'simulating system events' stamp: 'bs 7/31/2011 18:17:26.73'!
tbSubclassRemovedEvent
	^ (RemovedEvent 
		class: self tbSubclass
		category: self tbClassCategory)
			backup: self tbSubclass copy;
			saveCodeReference;
			yourself! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 09:38:42.364'!
tbTestClass
	^ self activeDict at: self tbTestClassName! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 09:38:31.429'!
tbTestClassName
	^ #CvTbPersonTest! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 10:42:21.497'!
tbTestMethod
	^ self tbClass >> self tbTestMethodName! !

!CvUsingTbTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/17/2011 10:42:08.207'!
tbTestMethodName
	^ #testFirstname! !

!CvUsingTbTestCase methodsFor: 'running' stamp: 'bs 3/16/2011 14:37:49.126'!
tearDown
	(self psCodeBases copyWithoutAll: codeBasesBeforeTestRun) 
		do: [:ea | self polySource removeCodeBase: ea].
	
	super tearDown! !

TestCase subclass: #CvVersionBarTest
	instanceVariableNames: 'versions versionBar controller'
	classVariableNames: 'Mock'
	poolDictionaries: ''
	category: 'CV-UI-Tests'!

!CvVersionBarTest class methodsFor: 'as yet unclassified' stamp: 'TM 6/21/2011 13:06:59.977'!
controller

	^ self useMock
		ifTrue: [ CvMockController new ]
		ifFalse: [ World cvController ]! !

!CvVersionBarTest class methodsFor: 'as yet unclassified' stamp: 'TM 6/24/2011 14:06:52.115'!
setMock: aBoolean

	Mock := aBoolean! !

!CvVersionBarTest class methodsFor: 'as yet unclassified' stamp: 'TM 6/24/2011 13:23:50.113'!
useMock

	^ Mock ifNil: [ Mock := true. ^Mock]! !

!CvVersionBarTest methodsFor: 'accessing' stamp: 'TM 5/19/2011 11:59:59.473'!
controller

	^ controller! !

!CvVersionBarTest methodsFor: 'accessing' stamp: 'TM 5/19/2011 11:59:45.799'!
controller: aMockController

	controller := aMockController! !

!CvVersionBarTest methodsFor: 'mocking' stamp: 'TM 6/24/2011 13:45:27.299'!
create: aNumber versionsFor: aWorkingCopy

	self class useMock
		ifTrue: [ 
			self controller activeWorkingCopy: aWorkingCopy.
			aNumber timesRepeat: [ self controller handleEvent: self simulateSystemEvent ]
			]
		ifFalse: [
			[aNumber timesRepeat: [ self controller handleEvent: self simulateSystemEvent ]] valueBasedOn: aWorkingCopy]

	! !

!CvVersionBarTest methodsFor: 'mocking' stamp: 'bs 8/1/2012 13:31:47.271'!
createTestGraph
|workingCopy1 workingCopy2|

	"Testgraph:	 
		                              /-------------------------------------> 11 -> 12 -> 13 -> 14 -> 15 
		1 -> 2 -> 3 -> 4 -> 5 -> 6->7 -> 8 -> 9 -> 10

	"

	workingCopy1 := self controller workingCopies first.
	self create: 10 versionsFor: workingCopy1.
	
	workingCopy2 := self createWorkingCopyAt: (self controller versionAt: 5).
	self create: 5 versionsFor: workingCopy2.
	
	"self controller versionsChronologically"! !

!CvVersionBarTest methodsFor: 'mocking' stamp: 'TM 6/24/2011 13:49:46.991'!
createWorkingCopyAt: aVersion
|workingCopy|
	
	self class useMock
		ifTrue: [ workingCopy := CvMockWorkingCopy new baseVersion:  aVersion.
				self controller addWorkingCopy: workingCopy ]
		ifFalse: [ workingCopy := aVersion checkout ].

	^workingCopy! !

!CvVersionBarTest methodsFor: 'accessing' stamp: 'TM 5/20/2011 11:38:19.86'!
highestLaneNumber

	^ self versionBar view rootBranch highestLaneNumber! !

!CvVersionBarTest methodsFor: 'accessing' stamp: 'TM 5/20/2011 10:50:20.455'!
items

	^ self versionBar view submorphs! !

!CvVersionBarTest methodsFor: 'accessing' stamp: 'TM 5/20/2011 11:42:59.364'!
rootBranch

	^ self versionBar view rootBranch! !

!CvVersionBarTest methodsFor: 'testing' stamp: 'bs 1/5/2012 15:05:55.155'!
setUp
	super setUp.
	
	self class useMock ifFalse: [ World cvInstallWithPkg: (PackageOrganizer default packageNamed: 'CV-TestBed' ifAbsent: []) ].

	self controller: ( self class controller).
	
	self createTestGraph.
	
	self versionBar: (CvVersionBar controller: self controller).! !

!CvVersionBarTest methodsFor: 'mocking' stamp: 'TM 6/24/2011 11:03:15.209'!
simulateSystemEvent

	^ (ModifiedEvent
			methodChangedFrom: CvTbPerson >> #firstname
			to: CvTbPerson >> #firstname
			selector: #firstName
			inClass: CvTbPerson)! !

!CvVersionBarTest methodsFor: 'testing' stamp: 'bs 2/3/2012 16:54:28.658'!
tearDown

	super tearDown.
	
	self class useMock ifFalse: [ World cvUninstall ].! !

!CvVersionBarTest methodsFor: 'testing' stamp: 'TM 6/24/2011 11:36:02.557'!
testAddingNewVersions
|size itemSize|
	<timeout: 60>
	"checking a new Version is added"

	size := self versions size.
	itemSize := self items size.
	
	self create: 1 versionsFor: (self workingCopyAt: 1).
	
	self assert: size + 1 = self versions size.
	self assert: itemSize + 1 = self items size.
	
	self create: 4 versionsFor: (self workingCopyAt: 1).	

	self assert: size + 5 = self versions size.
	self assert: itemSize + 5 = self items size.! !

!CvVersionBarTest methodsFor: 'testing' stamp: 'TM 6/24/2011 10:38:25.082'!
testChronologicalOrder
|item|
	<timeout: 60>
	item := self items last.
	
	self create: 5 versionsFor: (self workingCopyAt: 1).
	
	self assert: item position x < self items last position x.! !

!CvVersionBarTest methodsFor: 'testing' stamp: 'TM 6/24/2011 11:36:12.933'!
testForkBranch
|workingCopy|
	<timeout: 60>
	self assert: self highestLaneNumber = 2.
	
	workingCopy := self createWorkingCopyAt: (self versions at: 7).
	
	self assert: self highestLaneNumber = 2.
	
	self create: 5 versionsFor: workingCopy.
	
	self assert: self highestLaneNumber = 3.
	
	workingCopy := self createWorkingCopyAt: (self versions at: 12).
	
	self assert: self highestLaneNumber = 3.
	
	self create: 5 versionsFor: workingCopy.
	
	self assert: self highestLaneNumber = 4.! !

!CvVersionBarTest methodsFor: 'testing' stamp: 'TM 6/24/2011 11:36:18.664'!
testHideBranch
	<timeout: 60>
	self assert: self highestLaneNumber = 2.
	
	self rootBranch subbranches first hide.
	
	self assert: self highestLaneNumber = 1.
	
	self rootBranch subbranches second hide.
	
	self assert: self highestLaneNumber = 1.
	
	self rootBranch subbranches second show.
	self rootBranch subbranches first show.
		
	self assert: self highestLaneNumber = 2.! !

!CvVersionBarTest methodsFor: 'testing' stamp: 'TM 6/24/2011 11:36:25.709'!
testHideBranchNotVisible
	|branch|
	<timeout: 60>
	branch := self rootBranch subbranches first.
	branch hide.
		
	branch items do: [ :item | self deny: ( self versionBar view submorphs includes: item) ].
! !

!CvVersionBarTest methodsFor: 'testing' stamp: 'TM 6/24/2011 11:36:31.512'!
testHideShowBranch
	<timeout: 60>
	self assert: self highestLaneNumber = 2.
	
	self rootBranch subbranches first hide.
	
	self assert: self highestLaneNumber = 1.
	
	self rootBranch subbranches second hide.
	
	self assert: self highestLaneNumber = 1.
	
	self rootBranch subbranches second show.
	self rootBranch subbranches first show.
		
	self assert: self highestLaneNumber = 2.! !

!CvVersionBarTest methodsFor: 'testing' stamp: 'TM 6/24/2011 11:36:47.143'!
testStableItemSize
|size|
	<timeout: 60>
	self create: 5 versionsFor: (self createWorkingCopyAt: (self versions at: 7)).
	self create: 5 versionsFor: (self createWorkingCopyAt: (self versions at: 12)).
	
	1 to: 4 do: [ :n | self mock: 5 versionsFor: (self workingCopyAt: n)].

	size := self items size.

	self rootBranch subbranches do: [:branch | 
		branch subbranches do: [:subbranch | subbranch hide].
		branch subbranches reverse do: [:subbranch | subbranch show].
		branch hide. branch show.
		branch subbranches do: [:subbranch | subbranch show]].
	
	self assert: size = self items size
	
	! !

!CvVersionBarTest methodsFor: 'testing' stamp: 'TM 6/24/2011 11:36:56.13'!
testVisualisationAfterInitialization
|versionItems|
	<timeout: 60>	
	"checking all elements are displayed"
	
	versionItems := self items select: [ :item | item isKindOf: CvChronoVersionItem ].
	self assert: self versions size = versionItems size.

	"checking chronological order of elements"

	(1 to: self versions size) do: [ :n | 
		self assert: (self versions at: n) == (versionItems at: n) version ].! !

!CvVersionBarTest methodsFor: 'accessing' stamp: 'TM 5/19/2011 11:09:34.775'!
versionBar

	^ versionBar! !

!CvVersionBarTest methodsFor: 'accessing' stamp: 'TM 5/19/2011 18:17:44.887'!
versionBar: aVersionBar

	versionBar := aVersionBar! !

!CvVersionBarTest methodsFor: 'accessing' stamp: 'TM 5/20/2011 10:45:55.072'!
versions

	^ self controller versionsChronologically! !

!CvVersionBarTest methodsFor: 'accessing' stamp: 'TM 5/19/2011 18:25:54.129'!
versions: anOrderedCollection

	versions := anOrderedCollection! !

!CvVersionBarTest methodsFor: 'accessing' stamp: 'bs 8/1/2012 13:31:47.276'!
workingCopyAt: aNumber

	^ self controller workingCopies at: aNumber! !

CvVersionBarTest subclass: #CvVersionBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Tests'!

!CvVersionBrowserTest methodsFor: 'as yet unclassified' stamp: 'bs 8/16/2011 19:22:44.908'!
test01
	| model |
	model := CvBrowserTreeModel new.
	model controller: self controller.
	(UiTreeView new)
		model: model;
		topLeft: 50 @ 50;
		extent: 600 @ 300;
		openInWorld! !

!CvVersionBrowserTest methodsFor: 'as yet unclassified' stamp: 'bs 8/1/2012 13:31:47.29'!
test02
	| aVersion |
	aVersion := self controller workingCopies first baseVersion.
	aVersion predecessorPatch.! !

!TestCase methodsFor: '*CV-override' stamp: 'bs 5/11/2011 14:53:42.788'!
run: aResult 
	| originalRunCode | 
	originalRunCode := [aResult runCase: self].
	self activeCodeBase 
		ifNil: [originalRunCode value]
		ifNotNil: [:codeBase | 
			originalRunCode valueBasedOn: codeBase testCodeBase]
! !

!PackageList class methodsFor: '*CV' stamp: 'bs 4/15/2011 23:07:29.118'!
canBeLateBound
	^ false! !

MCPackage subclass: #CvPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

CvPackage class
	instanceVariableNames: 'repository'!

CvPackage class
	instanceVariableNames: 'repository'!

!CvPackage class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.073'!
canBeLateBound
	^ false! !

!CvPackage class methodsFor: 'as yet unclassified' stamp: 'bs 4/13/2011 23:12:13.941'!
named: aString
	^ self new name: aString! !

!CvPackage class methodsFor: 'testing' stamp: 'pt 1/16/2013 17:22:06.694'!
repository
	|repos index|
	
	repository ifNotNil: [ ^repository].
	
	repos := (MCPackage named: World cvController package name) workingCopy repositoryGroup repositories.
	(repos size = 0 or: [
		index := UIManager default chooseFrom: repos title: 'Choose a repository!!.'.
		index = 0]) ifTrue: [
			self inform: 'Cannot commit without a specified repository!!'. ^nil.].

	repository := repos at: index.
	^ repository! !

!CvPackage methodsFor: 'as yet unclassified' stamp: 'pt 1/16/2013 17:18:44.664'!
repository

	^ self class repository! !

!CvPackage methodsFor: 'as yet unclassified' stamp: 'bs 4/14/2011 12:55:09.061'!
snapshot
	| packageInfo definitions categories |
	packageInfo := self packageInfo.
	definitions := OrderedCollection new.
	categories := packageInfo systemCategories.
	categories isEmpty ifFalse: [ definitions add: (MCOrganizationDefinition categories: categories) ].
	packageInfo methods do: [:ea | definitions add: ea asMethodDefinition].
	(packageInfo respondsTo: #overriddenMethods) ifTrue:
		[packageInfo overriddenMethods
			do: [:ea | definitions add:
					(packageInfo changeRecordForOverriddenMethod: ea) asMethodDefinition]].
	packageInfo classes do: [:ea | definitions addAll: ea classDefinitions].
	(packageInfo respondsTo: #hasPreamble) ifTrue: [
		packageInfo hasPreamble ifTrue: [definitions add: (MCPreambleDefinition from: packageInfo)].
		packageInfo hasPostscript ifTrue: [definitions add: (MCPostscriptDefinition from: packageInfo)].
		packageInfo hasPreambleOfRemoval ifTrue: [definitions add: (MCRemovalPreambleDefinition from: packageInfo)].
		packageInfo hasPostscriptOfRemoval ifTrue: [definitions add: (MCRemovalPostscriptDefinition from: packageInfo)]]. 
	^ CvSnapshot fromDefinitions: definitions
! !

!CvPackage methodsFor: 'as yet unclassified' stamp: 'bs 4/14/2011 12:54:24.723'!
storeOn: aStream
	aStream
		nextPutAll: 'CvPackage';
		space; nextPutAll: 'named: '; store: name.! !

!OBEnvironmentNode methodsFor: '*CV' stamp: 'bs 9/6/2012 09:42:44.946'!
isDescendantOfClassCat: other
	
	^ false! !

!OBColumn methodsFor: '*CV-override' stamp: 'bs 8/14/2012 11:17:51.081'!
signalSelectionChanged
	| event |
	event := OBSelectionChanged column: self.
	self announcer announce: event.
	
	World cvIsInstalled ifFalse: [^ self].
	
	"when hovering a new browser window is opened for a preview"
	World  activeCodeBase isCvWorkingCopy ifFalse: [^ self].
	
	self activeWorkingCopy newSelection: (event node ifNotNil: [:ea | ea cvItemReference])! !

MCVersionInfo subclass: #CvVersionInfo
	instanceVariableNames: 'version mcVersionInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvVersionInfo class methodsFor: 'as yet unclassified' stamp: 'bs 7/25/2011 18:20:17.13'!
canBeLateBound

	^ true! !

!CvVersionInfo methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2011 16:46:19.032'!
ancestors: anArrayOfMcVersionInfo
	ancestors := anArrayOfMcVersionInfo
	! !

!CvVersionInfo methodsFor: 'as yet unclassified' stamp: 'sp 1/25/2013 10:32:43.157'!
author: aString
	author:= aString! !

!CvVersionInfo methodsFor: 'as yet unclassified' stamp: 'sp 1/25/2013 10:32:59.732'!
date: aDate
	date:= aDate! !

!CvVersionInfo methodsFor: 'as yet unclassified' stamp: 'bs 7/25/2011 18:20:37.44'!
dateAndTimeString

	^ self date yyyymmdd, ' ', self time print24! !

!CvVersionInfo methodsFor: 'ancestry' stamp: 'bs 4/27/2012 15:37:53.683'!
entriesOnPathTo: aVersionInfo
	| commonAncestor path pathRev current |
	commonAncestor := self commonAncestorWith: aVersionInfo.
	commonAncestor ifNil: [^ Array new].
	
	path := OrderedCollection new.
	pathRev := OrderedCollection new.
	current := self.
	[current = commonAncestor] 
		whileFalse: [
			path add: current.
			current := current ancestors first].
		
	current := aVersionInfo.
	[current = commonAncestor] 
		whileFalse: [
			pathRev add: current.
			current := current ancestors first].
	
	path addAll: pathRev reversed.
	^ path! !

!CvVersionInfo methodsFor: 'accessing' stamp: 'lk 1/2/2013 15:46:42.693'!
mcVersionInfo
	"return the associated version info in the Monticello version graph"
	^ mcVersionInfo! !

!CvVersionInfo methodsFor: 'accessing' stamp: 'lk 1/2/2013 15:47:07.352'!
mcVersionInfo: aMCVersionInfo
	mcVersionInfo := aMCVersionInfo.! !

!CvVersionInfo methodsFor: 'as yet unclassified' stamp: 'bs 3/4/2011 16:44:21.651'!
name: aName
	name := aName! !

!CvVersionInfo methodsFor: 'as yet unclassified' stamp: 'sp 1/25/2013 10:32:26.429'!
time: aTime
	time := aTime! !

!CvVersionInfo methodsFor: 'accessing' stamp: 'bs 3/4/2011 17:27:58.585'!
version
	^ version! !

!CvVersionInfo methodsFor: 'accessing' stamp: 'bs 3/4/2011 17:27:58.591'!
version: anObject
	version := anObject! !

!SystemDictionary methodsFor: '*CV' stamp: 'bs 8/3/2011 11:30:14.265'!
insertOrReplaceClass: aClass

	"approx. 1/3 of standard classes is stored using ReadOnlyVariableBinding, 
	which forbid to change value. Thus, we remove the old binding and create a new one."
	self removeKey: aClass name ifAbsent: []. "a new class might have been created"
	self at: aClass name put: aClass.! !

!PackageServices class methodsFor: '*CV' stamp: 'bs 4/15/2011 23:07:40.429'!
canBeLateBound
	^ false! !

MCThreeWayMerger subclass: #CvThreeWayMerger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvThreeWayMerger class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.126'!
canBeLateBound
	^ false! !

!CvThreeWayMerger methodsFor: 'loading' stamp: 'bs 5/13/2011 21:30:10.109'!
createLoader
	| loader |
	loader := CvPackageLoader new.
	loader provisions addAll: self provisions.
	self applyTo: loader.
	^ loader! !

!CvThreeWayMerger methodsFor: 'loading' stamp: 'bs 5/13/2011 21:30:14.668'!
load
	self createLoader load
! !

!CvThreeWayMerger methodsFor: 'loading' stamp: 'bs 5/13/2011 21:30:20.236'!
loadWithNameLike: baseName
	self createLoader loadWithNameLike: baseName
! !

!OBCodeNode methodsFor: '*CV' stamp: 'bs 5/9/2011 18:56:57.604'!
valueAt: aCodeBase

	^ self! !

!OBDefinition methodsFor: '*CV' stamp: 'bs 2/27/2012 21:47:55.285'!
isMethodDefinition

	^ false! !

!ClassChangeRecord class methodsFor: '*CV' stamp: 'bs 4/15/2011 23:08:08.529'!
canBeLateBound
	^ false! !

!ModifiedEvent methodsFor: '*CV' stamp: 'bs 8/25/2011 15:58:47.989'!
changedMetaObject

	^ self item ! !

!ModifiedEvent methodsFor: '*CV' stamp: 'bs 4/27/2012 14:58:03.734'!
checkoutChangesTo: aWorkingCopy

	self reboundItem 
		ifNotNil: [:aMethodOrClass | 
			aMethodOrClass checkoutCopyTo: aWorkingCopy ]! !

!ModifiedEvent methodsFor: '*CV' stamp: 'bs 8/27/2011 15:34:41.267'!
cleanUpChangesTo: aVersion
	self assert: [self isMethodItem].
	self copyOrganizationTo: aVersion.
	self item parent saveFlatCopyTo: aVersion.! !

!ModifiedEvent methodsFor: '*CV' stamp: 'bs 8/30/2011 11:51:27.562'!
includedInCheckoutOf: aClass

	^ self reboundItem = aClass! !

!ModifiedEvent methodsFor: '*CV' stamp: 'bs 8/23/2012 13:14:38.786'!
itemToBeCheckedOut

	^ self cvItemReference! !

!ModifiedEvent methodsFor: '*CV' stamp: 'bs 8/23/2012 13:48:30.891'!
requiresCheckoutTo: aWorkingCopy

	^ (self cvItemReference bind: self activeCodeBase)
		ifNil: [false] 
		ifNotNil: [:boundItem |
			boundItem requiresReCheckoutTo: aWorkingCopy]! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
adoptItemCopyFrom: aCodeBase
	
	self isItemKindOfClassOrMethod 
		ifTrue: [item := item valueAt: aCodeBase].! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
assertInvariantsAndCopyOrganizationTo: aVersion

	self assert: [self activeCodeBase isCvWorkingCopy].
	self assert: [aVersion isCvWorkingCopy not].
	
	aVersion adoptCopyOfOrganization: self activeCodeBase organization.
	
	! !

!AbstractEvent methodsFor: '*CV' stamp: 'bs 2/3/2012 22:41:25.247'!
canBeVersioned

	^ self cannotBeVersioned not! !

!AbstractEvent methodsFor: '*CV' stamp: 'bs 2/3/2012 22:46:02.087'!
cannotBeVersioned

	^ (self isClassItem and: [self item mustNotBeLateBound])
		or: (self isMethodItem and: [self item parent mustNotBeLateBound])! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
changedMetaObject

	self subclassResponsibility! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
checkoutChangesTo: aWorkingCopy

	self subclassResponsibility! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
cleanUpChangesTo: aVersion

	self subclassResponsibility
	! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
copyOrganizationTo: aVersion
	
	aVersion adoptCopyOfOrganization: self activeWorkingCopy organization.
	
	! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
createItemReference
	
	self itemKind = self class classKind
		ifTrue: [^ CvCodeReference class: self item].
	
	self itemKind = self class methodKind
		ifTrue: [^ CvCodeReference method: self item category: self itemProtocol].
		
	^ CvCodeReference nullReference.! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
createParentItemReference
	
	self isItemKindOfClassOrMethod
		ifTrue: [^ CvCodeReference class: self item parent].
		
	^ CvCodeReference nullReference.! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
createRebindBlockForItemParent
	| name aClass |
	aClass := self item parent.
	^ aClass isMeta
		ifTrue: [
			name := aClass theNonMetaClass name.
			[(Smalltalk at: name) theMetaClass]]
		ifFalse: [
			name := aClass name.
			[Smalltalk at: name]]! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
cvEventKindString
	
	^ String streamContents: [:s | self printEventKindOn: s]! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
cvItemReference

	^ environment at: #cvItemReference! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
cvParentItemReference

	^ environment at: #cvParentItemReference! !

!AbstractEvent methodsFor: '*CV' stamp: 'bs 5/12/2012 12:33:00.457'!
cvSummary
	| limitedString limit |
	limit := 100.
	limitedString := String streamContents: [:s | 
		self printEventKindOn: s.
		s nextPut: Character space.
		self cvItemReference printOn: s] limitedTo: limit.
	limitedString size < limit ifTrue: [^ limitedString].
	^ limitedString , '...etc...'! !

!AbstractEvent methodsFor: '*CV' stamp: 'bs 8/30/2011 11:51:27.566'!
includedInCheckoutOf: aClass

	self subclassResponsibility! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
isCategoryItem

	^ self itemKind = AbstractEvent categoryKind! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
isClassItem

	^ self itemKind = AbstractEvent classKind! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
isItemKindOfClassOrMethod

	^ {self class classKind. self class methodKind} includes: self itemKind! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
isMethodItem

	^ self itemKind = AbstractEvent methodKind! !

!AbstractEvent methodsFor: '*CV' stamp: 'bs 4/30/2012 12:55:54.251'!
itemToBeCheckedOut

	^ self subclassResponsibility! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
reboundItem

	^ self cvItemReference bind: self activeCodeBase! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
reboundParentItem

	^ self cvParentItemReference bind: self activeCodeBase! !

!AbstractEvent methodsFor: '*CV' stamp: 'bs 8/23/2012 13:32:52.062'!
requiresCheckoutTo: aWorkingCopy

	^ true! !

!AbstractEvent methodsFor: '*CV' stamp: ''!
saveCodeReference
	
	environment 
		at: #cvItemReference put: self createItemReference;
		at: #cvParentItemReference put: self createParentItemReference! !

!CompiledMethod methodsFor: '*CV' stamp: 'bs 8/10/2011 16:01:20.636'!
addCopyTo: aCodeBase do: aBlock
	| newClass newMethod |
	newMethod := self copy.
	newClass := self methodClass addCopyTo: aCodeBase do: aBlock.
	newClass methodDict at: self selector put: newMethod.
	^ newMethod! !

!CompiledMethod methodsFor: '*CV' stamp: 'bs 7/14/2011 17:24:28.229'!
addTo: aCodeBase 
	
	(self methodClass valueAt: aCodeBase) 
		addSelector: self selector withMethod: self! !

!CompiledMethod methodsFor: '*CV' stamp: 'bs 1/18/2012 16:13:34.941'!
asMcDefinition

	^ self methodReference asMethodDefinition! !

!CompiledMethod methodsFor: '*CV' stamp: 'bs 2/3/2012 16:11:30.178'!
checkoutCopyTo: aWorkingCopy
	| category classInWc |
	category := self methodClass organization categoryOfElement: self selector.
	classInWc := self methodClass valueAt: aWorkingCopy.
	classInWc addSelectorSilently: self selector withMethod: self copy.
	classInWc organization classify: self selector under: category.! !

!CompiledMethod methodsFor: '*CV' stamp: 'bs 9/13/2012 13:19:03.737'!
hasSimilarCodeThan: anotherMethod
	|  aMsgSeq anotherMsgSeq noDifferentHalts noDifferentShows noDifferentMsgs | 
	
	(self = anotherMethod) ifTrue: [^ true].
	
		"and: [aNode tempNames hasEqualElements: anotherNode tempNames]
		and: [aNode block statements size = anotherNode block statements size]
		and: [self messagesSequence hasEqualElements: anotherMethod messagesSequence]"
	
	aMsgSeq := self messagesSequence.
	anotherMsgSeq := anotherMethod messagesSequence.
	
	(aMsgSeq hasEqualElements: anotherMsgSeq)
		ifTrue: [^ true].
	
	noDifferentMsgs := (aMsgSeq size - anotherMsgSeq size) abs.
	noDifferentMsgs = 0 ifTrue: [^ true].
	
	noDifferentHalts := (
		  (aMsgSeq select: [:ea | ea = #halt]) size 
		- (anotherMsgSeq select: [:ea | ea = #halt]) size
		) abs.
	noDifferentShows := (
		  (aMsgSeq select: [:ea | ea = #show:]) size 
		- (anotherMsgSeq select: [:ea | ea = #show:]) size
		) abs.
	
	^ (noDifferentHalts > 0) or: [noDifferentShows > 0]! !

!CompiledMethod methodsFor: '*CV' stamp: 'bs 2/28/2011 11:49:31.326'!
parent
	^ self methodClass! !

!CompiledMethod methodsFor: '*CV' stamp: 'bs 7/13/2011 14:24:48.725'!
rebindBlock

	| classRebindBlock selector |
	classRebindBlock := self methodClass rebindBlock.
	selector := self selector asSymbol.
	^ [:aCodeBase | 
		(classRebindBlock value: aCodeBase) >> selector].! !

!CompiledMethod methodsFor: '*CV' stamp: 'bs 8/29/2011 16:12:16.027'!
removeFrom: aCodeBase

	(self methodClass valueAt: aCodeBase) 
		ifNotNil: [:aClass | aClass removeSelectorSilently: self selector]! !

!CompiledMethod methodsFor: '*CV' stamp: 'bs 8/23/2012 13:41:31.054'!
requiresReCheckoutTo: aWorkingCopy

	^ (self valueAt: aWorkingCopy) isNil
		or: [self ~~ (self valueAt: aWorkingCopy)]! !

!CompiledMethod methodsFor: '*CV' stamp: ''!
textRangeForFirstInstruction
	| map |
	map := self debuggerMap abstractSourceMap.
	^ map 
		ifEmpty: [0]
		ifNotEmpty: [(map at: map keys sorted first) first]! !

!CompiledMethod methodsFor: '*CV' stamp: 'bs 3/26/2011 21:30:28.64'!
valueAt: aCodeBase
	
	^ (self methodClass valueAt: aCodeBase) 
		ifNotNil: [:aClass |
			aClass compiledMethodAt: self selector ifAbsent: [nil]]! !

!OBList methodsFor: '*CV' stamp: ''!
backgroundColorAt: aRowIndex

	^ self fan backgroundColorAt: aRowIndex! !

!ModifiedClassDefinitionEvent methodsFor: '*CV' stamp: 'bs 8/25/2011 15:58:43.219'!
changedMetaObject

	^ self item! !

!ModifiedClassDefinitionEvent methodsFor: '*CV' stamp: 'bs 8/29/2011 14:17:26.02'!
checkoutChangesTo: aWorkingCopy

	self reboundItem checkoutCopyTo: aWorkingCopy! !

!ModifiedClassDefinitionEvent methodsFor: '*CV' stamp: 'bs 8/26/2011 13:43:30.001'!
cleanUpChangesTo: aVersion

	self copyOrganizationTo: aVersion.
	self item saveHierarchyCopyTo: aVersion.! !

!ModifiedClassDefinitionEvent methodsFor: '*CV' stamp: 'bs 8/30/2011 11:51:27.568'!
includedInCheckoutOf: aClass

	^ self reboundItem = aClass! !

!ModifiedClassDefinitionEvent methodsFor: '*CV' stamp: 'bs 4/30/2012 12:49:05.544'!
itemToBeCheckedOut

	^ self reboundParentItem! !

!ModifiedClassDefinitionEvent methodsFor: '*CV' stamp: 'bs 8/23/2012 13:59:41.421'!
requiresCheckoutTo: aWorkingCopy

	^ (self cvItemReference bind: self activeCodeBase)
		ifNil: [false] 
		ifNotNil: [:boundItem |
			boundItem requiresReCheckoutTo: aWorkingCopy]! !

!OBMethodCategoryNode methodsFor: '*CV' stamp: ''!
backgroundColor
	| activeWC refWC selectors |
	activeWC := self activeWorkingCopy.
	refWC := activeWC referenceWC.
	refWC ifNil: [^ nil].
	
	selectors := self theClass selectors.
	selectors = (self theClass valueAt: refWC) selectors
		ifFalse: [^ nil].
	
	(selectors allSatisfy: [:ea |
		((self theClass valueAt: activeWC) >> ea) ==
			((self theClass valueAt: refWC) >> ea)])
		ifTrue: [^ Color lightGray muchLighter]
		ifFalse: [^ nil]! !

!OBMethodCategoryNode methodsFor: '*CV' stamp: 'bs 8/17/2011 14:40:09.38'!
cvItemReference
	
	^ CvCodeReference methodCategory: self category class: self theClass! !

!OBMethodCategoryNode methodsFor: '*CV' stamp: 'bs 3/26/2011 21:06:57.351'!
valueAt: aCodeBase

	^ [super valueAt: aCodeBase]
		unless: [:superResult | superResult = self]
		proceed: [
			(self theClass organization categories includes: self category)
				ifFalse: [OBClassNode on: self theClass]
				ifTrue: [self]]! !

PsCodeBase subclass: #CvVersion
	uses: TUiItemModel
	instanceVariableNames: 'predecessor successors systemEvent number versionInfo controller testResult screenshot isBeginOfRefactoring isEndOfRefactoring refactoringName isCommittedToMC checked commitMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

CvVersion class
	uses: TUiItemModel classTrait
	instanceVariableNames: ''!

CvVersion subclass: #CvTestVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvTestVersion class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.122'!
canBeLateBound
	^ false! !

!CvTestVersion methodsFor: 'sunit' stamp: 'bs 5/11/2011 14:46:14.889'!
testCodeBase
	^ self! !

!CvVersion class methodsFor: 'as yet unclassified' stamp: 'bs 8/25/2011 17:25:07.805'!
newFrom: originalCodeBase
	| systemEvent |
	" required for consistency" 
	systemEvent := CvInitialVersionNullEvent new.
	
	^ (super newFrom: originalCodeBase)
		initializeWithEvent: systemEvent;
		yourself
	! !

!CvVersion class methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2011 13:13:59.322'!
newFrom: originalCodeBase startCopyAt: rootClassName
	
	^ self newFrom: (
		originalCodeBase copyWithClassesStartAt: rootClassName)
			
		! !

!CvVersion methodsFor: 'accessing' stamp: 'bs 3/1/2011 15:58:32.188'!
addSuccessor: aVersion
	^ self pvtSuccessors add: aVersion! !

!CvVersion methodsFor: 'accessing' stamp: 'bs 3/1/2011 15:55:39.567'!
addSuccessors: aVersion
	^ self pvtSuccessors add: aVersion! !

!CvVersion methodsFor: 'views' stamp: 'bs 7/18/2012 17:27:17.926'!
affectedClassCategory

	^ self changedCodeReference classCategoryReference 
		ifNil: [String space]
		ifNotNil: [:ref | ref name]! !

!CvVersion methodsFor: 'changed code' stamp: 'bs 8/16/2011 19:10:28.529'!
affectedClassCategoryReference

	^ self changedCodeReference classCategoryReference! !

!CvVersion methodsFor: 'views' stamp: 'bs 8/17/2011 21:23:27.31'!
affectedClassName

	^ self changedCodeReference classReference 
		ifNil: [String space]
		ifNotNil: [:classRef | classRef name]! !

!CvVersion methodsFor: 'views' stamp: 'bs 8/17/2011 21:23:23.028'!
affectedMethodName

	^ self changedCodeReference methodReference 
		ifNil: [String space]
		ifNotNil: [:methodRef | methodRef selector] ! !

!CvVersion methodsFor: 'enumerating' stamp: 'bs 1/13/2012 17:37:23.288'!
allPredecessorsDo: aBlock

	aBlock value: self.
	self predecessor ifNotNil: [:ea | ea allPredecessorsDo: aBlock].! !

!CvVersion methodsFor: 'branching' stamp: 'bs 7/19/2012 18:50:06.883'!
branch

	self predecessor ifNil: [^ 1].
	
	^ self predecessor branch + (self predecessor numberOfSuccessiveBranchesUpTo: self).! !

!CvVersion methodsFor: 'views' stamp: ''!
branchDescription

	^ (self predecessor ~= self chronologicalPredecessor
		or: [(self successors includes: self chronologicalSuccessor) not])
			ifTrue: [self path]
			ifFalse: [String space]! !

!CvVersion methodsFor: 'as yet unclassified' stamp: 'bs 8/24/2012 14:05:13.748'!
browseChange
	| closestReference |
	closestReference := self systemEvent cvItemReference.
	[closestReference isValidInActiveCodeBase] 
		whileFalse: [closestReference := closestReference parent].
	
	^ (OBSystemBrowser selection: closestReference asOBNode) open! !

!CvVersion methodsFor: 'initialize-release' stamp: 'bs 7/29/2011 14:49:55.397'!
captureWorldCanvas

	screenshot := SketchMorph withForm: (
		(World canvas form scaledToSize: 320@188) as8BitColorForm)! !

!CvVersion methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2011 13:04:28.613'!
changeAsText
	self predecessor ifNil: [^ 'initial version' asText].

	^ self predecessorDiff 
		ifNil: [self systemEvent asString asText]
		ifNotNil: [self predecessorDiff cvSummaryBody]. ! !

!CvVersion methodsFor: 'views' stamp: 'bs 8/16/2011 18:27:00.371'!
changeSummaryView
	| summaryMorphs result line | 
	summaryMorphs := self summary collect: [:ea | ea asTextMorph color: Color black; yourself].
	line := Morph new height: 1; width: 110; color: Color gray.
	
	result := (AlignmentMorph inAColumn: {})
		cellPositioning: #topLeft;
		color: Color white;
		borderWidth: 2;
		borderColor: Color gray.
	
	summaryMorphs allButLast do: [:ea | 
		result 
			addMorphBack: ea;
			addMorphBack: line copy ].
	result addMorphBack: summaryMorphs last.
	
	^ result! !

!CvVersion methodsFor: 'as yet unclassified' stamp: 'bs 8/2/2011 14:24:53.526'!
changeTimeAsText

	^ String streamContents: [:s | 
		self changeTimeStamp time print24: true showSeconds: false on: s]! !

!CvVersion methodsFor: 'views' stamp: 'bs 8/2/2011 14:19:07.584'!
changeTimeStamp

	^ self versionInfo timeStamp! !

!CvVersion methodsFor: 'changed code' stamp: 'bs 3/18/2011 22:41:36.141'!
changedClass

	^ self systemEvent environmentAt: #class! !

!CvVersion methodsFor: 'changed code' stamp: 'bs 3/11/2011 18:58:26.192'!
changedClassName

	^ self changedClass ifNotNil: [:class | class name]! !

!CvVersion methodsFor: 'patches' stamp: 'bs 1/19/2012 10:35:19.359'!
changedClassesAndMethodsUpThrough: aPredecessor

	^ (self withAllPredecessorsUpThrough: aPredecessor)
		collect: [:ea | ea changedCodeReference]
		thenSelect: [:ea | ea isCvClassReference or: ea isCvMethodReference]! !

!CvVersion methodsFor: 'patches' stamp: 'bs 5/12/2012 09:51:59.484'!
changedClassesAndMethodsUpTo: aPredecessor

	^ (self withAllPredecessorsUpTo: aPredecessor)
		collect: [:ea | ea changedCodeReference]
		thenSelect: [:ea | ea isCvClassReference or: ea isCvMethodReference]! !

!CvVersion methodsFor: 'changed code' stamp: 'bs 8/10/2011 14:09:54.587'!
changedCodeReference

	^ self systemEvent cvItemReference! !

!CvVersion methodsFor: 'views' stamp: 'bs 8/2/2011 14:09:22.719'!
changedEntityKind

	^ self systemEvent cvEventKindString! !

!CvVersion methodsFor: 'changed code' stamp: 'TM 3/11/2011 12:02:39.52'!
changedMethod

	^ self systemEvent environmentAt: #method! !

!CvVersion methodsFor: 'changed code' stamp: 'TM 3/11/2011 12:08:04.822'!
changedMethodSelector

	self changedMethod ifNil: [ ^nil ].
	
	^ self changedMethod selector! !

!CvVersion methodsFor: 'switching' stamp: 'bs 3/24/2011 15:19:00.345'!
changedNode
	
	self changedMethod ifNotNil: [:m | ^ m methodReference asNode].
	self changedClass ifNotNil: [:c | ^ c asNode].
	^ nil! !

!CvVersion methodsFor: 'as yet unclassified' stamp: 'bs 3/8/2011 09:29:27.693'!
checkout
	^ self controller checkout: self.! !

!CvVersion methodsFor: 'item model - hierarchy' stamp: 'bs 1/23/2012 13:19:58.177'!
childAt: index

	self error: 'should not be called'! !

!CvVersion methodsFor: 'item model - hierarchy' stamp: 'bs 1/23/2012 13:19:36.49'!
childCount
	
	^ 0! !

!CvVersion methodsFor: 'accessing' stamp: ''!
chronologicalPredecessor

	^ self controller versionsChronologically before: self ifAbsent: [nil]! !

!CvVersion methodsFor: 'accessing' stamp: ''!
chronologicalSuccessor

	^ self controller versionsChronologically after: self ifAbsent: [nil]! !

!CvVersion methodsFor: 'sunit' stamp: 'bs 7/25/2011 17:44:40.375'!
collectTestsInSuite
	| aSuite testsToRun testPkg | 
	aSuite := TestSuite new.
	testPkg := [self controller package] 
			unless: [:p | p name = 'CV' ] 
			proceed: [PackageInfo named: 'CV-TestBed'].
			
	testsToRun := (testPkg classes
		select: [:c | c isTestCaseClass])
			flatCollect: [:c | c testMethods].
	aSuite addTests: (testsToRun collect: [:ea | ea newTestCase]).
	^ aSuite! !

!CvVersion methodsFor: 'accessing' stamp: ''!
commitMessage
	^ commitMessage! !

!CvVersion methodsFor: 'accessing' stamp: ''!
commitMessage: anObject
	commitMessage := anObject! !

!CvVersion methodsFor: 'mc merging / ancestry' stamp: 'bs 3/4/2011 19:17:33.26'!
commonAncestorWith: aCvVersion
	^ (self versionInfo commonAncestorWith: aCvVersion versionInfo) version! !

!CvVersion methodsFor: 'accessing' stamp: 'bs 3/8/2011 09:29:19.963'!
controller
	^ controller! !

!CvVersion methodsFor: 'accessing' stamp: 'bs 3/8/2011 09:29:39.096'!
controller: anObject
	controller := anObject! !

!CvVersion methodsFor: 'copying' stamp: 'bs 3/24/2011 09:49:31.494'!
copy
	^ super copy! !

!CvVersion methodsFor: 'mc merging / ancestry' stamp: 'bs 3/6/2011 14:27:35.213'!
createVersionInfo
	^ (CvVersionInfo
		name: ''
		id: UUID new
		message: ''
		date: Date today
		time: Time now
		author: Utilities authorInitials 
		ancestors: {})
			version: self;
			yourself
		
! !

!CvVersion methodsFor: 'views' stamp: 'bs 2/4/2012 11:13:34.209'!
currentBaseIcon

	^ self isActive
		ifTrue: [UiFugueIcons eyeIcon]
		ifFalse: [nil]! !

!CvVersion methodsFor: 'test result' stamp: 'bs 3/17/2011 21:46:08.938'!
defectTests
	
	^ self basedOn: self do: [ 
		self testResult defects collect: [:ea | 
			MethodReference class: ea class selector: ea selector]]! !

!CvVersion methodsFor: 'views' stamp: 'bs 8/16/2011 18:36:32.478'!
description

	^ self changedEntityKind! !

!CvVersion methodsFor: 'mc merging / ancestry' stamp: 'bs 8/25/2011 16:44:27.608'!
entriesOnPathTo: aCvVersion
	
	^ (self versionInfo 
		entriesOnPathTo: aCvVersion versionInfo) 
			collect: [:ea | ea version]! !

!CvVersion methodsFor: 'accessing by path' stamp: 'bs 3/21/2011 14:56:57.314'!
findOnFirstBranchesPath: aVersionNo
	| aVersion |
	aVersion := self.
	[aVersion number = aVersionNo] whileFalse: [
		aVersion successors 
			ifNotEmpty: [aVersion := aVersion successors first]
			ifEmpty: [self error: 'could not find a version ', aVersionNo, ' on first-branches path from: ', self path]].
	^ aVersion! !

!CvVersion methodsFor: 'mc merging / ancestry' stamp: 'bs 3/4/2011 19:19:38.574'!
hasAncestor: aCvVersion
	^ self versionInfo hasAncestor: aCvVersion versionInfo! !

!CvVersion methodsFor: 'testing' stamp: 'TM 3/11/2011 09:49:29.703'!
hasPredecessor

	^ self predecessor isNil not! !

!CvVersion methodsFor: 'sunit' stamp: 'bs 5/15/2011 15:25:00.26'!
hasRunTests: aTestResult
	self emit! !

!CvVersion methodsFor: 'testing' stamp: 'bs 4/20/2011 13:41:26.215'!
hasSuccessors
	^ self successors notEmpty! !

!CvVersion methodsFor: 'initialize-release' stamp: 'sp 1/16/2013 11:55:08.509'!
initializeWithEvent: aSystemEvent 
	self 
		initialize;
		isCommittedToMC: false;
		versionInfo: self createVersionInfo;
		systemEvent: aSystemEvent;
		connect: self signal: #hasRunTests: toSelector: #processTestResult: .
	
	self systemEvent saveCodeReference.
	self captureWorldCanvas.! !

!CvVersion methodsFor: 'testing' stamp: 'bs 2/4/2012 18:11:41.672'!
isActive

	^ self == self activeWorkingCopy baseVersion! !

!CvVersion methodsFor: 'refactorings' stamp: 'bs 8/10/2011 17:30:19.414'!
isBeginOfRefactoring

	^ isBeginOfRefactoring ifNil: [false]	! !

!CvVersion methodsFor: 'views' stamp: 'bs 12/26/2012 18:38:02.513'!
isCheckable

	^ true! !

!CvVersion methodsFor: 'views' stamp: 'bs 2/4/2012 16:39:29.599'!
isChecked
	
	^ checked ifNil: [checked := false]! !

!CvVersion methodsFor: 'views' stamp: 'bs 2/4/2012 16:39:35.681'!
isChecked: aBoolean

	checked := aBoolean! !

!CvVersion methodsFor: 'changed code' stamp: 'bs 8/16/2011 17:33:47.936'!
isClassCategoryChange

	^ self changedCodeReference isCvClassCategoryReference! !

!CvVersion methodsFor: 'accessing' stamp: 'sp 1/16/2013 11:53:06.746'!
isCommittedToMC
	^ isCommittedToMC! !

!CvVersion methodsFor: 'accessing' stamp: 'sp 1/16/2013 11:53:20.436'!
isCommittedToMC: aBoolean
	isCommittedToMC := aBoolean! !

!CvVersion methodsFor: 'testing' stamp: 'bs 2/3/2012 17:20:04.459'!
isCurrentBaseVersion

	^ self == self activeCodeBase baseVersion! !

!CvVersion methodsFor: 'refactorings' stamp: 'bs 8/10/2011 17:31:21.537'!
isEndOfRefactoring

	^ isEndOfRefactoring ifNil: [false]	! !

!CvVersion methodsFor: 'testing' stamp: 'bs 11/9/2012 17:28:12.874'!
isInitialVersion

	^ self hasPredecessor not! !

!CvVersion methodsFor: 'refactorings' stamp: 'bs 8/3/2012 16:02:27.416'!
isPartOfRefactoring

	^ self refactoringName notNil! !

!CvVersion methodsFor: 'analysis' stamp: 'bs 8/30/2012 14:20:48.665'!
isRepetitive

	^ (Smalltalk globals at: #CvRepetition) includes: self! !

!CvVersion methodsFor: 'test result' stamp: 'bs 7/29/2011 18:27:41.59'!
isTestResultAvailable
	
	self testResult ifNil: [^ false].
	self hasPredecessor ifFalse: [^ true].
	^ self predecessor isTestResultAvailable! !

!CvVersion methodsFor: 'testing' stamp: 'bs 8/1/2011 17:33:37.078'!
isVersionGroup

	^ false! !

!CvVersion methodsFor: 'as yet unclassified' stamp: ''!
isVisible

	"^ self changedCodeReference matches: self activeWorkingCopy selectedItem"
	^ true! !

!CvVersion methodsFor: 'accessing' stamp: 'FB 1/9/2013 17:42:12.848'!
lastCommittedVersion
	"answer the latest CvVersion (self or closest in ancestry) that has an Monticello version associated"

	"look in self"
	self versionInfo mcVersionInfo ifNotNil: [ ^ self ].
	"look in ancestry"
	self versionInfo allAncestorsDo: [ :cvInfo |
		cvInfo mcVersionInfo ifNotNil: [ ^ cvInfo version ].
	].
	"no committed version was found in the history. try to find a package in the image
	 with a valid MCVersionInfo. return initial version"
	^self controller tryToSetInitialMCVersionInfo 
		ifNil: [nil]
		ifNotNil: [self controller firstVersion]! !

!CvVersion methodsFor: 'analysis' stamp: 'FB 1/17/2013 15:02:14.686'!
lastVersionInSuccessorChain
	"<^iOf: CvVersion>"
	"Answer the last CvVersion in the chain of the receiver's successors.
	 Always follow the last successor."
	
	|current|
	current := self.
	[current successors isNil or: [current successors isEmpty]]
		whileFalse: [current := current successors last].
	^current! !

!CvVersion methodsFor: 'refactorings' stamp: 'bs 8/10/2011 17:31:00.378'!
makeBeginOfRefactoring

	^ isBeginOfRefactoring := true! !

!CvVersion methodsFor: 'refactorings' stamp: 'bs 8/10/2011 17:31:39.525'!
makeEndOfRefactoring

	^ isEndOfRefactoring := true! !

!CvVersion methodsFor: 'mc merging / ancestry' stamp: 'bs 1/18/2012 14:24:58.361'!
mcOperation! !

!CvVersion methodsFor: 'mc merging / ancestry' stamp: 'pt 1/23/2013 17:36:22.648'!
mcPackage
	^ MCPackage named: self mcPackageName! !

!CvVersion methodsFor: 'mc merging / ancestry' stamp: 'sp 1/24/2013 17:13:58.813'!
mcPackageName
	"might not return proper package for extension methods.
	 explanaition: methodReference for changedMethods will be nil, when the workingcopy points to a version without the owner class defined."
	self changedMethod ifNotNil: [:m | 
		m methodReference ifNotNil:[
			^ m methodReference asNode containingPackage name] ].
	self changedClass ifNotNil: [:c | ^ c category asString ].
	^ self controller package name! !

!CvVersion methodsFor: 'mc merging / ancestry' stamp: 'bs 3/16/2011 18:38:55.449'!
mcSnapshot

	^ [self mcPackage snapshot] valueBasedOn: self! !

!CvVersion methodsFor: 'views' stamp: 'bs 1/23/2012 16:52:46.806'!
menu
	^ CvVersionMenu version: self! !

!CvVersion methodsFor: 'mc merging / ancestry' stamp: 'bs 8/1/2012 11:08:06.079'!
merged: anotherCvVersion
	
	"self versionInfo ancestors: (self versionInfo ancestors copyWith: anotherCvVersion versionInfo)"! !

!CvVersion methodsFor: 'accessing' stamp: 'bs 3/25/2011 20:25:59.165'!
name
	^ self asString! !

!CvVersion methodsFor: 'test result' stamp: 'bs 7/25/2011 18:32:02.383'!
newDefectTests

	self predecessor ifNil: [^ Set new].
	^ self defectTests difference: self predecessor defectTests! !

!CvVersion methodsFor: 'test result' stamp: 'bs 7/25/2011 18:31:58.478'!
newlyPassedTests
	
	self predecessor ifNil: [^ Set new].
	^ self passedTests difference: self predecessor passedTests! !

!CvVersion methodsFor: 'accessing by path' stamp: 'bs 3/21/2011 15:04:29.561'!
nextOnBranchNo: aNumber
	
	^ self successors at: aNumber ifAbsent: [
		self error: 'could not find branch no, ', aNumber, ' at version: ', self path].! !

!CvVersion methodsFor: 'analysis' stamp: 'bs 8/30/2012 14:20:59.15'!
nonRepetitivePredecessor

	^ self predecessor isRepetitive 
		ifTrue: [self predecessor nonRepetitivePredecessor]
		ifFalse: [self predecessor]! !

!CvVersion methodsFor: 'accessing' stamp: ''!
number
	^ number ifNil: [number := 1]! !

!CvVersion methodsFor: 'accessing' stamp: 'bs 3/1/2011 19:50:00.495'!
number: anObject
	number := anObject! !

!CvVersion methodsFor: 'branching' stamp: 'bs 7/19/2012 18:54:56.672'!
numberOfBranches

	^ self predecessor 
		ifNil: [self numberOfSuccessiveBranches]
		ifNotNil: [:pred | pred numberOfBranches]! !

!CvVersion methodsFor: 'branching' stamp: 'bs 7/19/2012 18:39:26.689'!
numberOfSuccessiveBranches

	^ self successors 
		ifEmpty: [1]
		ifNotEmpty: [:succs | (succs collect: [:ea | ea numberOfSuccessiveBranches]) sum]
! !

!CvVersion methodsFor: 'branching' stamp: 'bs 7/19/2012 18:39:33.695'!
numberOfSuccessiveBranchesUpTo: aSuccessorVersion

	^ (((self successors 
		copyUpTo: aSuccessorVersion)
		collect: [:ea | ea numberOfSuccessiveBranches])
		copyWith: 0) sum
! !

!CvVersion methodsFor: 'as yet unclassified' stamp: 'bs 3/18/2011 20:08:08.716'!
openBrowserOnChange

	self changedMethod ifNotNil: [:m | 
		^ OBSystemBrowser openOnClass: m methodClass selector: m selector].
	
	self changedClass ifNotNil: [:c | 
		^ OBSystemBrowser openOnClass: c].
	
	^ OBSystemBrowser open! !

!CvVersion methodsFor: 'mc merging / ancestry' stamp: 'bs 4/13/2011 23:14:06.305'!
package
	^ CvPackage named: self controller package name.! !

!CvVersion methodsFor: 'patches' stamp: 'bs 1/19/2012 14:20:03.264'!
partialSnapshotFor: codeRefs
	| definitions |
	definitions := OrderedCollection new.
	definitions add: (MCOrganizationDefinition categories: (Smalltalk organization categories)).
	self basedOn: self do: [
		definitions addAll: (
			((codeRefs collect: [:ea | ea bind: self]) copyWithout: nil) collect: [:ea | ea asMcDefinition])].
	^ CvSnapshot fromDefinitions: definitions! !

!CvVersion methodsFor: 'test result' stamp: 'bs 3/17/2011 21:46:23.278'!
passedTests
	
	^ self testResult passed collect: [:ea | 
		MethodReference class: ea class selector: ea selector]! !

!CvVersion methodsFor: 'patches' stamp: 'bs 5/12/2012 09:52:38.659'!
patchRelativeToBase: anotherVersion
	| ancestor changedCodeRefs | 
	ancestor := self commonAncestorWith: anotherVersion.
	changedCodeRefs := 
		((self changedClassesAndMethodsUpTo: ancestor),
			(anotherVersion changedClassesAndMethodsUpTo: ancestor))
				copyWithoutDuplicates.
			
	^ (self partialSnapshotFor: changedCodeRefs) 
		patchRelativeToBase: (
			anotherVersion partialSnapshotFor: changedCodeRefs)! !

!CvVersion methodsFor: 'accessing by path' stamp: 'bs 3/21/2011 15:36:58.117'!
path
	| finalMarker |
	finalMarker := self number asString.
	^ self predecessor 
		ifNil: [finalMarker]
		ifNotNil: [:pred | pred prependToPath: finalMarker forSuccessor: self]
		! !

!CvVersion methodsFor: 'accessing' stamp: 'bs 3/1/2011 16:49:53.276'!
predecessor
	^ predecessor! !

!CvVersion methodsFor: 'accessing' stamp: 'bs 3/4/2011 16:55:06.113'!
predecessor: aVersion
	
	predecessor ifNotNil: [predecessor removeSuccessor: self].
	
	aVersion addSuccessor: self.
	predecessor := aVersion.
	self number: aVersion number + 1.
	
	self versionInfo 
		name: self number asString;
		ancestors: { predecessor versionInfo }! !

!CvVersion methodsFor: 'patches' stamp: 'bs 7/25/2011 13:22:53.485'!
predecessorDiff

	^ self predecessorPatch operations 
		ifEmpty: [nil]
		ifNotEmpty: [self predecessorPatch operations first].! !

!CvVersion methodsFor: 'patches' stamp: 'bs 1/23/2012 16:19:22.488'!
predecessorPatch
	
	^ self patchRelativeToBase: self predecessor.
	! !

!CvVersion methodsFor: 'accessing by path' stamp: 'bs 3/21/2011 15:39:21.64'!
prependToPath: aPath forSuccessor: aVersion
	| newPath branchNo |
	newPath := aPath.
	
	branchNo := self successors indexOf: aVersion.
	branchNo > 1
		ifTrue: [newPath := '{1}/{2}->{3}' format: {self number. branchNo. aPath}].

	^ self predecessor 
		ifNil: [newPath]
		ifNotNil: [:pred | pred prependToPath: newPath forSuccessor: self]
	! !

!CvVersion methodsFor: 'printing' stamp: 'bs 5/5/2011 17:07:07.125'!
printOn: aStream
	aStream 
		nextPutAll: 'version ';
		nextPutAll: self path! !

!CvVersion methodsFor: 'sunit' stamp: 'bs 12/11/2012 10:42:28.262'!
processTestResult: aTestResult
	
	testResult := aTestResult.
	self propertiesChanged: #(#testResult).! !

!CvVersion methodsFor: 'item model - properties' stamp: 'bs 12/10/2012 16:18:28.161'!
properties
	"Return an ordered list of all known properties. This list can then be used to configure column specifications of item views more conveniently."
	
	^ #(#testResult)! !

!CvVersion methodsFor: 'accessing' stamp: 'bs 3/1/2011 15:54:01.57'!
pvtSuccessors
	^ successors ifNil: [successors := OrderedCollection new]! !

!CvVersion methodsFor: 'refactorings' stamp: 'bs 8/12/2011 15:35:56.487'!
refactoringName

	^ refactoringName ! !

!CvVersion methodsFor: 'refactorings' stamp: 'bs 8/12/2011 15:35:06.93'!
refactoringName: aName

	refactoringName := aName	! !

!CvVersion methodsFor: 'accessing' stamp: 'bs 3/1/2011 15:58:27.6'!
removeSuccessor: aVersion
	^ self pvtSuccessors remove: aVersion! !

!CvVersion methodsFor: 'accessing' stamp: 'bs 3/1/2011 15:58:09.938'!
removeSuccessors: aVersion
	^ self pvtSuccessors remove: aVersion! !

!CvVersion methodsFor: 'sunit' stamp: 'bs 8/23/2011 18:57:08.84'!
runTests

	self basedOn: self do: [	|testSuite theResult|
		testSuite := self collectTestsInSuite.
		[theResult := testSuite run] "prevent debuggers from popping up"
			on: Halt do: [TestFailure signal].
		self hasRunTests: theResult copyWithoutTestGarbage].! !

!CvVersion methodsFor: 'sunit' stamp: 'bs 8/8/2012 19:18:10.683'!
runTestsInBackground

	self controller testJobQueue nextPut: [self runTests]! !

!CvVersion methodsFor: 'initialize-release' stamp: 'bs 7/25/2011 11:12:26.011'!
screenshot

	^ screenshot! !

!CvVersion methodsFor: 'mc merging / ancestry' stamp: 'bs 4/13/2011 23:14:16.979'!
snapshot

	^ [self package snapshot] valueBasedOn: self! !

!CvVersion methodsFor: 'accessing' stamp: 'bs 3/30/2011 19:01:58.011'!
successors

	^ self pvtSuccessors copy! !

!CvVersion methodsFor: 'as yet unclassified' stamp: 'bs 7/25/2011 14:05:02.885'!
summary
	self predecessor ifNil: [^ Array with: 'initial version'].
	
	^ self predecessorDiff 
		ifNil: [Array with: self systemEvent asString]
		ifNotNil: [self predecessorDiff cvSummary]. ! !

!CvVersion methodsFor: 'accessing' stamp: 'bs 3/1/2011 16:49:46.669'!
systemEvent
	^ systemEvent! !

!CvVersion methodsFor: 'accessing' stamp: 'bs 7/18/2011 20:44:08.503'!
systemEvent: anObject
	systemEvent := anObject! !

!CvVersion methodsFor: 'sunit' stamp: 'bs 8/17/2011 18:25:48.99'!
testCodeBase
	"using systemEvent of the initial version as indicator which classes needs 
	 to be copied: e.g. to fasten tests, we copy only subclasses of #CvTbObject"
	^ CvTestVersion 
		newFrom: self
		startCopyAt: self controller nameOfRootClass! !

!CvVersion methodsFor: 'test result' stamp: 'bs 4/6/2011 12:00:24.773'!
testResult
	^ testResult! !

!CvVersion methodsFor: 'views' stamp: 'bs 11/16/2012 13:40:50.275'!
timeCreated

	^ self timeStamp time print24! !

!CvVersion methodsFor: 'accessing' stamp: 'bs 4/27/2011 14:13:22.664'!
timeStamp
	^ self versionInfo timeStamp! !

!CvVersion methodsFor: 'analysis' stamp: 'bs 8/30/2012 14:21:05.618'!
timeStampRepitition

	self hasPredecessor ifFalse: [^ self timeStamp].
	
	^ self nonRepetitivePredecessor timeStampRepitition + (self timeStamp - self predecessor timeStamp)! !

!CvVersion methodsFor: 'views' stamp: 'bs 2/4/2012 16:39:04.339'!
uncheck

	self isChecked: false.
	self propertyChanged: #isChecked.! !

!CvVersion methodsFor: 'as yet unclassified' stamp: 'bs 3/16/2011 17:30:59.663'!
version
	^ versionInfo id! !

!CvVersion methodsFor: 'accessing' stamp: 'bs 3/4/2011 16:52:30.927'!
versionInfo
	^ versionInfo! !

!CvVersion methodsFor: 'accessing' stamp: 'bs 3/4/2011 16:52:13.449'!
versionInfo: anObject
	versionInfo := anObject! !

!CvVersion methodsFor: 'analysis' stamp: 'bs 8/20/2012 11:52:03.231'!
wasCreatedBySignificantOperation

	^ self wasCreatedBySignificantOperationCountSameMethodInRow
		and: [
			"same method twice one after another"
			(self changedCodeReference ~= self predecessor changedCodeReference)]! !

!CvVersion methodsFor: 'analysis' stamp: 'bs 9/13/2012 13:10:57.64'!
wasCreatedBySignificantOperationCountSameMethodInRow

	| event |
	self hasPredecessor ifFalse: [^ false].
	
	self wasCreatedWithinRefactoring ifTrue: [^ false].
				
	event := self systemEvent.
	event isReorganized ifTrue: [^ false].
	event isRecategorized ifTrue: [^ false].
	({#category. #protocol} includes: event itemKind) ifTrue: [^ false].
	 
	event isMethodItem not ifTrue: [^ true].
	
	(event isModified not) 
		ifTrue: [^ true].
	
	(event item hasSimilarCodeThan: event oldItem) ifTrue: [^ false].
	
	^ true! !

!CvVersion methodsFor: 'analysis' stamp: 'bs 8/20/2012 11:53:40.897'!
wasCreatedWithinRefactoring

	^ self isPartOfRefactoring and: [self isBeginOfRefactoring not]! !

!CvVersion methodsFor: 'enumerating' stamp: 'bs 1/13/2012 17:54:18.839'!
withAllPredecessorsUpThrough: aVersion
	| result |
	self assert: [self hasAncestor: aVersion].
	
	result := OrderedCollection new.
	self allPredecessorsDo: [:ea | result add: ea. ea = aVersion ifTrue: [^ result]]! !

!CvVersion methodsFor: 'enumerating' stamp: 'bs 5/12/2012 09:51:23.7'!
withAllPredecessorsUpTo: aVersion
	| result |
	self assert: [self hasAncestor: aVersion].
	
	result := OrderedCollection new.
	self allPredecessorsDo: [:ea | 
		ea = aVersion 
			ifTrue: [^ result]
			ifFalse: [result add: ea].]! !

PsCodeBase subclass: #CvWorkingCopy
	instanceVariableNames: 'baseVersion controller undoStack isNextVersionBeginOfRefactoring currentRefactoryChange selectedItem referenceWC'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvWorkingCopy class methodsFor: 'as yet unclassified' stamp: ''!
checkout: aCvVersion
	
	SLLog info: 'checkout of ' sender: aCvVersion.
	 
	^ self basedOn: aCvVersion do: [
		self new 
			setController: aCvVersion controller andCheckout: aCvVersion;
			yourself]! !

!CvWorkingCopy methodsFor: 'versiong and rebasing' stamp: ''!
adoptCopyOfVersion: aVersion

	self baseVersion: aVersion.
	self adoptCodeBase: aVersion copy.
	(self classNamed: self controller nameOfRootClass) checkoutCopyTo: self 
	! !

!CvWorkingCopy methodsFor: 'merging' stamp: 'sp 1/2/2013 13:35:58.004'!
applyPatch: aPatch
	| merger |
	merger := CvThreeWayMerger new.
	merger addBaseSnapshot: self baseVersion mcSnapshot.
	merger applyPatch: aPatch.	
	
	merger conflicts ifEmpty: [
		self inform: 'No differences detected: there was nothing to be merged in.'].
	
	merger isMerged ifFalse: [
		(MCMergeResolutionRequest new merger: merger)
			signal: 'Merging ... ' ].
			
	merger isMerged ifTrue: [
		[merger load] valueBasedOn: self].! !

!CvWorkingCopy methodsFor: 'accessing' stamp: 'bs 2/28/2011 13:03:54.694'!
baseVersion
	^ baseVersion! !

!CvWorkingCopy methodsFor: 'accessing' stamp: ''!
baseVersion: anObject
	baseVersion := anObject! !

!CvWorkingCopy methodsFor: 'refactorings' stamp: ''!
checkForRefactoring: newVersion

	self isNextVersionBeginOfRefactoring
		ifTrue: [
			self resetNextVersionBeginOfRefactoring.
			newVersion makeBeginOfRefactoring].
	
	currentRefactoryChange ifNotNil: [:aChange | 
		newVersion refactoringName: aChange name]! !

!CvWorkingCopy methodsFor: 'merging' stamp: ''!
commonAncestorWith: aCvVersion
	^ self baseVersion commonAncestorWith: aCvVersion! !

!CvWorkingCopy methodsFor: 'accessing' stamp: 'bs 3/24/2011 07:58:31.035'!
controller
	^ controller! !

!CvWorkingCopy methodsFor: 'testing' stamp: 'bs 8/23/2011 08:11:43.641'!
isActiveCodeBase
	^ self activeCodeBase == self! !

!CvWorkingCopy methodsFor: 'testing' stamp: 'bs 3/6/2011 20:32:46.857'!
isCvWorkingCopy
	^ true! !

!CvWorkingCopy methodsFor: 'versiong and rebasing' stamp: ''!
isNeighbor: aVersion

	^ (self isSuccessorOf: aVersion) or: [self isPredecessorOf: aVersion]! !

!CvWorkingCopy methodsFor: 'refactorings' stamp: ''!
isNextVersionBeginOfRefactoring

	^ isNextVersionBeginOfRefactoring ifNil: [^ false]! !

!CvWorkingCopy methodsFor: 'versiong and rebasing' stamp: ''!
isPredecessorOf: aVersion

	^ self baseVersion = aVersion predecessor! !

!CvWorkingCopy methodsFor: 'versiong and rebasing' stamp: ''!
isSuccessorOf: aVersion

	^ self baseVersion predecessor = aVersion! !

!CvWorkingCopy methodsFor: 'refactorings' stamp: ''!
makeNextVersionBeginOfRefactoring

	isNextVersionBeginOfRefactoring := true.! !

!CvWorkingCopy methodsFor: 'merging' stamp: ''!
merge: aCvVersion
	| merger isAncestorMerge mergeBase patch |
	
	isAncestorMerge := self baseVersion hasAncestor: aCvVersion.
	isAncestorMerge ifTrue: [MCNoChangesException signal. ^ self].

	mergeBase := (self commonAncestorWith: aCvVersion) snapshot.
	patch := aCvVersion snapshot patchRelativeToBase: mergeBase.
	
	merger := CvThreeWayMerger new.
	merger addBaseSnapshot: mergeBase.
	merger applyPatch: patch.
	
	merger isMerged ifFalse: [
		(MCMergeResolutionRequest new merger: merger)
			signal: 'Merging ', aCvVersion versionInfo name].
	
	merger isMerged ifTrue: [
		[merger load] valueBasedOn: self.
		self baseVersion merged: aCvVersion ].

	! !

!CvWorkingCopy methodsFor: 'versiong and rebasing' stamp: 'bs 4/30/2012 14:59:42.23'!
moveOneStepBack
	| newBaseVersion |
	self baseVersion hasPredecessor ifFalse: [^ self].
	self undoStack push: self baseVersion.
	
	newBaseVersion := self baseVersion predecessor.
	self pvtRebaseTo: newBaseVersion! !

!CvWorkingCopy methodsFor: 'versiong and rebasing' stamp: 'bs 4/30/2012 14:59:49.577'!
moveOneStepForward
	| newBaseVersion |
	self undoStack isEmpty ifTrue: [^ self].
	newBaseVersion := self undoStack pop.
	
	self pvtRebaseTo: newBaseVersion! !

!CvWorkingCopy methodsFor: 'accessing' stamp: 'bs 3/25/2011 20:25:44.806'!
name
	^ self asString! !

!CvWorkingCopy methodsFor: 'accessing' stamp: 'bs 8/22/2011 22:06:23.954'!
nameOfRootClass
	^ self controller nameOfRootClass! !

!CvWorkingCopy methodsFor: 'selected source code' stamp: ''!
newSelection: aCodeReference 
	selectedItem := aCodeReference! !

!CvWorkingCopy methodsFor: 'as yet unclassified' stamp: ''!
openInNewEnvironment
	self assert: [World polySource codeBases includes: self].
	
	^ self basedOn: self do: [
		(CvWorkingEnvironment forWorkingCopy: self)
			openInWorld;
			browseLastChange;
			yourself]! !

!CvWorkingCopy methodsFor: 'as yet unclassified' stamp: 'bs 3/1/2011 16:25:52.199'!
polySource
	^ World polySource! !

!CvWorkingCopy methodsFor: 'merging' stamp: 'sp 1/23/2013 11:25:29.211'!
pretendApplyPatch: aPatch
	"pretends to apply aPatch regardless of possibly side effects:
		- does not notify user about conflicts
		- does not notify user about aPatch leading to no actual effect.
		- keeps its changes when merging conlflicts
	  and returns if there would be errors"

	^self pvtSilentlyApplyPatch: aPatch pretending: true.! !

!CvWorkingCopy methodsFor: 'printing' stamp: ''!
printOn: aStream
	aStream nextPutAll: 'working copy of version '.
	self baseVersion ifNotNil: [:v | v number printOn: aStream]! !

!CvWorkingCopy methodsFor: 'versiong and rebasing' stamp: 'lk 1/16/2013 14:25:44.555'!
pvtRebaseTo: newBaseVersion
	| oldBaseVersion changeEvents |
	changeEvents := (self baseVersion entriesOnPathTo: newBaseVersion) collect: [:ea | ea systemEvent].
	
	"rebase"
	self basedOn: newBaseVersion do: [
		
		changeEvents do: [:ea | 
			(ea requiresCheckoutTo: self) 
				ifTrue: [
					ea checkoutChangesTo: self]]].
	
	self adoptCopyOfOrganization: newBaseVersion organization.
	oldBaseVersion := self baseVersion.
	self baseVersion: newBaseVersion.
	
	"inform the MC working copy that we checked out another CV version - which might relate to different MC version"
	newBaseVersion lastCommittedVersion ifNotNil: [ :lastCvVersion |
		(MCPackage named: self controller package name) workingCopy ifNotNil: [ :mcWorkingCopy |
			"find MC version in the MC working copy for the CV version though the versionInfo"
			(mcWorkingCopy repositoryGroup versionWithInfo: lastCvVersion versionInfo mcVersionInfo)
				ifNotNil: [ :lastMcVersion | mcWorkingCopy loaded: lastMcVersion ].
		].
	].
	
	"emit event"
	self rebasedFrom: oldBaseVersion to: newBaseVersion! !

!CvWorkingCopy methodsFor: 'merging' stamp: 'sp 1/23/2013 13:29:14.074'!
pvtSilentlyApplyPatch: aPatch pretending: aBoolean
	" applies aPatch regardless of possibly side effects:
		- does not notify user about conflicts
		- does not notify user about aPatch leading to no actual effect.
		- keeps its changes when merging conlflicts
	  aBoolean indicating wheather to really apply the patch and inform user 
	  about missing requirements of aPatch or only to check for errors."

	| merger loader |
	merger := CvThreeWayMerger new.
	merger addBaseSnapshot: self baseVersion mcSnapshot.
	merger applyPatch: aPatch.	
	
	merger conflicts do: [ :conflict |
		conflict chooseRemote.
	].
	self assert: merger isMerged.
	
	loader := merger createLoader.
	( loader containsErrors not)
		ifTrue: [ aBoolean ifFalse: [ [merger load] valueBasedOn: self. ].
			      ^true]
		ifFalse: [ loader warnAboutDependencies.
			      ^false].! !

!CvWorkingCopy methodsFor: 'versiong and rebasing' stamp: 'bs 4/30/2012 15:04:19.597'!
rebaseTo: newBaseVersion

	(self undoStack isEmpty not and: [self undoStack top = newBaseVersion])
		ifTrue: [self undoStack pop]
		ifFalse: [[self undoStack isEmpty] whileFalse: [self undoStack pop]].
	
	self pvtRebaseTo: newBaseVersion! !

!CvWorkingCopy methodsFor: 'signals' stamp: 'bs 7/31/2012 10:28:52.708'!
rebasedFrom: oldVersion to: newVersion

	self emit! !

!CvWorkingCopy methodsFor: 'refactorings' stamp: ''!
refactoringBegins: aRefactoryChange
	
	(self isActiveCodeBase) ifFalse: [^ self].
	
	self makeNextVersionBeginOfRefactoring.
	currentRefactoryChange := aRefactoryChange.! !

!CvWorkingCopy methodsFor: 'refactorings' stamp: ''!
refactoringEnded: aRefactoringChange

	(self isActiveCodeBase) ifFalse: [^ self].
	
	self baseVersion makeEndOfRefactoring.
	currentRefactoryChange := nil.! !

!CvWorkingCopy methodsFor: 'accessing' stamp: ''!
referenceWC
	^ referenceWC! !

!CvWorkingCopy methodsFor: 'accessing' stamp: ''!
referenceWC: anObject
	referenceWC := anObject! !

!CvWorkingCopy methodsFor: 'refactorings' stamp: ''!
registerForRefactoringSignals

	self 
		connect: RefactoryChangeManager instance
		signal: #refactoringBegins:
		toSelector: #refactoringBegins:.
	
	self 
		connect: RefactoryChangeManager instance
		signal: #refactoringEnded:
		toSelector: #refactoringEnded:.! !

!CvWorkingCopy methodsFor: 'refactorings' stamp: 'bs 8/10/2011 17:37:56.55'!
resetNextVersionBeginOfRefactoring
	isNextVersionBeginOfRefactoring := false! !

!CvWorkingCopy methodsFor: 'accessing' stamp: 'bs 8/29/2011 14:23:00.162'!
rootClassInActiveCodeBase
	^ self activeCodeBase classNamed: self nameOfRootClass! !

!CvWorkingCopy methodsFor: 'versiong and rebasing' stamp: ''!
saveCopyToNewVersion
	| rootClass aVersion |
	rootClass := self classNamed: self nameOfRootClass.
	aVersion := CvVersion newFrom: self copy.
	[rootClass saveCopyTo: aVersion] valueBasedOn: self.
	aVersion controller: self controller.
	self controller versionSaved: aVersion.
	^ aVersion! !

!CvWorkingCopy methodsFor: 'versiong and rebasing' stamp: 'bs 7/31/2012 10:52:03.446'!
saveVersionForChange: aSystemEvent
	| newVersion |
	self isActiveCodeBase ifFalse: [^ self].
	
	aSystemEvent saveCodeReference.
	
	newVersion := self baseVersion copy.
	newVersion
		initializeWithEvent: aSystemEvent;
		predecessor: self baseVersion;
		controller: self controller.
		
	aSystemEvent cleanUpChangesTo: newVersion.
	
	self checkForRefactoring: newVersion.	
	self baseVersion: newVersion.
	self versionSaved.
	^ newVersion! !

!CvWorkingCopy methodsFor: 'selected source code' stamp: ''!
selectedItem
	^ selectedItem! !

!CvWorkingCopy methodsFor: 'initialize-release' stamp: ''!
setController: aCvController andCheckout: aCvVersion
	
	controller := aCvController.
	self adoptCopyOfVersion: aCvVersion.
	[self registerForRefactoringSignals] valueBasedOn: self.
	self controller activateWorkingCopy: self! !

!CvWorkingCopy methodsFor: 'initialize-release' stamp: ''!
setController: aCvController andStartVersioning: aCodeBase 

	controller := aCvController.
	self adoptCodeBase: aCodeBase.
	self baseVersion: self saveCopyToNewVersion.
	[self registerForRefactoringSignals] valueBasedOn: self.
	self controller activateWorkingCopy: self.! !

!CvWorkingCopy methodsFor: 'merging' stamp: 'sp 1/23/2013 11:24:42.536'!
silentlyApplyPatch: aPatch
	"applies aPatch regardless of possibly side effects:
		- does not notify user about conflicts
		- does not notify user about aPatch leading to no actual effect.
		- keeps its changes when merging conlflicts
		- does inform user about missing requirements of aPatch"

	self pvtSilentlyApplyPatch: aPatch pretending: false.! !

!CvWorkingCopy methodsFor: 'versiong and rebasing' stamp: 'bs 7/25/2011 13:51:08.899'!
undoStack
	^ undoStack
		ifNil: [undoStack := Stack new]! !

!CvWorkingCopy methodsFor: 'as yet unclassified' stamp: 'bs 3/15/2011 18:55:07.307'!
version
	^ self baseVersion version! !

!CvWorkingCopy methodsFor: 'signals' stamp: 'bs 4/6/2011 18:46:19.806'!
versionSaved
	self emit! !

!PsCodeBase methodsFor: '*CV' stamp: 'bs 8/23/2011 16:37:10.72'!
adoptClass: aClass
	
	self dictionary 
		removeKey: aClass name ifAbsent: [];
		at: aClass name put: aClass.
	! !

!PsCodeBase methodsFor: '*CV' stamp: 'bs 2/3/2012 22:43:29.761'!
adoptCopyOfClass: aClass
	| copyOfClass |
	self assert: [aClass canBeLateBound].
	self assert: [aClass name ~= #Metaclass].
	
	copyOfClass := aClass copy.
	copyOfClass bindSuperclassTo: self.
	
	self metaclassClass adoptInstance: copyOfClass class.
	(copyOfClass class) adoptInstance: copyOfClass.
	
	self adoptClass: copyOfClass.
	^ copyOfClass! !

!PsCodeBase methodsFor: '*CV' stamp: 'bs 8/25/2011 15:53:17.186'!
adoptFlatCopyOfClass: aClass
	| copyOfClass |
	self assert: [aClass name ~= #Metaclass].
	
	copyOfClass := aClass copy.
	
	self metaclassClass adoptInstance: copyOfClass class.
	(copyOfClass class) adoptInstance: copyOfClass.
	
	copyOfClass superclass: (aClass superclass valueAt: self).
	self adoptClass: copyOfClass.
	^ copyOfClass! !

!PsCodeBase methodsFor: '*CV' stamp: 'bs 8/10/2011 16:04:57.218'!
copyWithClassesStartAt: aClassName
	| copyOfSelf |
	copyOfSelf := self copy.	
	(copyOfSelf classNamed: aClassName) 
		addCopyTo: copyOfSelf do: [  ].
	^ copyOfSelf! !

!PsCodeBase methodsFor: '*CV' stamp: 'bs 3/6/2011 20:33:03.606'!
isCvWorkingCopy
	^ false! !

!PsCodeBase methodsFor: '*CV' stamp: 'bs 8/30/2011 09:57:56.65'!
rebindAllClassReferences

	self basedOn: self do: [
		Smalltalk allClasses 
			reject: [:ea | #ObjectTracer = ea name ]
			thenDo: [:ea | ea cleanUpSubclasses. ea cleanUpSuperclass].
		
		LateClassBinding allSubInstances do: [:ea | ea value].
		LateValueBinding allSubInstances do: [:ea | ea value]].! !

!PsCodeBase methodsFor: '*CV' stamp: 'bs 5/11/2011 15:07:44.313'!
testCodeBase

	^ self! !

!PsCodeBase methodsFor: '*CV' stamp: 'bs 3/15/2011 18:49:41.553'!
version
	^ self dictionary version! !

!OBNode methodsFor: '*CV' stamp: ''!
backgroundColor

	^ nil! !

!OBNode methodsFor: '*CV' stamp: 'bs 8/12/2011 15:50:59.057'!
cvItemReference
	
	^ CvCodeReference nullReference! !

!OBNode methodsFor: '*CV' stamp: 'bs 3/26/2011 21:12:06.3'!
valueAt: aCodeBase
	
	^ self! !

!ClassDescription methodsFor: '*CV' stamp: 'bs 1/5/2012 15:20:39.725'!
cvSubclassesDo: aBlock

	self subclassesDo: aBlock! !

!ProtoObject class methodsFor: '*CV' stamp: 'bs 8/29/2011 09:54:39.103'!
addCopyTo: aCodeBase do: aBlock
	| copyOfSelf copyOfMetaclass |
	
	copyOfMetaclass := Metaclass copy.
	copyOfMetaclass adoptInstance: copyOfMetaclass class.
	aCodeBase metaclassClass: copyOfMetaclass.
	
	copyOfSelf := aCodeBase adoptCopyOfClass: self.
	
	self subclasses
		select: [ :ea | ea name = #Object ]
		thenDo: [ :ea | ea addCopyTo: aCodeBase do: aBlock].
		
	^ copyOfSelf! !

!ProtoObject class methodsFor: '*CV' stamp: 'bs 8/27/2011 14:02:01.671'!
checkoutTo: aWorkingCopy
	
	! !

!ProtoObject class methodsFor: '*CV' stamp: 'bs 8/23/2011 16:37:36.161'!
copyMetacircularObjects

	| copyOfBehavior copyOfClass copyOfClassDescription copyOfMetaclass copyOfObject copyOfProtoObject |
	copyOfProtoObject := ProtoObject copy.
	copyOfObject := Object copy.
	copyOfBehavior := Behavior copy.
	copyOfClassDescription := ClassDescription copy.
	copyOfClass := Class copy.
	copyOfMetaclass := Metaclass copy.
	
	{copyOfBehavior. copyOfClass. copyOfClassDescription. copyOfMetaclass. copyOfObject. copyOfProtoObject} 
		do: [:ea | 
			copyOfClass adoptInstance: ea.
			copyOfMetaclass adoptInstance: ea class ].
	
	copyOfProtoObject! !

!ProtoObject class methodsFor: '*CV' stamp: 'bs 8/23/2011 15:29:19.351'!
cvOriginal

	^ nil! !

!ProtoObject class methodsFor: '*CV' stamp: 'bs 8/23/2011 15:29:26.013'!
cvOriginal: anObject

! !

!ProtoObject class methodsFor: '*CV' stamp: 'bs 4/15/2011 14:19:37.925'!
parent
	^ self! !

!ProtoObject class methodsFor: '*CV' stamp: 'bs 8/22/2011 17:19:57.336'!
saveCopyTo: aVersion

	self assert: [self activeCodeBase isCvWorkingCopy].
	self assert: [aVersion isCvWorkingCopy not].
	
	self 
		addCopyTo: aVersion
		do: [:classInWc :classInVersion | classInWc cvOriginal: classInVersion].
		
	Object flushCache.! !

!OBFan methodsFor: '*CV' stamp: ''!
backgroundColorAt: aRowIndex

	^ (self children at: aRowIndex ifAbsent: [^ nil]) backgroundColor! !

!RenamedEvent methodsFor: '*CV' stamp: 'bs 8/29/2011 14:16:45.773'!
checkoutChangesTo: aWorkingCopy

	self isCategoryItem ifTrue: [^ self].
	self reboundParentItem checkoutCopyTo: aWorkingCopy! !

!RenamedEvent methodsFor: '*CV' stamp: 'bs 8/3/2012 17:53:41.548'!
cleanUpChangesTo: aVersion

	self copyOrganizationTo: aVersion.
	self isCategoryItem ifTrue: [^ self].
	aVersion dictionary removeKey: self oldName ifAbsent: [].
	self item parent saveFlatCopyTo: aVersion.
	self item saveHierarchyCopyTo: aVersion.! !

!RenamedEvent methodsFor: '*CV' stamp: 'bs 8/30/2011 11:51:27.572'!
includedInCheckoutOf: aClass

	^ self isCategoryItem or: self reboundParentItem = aClass! !

!RenamedEvent methodsFor: '*CV' stamp: 'bs 4/30/2012 12:51:08.173'!
itemToBeCheckedOut

	^ self reboundParentItem! !

!RenamedEvent methodsFor: '*CV' stamp: 'bs 8/23/2012 14:43:35.405'!
requiresCheckoutTo: aWorkingCopy

	^ ((self activeCodeBase hasClassNamed: self oldName)
		and: [aWorkingCopy hasClassNamed: self newName])
		or: [
			(self activeCodeBase hasClassNamed: self newName)
				and: [aWorkingCopy hasClassNamed: self oldName]].! !

!Behavior methodsFor: '*CV' stamp: ''!
superclassWithoutFlushingCache: aClass 
	"Change the receiver's superclass to be aClass."
	"Note: Do not use 'aClass isKindOf: Behavior' here
		in case we recompile from Behavior itself."
	(aClass == nil or: [aClass isBehavior])
		ifTrue: [superclass := aClass]
		ifFalse: [self error: 'superclass must be a class-describing object']! !

!Delay class methodsFor: '*CV' stamp: 'bs 5/22/2011 16:03:30.323'!
canBeLateBound
	
	^ false! !

!Exception class methodsFor: '*CV' stamp: 'bs 7/18/2012 17:00:16.674'!
canBeLateBound

	^ false! !

!MCVersion methodsFor: '*CV' stamp: 'FB 1/16/2013 18:49:06.616'!
existsInCvGraph
	"<^(true | false)>"
	"Answer whether there is a CvVersion in the image whose version info
	 is the same as the receiver's version info."
	
	^(World cvController versionsChronologically
		detect: [:v | v versionInfo mcVersionInfo = self info]
		ifNone: [nil]) isNil not! !

!MCVersion methodsFor: '*CV' stamp: 'FB 1/17/2013 11:41:09.186'!
findPrecedingCvVersion
	"<^(iOf: CvVersion)>"
	"Answer a CvVersion v where v mcVersion = my predecessor.
	 If none is present, assume initial version as predecessor."
	
	|ancestor controller|
	controller := World cvController.
	ancestor := self info ancestors 
		ifNil: [^controller initialVersion] 
		ifNotNil: [:coll | coll 
			ifEmpty: [controller initialVersion]
			ifNotEmpty: [coll first]]. "FIXME what if this is a merge with several ancestors?"
	^controller versionsChronologically 
		detect: [:v | v versionInfo mcVersionInfo = ancestor]
		ifNone: [controller initialVersion]! !

UiTreeView subclass: #CvBrowserTreeView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

!CvBrowserTreeView methodsFor: 'as yet unclassified' stamp: 'bs 11/16/2012 14:26:46.272'!
addColumn: headerText textSelector: aSymbol
	
	self addColumn: (CvItemViewColumnSpec new
		headerText: headerText;
		textSelector: aSymbol).! !

!CvBrowserTreeView methodsFor: 'as yet unclassified' stamp: 'bs 11/16/2012 15:29:25.619'!
initialize

	super initialize.
	vHeaderScroller color: Color solarizedBase3Brwhite..
	hHeaderScroller color: Color solarizedBase3Brwhite.
	self color: Color solarizedBase3Brwhite.! !

!CvBrowserTreeView methodsFor: 'model - callbacks' stamp: 'bs 6/24/2012 16:20:02.378'!
overrideMenuTarget: aMenuItem

	^ self! !

!CvBrowserTreeView methodsFor: 'accessing - private' stamp: 'bs 7/29/2011 15:14:52.878'!
viewportClass

	^ CvBrowserTreeViewport! !

!Class class methodsFor: '*CV' stamp: 'bs 4/30/2012 16:46:51.094'!
addCopyTo: aCodeBase do: aBlock
	| copyOfSelf protoObjectClass |
	copyOfSelf := aCodeBase adoptCopyOfClass: self.
	copyOfSelf superclass addSubclass: copyOfSelf.
	
	protoObjectClass := (aCodeBase dictionary at: #ProtoObject).
	protoObjectClass bindSuperclassTo: aCodeBase.
	copyOfSelf addSubclassOrReplaceEquallyNamedWith: protoObjectClass class.

	^ copyOfSelf! !

!Class class methodsFor: '*CV' stamp: 'bs 8/27/2011 17:14:40.07'!
cleanUpSubclasses

	self pvtSubclasses: (
		self pvtSubclasses collect: [:ea | 
			(self environment classNamed: 
				ea theNonMetaClass name) theMetaClass])! !

!Class class methodsFor: '*CV' stamp: 'bs 1/5/2012 15:20:50.805'!
cvSubclassesDo: aBlock

	"not doing anything here"! !

!Class class methodsFor: '*CV' stamp: 'bs 4/30/2012 11:43:13.428'!
saveFlatCopyTo:	 aVersion 
	| copyOfSelf protoObjectClass |
	copyOfSelf := aVersion adoptCopyOfClass: self.
	
	protoObjectClass := (aVersion dictionary at: #ProtoObject).
	copyOfSelf addSubclass: protoObjectClass class.
	
	^ copyOfSelf! !

!Class methodsFor: '*CV' stamp: 'bs 4/30/2012 16:45:27.584'!
addSubclassOrReplaceEquallyNamedWith: newSubclass

	self pvtSubclasses copy 
		select: [:ea | ea name = newSubclass name]
		thenDo: [:ea | self removeSubclass: ea].
	self addSubclass: newSubclass.! !

!Class methodsFor: '*CV' stamp: 'bs 1/18/2012 14:27:45.538'!
asMcDefinition

	^ self asClassDefinition! !

!Class methodsFor: '*CV' stamp: 'bs 8/30/2011 09:59:03.943'!
bindSuperclassTo: aCodeBase
	| reboundSuperclass |
	(self name = #ProtoObject) ifTrue: [
		"ProtoObject lacks a superclass, the property is set to nil"
		self class superclassWithoutFlushingCache: (Class valueAt: aCodeBase).
		^ self].
	
	reboundSuperclass := self superclass valueAt: aCodeBase.
	self assert: [reboundSuperclass notNil].
	self superclassWithoutFlushingCache: reboundSuperclass.
	self class superclassWithoutFlushingCache: reboundSuperclass class! !

!Class methodsFor: '*CV' stamp: 'bs 8/29/2011 10:31:29.903'!
checkoutCopyTo: aWorkingCopy
	
	self checkoutCopyTo: aWorkingCopy do: []! !

!Class methodsFor: '*CV' stamp: 'bs 4/30/2012 16:33:11.817'!
checkoutCopyTo: aWorkingCopy do: aBlock
	
	self assert: [self activeCodeBase isCvWorkingCopy not].
	self assert: [aWorkingCopy isCvWorkingCopy].
	
	self 
		addCopyTo: aWorkingCopy	
		do: [:classFromSource :classInWc | 
			aBlock cull: classFromSource cull: classInWc.
			classInWc cvOriginal: classFromSource ].
	
	Object flushCache.! !

!Class methodsFor: '*CV' stamp: 'bs 8/27/2011 17:11:11.563'!
cleanUpSubclasses

	self pvtSubclasses: (self pvtSubclasses copy 
		select: [:ea | self environment hasClassNamed: ea name]
		thenCollect: [:ea | self environment classNamed: ea name]) asIdentitySet asArray.! !

!Class methodsFor: '*CV' stamp: 'bs 8/30/2011 09:33:57.617'!
cleanUpSuperclass

	self bindSuperclassTo: self activeCodeBase! !

!Class methodsFor: '*CV' stamp: 'bs 3/21/2011 18:30:43.551'!
cvCategory

	^ self category
	! !

!Class methodsFor: '*CV' stamp: 'bs 7/13/2011 14:26:17.897'!
rebindBlock

	name := self name.
	^ [:aCodeBase | aCodeBase classNamed: name]! !

!Class methodsFor: '*CV-override' stamp: 'bs 8/3/2012 18:07:40.99'!
rename: aString 
	"The new name of the receiver is the argument, aString."

	| oldName newName |
	(newName := aString asSymbol) = (oldName := self name)
		ifTrue: [^ self].
	(self environment includesKey: newName)
		ifTrue: [^ self error: newName , ' already exists'].
	(Undeclared includesKey: newName)
		ifTrue: [self inform: 'There are references to, ' , aString printString , '
from Undeclared. Check them after this change.'].
	name := newName.
	self copyAndRebindAllMethods.
	self environment renameClass: self from: oldName! !

!Class methodsFor: '*CV' stamp: 'bs 8/23/2012 11:50:28.175'!
requiresReCheckoutTo: aWorkingCopy

	^ (self valueAt: aWorkingCopy) isNil
		or: [self ~~ (self valueAt: aWorkingCopy) cvOriginal]! !

!Class methodsFor: '*CV' stamp: 'bs 4/30/2012 11:42:58.575'!
saveFlatCopyTo:	 aVersion
	| copyOfSelf |
	copyOfSelf := aVersion adoptCopyOfClass: self.
	self subclasses do: [:ea | 
		(ea valueAt: aVersion) 
			ifNil: [copyOfSelf addSubclass: ea] "will be added to the version later"
			ifNotNil: [:aSubclass | 
				copyOfSelf addSubclass: aSubclass]].
	self cvOriginal: copyOfSelf.
	^ copyOfSelf! !

!Class methodsFor: '*CV' stamp: 'bs 8/27/2011 15:37:12.477'!
saveHierarchyCopyTo: aVersion

	self assert: [self activeCodeBase isCvWorkingCopy].
	self assert: [aVersion isCvWorkingCopy not].
	
	self 
		addCopyTo: aVersion
		do: [:classInWc :classInVersion | classInWc cvOriginal: classInVersion].! !

!CommentedEvent methodsFor: '*CV' stamp: 'bs 8/25/2011 15:58:54.574'!
changedMetaObject

	^ item! !

!CommentedEvent methodsFor: '*CV' stamp: 'bs 8/29/2011 14:02:03.355'!
checkoutChangesTo: aWorkingCopy

	(self cvItemReference bind: aWorkingCopy)
		organization: (
			self reboundItem organization deepCopy)! !

!CommentedEvent methodsFor: '*CV' stamp: 'bs 8/26/2011 13:45:04.051'!
cleanUpChangesTo: aVersion

	self copyOrganizationTo: aVersion.
	self item saveFlatCopyTo: aVersion.
	! !

!CommentedEvent methodsFor: '*CV' stamp: 'bs 8/30/2011 11:51:27.581'!
includedInCheckoutOf: aClass

	^ self reboundItem = aClass! !

!CommentedEvent methodsFor: '*CV' stamp: 'bs 4/30/2012 11:49:21.377'!
itemToBeCheckedOut

	^ self reboundItem! !

!CommentedEvent methodsFor: '*CV' stamp: 'bs 7/14/2011 18:21:18.345'!
oldComment

	^ self slotNamed: 'oldComment'! !

!CommentedEvent methodsFor: '*CV' stamp: 'bs 7/14/2011 18:20:49.021'!
oldComment: aString

	self slotNamed: 'oldComment' put: aString! !

!CommentedEvent methodsFor: '*CV' stamp: 'bs 8/23/2012 13:48:12.844'!
requiresCheckoutTo: aWorkingCopy

	^ (self cvItemReference bind: self activeCodeBase)
		ifNil: [false] 
		ifNotNil: [:boundItem |
			boundItem requiresReCheckoutTo: aWorkingCopy]! !

MCSnapshot subclass: #CvSnapshot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV'!

!CvSnapshot class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.091'!
canBeLateBound
	^ false! !

!CvSnapshot methodsFor: 'as yet unclassified' stamp: 'bs 4/14/2011 12:56:40.659'!
patchRelativeToBase: aSnapshot
	^ CvPatch fromBase: aSnapshot target: self! !

PsBaseWindow subclass: #CvWorkingEnvironment
	instanceVariableNames: 'versionBar workingCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI'!

!CvWorkingEnvironment class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.174'!
canBeLateBound
	^ false! !

!CvWorkingEnvironment class methodsFor: 'as yet unclassified' stamp: 'TM 4/5/2011 15:33:23.9'!
forWorkingCopy: aWorkingCopy

	^ self basicNew initializeWithWorkingCopy: aWorkingCopy! !

!CvWorkingEnvironment methodsFor: 'as yet unclassified' stamp: 'bs 5/15/2011 18:14:35.522'!
browseLastChange
	self addWindow: self workingCopy baseVersion browseChange! !

!CvWorkingEnvironment methodsFor: 'as yet unclassified' stamp: 'bs 5/15/2011 18:14:27.33'!
browseSelection: anOBNode
	self addWindow: (OBSystemBrowser selection: anOBNode) open! !

!CvWorkingEnvironment methodsFor: 'accessing' stamp: 'bs 5/9/2011 20:52:19.762'!
controller
	^ self workingCopy controller! !

!CvWorkingEnvironment methodsFor: 'as yet unclassified' stamp: 'bs 5/19/2011 20:36:08.927'!
delete
	super delete.
	self workingCopy ifNotNil: [:wc |
		wc disconnectSignal: #rebasedFrom:to: from: self].
	versionBar delete.
	versionBar := nil.
	workingCopy := nil.! !

!CvWorkingEnvironment methodsFor: 'as yet unclassified' stamp: 'bs 4/12/2011 14:22:15.851'!
initialExtent

	^ 750@600! !

!CvWorkingEnvironment methodsFor: 'as yet unclassified' stamp: 'bs 5/9/2011 19:46:25.897'!
initializeWithWorkingCopy: aWorkingCopy
	
	self 
		initializeWithCodeBase: aWorkingCopy;
		workingCopy: aWorkingCopy;
		connect: World signal: #addedMorph: toSelector: #worldAddedMorph: .
	
	versionBar := CvVersionBar controller: aWorkingCopy controller.
	self paneMorph addMorph: versionBar.! !

!CvWorkingEnvironment methodsFor: 'as yet unclassified' stamp: ''!
noteNewOwner: aMorph

	super noteNewOwner: aMorph.
	self workingCopy referenceWC: self workingCopyOfParent ! !

!CvWorkingEnvironment methodsFor: 'as yet unclassified' stamp: 'bs 7/24/2012 11:14:16.653'!
recreateVersionBar

	self versionBar delete.
	self versionBar: (CvVersionBar controller: self controller).
	self paneMorph addMorph: self versionBar.! !

!CvWorkingEnvironment methodsFor: 'accessing' stamp: 'bs 7/24/2012 11:04:26.555'!
versionBar

	^ versionBar! !

!CvWorkingEnvironment methodsFor: 'accessing' stamp: 'bs 7/24/2012 11:09:54.562'!
versionBar: anObject

	versionBar := anObject! !

!CvWorkingEnvironment methodsFor: 'accessing' stamp: 'bs 3/25/2011 20:27:07.394'!
workingCopy
	^ workingCopy! !

!CvWorkingEnvironment methodsFor: 'accessing' stamp: 'bs 3/25/2011 20:26:59.345'!
workingCopy: anObject
	workingCopy := anObject! !

!CvWorkingEnvironment methodsFor: 'as yet unclassified' stamp: ''!
workingCopyOfParent

	^ self owner ifNotNil: [:m | m cvWorkingCopy]! !

!CvWorkingEnvironment methodsFor: 'as yet unclassified' stamp: 'bs 5/15/2011 18:14:18.457'!
worldAddedMorph: aMorph
	self = aMorph ifTrue: [^ self].
	aMorph isSystemWindow ifFalse: [^ self].
	(self containsPoint: ActiveHand position) ifFalse: [^ self].
	
	(self = TopWindow or: [self paneMorph submorphs includes: TopWindow]) 
		ifTrue: [self addWindow: aMorph]! !

!PasteUpMorph methodsFor: '*CV' stamp: 'bs 3/8/2011 09:30:19.602'!
cvController

	^ worldState cvController! !

!PasteUpMorph methodsFor: '*CV' stamp: 'bs 3/8/2011 09:31:43.238'!
cvController: aCvController

	worldState cvController: aCvController! !

!PasteUpMorph methodsFor: '*CV' stamp: 'bs 1/5/2012 15:07:58.522'!
cvInstall

	self cvInstallWithPkgNamed: (
		UIManager default 
			request: 'Package under development?' 
			initialAnswer: '').! !

!PasteUpMorph methodsFor: '*CV' stamp: 'bs 8/1/2012 15:35:18.099'!
cvInstallWithPkg: package
	| aWc |
	self 
		assert: self cvController isNil 
		description: 'ContinuousVersioning is already installed'.
	
	self cvController: (
		CvController 
			notifier: SystemChangeNotifier uniqueInstance
			polySource: self polySource).
	
	Preferences 
		enable: #systemWindowEmbedOK;
		disable: #fastDragWindowForMorphic.
	
	self cvController install.
	self cvController package: package.
	aWc := self cvController startVersioning: self polySource originalCodeBase.
	
	self cvVersionBar: nil. "ensure corresponding inst vars exist in this codebase"
	
	self psRebaseTo: aWc.
	self basedOn: aWc do: [
		self cvVersionBar: (CvVersionBar controller: self cvController).
		self cvVersionBar openInWorld: self].
	
	self setProperty: #cvIsInstalled toValue: true.! !

!PasteUpMorph methodsFor: '*CV' stamp: 'FB 1/17/2013 12:05:49.248'!
cvInstallWithPkgNamed: aName

	self cvInstallWithPkg: ( 
		PackageOrganizer default
			packageNamed: aName
			ifAbsent: [self informAboutInvalidPackageName. ^ self] ).
	self cvController tryToSetInitialMCVersionInfo! !

!PasteUpMorph methodsFor: '*CV' stamp: 'bs 8/1/2012 15:36:24.369'!
cvIsInstalled 

	^ self valueOfProperty: #cvIsInstalled ifAbsent: [false]! !

!PasteUpMorph methodsFor: '*CV' stamp: 'bs 8/1/2012 10:53:37.066'!
cvRecreateVersionBar

	self cvVersionBar delete.
	self cvVersionBar: (CvVersionBar controller: self cvController).
	self cvVersionBar openInWorld: self! !

!PasteUpMorph methodsFor: '*CV' stamp: 'bs 8/24/2012 13:25:34.369'!
cvUninstall

	self setProperty: #cvIsInstalled toValue: false.
	self cvController ifNil: [^ self].
	
	self cvVersionBar ifNotNil: [ :bar | bar delete].
	self cvVersionBar: nil.
	
	self assert: [self activeCodeBase isCvWorkingCopy].
	self polySource originalCodeBase organization: self activeCodeBase organization.
	
	self psRebaseTo: self polySource originalCodeBase.
	self basedOn: self polySource originalCodeBase do: [
		Smalltalk allClasses do: [:ea | ea cleanUpSubclasses].
		LateValueBinding allSubInstancesDo: [:ea | ea value].
		LateClassBinding allSubInstancesDo: [:ea | ea value]].
		
	self cvController uninstall.
	self cvController: nil! !

!PasteUpMorph methodsFor: '*CV' stamp: 'bs 5/13/2011 19:48:06.206'!
cvVersionBar

	^ worldState cvVersionBar! !

!PasteUpMorph methodsFor: '*CV' stamp: 'bs 5/13/2011 19:47:44.771'!
cvVersionBar: aVersionBar

	worldState cvVersionBar: aVersionBar! !

!PasteUpMorph methodsFor: '*CV' stamp: 'bs 5/13/2011 19:35:26.362'!
informAboutInvalidPackageName
	
	UIManager default 
		inform: 'There does not exist a package with the specified name'.! !

!PasteUpMorph methodsFor: '*CV' stamp: 'bs 5/13/2011 19:14:34.814'!
mergeChangesToOriginalCodeBase
	| aWc pkg org merger orgSnapshot patch wcSnapshot |
	self assert: [self activeCodeBase isCvWorkingCopy].
	aWc := self activeCodeBase.
	pkg := CvPackage named: self cvController package name.
	org := World polySource originalCodeBase.
	wcSnapshot := [pkg snapshot] valueBasedOn: aWc.
	orgSnapshot := [pkg snapshot] valueBasedOn: org.
	patch := wcSnapshot patchRelativeToBase: orgSnapshot.

	self basedOn: org do: [
		merger := MCThreeWayMerger new.
		merger addBaseSnapshot: orgSnapshot.
		merger applyPatch: patch.
		merger load]! !

!MCRepository methodsFor: '*CV' stamp: 'FB 1/17/2013 12:04:42.42'!
freshVersionsForPackageNamed: aString
	"<aString: iOf String, ^iOf: (OrderedCollection of: MCVersion)>"
	"Answer a chronologically ordered collection of versions in this repository 
	 that are newer than the ancestor of the initial CV version.
	 Precondition: controller's initial version is not nil."
	
	|versions oldest|
	versions := self sortedVersionsForPackageNamed: aString.
	oldest := World cvController initialVersion versionInfo mcVersionInfo.
	^versions select: [:v | (v info date > oldest date) or: 
		[(v info date = oldest date) and: [v info time > oldest time]]]! !

!MCRepository methodsFor: '*CV' stamp: 'sp 1/28/2013 14:46:20.299'!
sortedVersionsForPackageNamed: aString
	"<aString: iOf String, ^iOf: (OrderedCollection of: MCVersion)>"
	"Answer a chronologically ordered collection of all versions in 
	 the repository that belong to the given package"
	
	^(((self allVersionNames
		select: [ :ea | aString size <= ea size and: 
			[aString = (ea copyFrom: 1 to: aString size)]])
		collect: [ :ea | self versionNamed: ea]) 
		"select: [ :ea | ea package name = aString]")
		sortBy: [ :e1 :e2 | (e1 info date < e2 info date) or: 
			[(e1 info date = e2 info date) and: [e1 info time < e2 info time]]]! !

!MethodChangeRecord class methodsFor: '*CV' stamp: 'bs 4/15/2011 23:08:12.701'!
canBeLateBound
	^ false! !

Morph subclass: #CvAppMorph
	instanceVariableNames: 'workingCopy appCodeBase label followsWorkingCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI'!

!CvAppMorph class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.009'!
canBeLateBound
	^ false! !

!CvAppMorph class methodsFor: 'as yet unclassified' stamp: 'bs 4/13/2011 11:39:14.518'!
wrap: aMorph

	^ self basicNew initializeWithMorph: aMorph! !

!CvAppMorph methodsFor: 'as yet unclassified' stamp: 'bs 4/13/2011 13:37:23.086'!
followsWorkingCopy

	^ followsWorkingCopy! !

!CvAppMorph methodsFor: 'as yet unclassified' stamp: 'bs 4/13/2011 13:37:38.425'!
initializeWithMorph: aMorph

	self assert: PsActiveCodeBase value isCvWorkingCopy.
	workingCopy := PsActiveCodeBase value.
	appCodeBase := workingCopy baseVersion.
	self startFollowingWorkingCopy.
	self psRebaseTo: workingCopy.

	self connect: workingCopy signal: #versionSaved toSelector: #versionSaved.
	self connect: workingCopy signal: #rebasedFrom:to: toSelector: #rebasedFrom:to: .
	
	self 
		initialize;
		changeTableLayout;
		listDirection: #bottomToTop;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		color: Color transparent;
		borderColor: Color red;
		borderWidth: 0.
	
	aMorph
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	
	label := TextMorph new.
	self updateLabel.
	
	self 
		addMorphBack: aMorph;
		addMorphBack: (
			(self inARow: {
				label})
				hResizing: #spaceFill;
				vResizing: #rigid;
				wrapCentering: #topLeft;
				height: 25).! !

!CvAppMorph methodsFor: 'as yet unclassified' stamp: 'bs 4/13/2011 18:20:14.615'!
rebasedFrom: oldBaseVersion to: newBaseVersion
	
	self followsWorkingCopy
		ifTrue: [
			self stopFollowingWorkingCopy]! !

!CvAppMorph methodsFor: 'as yet unclassified' stamp: 'bs 4/13/2011 13:45:01.097'!
startFollowingWorkingCopy

	followsWorkingCopy := true.
	self psRebaseTo: workingCopy.
	self borderWidth: 0.! !

!CvAppMorph methodsFor: 'as yet unclassified' stamp: 'bs 4/13/2011 18:21:02.294'!
stopFollowingWorkingCopy

	followsWorkingCopy := false.
	self 
		psRebaseTo: appCodeBase;
		borderWidth: 2;
		updateLabel! !

!CvAppMorph methodsFor: 'as yet unclassified' stamp: 'bs 4/13/2011 18:20:44.978'!
updateLabel
	
	label contents: self psCodeBase asString ! !

!CvAppMorph methodsFor: 'as yet unclassified' stamp: 'bs 4/13/2011 13:37:09.123'!
versionSaved
	
	self followsWorkingCopy
		ifTrue: [
			appCodeBase := workingCopy baseVersion.
			self updateLabel]! !

Morph subclass: #CvBranchPoint
	instanceVariableNames: 'point branch group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Bar'!

CvBranchPoint subclass: #CvBranchEndPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Bar'!

!CvBranchEndPoint class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.023'!
canBeLateBound
	^ false! !

!CvBranchEndPoint methodsFor: 'as yet unclassified' stamp: 'bs 10/1/2012 14:38:26.362'!
initialize

	super initialize.
	self point right: self width - 1.
	self addMorphBack: (Morph new color: Color transparent; extent: 1@6).
	self addMorph: (Morph new color: Color transparent; extent: 6@6).
	! !

!CvBranchEndPoint methodsFor: 'as yet unclassified' stamp: 'bs 10/1/2012 17:04:45.223'!
mouseDown: evt

	self branch showSubbranches.! !

!CvBranchPoint class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.027'!
canBeLateBound
	^ false! !

!CvBranchPoint class methodsFor: 'as yet unclassified' stamp: 'bs 4/18/2011 22:00:51.172'!
endPointFor: aBranch

	^ CvBranchEndPoint new initializeWithBranch: aBranch! !

!CvBranchPoint class methodsFor: 'as yet unclassified' stamp: 'TM 4/11/2011 17:47:31.93'!
for: aBranch

	^ self new initializeWithBranch: aBranch! !

!CvBranchPoint class methodsFor: 'as yet unclassified' stamp: 'bs 4/18/2011 22:00:56.897'!
startPointFor: aBranch

	^ CvBranchStartPoint new initializeWithBranch: aBranch! !

!CvBranchPoint methodsFor: 'as yet unclassified' stamp: 'TM 4/11/2011 17:46:34.703'!
branch

	^branch! !

!CvBranchPoint methodsFor: 'as yet unclassified' stamp: 'TM 4/11/2011 17:46:29.493'!
branch: aVersionBranch

	branch := aVersionBranch! !

!CvBranchPoint methodsFor: 'as yet unclassified' stamp: 'bs 4/18/2011 22:04:37.158'!
clicked: evt! !

!CvBranchPoint methodsFor: 'as yet unclassified' stamp: 'TM 4/11/2011 18:13:50.689'!
glow

	self point color: Color orange! !

!CvBranchPoint methodsFor: 'as yet unclassified' stamp: 'TM 4/11/2011 17:50:51.947'!
group

	^ group! !

!CvBranchPoint methodsFor: 'as yet unclassified' stamp: 'TM 4/11/2011 17:50:34.209'!
group: aSet

	group := aSet! !

!CvBranchPoint methodsFor: 'as yet unclassified' stamp: 'TM 4/11/2011 18:19:25.612'!
highlightGroup

	self group do: [ :branchPoint | branchPoint glow]! !

!CvBranchPoint methodsFor: 'as yet unclassified' stamp: 'bs 11/9/2012 14:08:07.551'!
initialize

	super initialize.
	self
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #rigid;
		hResizing: #shrinkWrap;
		extent: 6@6;
		color: Color transparent;
		point: (CircleMorph new extent: 6@6; color: Color white; borderColor: Color white; borderWidth: 2; center: self center);
		group: (Set new add: self; yourself);
		addMorph: self point.
		
	self eventHandler: UiEventHandler new.
	self connect: self eventHandler signal: #mouseClicked: toSelector: #clicked:.! !

!CvBranchPoint methodsFor: 'as yet unclassified' stamp: 'bs 10/1/2012 13:46:02.855'!
initializeWithBranch: aBranch

	self 
		initialize;
		branch: aBranch.! !

!CvBranchPoint methodsFor: 'as yet unclassified' stamp: 'TM 4/12/2011 08:56:43.301'!
mouseDown: anEvent

	self highlightGroup
	! !

!CvBranchPoint methodsFor: 'as yet unclassified' stamp: 'bs 11/9/2012 13:08:59.614'!
mouseDownPriority

	^ 2! !

!CvBranchPoint methodsFor: 'as yet unclassified' stamp: 'TM 4/11/2011 18:16:12.862'!
mouseEnter: anEvent

	self highlightGroup
	! !

!CvBranchPoint methodsFor: 'as yet unclassified' stamp: 'TM 4/11/2011 18:16:33.311'!
mouseLeave: anEvent

	self normalizeGroup
	! !

!CvBranchPoint methodsFor: 'as yet unclassified' stamp: 'TM 4/11/2011 18:15:18.534'!
normalize

	self point color: Color white! !

!CvBranchPoint methodsFor: 'as yet unclassified' stamp: 'TM 4/11/2011 18:19:36.952'!
normalizeGroup

	self group do: [ :branchPoint | branchPoint normalize]! !

!CvBranchPoint methodsFor: 'as yet unclassified' stamp: 'TM 4/11/2011 17:45:42.41'!
point

	^ point! !

!CvBranchPoint methodsFor: 'as yet unclassified' stamp: 'TM 4/11/2011 17:45:34.868'!
point: aMorph

	point := aMorph! !

CvBranchPoint subclass: #CvBranchStartPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Bar'!

!CvBranchStartPoint class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.031'!
canBeLateBound
	^ false! !

!CvBranchStartPoint methodsFor: 'as yet unclassified' stamp: 'bs 5/9/2011 23:07:09.378'!
clicked: evt
	self branch hide! !

!CvBranchStartPoint methodsFor: 'as yet unclassified' stamp: 'bs 10/1/2012 14:38:33.903'!
initialize

	super initialize.
	self point left: 1.
	self addMorphBack: (Morph new color: Color transparent; extent: 6@6).
	self addMorph: (Morph new color: Color transparent; extent: 1@6).! !

!CvBranchStartPoint methodsFor: 'as yet unclassified' stamp: 'bs 5/5/2011 19:40:29.273'!
mouseDown: evt
	self branch hide.! !

Morph subclass: #CvBrowser
	instanceVariableNames: 'ui hoverView model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

!CvBrowser methodsFor: 'as yet unclassified' stamp: 'bs 12/26/2012 18:37:23.719'!
configureTreeView
	self ui treeView 
		addColumn: ' ' for: (
			CvItemViewColumnSpec newFrom: {
				#text -> #description. #menu -> #menu});
		"addColumn: 'Category' textSelector: #affectedClassCategory;"
		addColumn: 'Time' textSelector: #timeCreated;
		addColumn: 'Class' textSelector: #affectedClassName;
		addColumn: 'Method' textSelector: #affectedMethodName;
		addColumn: 'Branching' for: CvBrowserBranchColumnSpec new;
		addColumn: ' ' for: (
			UiItemViewColumnSpec newFrom: {#icon -> #currentBaseIcon});
		addColumn: ' ' for: (
			UiItemViewColumnSpec newFrom: {
				#checked -> #isChecked.
				#checkable -> #isCheckable});
		addColumn: 'Test Res.' for: CvBrowserTestResultColumnSpec new;
		addColumn: 'Test Chg.' for: CvBrowserTestChangesColumnSpec new;
		setVAlignmentForColumn: 8 to: #center.! !

!CvBrowser methodsFor: 'as yet unclassified' stamp: ''!
createAndSetModel

	model := CvBrowserTreeModel controller: World cvController.
	self ui treeView model: model root.! !

!CvBrowser methodsFor: 'as yet unclassified' stamp: 'bs 1/23/2012 13:27:17.157'!
currentVersionChanged: aVersionOrGroup
	
	self updateScreenshot: aVersionOrGroup.
	self updatePatchView: aVersionOrGroup.
	self updateChangeDetailsView: aVersionOrGroup.! !

!CvBrowser methodsFor: 'as yet unclassified' stamp: ''!
cvController

	^ World cvController! !

!CvBrowser methodsFor: 'as yet unclassified' stamp: 'bs 7/26/2011 19:06:11.154'!
deleteHoverView

	hoverView ifNotNil: [
		hoverView delete.
		hoverView := nil]! !

!CvBrowser methodsFor: 'as yet unclassified' stamp: 'FB 1/22/2013 15:18:13.053'!
fetchRemoteChanges

	World cvController fetchRemoteChanges.! !

!CvBrowser methodsFor: 'as yet unclassified' stamp: 'pt 1/17/2013 16:06:35.262'!
initialize
	self assert: [World cvIsInstalled].
	super initialize.
	self ui setupUi: self.
	self configureTreeView.
	self createAndSetModel.
	self connect: self ui treeView signal: #currentNodeChanged: toSelector: #currentVersionChanged:.
	self connect: self activeWorkingCopy signal: #rebasedFrom:to: toSelector: #rebasedFrom:to:.
	self connect: self ui fetchChangesButton signal: #pressed toSelector: #fetchRemoteChanges! !

!CvBrowser methodsFor: 'as yet unclassified' stamp: 'bs 8/17/2011 17:19:42.358'!
open
 	(self openInWindowLabeled: 'Continuous Versions Browser')
		model: model! !

!CvBrowser methodsFor: 'as yet unclassified' stamp: ''!
rebasedFrom: oldVersion to: newVersion 
	
	self ui treeView changeAllItems! !

!CvBrowser methodsFor: 'as yet unclassified' stamp: 'bs 7/26/2011 19:06:11.504'!
treeHovered: aModelIndex
	| summary |
	self deleteHoverView.
	summary := (aModelIndex valueOfProperty: #version) summaryView.
	hoverView := (self inARow: {summary})
		color: Color yellow paler muchLighter;
		openInWorld;
		topLeft: ActiveHand position + (10@10)! !

!CvBrowser methodsFor: 'as yet unclassified' stamp: 'bs 7/26/2011 19:06:11.562'!
treeMouseLeft: evt

	self deleteHoverView! !

!CvBrowser methodsFor: 'as yet unclassified' stamp: 'pt 1/16/2013 14:37:10.462'!
ui
  ^ ui ifNil: [ui := CvBrowserUiMod new]! !

!CvBrowser methodsFor: 'as yet unclassified' stamp: 'bs 1/23/2012 13:28:50.149'!
updateChangeDetailsView: aVersionOrGroup

	self ui changeDetails theText: aVersionOrGroup changeAsText! !

!CvBrowser methodsFor: 'as yet unclassified' stamp: 'bs 2/26/2012 10:40:09.067'!
updatePatchView: aVersionOrGroup
	| patchView aVersion thePatch |
	self ui patchViewContainer removeAllMorphs.
	aVersion := aVersionOrGroup.
	aVersionOrGroup isVersionGroup 
		ifTrue: [aVersion := aVersionOrGroup lastVersion].
	
	thePatch := self activeCodeBase baseVersion patchRelativeToBase: aVersion.
	patchView := 
		(MCPatchBrowser forPatch: thePatch) buildPane
			borderWidth: 0;
			hResizing: #spaceFill;
			vResizing: #spaceFill.
	self ui patchViewContainer addMorph: patchView
	! !

!CvBrowser methodsFor: 'as yet unclassified' stamp: 'bs 1/23/2012 13:27:32.449'!
updateScreenshot: aVersionOrGroup
	| sketchMorph |
	self ui screenshotContainer removeAllMorphs.
	sketchMorph := aVersionOrGroup screenshot.
	sketchMorph frameFractions: (0@0 corner: 1@1).
	sketchMorph extent: self ui screenshotContainer extent.
	self ui screenshotContainer addMorph: sketchMorph
	! !

CvBrowser subclass: #CvCommitBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Commit'!

!CvCommitBrowser methodsFor: 'as yet unclassified' stamp: ''!
configureTreeView

	self ui treeView 
		addColumn: 'Commit Message' for: (
			CvCommitTextColumn newFrom: {
				#text -> #commitMessage. #menu -> #menu});
		addColumn: ' ' for: (
			UiItemViewColumnSpec newFrom: {#icon -> #currentBaseIcon})! !

!CvCommitBrowser methodsFor: 'as yet unclassified' stamp: ''!
createAndSetModel
	| root |
	root := CvRootGroup new.
	self cvController versionsChronologically 
		select: [:ea | ea commitMessage notNil]
		thenDo: [:ea | root insert: ea].
	self ui treeView model: root.! !

!CvCommitBrowser methodsFor: 'as yet unclassified' stamp: ''!
currentVersionChanged: aVersionOrGroup
	
	self updatePatchView: aVersionOrGroup.! !

!CvCommitBrowser methodsFor: 'as yet unclassified' stamp: ''!
cvController

	^ World cvController! !

!CvCommitBrowser methodsFor: 'as yet unclassified' stamp: ''!
initialize
	super initialize.
	self ui menu delete.
	self ui changeDetails delete.
	self ui screenshotContainer delete.
	self ui rightColumnContainer width: 450.
	self width: 1000.
	self connect: self activeWorkingCopy signal: #rebasedFrom:to: toSelector: #rebasedFrom:to:.! !

!CvCommitBrowser methodsFor: 'as yet unclassified' stamp: ''!
open
 	self openInWindowLabeled: 'Commit Browser'! !

!CvCommitBrowser methodsFor: 'as yet unclassified' stamp: ''!
rebasedFrom: oldVersion to: newVersion 
	
	self ui treeView changeAllItems! !

Morph subclass: #CvChronoEmptyLane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Bar'!

!CvChronoEmptyLane class methodsFor: 'as yet unclassified' stamp: 'bs 10/1/2012 14:07:02.567'!
canBeLateBound

	^ false! !

!CvChronoEmptyLane methodsFor: 'as yet unclassified' stamp: 'bs 11/9/2012 14:13:51.689'!
drawOn: aCanvas

	super drawOn: aCanvas.
	aCanvas 
		line: self left@(self top + (self height/2) rounded) 
		to: self right@(self top + (self height/2) rounded) 
		width: 1
		color: Color white
		dashLength: 3
		secondColor: Color transparent
		secondDashLength: 3
		startingOffset: 0! !

!CvChronoEmptyLane methodsFor: 'as yet unclassified' stamp: 'bs 11/9/2012 14:20:31.167'!
initialize

	super initialize.
	self 
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		rubberBandCells: true;
		extent: 1@24;
		color: (Color transparent)! !

!CvChronoEmptyLane methodsFor: 'as yet unclassified' stamp: 'bs 10/1/2012 16:08:50.888'!
isVisible 

	^ true! !

Morph subclass: #CvChronoItem
	instanceVariableNames: 'numberOfLanes itemPosition timeLane predecessor successor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Bar'!

CvChronoItem subclass: #CvChronoGroupItem
	instanceVariableNames: 'branch versionItems container timeBeginMorph timeEndMorph count groupNode itemLane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Bar'!

!CvChronoGroupItem class methodsFor: 'as yet unclassified' stamp: 'TM 5/6/2011 10:48:28.235'!
for: aVersionItem

	^ self new appendVersionItem: aVersionItem! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/6/2011 10:42:49.424'!
addVersionBack: aVersion

	self container addMorphBack: aVersion.! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/12/2011 15:24:20.313'!
appendVersionItem: aVersionItem

	self versionItems add: aVersionItem.
	self branch releaseItem: aVersionItem.
	self linkSuccessorOf: aVersionItem.

	self updateCount.
	"self updateTime."! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/6/2011 10:25:49.451'!
branch

	^ branch! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/6/2011 10:25:42.478'!
branch: aBranch

	branch := aBranch! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/6/2011 10:41:23.002'!
container

	^ container! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/6/2011 10:41:40.277'!
container: aMorph

	container := aMorph! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/6/2011 11:20:11.78'!
createContainer

	^ Morph new
		changeTableLayout;
		listDirection: #leftToRight;
		"hResizing: #spaceFill;"
		rubberBandCells: true;
		extent: 20@20;
		color: Color gray! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/12/2011 18:20:39.518'!
handlesMouseDown: anEvent

	^ true! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'bs 11/8/2012 15:37:02.771'!
initialize

	super initialize.
	self
		versionItems: OrderedCollection new;
		container: self createContainer.
	
	groupNode := CvGroupNode new.
	itemLane := self createItemLane addMorphBack: (
		self createItemContainer addMorph: groupNode).
	
	count := '0' asStringMorph font: (StrikeFont createDejaVu: 7); color: Color white.
	self container addMorph: count.! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/6/2011 14:59:05.959'!
isActive

	^ true! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/6/2011 11:25:11.329'!
isGroup

	^true! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/12/2011 14:11:12.269'!
linkPredecessorOf: aVersionItem.

	self predecessor: aVersionItem predecessor
	! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/12/2011 14:11:33.433'!
linkSuccessorOf: aVersionItem.

	self successor: aVersionItem successor! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/12/2011 18:25:18.786'!
mouseDown: anEvent

	self releaseItems.! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/12/2011 18:42:50.077'!
releaseItems

	self versionItems do: [ :version | 
		self removeVersion: version.
		self branch addItem: version before: self.
		self relinkSuccessorOf: version ].
	
	self branch removeItem: self.
	self branch hide; show.! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/12/2011 14:12:05.434'!
relinkPredecessorOf: aVersionItem.

	aVersionItem predecessor:  aVersionItem predecessor! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/12/2011 14:10:25.205'!
relinkSuccessorOf: aVersionItem.

	aVersionItem successor:  aVersionItem successor! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/12/2011 18:19:19.555'!
removeVersion: anVersionItem

	self versionItems remove: anVersionItem! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'bs 5/18/2011 21:39:57.012'!
showItemAt: laneNumber

	self at: laneNumber put: itemLane! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/6/2011 14:44:05.644'!
updateCount

	count contents: self versionItems size asString! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/6/2011 12:06:53.45'!
updateTime
|timestamps|

	timestamps := self versionItems collect: [ :versionItem | versionItem version versionInfo time].
	timeBeginMorph time: timestamps min.
	timeEndMorph time: timestamps max! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/6/2011 12:06:36.675'!
versionItems

	^ versionItems! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'TM 5/6/2011 12:06:28.362'!
versionItems: aOrderedCollection

	versionItems := OrderedCollection new! !

!CvChronoGroupItem methodsFor: 'as yet unclassified' stamp: 'bs 5/9/2011 11:30:48.056'!
versionNode
	^ self versionItems last versionNode! !

!CvChronoItem class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.039'!
canBeLateBound
	^ false! !

!CvChronoItem methodsFor: 'as yet unclassified' stamp: 'bs 4/26/2011 14:26:12.53'!
addEmptyLane
	self addMorph: self createEmptyLane! !

!CvChronoItem methodsFor: 'as yet unclassified' stamp: 'bs 11/9/2012 13:56:08.842'!
addEmptyLaneAbove: aPosition
	
	aPosition = 0 
		ifTrue: [self addMorphBack: self createEmptyLane]
		ifFalse: [self addMorph: self createEmptyLane inFrontOf: (self laneAt: aPosition)]! !

!CvChronoItem methodsFor: 'as yet unclassified' stamp: 'bs 4/26/2011 14:57:51.78'!
addItemLane: anItemLaneMorph
	self addMorph: anItemLaneMorph.! !

!CvChronoItem methodsFor: 'as yet unclassified' stamp: 'bs 4/26/2011 17:09:38.436'!
addLaneSpace
	self addMorph: self createLaneSpace! !

!CvChronoItem methodsFor: 'as yet unclassified' stamp: 'bs 4/27/2011 15:50:09.135'!
addLaneSpaceAbove: aPosition
	self addMorph: self createLaneSpace inFrontOf: (self laneAt: aPosition)! !

!CvChronoItem methodsFor: 'as yet unclassified' stamp: 'bs 5/4/2011 13:49:07.599'!
at: laneNumber put: aLaneMorph
	
	self 
		replaceSubmorph: (self laneAt: laneNumber) 
		by: aLaneMorph! !

!CvChronoItem methodsFor: 'initialization' stamp: 'bs 11/8/2012 15:47:32.246'!
buildLanes

	self firstVisiblePredecessor
		ifNil: [
			self successor submorphs reversed do: [:ea | 
					ea color = Color transparent
						ifTrue: [self addLaneSpace]
						ifFalse: [self addEmptyLane]].]
		ifNotNil: [ :visible |
				visible submorphs reversed do: [:ea | 
					ea isVisible
						ifTrue: [self addEmptyLane]
						ifFalse: [self addLaneSpace]].].
! !

!CvChronoItem methodsFor: 'as yet unclassified' stamp: 'bs 10/1/2012 16:06:42.655'!
createEmptyLane
	^ CvChronoEmptyLane new! !

!CvChronoItem methodsFor: 'as yet unclassified' stamp: 'bs 10/1/2012 13:59:56.512'!
createItemContainer
	^ (self inAColumn: {})
		hResizing: #shrinkWrap;
		color: Color transparent! !

!CvChronoItem methodsFor: 'as yet unclassified' stamp: 'bs 10/1/2012 16:07:03.188'!
createItemLane
	^ CvChronoEmptyLane new! !

!CvChronoItem methodsFor: 'as yet unclassified' stamp: 'bs 10/1/2012 16:09:11.358'!
createLaneSpace
	
	^ CvChronoLaneSpace new! !

!CvChronoItem methodsFor: 'as yet unclassified' stamp: 'bs 4/27/2011 09:50:51.348'!
createTimeLane
	^ timeLane := Morph new
		changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #spaceFill;
		extent: 1@20;
		color: Color transparent! !

!CvChronoItem methodsFor: 'accessing' stamp: 'bs 5/4/2011 19:42:31.676'!
firstVisiblePredecessor

	^ self predecessor ifNotNil: [:pred | 
		pred isVisible
			ifTrue: [self predecessor]
			ifFalse: [self predecessor firstVisiblePredecessor]]	 ! !

!CvChronoItem methodsFor: 'initialization' stamp: 'bs 10/1/2012 13:37:19.295'!
initialize
	super initialize.
	self 
		changeTableLayout;
		listDirection: #topToBottom;
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		rubberBandCells: true;
		color: Color transparent;
		cellInset: 2;
		extent: 1@1.! !

!CvChronoItem methodsFor: 'as yet unclassified' stamp: 'TM 5/6/2011 11:26:02.321'!
isGroup

	^ false! !

!CvChronoItem methodsFor: 'as yet unclassified' stamp: 'TM 5/6/2011 11:25:53.778'!
isVersion

	^ false! !

!CvChronoItem methodsFor: 'hide / show' stamp: 'bs 5/4/2011 19:42:47.897'!
isVisible
	^ self owner notNil! !

!CvChronoItem methodsFor: 'as yet unclassified' stamp: 'bs 11/8/2012 15:43:58.734'!
laneAt: aPosition
	| laneInFront |
	laneInFront := self lastSubmorph.
	(aPosition - 1) timesRepeat: [laneInFront := laneInFront submorphBefore].
	^ laneInFront! !

!CvChronoItem methodsFor: 'as yet unclassified' stamp: 'bs 4/21/2011 17:30:36.84'!
laneHeight
	^ 21! !

!CvChronoItem methodsFor: 'accessing' stamp: 'bs 4/21/2011 17:29:24.797'!
numberOfLanes
	^ numberOfLanes! !

!CvChronoItem methodsFor: 'accessing' stamp: 'bs 4/21/2011 17:29:50.538'!
numberOfLanes: anObject
	numberOfLanes := anObject! !

!CvChronoItem methodsFor: 'accessing' stamp: 'TM 5/12/2011 14:06:52.799'!
predecessor

	^ predecessor! !

!CvChronoItem methodsFor: 'accessing' stamp: 'TM 5/12/2011 14:18:57.224'!
predecessor: aChronoItem

	predecessor := aChronoItem.
	(aChronoItem notNil and: [ aChronoItem successor  ~= self ])
		ifTrue: [ aChronoItem successor: self ] ! !

!CvChronoItem methodsFor: 'as yet unclassified' stamp: 'bs 4/27/2011 21:25:49.497'!
removeLane: laneNumber
	self removeMorph: (self laneAt: laneNumber)! !

!CvChronoItem methodsFor: 'hide / show' stamp: 'bs 11/9/2012 13:07:23.108'!
removeLanes
	
	self submorphs do: [:ea | ea delete].! !

!CvChronoItem methodsFor: 'accessing' stamp: 'TM 5/12/2011 14:04:04.399'!
successor

	^ successor! !

!CvChronoItem methodsFor: 'accessing' stamp: 'TM 5/12/2011 14:20:35.542'!
successor: aChronoItem

	successor := aChronoItem.
	(aChronoItem notNil and: [ aChronoItem predecessor ~= self ])
		ifTrue: [ aChronoItem predecessor: self ] ! !

CvChronoItem subclass: #CvChronoPointsItem
	instanceVariableNames: 'branch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Bar'!

!CvChronoPointsItem methodsFor: 'as yet unclassified' stamp: 'bs 10/1/2012 17:09:47.123'!
addPoint: aBranchPoint toLane: aLane
	
	aLane addMorph: (
		self createItemContainer
			vResizing: #spaceFill;
			addAllMorphs: {
				self newSpacer.
				aBranchPoint.
				self newSpacer})! !

!CvChronoPointsItem methodsFor: 'as yet unclassified' stamp: 'bs 10/1/2012 17:23:04.95'!
at: laneNumber putPoint: aBranchPoint
	| lane |
	lane :=CvChronoEmptyLane new.
	lane hResizing: #shrinkWrap.
	self addPoint: aBranchPoint toLane: lane.
	self at: laneNumber put: lane.! !

!CvChronoPointsItem methodsFor: 'as yet unclassified' stamp: 'bs 4/27/2011 09:52:26.241'!
createItemLane
	^ super createItemLane
		hResizing: #shrinkWrap! !

!CvChronoPointsItem methodsFor: 'as yet unclassified' stamp: 'bs 11/9/2012 11:47:50.688'!
lanes

	^  self submorphs reversed! !

CvChronoPointsItem subclass: #CvChronoStartPointsItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Bar'!

!CvChronoStartPointsItem methodsFor: 'as yet unclassified' stamp: 'bs 10/2/2012 10:52:56.527'!
drawBottomConnection: aLane on: aCanvas

	self drawLineOn: aCanvas from: aLane leftCenter to: aLane bottomLeft! !

!CvChronoStartPointsItem methodsFor: 'as yet unclassified' stamp: 'bs 10/2/2012 10:54:15.936'!
drawConnections: aLane on: aCanvas
	
	(self isThereAPointAbove: aLane)				
		ifTrue: [self drawTopConnection: aLane on: aCanvas].
			
	(self isThereAPointLeftOf: aLane)
		ifFalse: [self drawBottomConnection: aLane on: aCanvas].
			
		! !

!CvChronoStartPointsItem methodsFor: 'as yet unclassified' stamp: 'bs 11/9/2012 14:14:20.077'!
drawLineOn: aCanvas from: start to: end
	
	aCanvas 
		line: start 
		to: end 
		width: 1 
		color: Color white
		dashLength: 3
		secondColor: Color transparent
		secondDashLength: 3
		startingOffset: 0! !

!CvChronoStartPointsItem methodsFor: 'as yet unclassified' stamp: 'bs 11/9/2012 11:47:58.871'!
drawOn: aCanvas
	
	super drawOn: aCanvas.
		
	self lanes
		select: [:ea | ea isVisible]
		thenDo: [:ea | self drawConnections: ea on: aCanvas].! !

!CvChronoStartPointsItem methodsFor: 'as yet unclassified' stamp: 'bs 10/2/2012 10:51:56.11'!
drawTopConnection: aLane on: aCanvas

	self drawLineOn: aCanvas from: aLane topLeft to: aLane leftCenter! !

!CvChronoStartPointsItem methodsFor: 'as yet unclassified' stamp: 'bs 11/9/2012 11:48:24.373'!
isThereAPointAbove: lane

	| index lanes |
	lanes := self lanes.
	index := lanes indexOf: lane.
	^ (index < lanes size) and: [(lanes at: index + 1) isVisible] ! !

!CvChronoStartPointsItem methodsFor: 'as yet unclassified' stamp: 'bs 11/9/2012 11:48:37.869'!
isThereAPointLeftOf: lane

	| index lanes |
	lanes := self lanes.
	index := lanes indexOf: lane.
	^ (self predecessor lanes at: index) isVisible.! !

CvChronoItem subclass: #CvChronoVersionItem
	instanceVariableNames: 'version versionNode itemLane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Bar'!

!CvChronoVersionItem class methodsFor: 'as yet unclassified' stamp: 'bs 4/26/2011 16:53:36.189'!
forVersion: aCvVersion

	^ self basicNew initializeWithVersion: aCvVersion! !

!CvChronoVersionItem methodsFor: 'as yet unclassified' stamp: 'bs 11/9/2012 13:02:35.912'!
adaptToPredecessor
	| delta |
	delta := 0.
	delta := delta + (self minutesToPredecessor min: 60).
	
	delta ~= 0 ifTrue: [
		itemLane addMorph: (
			self newSpacer
				hResizing: #rigid;
				extent: (((delta * delta) log: 2) rounded) @ 1) ]! !

!CvChronoVersionItem methodsFor: 'initialization' stamp: 'bs 10/1/2012 16:13:10.225'!
buildLanes
		
	self firstVisiblePredecessor
		ifNil: [self addLaneSpace]
		ifNotNil: [super buildLanes]! !

!CvChronoVersionItem methodsFor: 'as yet unclassified' stamp: 'bs 5/4/2011 13:52:25.696'!
createItemLane
	^ super createItemLane
		hResizing: #shrinkWrap! !

!CvChronoVersionItem methodsFor: 'as yet unclassified' stamp: 'bs 11/8/2012 15:36:55.194'!
initializeWithVersion: aCvVersion
	
	self initialize.
	version := aCvVersion.
	versionNode := CvVersionNode for: self version.
	
	itemLane := self createItemLane addMorphBack: (
		self createItemContainer addMorph: self versionNode)! !

!CvChronoVersionItem methodsFor: 'accessing' stamp: 'bs 5/16/2011 09:30:27.037'!
isActive
	^ self versionNode hasAssignedWorkingCopy! !

!CvChronoVersionItem methodsFor: 'time' stamp: 'bs 5/12/2011 17:40:41.114'!
isPredecessorInSameFiveMinBlock
	"examples: 
	 14:49 and: 14:51 ->  | (49 \\ 5) <= (51 \\ 5) | -> false
	 14:51 and: 14:53 ->  | (51 \\ 5) <= (53 \\ 5) | -> true "
	^ self minutesToPredecessor < 5 
		and: [(self predecessor time minutes \\ 5) <= (self time minutes \\ 5)]! !

!CvChronoVersionItem methodsFor: 'accessing' stamp: 'TM 5/6/2011 11:25:41.385'!
isVersion

	^true! !

!CvChronoVersionItem methodsFor: 'time' stamp: 'bs 5/12/2011 17:26:28.105'!
minutesToPredecessor
	
	^ (self timeStamp - self predecessor timeStamp) minutes! !

!CvChronoVersionItem methodsFor: 'as yet unclassified' stamp: 'bs 4/29/2011 15:11:05.65'!
showItemAt: laneNumber

	self at: laneNumber put: itemLane! !

!CvChronoVersionItem methodsFor: 'time' stamp: 'bs 5/12/2011 17:35:23.927'!
time
	^ self timeStamp time! !

!CvChronoVersionItem methodsFor: 'time' stamp: 'bs 4/27/2011 14:13:51.917'!
timeStamp
	^ self version timeStamp! !

!CvChronoVersionItem methodsFor: 'accessing' stamp: 'bs 4/23/2011 15:04:38.875'!
version
	^ version! !

!CvChronoVersionItem methodsFor: 'accessing' stamp: 'bs 4/27/2011 13:20:11.334'!
versionNode
	^ versionNode! !

Morph subclass: #CvChronoLaneSpace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Bar'!

!CvChronoLaneSpace methodsFor: 'as yet unclassified' stamp: 'bs 11/9/2012 14:20:36.764'!
initialize

	super initialize.
	self 
		hResizing: #spaceFill;
		extent: 0@24;
		color: Color transparent! !

!CvChronoLaneSpace methodsFor: 'as yet unclassified' stamp: 'bs 10/1/2012 16:08:42.897'!
isVisible

	^ false! !

Morph subclass: #CvChronoView
	instanceVariableNames: 'rootBranch selectedNodes lastCreatedItems versionBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Bar'!

!CvChronoView class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.049'!
canBeLateBound
	^ false! !

!CvChronoView class methodsFor: 'instance creation' stamp: 'bs 5/10/2011 22:18:58.134'!
versionBar: aVersionBar

	^ self basicNew initializeWithVersionBar: aVersionBar! !

!CvChronoView methodsFor: 'as yet unclassified' stamp: 'bs 5/13/2011 10:52:00.62'!
addItem: anItem

	self addMorphBack: anItem.
	"self groupItems"! !

!CvChronoView methodsFor: 'as yet unclassified' stamp: 'bs 5/10/2011 22:45:01.972'!
addNewVersion: aVersion
	 | subbranch newItem |
	subbranch := rootBranch subbranchOf: aVersion predecessor. 
	newItem := subbranch appendNewVersion: aVersion.
	versionBar scrollToShow: newItem.
	^ newItem! !

!CvChronoView methodsFor: 'accessing' stamp: 'bs 4/27/2011 11:45:28.212'!
allItems
	^ self rootBranch allItems! !

!CvChronoView methodsFor: 'accessing' stamp: 'bs 5/2/2011 22:26:04.803'!
allNodesDo: aBlock

	^ self rootBranch allNodesDo: aBlock! !

!CvChronoView methodsFor: 'node selection' stamp: 'bs 4/27/2011 13:18:43.551'!
allSelectedNodes
	^ selectedNodes ifNil: [selectedNodes := OrderedCollection new]! !

!CvChronoView methodsFor: 'node selection' stamp: 'bs 4/27/2011 13:34:30.799'!
allSelectedNodesInRanges
	| currentRange ranges |
	ranges := OrderedCollection new.
	currentRange := OrderedCollection new.
	self rootBranch addSelectedNodesToRanges: ranges withCurrentRange: currentRange.
	^ ranges! !

!CvChronoView methodsFor: 'accessing' stamp: 'TM 5/12/2011 14:31:40.681'!
canItemBeGrouped: anVersionItem

	^ (lastCreatedItems includes: anVersionItem) not
! !

!CvChronoView methodsFor: 'as yet unclassified' stamp: 'bs 5/4/2011 21:05:49.556'!
displayVersions: versions
	self removeAllMorphs.
	
	rootBranch := CvBranch new initializeAsRootWithView: self.
	rootBranch appendNewItemForVersion: versions first.
	versions allButFirst do: [:ea | self addNewVersion: ea]
	
	! !

!CvChronoView methodsFor: 'accessing' stamp: 'TM 5/12/2011 15:59:45.047'!
groupItems

	self lastCreatedItems size <= 10
		ifTrue: [ ^self ].

	self rootBranch tryGrouping.
	
	self lastCreatedItems: (self lastCreatedItems last: 3).! !

!CvChronoView methodsFor: 'as yet unclassified' stamp: 'bs 4/28/2011 18:25:18.716'!
hideItem: anItem

	self removeMorph: anItem.! !

!CvChronoView methodsFor: 'as yet unclassified' stamp: 'bs 6/16/2011 19:07:38.117'!
highlight: aCodeReference

	self allNodesDo: [:node | 
		node highlightFor: aCodeReference]! !

!CvChronoView methodsFor: 'as yet unclassified' stamp: 'bs 5/13/2011 10:51:17.787'!
initialize
	super initialize.
	self 
		changeTableLayout;
		color: Color transparent;
		listDirection: #leftToRight; 
		vResizing: #shrinkWrap;
		hResizing: #shrinkWrap;
		lastCreatedItems: OrderedCollection new! !

!CvChronoView methodsFor: 'as yet unclassified' stamp: 'bs 5/10/2011 22:18:07.403'!
initializeWithVersionBar: aVersionBar
	self initialize.
	versionBar := aVersionBar.! !

!CvChronoView methodsFor: 'accessing' stamp: 'TM 5/12/2011 13:47:47.832'!
lastCreatedItems

	^ lastCreatedItems! !

!CvChronoView methodsFor: 'accessing' stamp: 'TM 5/12/2011 13:47:37.832'!
lastCreatedItems: anOrderedCollection

	lastCreatedItems := anOrderedCollection! !

!CvChronoView methodsFor: 'accessing' stamp: 'TM 5/12/2011 14:44:20.227'!
linkWithLastItem: newItem
|lastItem|
	lastCreatedItems isEmpty
		ifTrue: [ lastItem := nil ]
		ifFalse: [ lastItem := lastCreatedItems last ].
	newItem predecessor: lastItem.
	lastCreatedItems add: newItem! !

!CvChronoView methodsFor: 'accessing' stamp: 'bs 4/28/2011 16:28:35.255'!
numberOfLanes
	^ self rootBranch highestLaneNumber! !

!CvChronoView methodsFor: 'accessing' stamp: 'bs 4/27/2011 11:36:06.367'!
rootBranch
	^ rootBranch! !

!CvChronoView methodsFor: 'accessing' stamp: 'bs 4/29/2011 14:10:09.171'!
rootBranch: anObject
	rootBranch := anObject! !

!CvChronoView methodsFor: 'as yet unclassified' stamp: 'bs 4/29/2011 14:49:20.239'!
showItem: anItem
	
	self addMorph: anItem after: anItem firstVisiblePredecessor! !

!CvChronoView methodsFor: 'accessing' stamp: 'bs 8/1/2012 13:47:32.797'!
versionBar

	^ versionBar! !

!CvChronoView methodsFor: 'derived accessing' stamp: 'bs 8/1/2012 13:31:47.267'!
workingCopies

	^ self versionBar workingCopies! !

Morph subclass: #CvCommitDialog
	instanceVariableNames: 'ui'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Commit'!

!CvCommitDialog methodsFor: 'as yet unclassified' stamp: ''!
commitButtonClicked: isButtonChecked
	
	self ui message theText asString withoutTrailingBlanks 
		ifEmpty: [
			self inform: 'the commit message must not be empty.'.
			^ self].
		
	self activeWorkingCopy baseVersion commitMessage: self ui message theText.
	self resetAndDisable. 
	! !

!CvCommitDialog methodsFor: 'as yet unclassified' stamp: ''!
cvController

	^ World cvController! !

!CvCommitDialog methodsFor: 'as yet unclassified' stamp: ''!
enable

	self ui button enabled: true! !

!CvCommitDialog methodsFor: 'as yet unclassified' stamp: ''!
initialize
	self assert: [World cvIsInstalled].
	super initialize.
	self ui setupUi: self.
	self resetAndDisable.
	
	self connect: self cvController signal: #versionSaved: toSelector: #versionSaved:.
	self connect: self ui button signal: #clicked: toSelector: #commitButtonClicked:.! !

!CvCommitDialog methodsFor: 'as yet unclassified' stamp: ''!
open

 	self openInWindowLabeled: 'Commit Dialog'! !

!CvCommitDialog methodsFor: 'as yet unclassified' stamp: ''!
resetAndDisable

	self ui message theText: nil.
	self ui button enabled: false.! !

!CvCommitDialog methodsFor: 'as yet unclassified' stamp: ''!
ui
	
	^ ui ifNil: [ui := CvCommitDialogUi new]! !

!CvCommitDialog methodsFor: 'as yet unclassified' stamp: ''!
versionSaved: aVersion 

	self enable.! !

Morph subclass: #CvEmptyBranchMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

!CvEmptyBranchMorph methodsFor: 'as yet unclassified' stamp: 'bs 11/16/2012 14:00:27.046'!
initialize

	super initialize.
	self 
		extent: 16@16;
		color: Color transparent! !

!CvEmptyBranchMorph methodsFor: 'as yet unclassified' stamp: 'bs 11/16/2012 14:28:58.26'!
lineColor

	^ Color solarizedBase01Brgreen! !

CvEmptyBranchMorph subclass: #CvForkBranchMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

!CvForkBranchMorph methodsFor: 'as yet unclassified' stamp: 'bs 11/16/2012 14:29:12.091'!
drawOn: aCanvas

	super drawOn: aCanvas.
	aCanvas 
		line: (1 @ (self height / 2)) + self topLeft 
		to: ((self width / 2) @ (self height / 2)) + self topLeft 
		width: 2 
		color: self lineColor.
		
	aCanvas 
		line: ((self width / 2) @ (self height / 2)) + self topLeft 
		to: ((self width / 2) @ (self height)) + self topLeft 
		width: 2 
		color: self lineColor.! !

CvEmptyBranchMorph subclass: #CvHairLineBranchMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

!CvHairLineBranchMorph methodsFor: 'as yet unclassified' stamp: 'bs 11/16/2012 14:29:16.853'!
drawOn: aCanvas

	super drawOn: aCanvas.
	aCanvas 
		line: ((self width / 2) @ 1) + self topLeft 
		to: ((self width / 2) @ (self height)) + self topLeft 
		width: 1 
		color: self lineColor ! !

CvEmptyBranchMorph subclass: #CvLineBranchMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Browser'!

!CvLineBranchMorph methodsFor: 'as yet unclassified' stamp: 'bs 11/16/2012 14:29:21.338'!
drawOn: aCanvas

	super drawOn: aCanvas.
	aCanvas 
		line: ((self width / 2) @ 1) + self topLeft 
		to: ((self width / 2) @ (self height)) + self topLeft 
		width: 2 
		color: self lineColor! !

Morph subclass: #CvEventNotifier
	instanceVariableNames: 'baseline killTime currentPatch oldVersion newVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI'!

!CvEventNotifier class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.065'!
canBeLateBound
	^ false! !

!CvEventNotifier methodsFor: 'as yet unclassified' stamp: 'bs 3/28/2011 15:33:30.676'!
baseline
	^ baseline! !

!CvEventNotifier methodsFor: 'as yet unclassified' stamp: 'bs 8/14/2012 13:15:51.7'!
cleanUp

	self stopScheduledFadeOuts.
	self removeAllMorphs.
	oldVersion := newVersion := currentPatch := nil! !

!CvEventNotifier methodsFor: 'as yet unclassified' stamp: 'bs 8/14/2012 16:40:18.306'!
click: anEvent
	
	self showPatchOperationInfo! !

!CvEventNotifier methodsFor: 'as yet unclassified' stamp: 'bs 3/29/2011 09:58:22.677'!
createBaselineMorph
	
	^ Morph new 
		height: 7; width: 10; 
		color: Color orange; 
		borderWidth: 2; borderColor: Color white;
		hResizing: #spaceFill.! !

!CvEventNotifier methodsFor: 'fading out' stamp: 'bs 5/3/2011 10:25:08.796'!
fadeOutNotifications
	
	self stopStepping.
	(self submorphs copyWithout: self baseline) do: [:m | 
		m fadeOutThen: [m delete].
		self width: 2].
	! !

!CvEventNotifier methodsFor: 'as yet unclassified' stamp: 'bs 8/14/2012 14:32:57.888'!
handlesMouseDown: anEvent

	^ true! !

!CvEventNotifier methodsFor: 'as yet unclassified' stamp: 'bs 5/3/2011 13:33:57.319'!
initialize
	super initialize.
	
	self 
		changeTableLayout;
		listDirection: #bottomToTop;
		color: Color transparent;
		borderWidth: 0;
		extent: 0@0.
		
	baseline := self createBaselineMorph.! !

!CvEventNotifier methodsFor: 'as yet unclassified' stamp: 'bs 8/14/2012 16:40:26.746'!
mouseDown: anEvent

	ActiveHand waitForClicksOrDrag: self event: anEvent! !

!CvEventNotifier methodsFor: 'as yet unclassified' stamp: 'bs 8/14/2012 13:20:39.227'!
rebasedFrom: aVersion to: anotherVersion

	self cleanUp.
	oldVersion := aVersion.
	newVersion := anotherVersion.
	currentPatch := newVersion patchRelativeToBase: oldVersion.
	
	self showRebasedSuccessfulNotification! !

!CvEventNotifier methodsFor: 'fading out' stamp: 'bs 8/14/2012 13:22:53.295'!
scheduleFadeOut
	
	killTime := Time now addSeconds: 5.
	self startStepping.! !

!CvEventNotifier methodsFor: 'as yet unclassified' stamp: 'bs 8/14/2012 16:39:16.495'!
showPatchOperationInfo
	| line note scrollPane window |
	self removeAllMorphs.
	
	currentPatch := newVersion patchRelativeToBase: oldVersion.
	line := Morph new height: 1; width: 1; hResizing: #spaceFill; color: Color gray.
	
	note := (self inAColumn: {}) 
		color: (Color r: 100 g: 168 b: 209 range: 255) muchLighter;
		cellPositioning: #bottomLeft;
		width: 100;
		borderWidth: 2;
		borderColor: Color darkGray.
	
	currentPatch operations do: [:op | 
		note addMorph: ((self inAColumn: {
			op cvSummaryHeader asTextMorph .
			op cvSummaryBody asTextMorph })
				cellPositioning: #topLeft).
				
		note addMorph: line copy].
	
	self 
		layoutChanged;
		changed.
		
	window := SystemWindow labelled: 'List of performed rebase operations'.
	window paneColor: Color darkGray.
	scrollPane := ScrollPane new.
	scrollPane hResizing: #shrinkWrap.
	scrollPane scroller addMorph: note.
	window addMorph: scrollPane frame: (0@0 corner: 1@1).
	window openInWorld.
	window width: note width + 30.
	window bottomLeft: self bottomLeft.
		
	! !

!CvEventNotifier methodsFor: 'as yet unclassified' stamp: 'bs 8/14/2012 14:43:19.376'!
showRebasedSuccessfulNotification
	| note |
	self stopScheduledFadeOuts.
	self removeAllMorphs.
	
	note := (self inAColumn: {}) 
		color: (Color r: 100 g: 168 b: 209 range: 255) muchLighter;
		cellPositioning: #bottomLeft;
		width: 100;
		borderWidth: 2;
		borderColor: Color darkGray.
		
	self addMorph: note.
	
	note addMorph: (
		((('{1} change operations were applied' format: {currentPatch operations size}),
		String cr,
		('rebased to version: {1}' format: {newVersion asString}))
			asText
				addAttribute: TextEmphasis underlined;
				yourself)
			asTextMorph lock).
	
	self color: Color transparent.
	self cellPositioning: #bottomLeft.
	self layoutChanged.
	self changed.
	
	self scheduleFadeOut.! !

!CvEventNotifier methodsFor: 'fading out' stamp: 'bs 3/28/2011 21:16:33.517'!
step
	
	(killTime notNil and: [killTime <= Time now]) ifTrue: [
		self fadeOutNotifications.
		self stopStepping ]! !

!CvEventNotifier methodsFor: 'fading out' stamp: 'bs 3/28/2011 21:06:48.209'!
stopScheduledFadeOuts
	
	self stopStepping! !

!CvEventNotifier methodsFor: 'as yet unclassified' stamp: 'bs 3/30/2011 19:34:53.187'!
wentOneStepBackTo: aVersion

	| undone undoneRow lastActionBeforeBaseline lastActionBeforeBaselineRow |
	self stopScheduledFadeOuts.
	self removeAllMorphs.
	
	aVersion predecessor ifNil: [^ self].
	
	undone := (CvVersionNode for: aVersion predecessor) createSummaryView.
	undone 
		color: Color gray lighter lighter;
		borderWidth: 0.
	undoneRow :=  (self inARow: {undone. AlignmentMorph newSpacer: Color lightGray})
		hResizing: #spaceFill.
	self addMorph: undoneRow.
	
	self addMorph: self baseline.
	
	lastActionBeforeBaseline := (CvVersionNode for: aVersion) createSummaryView.
	lastActionBeforeBaseline 
		borderWidth: 0.
	lastActionBeforeBaseline color: Color white.
	lastActionBeforeBaselineRow := (self inARow: {
		lastActionBeforeBaseline.
		AlignmentMorph newSpacer: Color white})
		hResizing: #spaceFill.
	self addMorph: lastActionBeforeBaselineRow.
	
	self layoutChanged.
	self changed.
	
	self scheduleFadeOut.! !

Morph subclass: #CvGroupNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Nodes'!

!CvGroupNode class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.069'!
canBeLateBound
	^ false! !

!CvGroupNode methodsFor: 'as yet unclassified' stamp: 'bs 5/18/2011 21:34:22.358'!
buildMenu
	| aMenu |
	aMenu := MenuMorph new defaultTarget: self.
	aMenu add: 'ungroup' action: #ungroup.
	^ aMenu! !

!CvGroupNode methodsFor: 'as yet unclassified' stamp: 'bs 5/18/2011 21:31:16.92'!
click: evt

	self offerMenu! !

!CvGroupNode methodsFor: 'as yet unclassified' stamp: 'bs 5/18/2011 21:29:20.187'!
handlesMouseDown: evt
	 
	^ true! !

!CvGroupNode methodsFor: 'as yet unclassified' stamp: 'bs 5/18/2011 21:28:39.291'!
initialize
	super initialize.
	self extent: 18@18.! !

!CvGroupNode methodsFor: 'as yet unclassified' stamp: 'bs 5/18/2011 21:31:03.04'!
mouseDown: evt
	evt hand waitForClicksOrDrag: self event: evt! !

!CvGroupNode methodsFor: 'as yet unclassified' stamp: 'bs 5/18/2011 21:31:32.254'!
offerMenu
	| aMenu |
	aMenu := self buildMenu.
	aMenu popUpEvent: self currentEvent in: self world! !

!CvGroupNode methodsFor: 'as yet unclassified' stamp: 'bs 5/18/2011 21:34:28.013'!
ungroup! !

Morph subclass: #CvPreview
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI'!

!CvPreview methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2011 20:51:24.439'!
initialize

	super initialize.
	self 
		changeTableLayout;
		extent: 550@700;
		color: Color darkGray;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		layoutInset: 10
	! !

!CvPreview methodsFor: 'as yet unclassified' stamp: 'sp 1/13/2013 21:06:01.422'!
previewOn: aCodeBase
	
	| aWindow |
	SystemWindow topWindow supportsPreview ifFalse: [^ self].
	aWindow := SystemWindow topWindow previewOn: aCodeBase.
	aWindow extent: 515@330.
	self addMorph: aWindow. ! !

Morph subclass: #CvToolTip
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Nodes'!

!CvToolTip class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.134'!
canBeLateBound
	^ false! !

!CvToolTip class methodsFor: 'as yet unclassified' stamp: 'bs 3/31/2011 11:20:12.908'!
forMorph: aMorph

	^ self new 
		initializeWithMorph: aMorph;
		yourself! !

!CvToolTip class methodsFor: 'as yet unclassified' stamp: 'bs 3/31/2011 12:14:05.515'!
onTopOf: aReferenceMorph forContent: aContentMorph
	
	^ self new 
		initializeWithMorph: aContentMorph;
		yourself! !

!CvToolTip methodsFor: 'as yet unclassified' stamp: 'bs 3/31/2011 11:26:42.328'!
handlesMouseOver: anEvent

	^ true! !

!CvToolTip methodsFor: 'as yet unclassified' stamp: 'bs 3/31/2011 12:14:54.715'!
initializeWithContent: aMorph

	self extent: aMorph extent + (10@10).
	self bottomLeft: ActiveHand position + (-5@5).
	self color: Color transparent.

	self addMorph: aMorph.
	aMorph position: self position + (5@5).
	! !

!CvToolTip methodsFor: 'as yet unclassified' stamp: 'bs 3/31/2011 11:27:17.125'!
initializeWithMorph: aMorph

	self extent: aMorph extent + (10@10).
	self bottomLeft: ActiveHand position + (-5@5).
	self color: Color transparent.

	self addMorph: aMorph.
	aMorph position: self position + (5@5).
	! !

!CvToolTip methodsFor: 'as yet unclassified' stamp: 'bs 3/31/2011 11:24:30.663'!
mouseLeave: evt

	self delete.! !

Morph subclass: #CvVersionMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI'!

!CvVersionMorph methodsFor: 'as yet unclassified' stamp: ''!
doLayout
	
	self 
		width: 350;
		height: 100;
		borderWidth: 2;
		borderColor: Color black;
		color: Color white.
	! !

!CvVersionMorph methodsFor: 'as yet unclassified' stamp: ''!
step 

	[self doLayout]
		on: Error
		do: [^ self]  ! !

!CvVersionMorph methodsFor: 'as yet unclassified' stamp: ''!
wantsSteps

	^ true! !

Morph subclass: #CvVersionNode
	instanceVariableNames: 'version branch hoverView summary testResultsMorph lowBar highBar wcPointers isDarkened preview'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI-Nodes'!

CvVersionNode class
	instanceVariableNames: 'summary'!

CvVersionNode class
	instanceVariableNames: 'summary'!

!CvVersionNode class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.152'!
canBeLateBound
	^ false! !

!CvVersionNode class methodsFor: 'as yet unclassified' stamp: 'TM 4/5/2011 15:17:13.997'!
for: aCvVersion

	^ self forVersion: aCvVersion! !

!CvVersionNode class methodsFor: 'as yet unclassified' stamp: 'TM 4/5/2011 15:16:55.93'!
forVersion: aCvVersion

	^ self new initializeWithVersion: aCvVersion! !

!CvVersionNode methodsFor: 'highlighting' stamp: 'bs 4/20/2011 14:18:09.846'!
addNode: aVersionNode

	self version successors size > 1
		ifTrue: [ ( self branch forkAt: self ) addNode: aVersionNode ]
		ifFalse: [ self branch addNode: aVersionNode ].! !

!CvVersionNode methodsFor: 'working copy pointer' stamp: 'bs 9/7/2012 13:46:54.542'!
addWcPointer: aWcPointer
	self wcPointers ifEmpty: [
		self borderColor: (Color gray: 0.75).
		self color: (Color gray: 0.75)].
	self wcPointers add: aWcPointer.
	self addMorphBack: aWcPointer
	! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 4/18/2011 14:45:30.529'!
allSelectedNodes

	^ self branch allSelectedNodes! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 4/18/2011 15:30:09.654'!
allSelectedNodesInRanges
	
	^ self branch allSelectedNodesInRanges! !

!CvVersionNode methodsFor: 'selection menu items' stamp: 'pt 1/9/2013 16:10:10.058'!
appendSelectionMenuItems: aMenuMorph

	aMenuMorph 
		addMenuItem: (MenuItemMorph new
			contents: 'clear selection';
			target: self;
			selector: #clearSelection;
			arguments: Array new;
			isEnabled: self allSelectedNodes notEmpty);
		addMenuItem: (MenuItemMorph new
			contents: 'apply changes on ...';
			subMenu: self buildApplyChangesSubmenu;
			icon: nil;
			isEnabled: self allSelectedNodes notEmpty);
		addMenuItem: (MenuItemMorph new
			contents: 'revert changes on ...';
			subMenu: self buildRevertChangesSubmenu;
			icon: nil;
			isEnabled: self allSelectedNodes notEmpty);
		addMenuItem: (MenuItemMorph new
			contents: 'merge with selected version';
			target: self;
			selector: #mergeSelectedVersion;
			arguments: Array new;
			isEnabled: (self hasAssignedWorkingCopy and: [self allSelectedNodes size = 1]));
		addMenuItem: (MenuItemMorph new
			contents: 'commit selected versions to Monticello';
			target: self;
			selector: #commit;
			isEnabled: (CvCommit isApplicableFor: self allSelectedNodes)).! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 7/31/2012 10:09:01.791'!
applyChangesOn: aWc
	| ranges |
	self allSelectedNodes ifEmpty: [^ self].
	
	ranges := self allSelectedNodesInRanges.
	ranges do: [:eachRange | | patchBase lastVersion patch |
		patchBase := eachRange first version predecessor.
		lastVersion := eachRange last version.
		patch := lastVersion patchRelativeToBase: patchBase.
		aWc applyPatch: patch ].
	
	self allSelectedNodes do: [:ea | ea deselect].! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 4/30/2011 15:55:30.708'!
applyChangesOnNewWc
	self applyChangesOn: self version checkout! !

!CvVersionNode methodsFor: 'working copy pointer' stamp: 'bs 5/13/2011 20:33:50.618'!
assignedWorkingCopies

	^ self wcPointers collect: [:ea | ea workingCopy]! !

!CvVersionNode methodsFor: 'working copy pointer' stamp: 'bs 5/13/2011 20:34:14.252'!
assignedWorkingCopy

	^ self assignedWorkingCopies first! !

!CvVersionNode methodsFor: 'highlighting' stamp: 'TM 3/31/2011 15:19:15.888'!
branch

	^ branch! !

!CvVersionNode methodsFor: 'highlighting' stamp: 'TM 3/31/2011 15:19:09.669'!
branch: aVersionBranch

	branch := aVersionBranch! !

!CvVersionNode methodsFor: 'selection menu items' stamp: 'bs 8/1/2012 13:31:47.253'!
buildApplyChangesSubmenu
	| aMenu |
	aMenu := MenuMorph new defaultTarget: self.
	aMenu add: 'new working copy' action: #applyChangesOnNewWc. 
	self versionBar workingCopies do: [:aWc | 
		aMenu addMenuItem: (MenuItemMorph new
			contents: aWc asString;
			target: self;
			selector: #applyChangesOn: ;
			arguments: {aWc};
			icon: (aWc color iconOrThumbnailOfSize: 10)) ].
	^ aMenu! !

!CvVersionNode methodsFor: 'menu actions' stamp: 'bs 1/11/2012 16:32:09.055'!
buildMenu
	^ CvVersionNodeMenu versionNode: self! !

!CvVersionNode methodsFor: 'menu actions' stamp: 'bs 8/1/2012 13:31:47.242'!
buildRebaseSubmenu
	| aMenu |
	aMenu := MenuMorph new defaultTarget: self.
	self versionBar workingCopies do: [:aWc | 
		aMenu addMenuItem: (MenuItemMorph new
			contents: aWc asString;
			target: self;
			selector: #rebaseWorkingCopy: ;
			arguments: {aWc};
			icon: (aWc color iconOrThumbnailOfSize: 10)) ].
	^ aMenu! !

!CvVersionNode methodsFor: 'selection menu items' stamp: 'bs 8/1/2012 13:31:47.249'!
buildRevertChangesSubmenu
	| aMenu |
	aMenu := MenuMorph new defaultTarget: self.
	aMenu add: 'new working copy' action: #revertChangesOnNewWc. 
	self versionBar workingCopies do: [:aWc | 
		aMenu addMenuItem: (MenuItemMorph new
			contents: aWc asString;
			target: self;
			selector: #revertChangesOn: ;
			arguments: {aWc};
			icon: (aWc color iconOrThumbnailOfSize: 10)) ].
	^ aMenu! !

!CvVersionNode methodsFor: 'menu actions' stamp: 'bs 4/6/2011 16:01:44.493'!
checkoutAndOpenInNewEnvironment
	| newWorkingCopy |
	newWorkingCopy := self version checkout.
	newWorkingCopy openInNewEnvironment! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 4/18/2011 14:57:34.234'!
clearSelection
	
	self allSelectedNodes copy do: [:ea | ea deselect]! !

!CvVersionNode methodsFor: 'event handling' stamp: 'bs 4/18/2011 11:58:33.349'!
click: evt

	self offerMenu! !

!CvVersionNode methodsFor: 'expand/collapse' stamp: 'bs 3/18/2011 09:12:08.453'!
collapse
	summary ifNil: [^ self].
	
	summary delete.
	summary := nil.
	self extent: 10@10! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 4/17/2011 21:08:32.438'!
collectNodesBackToVersion: ancestorVersion in: aCollection
	
	self version = ancestorVersion ifTrue: [^ aCollection].
	
	aCollection add: self.
	(self branch nodeBefore: self) 
		collectNodesBackToVersion: ancestorVersion in: aCollection! !

!CvVersionNode methodsFor: 'selection' stamp: 'pt 1/10/2013 18:32:51.649'!
commit

	self assert: (self allSelectedNodes notEmpty).	
	CvCommit tryCommit: self allSelectedNodes.! !

!CvVersionNode methodsFor: 'hovering' stamp: 'FB 12/21/2012 15:00:42.298'!
createHoverHeader
	| result line modifier author time | 
	modifier := self version predecessorDiff
		ifNil: ['---' asText]
		ifNotNil: [:diff | diff cvSummaryPrefix asText].
	modifier allBold; addAttribute: (TextColor color: Color solarizedBase1Brcyan).
	
	author := self version versionInfo author asText.
	author addAttribute: (TextColor color: Color solarizedBase1Brcyan).
	
	time := self version versionInfo time print24WithoutSeconds asText.
	time addAttribute: (TextColor color: Color solarizedBase1Brcyan).
	
	line := Morph new height: 15; width: 1; color: Color solarizedBase1Brcyan.
	
	result := (AlignmentMorph inARow: {})
		cellPositioning: #topLeft;
		cellInset: 4;
		color: Color transparent;
		borderWidth: 0.
	
	result 
		addMorphBack: modifier asTextMorph;
		addMorphBack: line copy;
		addMorphBack: author asTextMorph;
		addMorphBack: self newSpacer;
		addMorphBack: line copy;
		addMorphBack: time asTextMorph.
	^ result! !

!CvVersionNode methodsFor: 'hovering' stamp: 'bs 12/4/2012 13:11:05.958'!
createHoverTestView
	| result newPassesMorph newPassesText newDefectsMorph newDefectsText overallText | 
	newPassesMorph := Morph new 
		borderWidth: 0;
		color: Color solarizedGreen;
		extent: 30@20.
	
	self version isTestResultAvailable
		ifFalse: [^ 'results not yet available' asText
					addAttribute: (TextColor color: Color solarizedBase1Brcyan);
					asTextMorph].
		
	newPassesText := self version newlyPassedTests size asString asTextMorph color: Color white.
	newPassesMorph addMorph: newPassesText.
	newPassesText center: newPassesMorph center.
	
	newDefectsMorph := Morph new 
		borderWidth: 0;
		color: Color solarizedOrange;
		extent: 30@20.
	newDefectsText := self version newDefectTests size asString asTextMorph color: Color white.
	newDefectsMorph addMorph: newDefectsText.
	newDefectsText center: newDefectsMorph center.
	
	overallText := 
		(self version testResult passedCount asString, 
		' / ', 
		self version testResult runCount asString,
		' passes')
		asText.
	overallText addAttribute: (TextColor color: Color solarizedBase1Brcyan).
	
	result := (AlignmentMorph inARow: {})
		cellPositioning: #topLeft;
		color: Color transparent;
		borderWidth: 0.
	
	result 
		addMorphBack: newPassesMorph;
		addMorphBack: newDefectsMorph;
		addMorphBack: (self newSpaceBufferOfWidth: 10);
		addMorphBack: self newSpacer;
		addMorphBack: overallText asTextMorph.
	^ result! !

!CvVersionNode methodsFor: 'hovering' stamp: 'bs 11/9/2012 17:48:03.082'!
createHoverView
	| item line | 
	self version isInitialVersion
		ifTrue: [^ self inARow: {'initial version' asTextMorph}].
		
	item := self version systemEvent cvItemReference asString asText.
	item addAttribute: (TextColor color: Color solarizedBase01Brgreen).
	
	line := Morph new height: 1; width: 110; color: Color gray.
	line hResizing: #spaceFill.
	
	^ AlignmentMorph inAColumn: {
		(self createHoverHeader hResizing: #spaceFill; yourself).
		line copy.
		item asTextMorph.
		line copy.
		(self createHoverTestView hResizing: #spaceFill; yourself) }! !

!CvVersionNode methodsFor: 'hovering' stamp: 'bs 11/9/2012 17:51:30.81'!
createSummaryView
	| summary summaryMorphs result line | 
	summary := self version summary.
	summaryMorphs := summary collect: [:ea | ea asTextMorph color: Color black; yourself].
	line := Morph new height: 1; width: 10; color: Color gray; hResizing: #spaceFill.
	
	result := (AlignmentMorph inAColumn: {})
		cellPositioning: #topLeft;
		layoutInset: 3.
	
	summaryMorphs allButLast do: [:ea | 
		result 
			addMorphBack: ea;
			addMorphBack: line copy ].
	result addMorphBack: summaryMorphs last.
	
	result 
		x: self topRight x + (result width / 2);
		y: self topRight y - result height.
	^ result! !

!CvVersionNode methodsFor: 'menu actions' stamp: 'bs 4/12/2011 14:34:39.461'!
createTestRunner
	| runnerWindow |
	runnerWindow := TestRunner build.
	runnerWindow model 
		result: self version testResult;
		updateResults.
	runnerWindow refreshWindowColor.
	^ runnerWindow! !

!CvVersionNode methodsFor: 'as yet unclassified' stamp: 'bs 11/8/2012 16:42:03.529'!
defaultColor

	^ Color solarizedBase02Black! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 7/30/2012 13:00:28.709'!
deselect

	self allSelectedNodes remove: self.
	self changed.! !

!CvVersionNode methodsFor: 'test results' stamp: 'bs 12/10/2012 15:53:16.03'!
displayTestResult
	|passed|	

	self version testResult runCount isZero ifTrue: [^ self].
	
	passed := (14 * self version testResult passedRatio) truncated.
	
	testResultsMorph 
		removeAllMorphs;
		addMorph: (self inARow: (CvTestChangeIndicators version: self version size: 7) asArray);
		addMorph: (self inARow: {
			Morph new color: Color solarizedGreen lighter; extent: passed@7.
			Morph new color: Color solarizedOrange; extent: (14-passed)@7 }).! !

!CvVersionNode methodsFor: 'drawing' stamp: 'bs 7/30/2012 11:48:41.808'!
drawOn: aCanvas
	| backgroundColor |
	backgroundColor := 
		self isSelected 
			ifTrue: [Color white] 
			ifFalse: [self defaultColor].
		
	aCanvas 
		fillRectangle: self bounds 
		fillStyle: backgroundColor 
		borderStyle: self borderStyle.
! !

!CvVersionNode methodsFor: 'expand/collapse' stamp: 'bs 3/18/2011 09:54:24.999'!
expand
	"summary := self inARow: {'Morphic' asTextMorph}."
	summary := Morph new extent: 10@50.
	self addMorphBack: summary.! !

!CvVersionNode methodsFor: 'highlighting' stamp: 'bs 6/16/2011 20:18:22.667'!
fullDrawOn: aCanvas
	| canvasToDrawOn |
	canvasToDrawOn := aCanvas.
	(self isSelected not 
		"and: [self hasAssignedWorkingCopy not] "
		and: [self isDarkened]) ifTrue: [
		canvasToDrawOn := (
			AnimBrightnessMappingCanvas
				on: aCanvas)
				brightness: 0.5].
	super fullDrawOn: canvasToDrawOn! !

!CvVersionNode methodsFor: 'event handling' stamp: 'bs 4/18/2011 13:37:51.075'!
handleMouseDown: anEvent
	anEvent wasHandled: true.
	self mouseDown: anEvent.! !

!CvVersionNode methodsFor: 'event handling' stamp: 'bs 3/15/2011 11:48:22.57'!
handlesMouseDown: evt
	 ^ true! !

!CvVersionNode methodsFor: 'hovering' stamp: 'bs 3/13/2011 18:12:27.927'!
handlesMouseOver: anEvent
	^ true! !

!CvVersionNode methodsFor: 'working copy pointer' stamp: 'bs 5/13/2011 20:31:20.389'!
hasAssignedWorkingCopy
	
	^ self wcPointers notEmpty! !

!CvVersionNode methodsFor: 'hovering' stamp: 'bs 4/18/2011 11:42:44.75'!
hideHoverView
	hoverView ifNil: [^ self].	
	hoverView delete.
	hoverView := nil! !

!CvVersionNode methodsFor: 'as yet unclassified' stamp: 'bs 4/18/2011 14:33:22.353'!
highBar
	^ highBar! !

!CvVersionNode methodsFor: 'highlighting' stamp: 'bs 5/15/2011 14:45:12.656'!
highlight
	
	self highBar height: 1.
	self lowBar height: 7.
	self highBar color: (Color gray: 0.8)! !

!CvVersionNode methodsFor: 'highlighting' stamp: 'bs 7/25/2011 17:00:18.204'!
highlightFor: aCodeReference
		
	self resetHighlight.
	(self version changedCodeReference matches: aCodeReference) 
		ifFalse: [
			isDarkened := true.
			self changed]! !

!CvVersionNode methodsFor: 'as yet unclassified' stamp: 'bs 11/9/2012 14:20:14.904'!
initializeLayout

	self
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #rigid;
		hResizing: #shrinkWrap;
		color: self defaultColor;
		extent: 5@24;
		borderColor: self defaultColor;
		borderWidth: 0.
	
	highBar := Morph new extent: 16@4; color: Color transparent.
	
	testResultsMorph := (self inAColumn: {}) 
		listDirection: #bottomToTop;
		extent: 16@16;
		color: (Color solarizedBase03Brblack);
		borderWidth: 1;
		borderColor: Color solarizedBase0Brblue.
	
	lowBar := (self inAColumn: {}) 
		listDirection: #bottomToTop;
		extent: 16@4.
	
	self addMorph: (Morph new extent: 2@5; color: Color transparent).
	self addMorph: (self inAColumn: {
		highBar. testResultsMorph. lowBar}).
	self addMorph: (Morph new extent: 5@5; color: Color transparent).
	! !

!CvVersionNode methodsFor: 'as yet unclassified' stamp: 'bs 6/3/2011 20:38:44.057'!
initializeWithVersion: aCvVersion

	super initialize.
	self 
		version: aCvVersion;
		initializeLayout.! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 4/30/2011 17:13:19.415'!
invertSelection! !

!CvVersionNode methodsFor: 'as yet unclassified' stamp: 'bs 4/30/2011 18:25:36.68'!
invertSelection: versionRanges upThrough: baseVersion
	| result current |
	result := OrderedCollection new.
	current := baseVersion.
	versionRanges reversed do: [:eaSelRange |  | resultRange |
		resultRange := OrderedCollection new.
		[current = eaSelRange last] 
			whileFalse: [
				resultRange add: current.
				current := current predecessor].
		resultRange ifNotEmpty: [
			result addFirst: resultRange reversed].
		current := eaSelRange first predecessor].
	^ result.! !

!CvVersionNode methodsFor: 'highlighting' stamp: 'bs 6/3/2011 21:02:51.567'!
isDarkened
	^ isDarkened ifNil: [isDarkened := false]! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 7/30/2012 11:47:21.454'!
isSelected

	^ self allSelectedNodes includes: self! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 7/24/2012 14:01:57.226'!
isTheOnlySelectedNode

	^ (self allSelectedNodes size = 1) and: [self isSelected]! !

!CvVersionNode methodsFor: 'hovering' stamp: 'bs 4/18/2011 21:27:07.978'!
logicalTime

	^ self version controller logicalTimeOf: self version! !

!CvVersionNode methodsFor: 'as yet unclassified' stamp: 'bs 4/6/2011 15:27:50.782'!
lowBar
	^ lowBar! !

!CvVersionNode methodsFor: 'mark active / inactive' stamp: 'TM 4/8/2011 09:57:27.493'!
markInactive

	self
		borderWidth: 0.
		
	lowBar ifNotNil: [ :bar | bar removeAllMorphs ]! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 5/13/2011 20:30:08.594'!
mergeSelectedVersion

	self assert: (self hasAssignedWorkingCopy and: [self allSelectedNodes size = 1]).	
	self assignedWorkingCopy merge: self allSelectedNodes first version.! !

!CvVersionNode methodsFor: 'event handling' stamp: 'bs 4/18/2011 16:48:57.164'!
mouseDown: evt
	self hideHoverView.
	
	(evt shiftPressed not and: [evt yellowButtonPressed])
		ifTrue: [^ evt hand waitForClicksOrDrag: self event: evt].
	
	self mouseDownForSelection: evt.! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 7/24/2012 14:02:27.848'!
mouseDownForSelection: evt	
	
	self version hasPredecessor ifFalse: [Beeper beep. ^ self].
	
	self isTheOnlySelectedNode ifTrue: [^ self deselect].
	 
	(evt shiftPressed and: [evt anyModifierKeyPressed]) 
		ifTrue: [
			^ self isSelected 
				ifTrue: [self deselect]
				ifFalse: [self select]].
	
	(evt shiftPressed and: [self isSelected not]) 
		ifTrue: [^ self selectRange].
	
	self allSelectedNodes copy do: [:ea | ea deselect].
	self select.! !

!CvVersionNode methodsFor: 'event handling' stamp: 'bs 4/19/2011 20:51:57.871'!
mouseDownPriority
	^ 5! !

!CvVersionNode methodsFor: 'hovering' stamp: 'sp 1/13/2013 21:11:09.272'!
mouseEnter: anEvent

	(anEvent shiftPressed and: [anEvent commandKeyPressed])
		ifTrue: [^ self showPreview].
	
	hoverView := anEvent shiftPressed
		ifTrue: [self createSummaryView]
		ifFalse: [self createHoverView].
	
	hoverView
		color: Color solarizedBase3Brwhite;
		borderWidth: 2;
		borderColor: Color solarizedBlue;
		openInWorld;
		bottomLeft: (self localPointToGlobal: self topLeft) ! !

!CvVersionNode methodsFor: 'hovering' stamp: 'bs 7/18/2011 20:40:07.407'!
mouseLeave: anEvent
	self hideHoverView.
	preview ifNotNil: [preview delete. preview := nil]! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 4/17/2011 21:20:24.109'!
nodesBackToVersion: ancestorVersion
	| result |
	result := OrderedCollection new.
	self collectNodesBackToVersion: ancestorVersion in: result.
	result remove: self ifAbsent: [].
	^ result! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 4/18/2011 14:46:52.113'!
nodesBetween: aNode and: anotherNode
	| ancestorVersion |
	ancestorVersion := anotherNode version commonAncestorWith: aNode version.
	^ (aNode nodesBackToVersion: ancestorVersion), 
		(anotherNode nodesBackToVersion: ancestorVersion)
			 ! !

!CvVersionNode methodsFor: 'as yet unclassified' stamp: 'bs 4/20/2011 12:13:02.398'!
noteNewOwner: ownerMorph
	super noteNewOwner: ownerMorph.! !

!CvVersionNode methodsFor: 'event handling' stamp: 'bs 3/23/2011 13:09:51.553'!
offerMenu
	| aMenu |
	aMenu := self buildMenu.
	aMenu popUpEvent: self currentEvent in: self world! !

!CvVersionNode methodsFor: 'menu actions' stamp: 'bs 4/12/2011 14:11:41.288'!
openTestResultInspector
	
	self version testResult basicInspect openInHand! !

!CvVersionNode methodsFor: 'as yet unclassified' stamp: 'TM 4/1/2011 13:32:56.51'!
predecessor

	^ self version predecessor! !

!CvVersionNode methodsFor: 'event handling' stamp: 'bs 4/19/2011 20:53:26.183'!
processEvent: anEvent using: defaultDispatcher
	
	(self containsPoint: anEvent position)
		ifTrue: [self handleEvent: anEvent]
		ifFalse: [^ super processEvent: anEvent using: defaultDispatcher]! !

!CvVersionNode methodsFor: 'menu actions' stamp: 'bs 4/6/2011 19:44:49.059'!
rebaseWorkingCopy: aWc
	
	aWc rebaseTo: self version! !

!CvVersionNode methodsFor: 'working copy pointer' stamp: 'bs 6/3/2011 22:11:13.312'!
removeWcPointer: aWcPointer
	self removeMorph: aWcPointer.
	self wcPointers remove: aWcPointer.
	self wcPointers ifEmpty: [
		self borderColor: self defaultColor.
		self color: self defaultColor]! !

!CvVersionNode methodsFor: 'highlighting' stamp: 'bs 6/3/2011 21:27:22.648'!
resetHighlight
	
	"self highBar height: 4.
	self lowBar height: 4.
	self highBar color: Color transparent"
	isDarkened := false.
	self changed.! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 7/31/2012 10:09:08.924'!
revertChangesOn: aWc
	| ranges versionInFrontOfSelection currentBase toBeAppliedRanges |
	self allSelectedNodes ifEmpty: [^ self].
	
	ranges := self selectedVersionsInRanges.
	ranges do: [:eachRange | 
		(aWc baseVersion hasAncestor: eachRange last)
			ifFalse: [self inform: 'You can only revert versions/changes that are on the path to the working copy to be affected.'. ^ self]].
	
	currentBase := aWc baseVersion.
	
	versionInFrontOfSelection := ranges first first predecessor.
	aWc rebaseTo: versionInFrontOfSelection.
	
	toBeAppliedRanges := self invertSelection: ranges upThrough: currentBase.
	toBeAppliedRanges do: [:eachRange | | patchBase lastVersion patch |
		patchBase := eachRange first predecessor.
		lastVersion := eachRange last.
		patch := lastVersion patchRelativeToBase: patchBase.
		aWc applyPatch: patch ].
	
	self allSelectedNodes do: [:ea | ea deselect].! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 4/30/2011 16:09:09.422'!
revertChangesOnNewWc
	self revertChangesOn: self version checkout! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 7/30/2012 13:00:19.914'!
select

	self allSelectedNodes add: self.
	self changed.! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 4/18/2011 14:46:16.952'!
selectRange

	self allSelectedNodes notEmpty
		ifTrue: [ | previousSelection ancestorVersion ancestorNode |
			previousSelection := self allSelectedNodes last.
			(self nodesBetween: self and: previousSelection) do: [:ea | ea select]].
	self select.! !

!CvVersionNode methodsFor: 'selection' stamp: 'bs 4/30/2011 18:29:09.923'!
selectedVersionsInRanges
	
	^ self allSelectedNodesInRanges 
		collect: [:eaRange | eaRange collect: [:eaNode | eaNode version]].! !

!CvVersionNode methodsFor: 'hovering' stamp: 'bs 7/18/2011 20:53:40.662'!
showPreview

	preview := CvPreview new.
	preview previewOn: self version.
	preview openInWorld.
	preview bottomLeft: self versionBar topLeft.! !

!CvVersionNode methodsFor: 'as yet unclassified' stamp: 'bs 5/12/2011 16:21:15.248'!
step
	self version testResult ifNil: [^ self].
	self version hasPredecessor ifTrue: [
		self version predecessor testResult ifNil: [^ self]].
	
	self version testResult ifNotNil: [
		self displayTestResult.
		self stopStepping ].! !

!CvVersionNode methodsFor: 'as yet unclassified' stamp: 'TM 4/1/2011 13:32:46.729'!
successors

	^self version successors! !

!CvVersionNode methodsFor: 'as yet unclassified' stamp: 'TM 3/10/2011 15:56:03.155'!
version

	^ version! !

!CvVersionNode methodsFor: 'as yet unclassified' stamp: 'TM 3/10/2011 15:55:51.178'!
version: aCvVersion

	version := aCvVersion! !

!CvVersionNode methodsFor: 'as yet unclassified' stamp: 'bs 3/24/2011 11:03:58.011'!
versionBar
	| result |
	result := self owner.
	[result isKindOf: CvVersionBar] whileFalse: [result := result owner].
	^ result! !

!CvVersionNode methodsFor: 'as yet unclassified' stamp: 'bs 4/20/2011 11:44:45.47'!
versionNodeBefore
	
	^ self submorphBefore ifNotNil: [:m |
		(m isKindOf: CvVersionNode) ifTrue: [m] ifFalse: [nil]]! !

!CvVersionNode methodsFor: 'working copy pointer' stamp: 'bs 5/12/2011 21:44:10.99'!
wcPointers
	^ wcPointers ifNil: [wcPointers := OrderedCollection new]! !

!CvVersionNode methodsFor: 'derived accessing' stamp: 'bs 8/1/2012 13:31:47.237'!
workingCopies

	^ self branch workingCopies! !

Morph subclass: #CvWorkingCopyPointer
	instanceVariableNames: 'versionBar baseVersionNode container workingCopyWeakArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CV-UI'!

!CvWorkingCopyPointer class methodsFor: 'testing' stamp: 'bs 6/6/2011 16:51:04.17'!
canBeLateBound
	^ false! !

!CvWorkingCopyPointer class methodsFor: 'as yet unclassified' stamp: 'bs 4/6/2011 14:47:54.027'!
workingCopy: aWc versionBar: aVersionBar

	^ self new initializeWithWorkingCopy: aWc versionBar: aVersionBar! !

!CvWorkingCopyPointer methodsFor: 'as yet unclassified' stamp: 'FB 1/17/2013 13:06:16.366'!
drawOn: aCanvas

	|color|
	color := self workingCopy
		ifNil: [Color red]
		ifNotNil: [:wc | wc color].
	aCanvas 
		drawPolygon: {self left@ self center y. self right@self top. self right@self bottom}
		fillStyle: color.! !

!CvWorkingCopyPointer methodsFor: 'as yet unclassified' stamp: 'bs 9/7/2012 13:40:58.283'!
fullDrawOn: aCanvas

	super fullDrawOn: aCanvas originalCanvas! !

!CvWorkingCopyPointer methodsFor: 'as yet unclassified' stamp: 'bs 9/7/2012 13:46:23.446'!
initializeWithWorkingCopy: aWc versionBar: aVersionBar

	self workingCopy: aWc.
	self versionBar: aVersionBar.
	self extent: 9@18; color: self workingCopy color.
	
	self connect: aWc signal: #versionSaved toSelector: #versionSaved.
	self connect: aWc signal: #rebasedFrom:to: toSelector: #rebasedFrom:to:.
	
	self rebasedFrom: nil to: self workingCopy baseVersion.
	self startStepping.! !

!CvWorkingCopyPointer methodsFor: 'as yet unclassified' stamp: 'bs 8/23/2011 09:34:35.42'!
rebasedFrom: oldVersion to: newVersion
	| newItem |
	self removeFromVersionNode.
	newVersion ifNil: [^ self].
	newItem := self versionBar view allItems detect: [:ea | ea version = newVersion].
	baseVersionNode := newItem versionNode.	
	baseVersionNode addWcPointer: self! !

!CvWorkingCopyPointer methodsFor: 'as yet unclassified' stamp: 'bs 5/12/2011 22:03:58.72'!
removeFromVersionNode 
	
	baseVersionNode ifNotNil: [
		baseVersionNode removeWcPointer: self]! !

!CvWorkingCopyPointer methodsFor: 'as yet unclassified' stamp: 'bs 5/12/2011 22:04:14.883'!
step

	self workingCopy ifNil: [
		self removeFromVersionNode.
		self delete].! !

!CvWorkingCopyPointer methodsFor: 'as yet unclassified' stamp: 'bs 5/3/2011 14:43:46.818'!
stepTime
	
	^ 1000! !

!CvWorkingCopyPointer methodsFor: 'accessing' stamp: 'bs 5/3/2011 15:08:59.523'!
versionBar
	^ versionBar! !

!CvWorkingCopyPointer methodsFor: 'accessing' stamp: 'bs 5/3/2011 15:08:52.557'!
versionBar: anObject
	versionBar := anObject
	! !

!CvWorkingCopyPointer methodsFor: 'as yet unclassified' stamp: 'bs 7/31/2012 10:52:17.892'!
versionSaved
	| newBase |
	"the order of the statements is important. removing the morph can make a branch inactive, as the presence of this morph is the indicator for branch activity. While appending a new version, inactive branches were hid."
	self versionBar view addNewVersion: self workingCopy baseVersion.
	newBase := self workingCopy baseVersion.
	self rebasedFrom: newBase predecessor to: newBase.! !

!CvWorkingCopyPointer methodsFor: 'accessing' stamp: 'bs 5/3/2011 15:08:25.862'!
workingCopy

	^ workingCopyWeakArray first! !

!CvWorkingCopyPointer methodsFor: 'accessing' stamp: 'bs 5/3/2011 15:08:17.566'!
workingCopy: aWorkingCopy
	
	workingCopyWeakArray := WeakArray with: aWorkingCopy! !

!Morph methodsFor: '*CV' stamp: ''!
cvWorkingCopy

	self assert: [self psCodeBase isCvWorkingCopy].
	^ self psCodeBase! !

!Morph methodsFor: '*CV' stamp: 'bs 5/15/2011 16:08:46.428'!
wantsToKeepSubmorph: aMorph
	
	^ false! !
CvTbTestCase initialize!
CvPackageInfo initialize!
